C#############################################################
      subroutine MAPOPT(itran,plotf,prog,ssize,xwin,ywin,
     * xdim,ydim,xlow,ylow,sbox,fxdim,fydim,xmarg,ymarg,fxlow,
     * fylow,labelx,labely,title,hue,light,sat,fhue,thick,ctype
     +,
     * zmin,zmax,dz,KEY)
      character*20 sk
      logical tf,KEY
	 character plotf*(*),prog*(*),sbox*(*)
	 character labelx*(*),labely*(*),title*(*),ctype*(*)
	 character buf*(100)
      data sk/'PARAM_MAP'/
      itran=1
      plotf='ftannice.ps'
      prog='FTAN'
      ssize=0.75
      xwin=0.27
      ywin=0.0
c itran -  A flag which indicates which mode for plotting
c          0 - Portrait mode,  1 - Landscape mode.
c plotf - The name of a postscript plot  file. If this string is 
c         empty, then a default file named "niceplot" will be 
c         created. If this string is "none", then no postcript 
c         output will be produced.
c prog  - A program name that is displyed in the X window title 
c         bar and the icon.
c ssize - The initial size of the window in screen units (0.0  - 1.0).
c         In portrait mode this is the height of the screen and in 
c         landscape mode this is the width of the window.
c xwin,ywin - The initial x-y location of the window in screen units.
      xdim=7.5
      ydim=10.0
      xlow=0.0
      ylow=0.0
c xdim  -  Horizontal dimension in inches 
c ydim  - Vertical dimension in inche 
c xlow  - Horizontal location of lower left hand corner of plot in inches 
c ylow  - Vertical location of lower left hand corner of plot in inches
      sbox='Y'
c sbox  - N - don't map the box, Y - map the box
      fxdim=5.0
      fydim=5.0
      xmarg=.5
      ymarg=.5
      fxlow=2.
      fylow=1.
      labelx='Period (sec)' 
C     IF(.NOT.KEY)labelx='Frequency (Hz)'
      labely='Group velocity (km/sec)'
      title='FTAN'
c fxdim - X dimension of the map in inches. 
c fydim - Y dimension of the map in inches. 
c xmarg - The margin below the  x-axis  in inches, determines the 
c         vertical spacing of the x-axis label. 
c ymarg - The margin to the left of the y-axis in inches, 
c         determines the horizontal spacing of the y-axis label.
c fxlow - X-location of the lower left hand corner of the map in 
c         inches from the lower left hand corner of the plot.
c fylow - Y-location of the lower left hand corner of the map in
c         inches from the lower left hand corner of the plot.
c labelx- The character string label for the x- axis.
c labely- The character string label for the y- axis.
c title - The character string title which is placed on top of the plot.
      hue=120.
      light=0.8
      sat=1.0
      grhue=240.
c ONLY FOR COLOR MONITOR !!!*******************************
c hue   - The hue of the foreground color (0.0 to 360.0 where
c         0.0 = red, 120.0 = green, 240.0 = blue).
c light - The lightness of the foreground color (0.0 to 1.0
c         where 0.0 is always black, 1.0 is always white and 0.5
c         is a pure color when sat = 1.0. light is a gray scale
c         when sat = 0.0).
c sat   - The saturation of the foreground color (0.0 to 1.0 where 
c         0.0 means no color (gray scale) and 1.0 means pure color 
c         when light = 0.5).
c fhue  - The hue of the dispersion curve color (0.0 to 360.0 where
c         0.0 = red, 120.0 = green, 240.0 = blue).
c END ONLY FOR COLOR MONITOR !!!*******************************
      ctype='both'
      thick=0.02
      zmin=60.
      zmax=100.
      dz=2.
c ctype - Contour type:
c            lines - make line contours only
c            colors - make color contours only
c            both - make line contours on top of color contours
c thick - Thickness of the dispersion curve line in inches
c zmin  - The minimum z-value for contour clipping 
c zmax  - The maximum z-value for contour clipping. If zmax = zmin,
c         then no clipping will take place and internal values 
c         of zmin and zmax will be computed automatically from
c         the range of the data
c dz    - The z contour line increment. If dz  <= 0.0, then
c         a "nice" increment will be chosen. Chosen "nice" increment
c         in input dz <= 0.0
      INQUIRE (file=sk,exist=tf)
          if (tf) then
              OPEN(77,file=sk)
1	      read(77,'(a80)') buf
	      if(buf(1:1).eq.'#') goto 1
	      read(buf,*) itran,plotf,prog,ssize,xwin,ywin
2	      read(77,'(a80)') buf
	      if(buf(1:1).eq.'#') goto 2
	      read(buf,*) xdim,ydim,xlow,ylow
3	      read(77,'(a80)') buf
	      if(buf(1:1).eq.'#') goto 3
	      read(buf,*) sbox
4	      read(77,'(a80)') buf
	      if(buf(1:1).eq.'#') goto 4
	      read(buf,*) fxdim,fydim,xmarg,ymarg,fxlow,fylow
5	      read(77,'(a80)') buf
	      if(buf(1:1).eq.'#') goto 5
	      read(buf,*) labelx
6	      read(77,'(a80)') buf
	      if(buf(1:1).eq.'#') goto 6
	      read(buf,*) labely
7	      read(77,'(a80)') buf
	      if(buf(1:1).eq.'#') goto 7
	      read(buf,*) title
8	      read(77,'(a80)') buf
	      if(buf(1:1).eq.'#') goto 8
	      read(buf,*) hue,light,sat,grhue
9	      read(77,'(a80)') buf
	      if(buf(1:1).eq.'#') goto 9
	      read(buf,*) ctype,thick,zmin,zmax,dz
              CLOSE (77)
          end if
      return
      end
