c///////////////////////////////////////////////////////////////////////
c-----------------------------------------------------------------------
	real*4 function ANGLE (vec1,k1,ic1,vec2,k2,ic2)
c-----------------------------------------------------------------------
		integer*4 k1,k2,ic1,ic2
		real*4 vec1(6,k1),vec2(6,k2)
			real*4 accur
				data accur /1.e-5/
c-----------------------------------------------------------------------
c			    ANGLE between two COMPLEX VECTORS
c-----------------------------------------------------------------------
			call SPROD (vec1,k1,ic1,vec2,k2,ic2, r,s)
					r=SQRT(r*r+s*s)

			call SPROD (vec1,k1,0,vec1,k1,0, p,s)
			call SPROD (vec2,k2,0,vec2,k2,0, q,s)
					p=SQRT(p)
					q=SQRT(q)

		if ((p.lt.accur).or.(q.lt.accur)) then
	ANGLE=0.
		else
			s=r/p/q
	ANGLE=ACOS(s)
		end if
							RETURN
							END

c///////////////////////////////////////////////////////////////////////
c-----------------------------------------------------------------------
	subroutine ANYPA (coma,	  energ,val1,val2,val3,
     *  				vet1,vet2,uvec1,kv1,
     *  				vnu1,vnu2,uvec3,kv3 )
c-----------------------------------------------------------------------
		integer*4 kv1,kv3
		real*4 coma(3,3)
		real*4 energ,val1,val2,val3,vet1,vet2,vnu1,vnu2
		real*4 uvec1(6,kv1),uvec3(6,kv3)
			real*4 val(3),vec(6,3)
c-----------------------------------------------------------------------
c	    get POLARIZATION VECTORS (parameters of complex LINE or PLANE)
c						by COVARIANCE MATRIX
c-----------------------------------------------------------------------

			call HEI (coma,  val,vec)
				energ=val(1)+val(2)+val(3)
						val1=val(1)/energ
						val2=val(2)/energ
						val3=val(3)/energ
	call CONORM (vec,1,  amp,pha,vet1,vet2,uvec1,kv1)
	call CONORM (vec,3,  amp,pha,vnu1,vnu2,uvec3,kv3)
								RETURN
								END

c///////////////////////////////////////////////////////////////////////
c-----------------------------------------------------------------------
	subroutine CHO2 (etalon,vec,kv,pha)
c-----------------------------------------------------------------------
		integer*4 kv
		real*4 etalon(6),vec(6,kv)
		real*4 pha
c-----------------------------------------------------------------------
c- choose ONE of TWO polarization vectors; they differ by "-1" factor
c-----------------------------------------------------------------------
						pi=3.141592654

	r=etalon(1)*vec(1,kv)+etalon(2)*vec(2,kv)+etalon(3)*vec(
     +3,kv)

			if (r.lt.0.) then
	pha=pha+pi
		do 100 i=1,6
	vec(i,kv)=-vec(i,kv)
100		continue
			end if
							RETURN
							END

c///////////////////////////////////////////////////////////////////////
c-----------------------------------------------------------------------
	subroutine CHO4 (etalon,vmu1,vmu2,uvec,kv,pha)
c-----------------------------------------------------------------------
		integer*4 kv
		real*4 etalon(6),uvec(6,kv)
		real*4 vmu1,vmu2,pha
			real*4 vec(6)
c-----------------------------------------------------------------------
c	 choose ONE of FOUR polarization vectors differs by "i" multiplying
c-----------------------------------------------------------------------
						pi=3.141592654

					do 100 i=1,3
					       j=i+3
			vec(i)=vmu1*uvec(i,kv)
			vec(j)=vmu2*uvec(j,kv)
100					continue

		call SPROD (vec,1,0,etalon,1,0,  rre,rim)

			if (ABS(rim).gt.ABS(rre)) then
c		    ........................
	pha=pha+pi/2.
	r=vmu1
	vmu1=vmu2
	vmu2=r
				rre=rim
		do 101 i=1,3
		       j=i+3
	r=uvec(i,kv)
	uvec(i,kv)=uvec(j,kv)
	uvec(j,kv)=-r
				r=vec(i)
				vec(i)=vec(j)
				vec(j)=-r
101		continue
c		    ........................
			end if

					if (rre.lt.0.) then
			pha=pha-pi
				do 102 i=1,6
			uvec(i,kv)=-uvec(i,kv)
102				continue
					end if
							RETURN
							END

c///////////////////////////////////////////////////////////////////////
c-----------------------------------------------------------------------
	subroutine CONORM (z,kz,    amp,pha,vmu1,vmu2,uvec,kv)
c-----------------------------------------------------------------------
		integer*4 kz,kv
		real*4 z(6,kz),uvec(6,kv)
		real*4 amp,pha,vmu1,vmu2
c-----------------------------------------------------------------------
c			    NORMALIZING COMPLEX VECTOR to SPECIAL FORM:
c	    Z=A+iB=[vmu1*uvec(1-3,.)+i*vmu2*uvec(4-6,.)]*amp*exp[i*pha]
c					vmu1**2+vmu2**2=1
c					( uvec(1-3,.),uvec(4-6,.) )=0
c-----------------------------------------------------------------------
						accur=1.e-4
						pi=3.141592654
				r=0.
				s=0.
					do 100 i=1,3
					       j=i+3
				r=r+z(i,kz)*z(j,kz)
				s=s+z(i,kz)*z(i,kz)-z(j,kz)*z(j,kz)
     +
100					continue
			r=2.*r
			p=SQRT(r*r+s*s)

			if (p.lt.accur) then
		pha=0.
			else
		s=SIGN(1.,s)*r/p
		pha=ASIN(s)/2.
	if (s.lt.0.) pha=-ABS(pha)
			end if

				co=COS(pha)
				si=SIN(pha)
		 if (pha.lt.0.) si=-ABS(si)
							do 101 i=1,3
							       j=i+3
					uvec(i,kv)=co*z(i,kz)+si*z(j
     +,kz)
					uvec(j,kv)=co*z(j,kz)-si*z(i
     +,kz)
101							continue

		r=0.
		s=0.
			do 102 i=1,3
			       j=i+3
		r=r+uvec(i,kv)*uvec(i,kv)
		s=s+uvec(j,kv)*uvec(j,kv)
102			continue
					amp=SQRT(r+s)

						if (amp.lt.accur) the
     +n
c					    .................................
					amp=0.
					pha=0.
					vmu1=1.
					vmu2=0.
							do 103 i=1,6
							    p=0.
						if (i.eq.1) p=1.
					uvec(i,kv)=p
103							continue

						else
c					    .................................
	vmu1=SQRT(r)/amp
	vmu2=SQRT(s)/amp
				if (vmu2.gt.vmu1) then
c			    ..................
		pha=pha+pi/2.
		r=vmu1
		vmu1=vmu2
		vmu2=r
			do 104 i=1,3
			       j=i+3
		r=uvec(i,kv)
		uvec(i,kv)=uvec(j,kv)
		uvec(j,kv)=-r
104			continue
c			    ..................
				end if
				
					if(vmu2.lt.accur) then
						vmu1=1.
						vmu2=0.
					end if

			do 105 i=1,3
			       j=i+3
	uvec(i,kv)=uvec(i,kv)/amp/vmu1

		if (vmu2.lt.accur) then
	uvec(j,kv)=0.
		else
	uvec(j,kv)=uvec(j,kv)/amp/vmu2
		end if
105			continue
c					    .................................
						end if
								RETURN
								END

c///////////////////////////////////////////////////////////////////////
c-----------------------------------------------------------------------
	subroutine CROSHO (uvec,kv,  cros,kc,ier)
c-----------------------------------------------------------------------
		integer*4 kv,kc,ier
		real*4 uvec(6,kv),cros(2,kc)
			real*4 vp(6),vq(6),verti(6)
				data verti /0.,0.,0.,0.,0.,1./
c-----------------------------------------------------------------------
c	  cros() - vector in horizontal plane - cross of this plane
c				with plane of ellipse "uvec()"
c-----------------------------------------------------------------------
						accur=1.e-5
	ier=0
			call VPROD (uvec,kv,0,uvec,kv,1,  vp,1)
			call VPROD (vp,1,0,verti,1,0,  vq,1)

				r=SQRT(vq(1)*vq(1)+vq(2)*vq(2))

		if (r.lt.accur) then
	ier=1
		else
	cros(1,kc)=vq(1)/r
	cros(2,kc)=vq(2)/r
		end if
								RETURN
								END

c///////////////////////////////////////////////////////////////////////
c-----------------------------------------------------------------------
	subroutine DEFPAR (ktd,kwd,az0,iraz,cmi,par)
c-----------------------------------------------------------------------
		integer*4 ktd,kwd,iraz
		real*4 az0
		real*4 cmi,par(22)
c-----------------------------------------------------------------------
c				    ------------------------------
c	#########  COVARYANCE MATRIXES are calculated not in every point,
c			but with steps: ktd - by time, ktw - frequency
c			other polariz. vectors are found by interpolation
							ktd=1
							kwd=1
c				    ------------------------------
c			#########  DEFAULT "a priori AZIMUTH" :
								az0=0.
								iraz=0
c				    ------------------------------

c#########  amplitudes less then cmi*AMAX are ignored:
					cmi=0.01
c#########  MATRIX is calculated in GAUSSIAN window given by parameters:
					par(1)=0.1
					par(2)=0.1
c  window=EXP{-0.5[(w-w0)/(par(2)/beta)]**2-0.5[(t-t0)*beta/par(1)]**2}

c##########     par(3) - only points with QUALfunction > par(3) are used
c				for "MAPs"
c		par(4) - only points with QUALfunction > par(4) are used
c				for AVERAGE AZIMUTH calculation
					par(3)=0.1
					par(4)=0.4

c######### every QUALITY FUNCTION is a product of elementary functions
c	as given by equation written in "QUAF"-subroutine	

c######## RAYLEIGH noise/signal "boundary" ratio:
					par(5)=1.5

					par(6)=0.5
					par(7)=0.5

c########  RAYLEIGH MAIN AXES "boundary" ratio (1/par(8)<..<par(8)):
					par(8)=4.

					par(9)=0.5
					par(10)=0.5
					par(11)=0.5
					par(12)=0.5
					par(13)=0.5

c######## LOVE noise/signal "boundary" ratio:
					par(14)=1.5

					par(15)=0.5
					par(16)=0.5

c########  LOVE MAIN AXES "boundary" ratio (...<par(17)
					par(17)=3.

					par(18)=0.5
					par(19)=0.5
					par(20)=0.5
					par(21)=0.5
					par(22)=0.5
C        print*,' PARAMETERS FOR CUT-OFF OF WEAK AND BAD SIGNALS:'
C	 print 1000,cmi
C1000	 format('cmi=   ',E10.3,'; points with amplitudes < cmi*AMAX are ignored')
C	 print 1001, par(3)
C1001	 format('par(3)=',E10.3,'; only points with QUALfunction > par(3) are used for "MAPs"')
C	 print 1002, par(4)
C1002	 format('par(4)=',E10.3,'; only points with QUALfunction > par(4) are used for' /
C     *	  'AVERAGE AZIMUTH calculation')
								RETURN
								END
c///////////////////////////////////////////////////////////////////////
c-----------------------------------------------------------------------
	real*4 function EPLANG (vec,kv,ellips,ke, ier)
c-----------------------------------------------------------------------
		integer*4 kv,ke
		real*4 vec(6,kv),ellips(6,ke) 
			real*4 v(6)
			real*4 accur,pi
		    data accur /1.e-4/, pi /3.141592654/
c-----------------------------------------------------------------------
c   ANGLE of VECTOR "vec" to "PHYSICAL" plane of ELLIPSE given by "ellipse"
c		sign of EPLAND_G is given by sign of COS(alpha) where
c		    alpha - "PHIZICAL" angle between RE(vec) and
c			"ROTATION vector" of ellipse ( [Im(el.)*Re(el.)] )
c	ier = 1    - if ellipse - "REAL" vector
c-----------------------------------------------------------------------
					ier=0
		call VPROD (ellips,ke,0,ellips,ke,1, v,1)

				call SPROD (v,1,0,v,1,0, r,s)
			if (SQRT(r).lt.accur) then
					ier=1
	EPLANG=0.
			else
	EPLANG=pi/2.-ANGLE(vec,1,0,v,1,0)
		call SPROD (vec,kv,0,v,1,0, r,s)
	if (s.lt.0.) EPLANG=-EPLANG
			end if
							RETURN
							END

c///////////////////////////////////////////////////////////////////////
c-----------------------------------------------------------------------
	real*4 function EXPO (t,w,gmat)
c-----------------------------------------------------------------------
		real*4 t,w
		real*4 gmat(3)
			real*4 vmin
		    data vmin /-4./
c				    !(change together with cowin in GETCOM)
c-----------------------------------------------------------------------
	p=gmat(1)*t*t+gmat(2)*t*w+gmat(3)*w*w
						EXPO=0.
				 if (p.gt.vmin) EXPO=EXP(p)
								RETURN
								END

c///////////////////////////////////////////////////////////////////////
c-----------------------------------------------------------------------
	subroutine GAUMA (st,sw,rt,  gmat)
c-----------------------------------------------------------------------
		real*4 st,sw,rt
		real*4 gmat(3)
c-----------------------------------------------------------------------
c  -INPUT: st (>=rt) - apparent width of ellips by by time
c	   sw (ne.0) -           --"--          by frequency (in radians)
c		( sw < 0  - largest ellipse's axes corresponds to dw/dt < 0 )
c				if st=rt last condition has no sense
c	   rt (>0)   - "central" width of ellipse by time
c				( all of them by isoline 0.5 )

c  -OUTPUT:   gmat = (a,b,c) - coefficients (a,c-negative) of form :
c						a*t**2+b*t*w+c*w**2
c-----------------------------------------------------------------------
					half=1./2.
	gmat(1)=-half/rt/rt
	gmat(2)=-SQRT(ABS(st*st-rt*rt))/sw/rt/rt
	gmat(3)=-half*st*st/sw/sw/rt/rt
								RETURN
								END
c///////////////////////////////////////////////////////////////////////
c-----------------------------------------------------------------------
	subroutine HEI (coma, val,vec)
c-----------------------------------------------------------------------
		real*4 coma(3,3),val(3),vec(6,3)
			real*8 rmat(6,6),rval(6),rvec(6,6),bar(6),
     +zar(6)
			real*8 r,s,p,q,nul,one,ten
			real*8 DBLE,DSQRT
c-----------------------------------------------------------------------
c		    HERMITIAN POSITIVELY DEFINED MATRIX EIGENVECTORS PROBLEM
c	    - INPUT :
c		      coma(i,j), i<=j  -  real part of matrix
c				 i> j  -  im...... part of matrix
c	    - OUTPUT :
c		      val(1) >= val(2) >= val(3)  -  eigenvalues
c		      vec  -  corresponding eigenvectors
c-----------------------------------------------------------------------
							nul=0.d0
							one=1.d0
							ten=1.d+1

						do 100 i=1,3
					do 101 j=i,3
				rmat(i,j)=DBLE(coma(i,j))
				rmat(i+3,j+3)=DBLE(coma(i,j))
				rmat(i,j+3)=-DBLE(coma(j,i))
				rmat(j,i+3)= DBLE(coma(j,i))
101					continue
			rmat(i,i+3)=nul
100						continue

						do 102 i=2,6
						do 102 j=1,i-1
				rmat(i,j)=rmat(j,i)
102						continue

		call JACOB2 (6,6,rmat,  rval,rvec,  irot,bar,zar)
     +

							do 103 nv=1,2
							       nv1=nv+
     +1
							       nv2=7-n
     +v
c						    ...........................
	s=ten
						do 104 k=nv1,nv2
c					    .....................
				p=nul
				q=nul
					do 105 i=1,3
					       j=i+3
				p=p+rvec(i,nv)*rvec(i,k)
				p=p+rvec(j,nv)*rvec(j,k)
				q=q+rvec(i,nv)*rvec(j,k)
				q=q-rvec(j,nv)*rvec(i,k)
105					continue

			do 106 i=1,3
			       j=i+3
		rvec(i,k)=rvec(i,k)-p*rvec(i,nv)+q*rvec(j,nv)
		rvec(j,k)=rvec(j,k)-p*rvec(j,nv)-q*rvec(i,nv)
106			continue

	    r=nul
		    do 107 i=1,6
	    r=r+rvec(i,k)**2
107		    continue

	if (r.lt.s) then
	     s=r
	     nn=k
	end if
c					    .....................
104						continue

			r=rval(nn)
			rval(nn)=rval(nv2)
			rval(nv2)=r
					do 108 i=1,6
				r=rvec(i,nn)
				rvec(i,nn)=rvec(i,nv2)
				rvec(i,nv2)=r
108					continue

			do 109 k=nv1,nv2-1
c		    ...................
	r=nul
		do 110 i=1,6
	r=r+rvec(i,k)**2
110		continue
	r=DSQRT(r)

		do 111 i=1,6
	rvec(i,k)=rvec(i,k)/r
111		continue
c		    ...................
109			continue
c						    ...........................
103							continue

					do 112 k=1,3
c				    ......................
		s=-one
				do 113 j=1,3
			if (rval(j).gt.s) then
		s=rval(j)
		nn=j
			end if
113				continue

					rval(nn)=-one
	val(k)=SNGL(s)
		do 114 i=1,6
	vec(i,k)=SNGL(rvec(i,nn))
114		continue
c				    ......................
112					continue
								RETURN
								END

c///////////////////////////////////////////////////////////////////////
c-----------------------------------------------------------------------
	subroutine JAC1 (a,  d,v)
c-----------------------------------------------------------------------
		real*4 a(2,2),v(2,2),d(2)
		real*8 a2(2,2),v2(2,2),d2(2),b2(2),z2(2)
		real*8 DBLE
c-----------------------------------------------------------------------
				a2(1,1)=DBLE(a(1,1))
				a2(1,2)=DBLE(a(1,2))
				a2(2,1)=DBLE(a(2,1))
				a2(2,2)=DBLE(a(2,2))

	call JACOB2 (2,2,a2,    d2,v2,   irot,b2,z2)

					v(1,1)=SNGL(v2(1,1))
					v(1,2)=SNGL(v2(1,2))
					v(2,1)=SNGL(v2(2,1))
					v(2,2)=SNGL(v2(2,2))

					d(1)=SNGL(d2(1))
					d(2)=SNGL(d2(2))
								RETURN
								END


c///////////////////////////////////////////////////////////////////////
c-----------------------------------------------------------------------
	subroutine JACOB2 (nm,n,a,    d,v,   rot,b,z)
c-----------------------------------------------------------------------
		integer*4  nm,n,rot
		real*8 a(nm,n),v(nm,n),d(n),b(n),z(n)
		    integer*4 falrot,n1,n2,n3,p,q,i,j
		    real*8 tau,theta,tr,ze,w,aw,sm,g,t,ap,aq,h,ah
     +,c,s
		    real*8 DABS,DBLE,DSQRT
		    real*8 tmp,one,ost,accur
c-----------------------------------------------------------------------
c				SIMMETRIC MATRIX EIGENVECTORS PROBLEM
c-----------------------------------------------------------------------
							ze=0.d0
							half=.5d0
							one=1.d0
							hun=1.d+02
							accur=1.d-40  
     +
c								     !!!! ad

						do 200 p=1,n
					do 199 q=1,n
				v(p,q)=ze
199					continue
				v(p,p)=one
200						continue

		do 10 p=1,n
		    w=a(p,p)
	b(p)=w
	d(p)=w
	z(p)=ze
10		continue

				rot=0
				falrot=0
						if (n.eq.1) goto 3000
     +
							n1=n-1

						do 20 i=1,50
c					...............................
	sm=ze
		do 30 p=1,n1
		    n2=p+1
		do 29 q=n2,n
	sm=sm+DABS(a(p,q))
29		continue
30		continue
					if (sm.lt.accur) goto 3000
c						if (sm.eq.ze) goto 3000
c							  ^^  accur ???????????
				    tr=ze
			if (i.lt.4) tr=2.d-01*sm/DBLE(n*n)

					do 40 p=1,n1
c				    .........................
							n2=p+1
			do 39 q=n2,n
		w=a(p,q)
	aw=DABS(w)
	g=aw*hun
					if (i.lt.5) goto 44
	ap=DABS(D(p))
	aq=DABS(D(q))
		tmp=ap+g
					if (tmp.gt.ap) goto 44
		tmp=aq+g
					if (tmp.gt.aq) goto 44
	a(p,q)=ze
			falrot=falrot+1
					goto 39
44						continue
				if (aw.le.tr) goto 39
		tmp=d(p)
		h=d(q)
		h=h-tmp
		ah=DABS(h)
		tmp=ah+g
			if (tmp.eq.ah) goto 50
		theta=half*h/w
	t=one/(DABS(theta)+DSQRT(one+theta*theta))
		if (theta.lt.ze) t=-t
						goto 60
50				continue
	t=w/h
60						continue
		c=one/DSQRT(one+t*t)
		s=t*c
		tau=s/(one+c)
		h=t*w
	z(p)=z(p)-h
	z(q)=z(q)+h
	d(p)=d(p)-h
	d(q)=d(q)+h
	a(p,q)=ze
		ost=one-s*tau
					n3=p-1
				if (n3.lt.1) goto 77

			do 70 j=1,n3
		g=a(j,p)
		h=a(j,q)
	a(j,p)=g*ost-h*s
	a(j,q)=h*ost+g*s
70			continue
77					continue

				    n3=q-1
				if (n3.lt.n2) goto 88

			do 80 j=n2,n3
		g=a(p,j)
		h=a(j,q)
	a(p,j)=g*ost-h*s
	a(j,q)=h*ost+g*s
80			continue
88					continue

				    n3=q+1
				if (n.lt.n3) goto 99

			do 90 j=n3,n
		g=a(p,j)
		h=a(q,j)
	a(p,j)=g*ost-h*s
	a(q,j)=h*ost+g*s
90			continue
99					continue

			do 300 j=1,n
		g=v(j,p)
		h=v(j,q)
	v(j,p)=g*ost-h*s
	v(j,q)=h*ost+g*s
300			continue
						rot=rot+1
c				    .........................
39					continue
40					continue

			do 100 p=1,n
		tmp=z(p)
		b(p)=b(p)+tmp
		d(p)=b(p)
		z(p)=ze
100			continue
c					...............................
20						continue
3000							continue
								RETURN
								END
c///////////////////////////////////////////////////////////////////////
c-----------------------------------------------------------------------
	real*4 function QUAEL (val,ratsn,powsn,powsnx)
c-----------------------------------------------------------------------
		real*4 val,ratsn,powsn,powsnx
			real*4 accur
				data accur /1.e-4/
c-----------------------------------------------------------------------
c	    ELLIPTICALLY (LINEARLY) polarized SIGNAL: QUALITY FUNCTION
c		    val  - max eigenvalue

c	    "STEP LEVELs" (upper) :
c			ratsn  < signal/noise ratio
c-----------------------------------------------------------------------
		x=3.*val-1.
				if (x.lt.accur) then
	QUAEL=0.
				else
		x=ratsn*SQRT(ABS((1.-val)/x))
		x=x**powsnx
	QUAEL=QUAF(powsn,x)
				end if
							RETURN
							END

c///////////////////////////////////////////////////////////////////////
c-----------------------------------------------------------------------
	real*4 function QUAF (pow,x)
c-----------------------------------------------------------------------
		real*4 pow,x
c-----------------------------------------------------------------------
c	 QUAF = [ 1 + |cos(2*arctg(x))|**pow * siqn(cos(2*arctg(x))) ]/2
c			for pow=.44, x=.5  - QUAF=.9  ( x=2 - QUAF=.1 )
c-----------------------------------------------------------------------
		y=COS(2.*ATAN(x))
			s=SIGN(1.,y)
		y=ABS(y)
		y=y**pow
	QUAF=(1.+y*s)/2.
							RETURN
							END

c///////////////////////////////////////////////////////////////////////
c-----------------------------------------------------------------------
	real*4 function QUALI (val,vmu1,vmu2,ratsn,ratmu,
     * 					     powsn,powmu,
     * 					     powsnx,powmux)
c-----------------------------------------------------------------------
*		real*4 val,vmu1,vmu2
		real*4 ratsn,ratmu,powsn,powmu,powsnx,powmux
			real*4 accur
				data accur /1.e-4/
c-----------------------------------------------------------------------
c	    LINEARLY polarized SIGNAL QUALITY FUNCTION
c		    val   - max eigenvalue
c		vmu1,vmu2 - ellipse's hemiaxes lengths

c	    "STEP LEVELs" (upper)  (!! must be > 0) :
c			ratsn  < signal/noise ratio
c		   1 >  ratmu  > ellipse's axes ratio
c-----------------------------------------------------------------------
c	  "ELLIPTICAL polarization" term
c---------------------------
		q1=QUAEL(val,ratsn,powsn,powsnx)

c------------------------------------------
c	  "AXES RATIO" term
c---------------------------
			r=ratmu-1./ratmu
			r=1./ABS(r)
			x=ABS(vmu1*vmu1-vmu2*vmu2)
				if (x.lt.accur) then
		q2=0.
				else
			x=vmu1*vmu2/x/r
			x=x**powmux
		q2=QUAF(powmu,x)
				end if

c---------------------------
	QUALI=q1*q2
							RETURN
							END

c///////////////////////////////////////////////////////////////////////
c-----------------------------------------------------------------------
	real*4 function QUALOV (val,vmu1,vmu2,uvec,kv,
     *  				ratsn,ratmu,angho,
     *  				powsn,powmu,powho,
     * 					powsnx,powmux,powhox)
     +
c-----------------------------------------------------------------------
		integer*4 kv
		real*4 uvec(6,kv)
		real*4 val,vmu1,vmu2
		real*4 ratsn,ratmu,angho,powsn,powmu,powho
		real*4 powsnx,powmux,powhox
			real*4 vp(6),vert(6)
			real*4 pi,angmax
			    data pi /3.141592654/, angmax /1.5/
			    data vert /0.,0.,1.,0.,0.,0./
c-----------------------------------------------------------------------
c		LOVE WAVE (linearly polarized) QUALITY FUNCTION
c------------------------------------------
c	    val  - max eigen value
c	    vmu1*uvec(1-3,kv)+i*vmu2*uvec(4-6,kv) - vector of polarization

c	    "STEP LEVELs" (upper)  (!! must be > 0) :
c			ratsn  < signal/noise ratio
c		   1 >  ratmu  > ellipse's axes ratio
c			angho > angle to horizon

c	    pow... - cosine's power in corresponding "QUAF"-function
c-----------------------------------------------------------------------
						do 100 i=1,3
						       j=i+3
					vp(i)=vmu1*uvec(i,kv)
					vp(j)=vmu2*uvec(j,kv)
100						continue

c------------------------------------------
c	  "LINEAR polarization" term
c---------------------------
		q1=QUALI (val,vmu1,vmu2,ratsn,ratmu,
     * 					powsn,powmu,
     * 					powsnx,powmux)

c------------------------------------------
c	  "HORIZONTAL" term
c---------------------------
			a=pi/2.-ANGLE(vert,1,0,vp,1,0)

				if (a.gt.angmax) then
		q2=0.
				else
			a=TAN(a)
			r=TAN(angho)
			x=ABS(a/r)
			x=x**powhox
		q2=QUAF(powho,x)
				end if

c---------------------------
	QUALOV=q1*q2
							RETURN
							END

c///////////////////////////////////////////////////////////////////////
c-----------------------------------------------------------------------
	real*4 function QUARAY (val,vmu1,vmu2,uvec,kv,
     *  				ratsn,ratmu,angve,
     *  				powsn,powmu,powve,
     *  				powsnx,powmux,powvex)
c-----------------------------------------------------------------------
		integer*4 kv
		real*4 uvec(6,kv)
		real*4 val,vmu1,vmu2
		real*4 ratsn,ratmu,angve,powsn,powmu,powve
		real*4 powsnx,powmux,powvex
			real*4 vert(6)
			real*4 accur,angmax
	    data accur /1.e-4/, angmax /1.5/
	    data vert /0.,0.,1.,0.,0.,0./
c-----------------------------------------------------------------------
c		RAYLEIGH WAVE (ellipticaly polarized) QUALITY FUNCTION
c------------------------------------------
c	    val  - max eigen value
c	    vmu1*uvec(1-3,kv)+i*vmu2*uvec(4-6,kv) - vector of polarization

c	    "STEP LEVELs" (upper)  (!! must be > 0) :
c			ratsn  < signal/noise ratio
c		   1 <  ratmu  > ellipse's axes ratio  >  1/ratmu  <  1
c			angve > angle to vertical

c	    pow... - cosine's power in corresponding "QUAF"-function
c-----------------------------------------------------------------------
c	  "ELLIPTICAL polarization" term
c---------------------------
		q1=QUAEL(val,ratsn,powsn,powsnx)

c------------------------------------------
c	  "AXES RATIO" term
c---------------------------
			r=ratmu-1./ratmu
			r=1./ABS(r)
			x=vmu1*vmu2
				if (x.lt.accur) then
		q2=0.
				else
			x=r*ABS(vmu1*vmu1-vmu2*vmu2)/x
			x=x**powmux
		q2=QUAF(powmu,x)
				end if

c------------------------------------------
c	  "VERTICAL" term
c---------------------------
			a=ABS(EPLANG (vert,1,uvec,kv, ier))

				if ((ier.eq.1).or.(a.gt.angmax)) th
     +en
		q3=0.
				else
			a=TAN(a)
			r=TAN(angve)
			x=ABS(a/r)
			x=x**powvex
		q3=QUAF(powve,x)
				end if

c---------------------------
	QUARAY=q1*q2*q3
							RETURN
							END
c///////////////////////////////////////////////////////////////////////
c-----------------------------------------------------------------------
	subroutine SPROD (vec1,k1,ic1,vec2,k2,ic2,  rre,rim)
c-----------------------------------------------------------------------
		integer*4 k1,k2,ic1,ic2
		real*4 vec1(6,k1),vec2(6,k2)
		real*4 rre,rim
c-----------------------------------------------------------------------
							p=1.
							q=1.
					  if (ic1.gt.0) p=-p
					  if (ic2.gt.0) q=-q
							r=p*q
			rre=0.
			rim=0.
				do 100 i=1,3
				       j=i+3
	rre=rre+  vec1(i,k1)*vec2(i,k2)+r*vec1(j,k1)*vec2(j,k2)
	rim=rim+p*vec1(j,k1)*vec2(i,k2)-q*vec1(i,k1)*vec2(j,k2)
100				continue
							RETURN
							END

c///////////////////////////////////////////////////////////////////////
c-----------------------------------------------------------------------
	subroutine TERPO (kt,kw,qua,vmu1,vmu2,uvec,nv,num,
     *  		   mmax,mt1,nw1,w,ktd,kwd,etalon,ip,
     *  		     			   qual,vm1,vm2
     +,uve,ier)
c-----------------------------------------------------------------------
		real*4 qua(nv),vmu1(nv),vmu2(nv),uvec(6,nv)
		integer*2 num(mmax,1)
		real*4 w(1)
		real*4 etalon(6)
		real*4 qual,vm1,vm2,uve(6)
			real*4 vr(6)
c-----------------------------------------------------------------------
c	    POLARIZATION PARAMETERS in"TERPO"lation
c		result in vm1,vm2,uve - normalized polarization vector
c		     ip = 0  - etalon not used
c			= 1  - "LOVE"-kind usage
c			= 2  - "RAYLEIGH"-kind usage
c					ier=0 - no result
c-----------------------------------------------------------------------
							icutn=32000
	ier=1
	qual=0.
		kv=num(kt,kw)
						if (kv.gt.0) then
	ier=0
						if (kv.le.icutn) then
     +
c					    ...........................
				qual=qua(kv)
				vm1=vmu1(kv)
				vm2=vmu2(kv)
					do 100 i=1,6
				uve(i)=uvec(i,kv)
100					continue

						else
c					    ...........................
			i1=(kt-mt1)/ktd*ktd+mt1
							i2=i1+ktd
c??					  if (i1.eq.kt) i2=i1
			j1=(kw-nw1)/kwd*kwd+nw1
							j2=j1+kwd
c??					  if (j1.eq.kw) j2=j1

c----------------------
	rmin=0.6
c----------------------
		r=0.
			do 101 i=1,6
		vr(i)=0.
101			continue

						dw=ABS(w(j2)-w(j1))
				do 102 i=i1,i2,ktd
				do 102 j=j1,j2,kwd
		kv=num(i,j)
			if ((kv.gt.0).and.(kv.le.icutn)) then
c		    .................
					p=1.-REAL(IABS(i-kt))/REAL(k
     +td)
					q=1.-ABS(w(j)-w(kw))/dw
					p=p*q
	r=r+p
	qual=qual+p*qua(kv)
		do 103 k=1,3
		       l=k+3
	vr(k)=vr(k)+p*vmu1(kv)*uvec(k,kv)
	vr(l)=vr(l)+p*vmu2(kv)*uvec(l,kv)
103		continue
c		    .................
			end if
102				continue

			if (r.lt.rmin) then
	ier=1
	qual=0.
			else
c		       .......................
	qual=qual/r
		do 104 i=1,6
	vr(i)=vr(i)/r
104		continue

	call CONORM (vr,1,    amp,pha,vm1,vm2,uve,1)

		if (ip.eq.1) then
	call CHO2 (etalon,uve,1,pha)
		else if (ip.eq.2) then
	call CHO4 (etalon,vm1,vm2,uve,1,pha)
		end if
c		       .......................
			end if
c					    ...........................
						end if
						end if
								RETURN
								END

c///////////////////////////////////////////////////////////////////////
c-----------------------------------------------------------------------
	subroutine TRAM (amp,mmax,m1,m2,nmax,n1,n2,k, amax)
c-----------------------------------------------------------------------
		integer*4 mmax,m1,m2,nmax,n1,n2,k
		real*4 amp(mmax,nmax,k)
		real*4 amax
c-----------------------------------------------------------------------
							accur=1.e-5
							cutn=100000.
				amax=0.
						do 100 j=n1,n2
						do 100 i=m1,m2
					r=amp(i,j,k)
				if ((r.lt.cutn).and.(r.gt.amax)) am
     +ax=r
100						continue

				if (amax.gt.accur) then
			do 101 j=n1,n2
			do 101 i=m1,m2
			    r=amp(i,j,k)
		if (r.lt.accur) then
	r=0.
		else if (r.lt.cutn) then
	r=99.+20.*ALOG10(r/amax)
		end if
	amp(i,j,k)=r
101			continue
				end if
								RETURN
								END

c///////////////////////////////////////////////////////////////////////
c-----------------------------------------------------------------------
	subroutine VPROD (vec1,k1,ic1,vec2,k2,ic2,  rvec,kr)
c-----------------------------------------------------------------------
		integer*4 k1,k2,ic1,ic2,kr
		real*4 vec1(6,k1),vec2(6,k2),rvec(6,kr)
c-----------------------------------------------------------------------
							p=1.
							q=1.
					  if (ic1.gt.0) p=-p
					  if (ic2.gt.0) q=-q
							r=p*q

	rvec(1,kr)=   vec1(2,k1)*vec2(3,k2)-vec1(3,k1)*vec2(2,k2
     +)
     *            -r*(vec1(5,k1)*vec2(6,k2)-vec1(6,k1)*vec2(5,k
     +2))
	rvec(2,kr)=   vec1(3,k1)*vec2(1,k2)-vec1(1,k1)*vec2(3,k2
     +)
     *            -r*(vec1(6,k1)*vec2(4,k2)-vec1(4,k1)*vec2(6,k
     +2))
	rvec(3,kr)=   vec1(1,k1)*vec2(2,k2)-vec1(2,k1)*vec2(1,k2
     +)
     *            -r*(vec1(4,k1)*vec2(5,k2)-vec1(5,k1)*vec2(4,k
     +2))
	rvec(4,kr)=p*(vec1(3,k1)*vec2(5,k2)-vec1(2,k1)*vec2(6,k2
     +))
     *            +q*(vec1(6,k1)*vec2(2,k2)-vec1(5,k1)*vec2(3,k
     +2))
	rvec(5,kr)=p*(vec1(1,k1)*vec2(6,k2)-vec1(3,k1)*vec2(4,k2
     +))
     *            +q*(vec1(4,k1)*vec2(3,k2)-vec1(6,k1)*vec2(1,k
     +2))
	rvec(6,kr)=p*(vec1(2,k1)*vec2(4,k2)-vec1(1,k1)*vec2(5,k2
     +))
     *  	  +q*(vec1(5,k1)*vec2(1,k2)-vec1(4,k1)*vec2(2,k2
     +))

							RETURN
							END

