#define STATION_LENGTH 6
#define CHANNEL_LENGTH 8
#define LT -1
#define EQ 0
#define GT 1

typedef char Station[STATION_LENGTH];
typedef char Channel[CHANNEL_LENGTH];
typedef double Time;

Station	*sta;
Channel	*chn;
Time	*tim;
int	*ind;

/*
 *  Comparison routine used by qsort to determine station-channel-time order
 */
static int sct_cmp(i1, i2)
int 	*i1, *i2;
{
  int result = 0;

  if (result = strncmp(sta[*i1], sta[*i2], STATION_LENGTH)) return(result);
  if (result = strncmp(chn[*i1], chn[*i2], CHANNEL_LENGTH)) return(result);
  if (tim[*i1] > tim[*i2]) return(GT);
  if (tim[*i1] < tim[*i2]) return(LT);
  return(EQ);
}

/*
 *  C-callable sct sorting routine
 */
void sct_sort(num_pts, station, channel, time, index)
int	num_pts;
Station	*station;
Channel	*channel;
Time	*time;
int	*index;
{
  int i;

  sta = station;
  chn = channel;
  tim = time;
  ind = index;

  for (i = 0; i < num_pts; i++) index[i] = i;	/* Set array indices */
  qsort(index, num_pts, sizeof(int), sct_cmp);
}


/*
 *  Fortan-callable sct sorting routine
 */
void sct_sort__(num_ptr, station, channel, time, index)
int	*num_ptr;
Station	*station;
Channel	*channel;
Time	*time;
int	*index;
{
  int i;

  sct_sort(*num_ptr, station, channel, time, index);
  for (i = 0; i < *num_ptr; i++) index[i]++;	/* Set Fortran style indices */
}

