#include "fmt4cmdw.h"	// our header
#include <ctype.h>
#include <unistd.h>
#include <sys/stat.h>
#include <stdlib.h>
#include <dirent.h>
#include <math.h>
#include <functional>
const char noNetLoc[] = "--";
const float Pi2 = 6.2831852; 
extern "C"{
int mday2doy(int yr, int mo, int da);
}
struct sta_Comp : public binary_function < Station *& , Station *&, bool> {
        bool operator()(Station *& x, Station *& y) { 
	  if(strcmp(x->itsNameStation,y->itsNameStation) > 0 )
	  return false; else return true; }
};

struct loc_Comp : public binary_function < Location *& , Location *&, bool> {
        bool operator()(Location *& x, Location *& y) { 
	  if(strcmp(x->itsNameLocation,y->itsNameLocation) > 0 )
	  return false; else return true; }
};


struct chan_Comp : public binary_function < Channel *& , Channel *&, bool> {
        bool operator()(Channel *& x, Channel *& y) { 
	  if(strcmp(x->itsNameChannel,y->itsNameChannel) > 0 )
	  return false; else return true; }
};
struct comp_Comp : public binary_function < Comp *& , Comp *&, bool> {
        bool operator()(Comp *& x, Comp *& y) { 
	  if(strcmp(x->itsNameComp,y->itsNameComp) > 0 )
	  return false; else return true; }
};

struct rec_Comp : public binary_function < Record *& , Record *&, bool> {
        bool operator()(Record *& x, Record *& y) { 
	  if(strcmp(x->itsNameOut,y->itsNameOut) > 0 )
	  return false; else return true; }
};



/*
   struct sta_Comp : public binary_function<double, double, bool> {
        bool operator()(double x, double y) { return fabs(x) < fabs(y); }
    };
*/
extern "C"{
int SaveOrigin (char *Origin_name, ORIG *origin,char *OutErr); 
int GetRecordInfo(ahhed *ah_header ,char *FileNameIn,char *OutErr);
}

void getOutName(ahhed   *ah,char **ah_name_out);

void cp2upper(char    *out, char  *in);
void rmRightZeroes(char *in );
int FindNetCode(char *str,char ** ahnet);
int FindLocationCode (char *str,char ** ahLoc);
float GetVang(char *str);
float GetHang(char *str);


float 
GetHang(char *str){
float hang;
char *ptr;
ptr = strstr(str,"azm=") + 4;
sscanf(ptr,"%f",&hang); 

return hang;
}
float 
GetVang(char *str){
float vang;
char *ptr;
ptr = strstr(str,"inc=") + 4; 
sscanf(ptr,"%f",&vang); vang += 90;
return vang;
}

int
 FindLocationCode(char *st,char ** ahLoc){
char *ptr;
char str[_MAX_FILE_NAME];
int i;
strcpy(str,st);
ptr = str;
for (i = 0; i < 8; i++)
if (( ptr = strchr(ptr,'.') ) == 0 ) return 1;
else ptr++;

if ( strchr(ptr,'.') == 0 ) return 1; else *strchr(ptr,'.') = '\0';
if (strlen(ptr) == 0) strcpy(*ahLoc,noNetLoc); else
strcpy(*ahLoc,ptr);
return 0;
}


int 
 FindNetCode(char *st,char ** ahnet){
char *ptr;
char str[_MAX_FILE_NAME];
int i;
strcpy(str,st);
ptr = str;
for (i = 0; i < 6; i++)
if (( ptr = strchr(ptr,'.') ) == 0 ) return 1;
else ptr++;
if ( strchr(ptr,'.') == 0 ) return 1; else *strchr(ptr,'.') = '\0';
strcpy(*ahnet,ptr);
return 0;
}
void 
getOutName(ahhed          *ah,char **ah_name_out)
 {
    char   wstr[24],zstr[24],name[_MAX_FILE_NAME];
    int jday1,j;
jday1 = mday2doy((int) ah->record.abstime.yr,
			(int) ah->record.abstime.mo,
			(int)ah->record.abstime.day);

strcpy(wstr,ah->station.code);

for (j = 0;j < (int) strlen(wstr);j++) if (wstr[j] == ' ') {wstr[j] = '\0';
break;}

strcpy(zstr,ah->station.chan);
for (j = 0;j < (int)strlen(zstr);j++) if (zstr[j] == ' ') {zstr[j] = '\0';
break;}

sprintf(name,"%4d.%3d.%2d.%2d.%5.2f.%s.%s",
ah->record.abstime.yr,
jday1,
ah->record.abstime.hr,
ah->record.abstime.mn,
ah->record.abstime.sec,
wstr,
zstr
);
for (j = 0;j < (int)strlen(name);j++) if (name[j] == ' ') name[j] = '0';
strcpy(*ah_name_out,name);
}


void
cp2upper(char           *out, char           *in)
{
    while ((*out++ = toupper(*in++)) != 0);
}

void rmRightZeroes(char *in ) {
int i = strlen(in) -1;
while ( i >=0  &&  in [i] == ' ') in[i--] = '\0';

}
int
Ah4DbCmdWindow::GetListOfAhRecords(char *PlaceDbase,char *OutErr) {
list<string>::iterator itr;


	if (!itsRecordList.empty() ) {
		for(itr=itsRecordList.begin();itr!=itsRecordList.end();itr++)
		(*itr).erase();
	itsRecordList.clear();
	}

 
   DIR              *dirp;
   struct dirent    *dp;
   struct stat       s_buf;
   char zstr[_MAX_FILE_NAME];

   int cnt = 0;

   if (stat(PlaceDbase, &s_buf) == -1 || !(s_buf.st_mode & S_IREAD))
{ sprintf(OutErr,"System error. '%s' Directory. \n    Try again or Quit\n",PlaceDbase) ;  return 1;   } 

if (s_buf.st_mode & S_IFDIR )    {
     if (!(dirp = opendir(PlaceDbase))) {
      sprintf (OutErr,"Error: Can't open %s Directory with Ah Bin Seis",PlaceDbase); 
                         return 1;}

  
    while  ( ( dp = readdir(dirp) ) )   
        if (strcmp(dp->d_name, ".") && strcmp(dp->d_name, "..")) {
        strcpy(zstr,dp->d_name);
        if (strrchr(zstr,'.') != 0) 
        if ( !strcmp(strrchr(zstr,'.')+1,"AH"))  
              {
      	        cnt++;

		itsRecordList.push_back(dp->d_name);

		}              
          }
     closedir(dirp);
      }
if (cnt == 0) {

sprintf (OutErr,"Error: Not found any file with  Ah Bin Seis \nError: in the Directory '%s'\n",PlaceDbase); 
                         return 1; }



	if (chdir(PlaceDbase) == -1) {

            sprintf(OutErr,"Can't change directory %s",PlaceDbase);
            return 1;
            }

if (GetListOfStationChannel(OutErr)){
return 1;
}

return 0;

}


int
Ah4DbCmdWindow::MakeJustDbase(char *PlaceDbase,char *OutErr) {

char sysStr[128],backSlash = 0x5c;

int returnCode = DirectoryIsEmpty(OutErr,origin.PlaceDirName,"");

    if  ( returnCode == -1)  return 1;

 if  ( returnCode > 0) { 
      	    char  YNnote[2048];
   	    vYNReplyDialog ynd(this);   // make an instance
            int ans;
            sprintf(YNnote," Directory '%s' is not empty. \n Do you want to delete alit's entries?", 
            origin.PlaceDirName);
                     
           if ( (ans = ynd.AskYN(YNnote)) == 1) { // OK
           if (chdir(origin.PlaceDirName) != 0)	
      {
         sprintf(OutErr, "Error: Unable to chdir to\n  %s",origin.PlaceDirName);
	return 1;
      }

	sprintf(sysStr,"%crm -f -r *",backSlash);
	system(sysStr);


	} // O.K.

           if ( ans  == -1)  // Cancel
        {
          sprintf(OutErr," Place Directory %s\n is not empty.\n Choose other directory",origin.PlaceDirName);
          return -1;

      } // Cancel



      

 } //  returnCode > 0




int i = 1;


	if (chdir(PlaceDbase) == -1) {  	   
            sprintf(OutErr,"Can't change directory %s",PlaceDbase);
            return 1;
}



if ( chdir("wf") == -1 ) 
          if(mkdir("wf", 0777) == -1) {
          sprintf(OutErr, "System Error: Cannot create directory\n   %s/wf", 
          "wf");
          return 1;
          } 


	if (chdir(PlaceDbase) == -1) {  	   
            sprintf(OutErr,"Can't change directory %s",PlaceDbase);
            return 1;
}




char AhBinFileName[2048];
char OutFileName[_MAX_FILE_NAME];

char database_name[_MAX_FILE_NAME];
char sysString[3048];
    char*             absflag;
    vNoticeDialog note(this);

    absflag = strrchr(origin.ScriptName, '/');
    strcpy( database_name, absflag+1); 
   *strrchr(database_name,'.') = '\0';

fprintf(stderr,"\n\nDbase Root Name: %s\n",database_name);
strcpy(sysString,database_name); strcat(sysString,".origin");
if (SaveOrigin (sysString, &origin,OutErr) ){
            
            return 1;

}

// Create Dbftan :>


sprintf(sysString,"printf '# Ftan program script \n' > Gftan");
        system(sysString);
if (origin.OutDtValue == 0) 
sprintf(sysString,"printf 'gftan %s_l flt %s %s\n' >> Gftan", database_name,database_name,database_name); 
else 
sprintf(sysString,"printf 'gftan %s flt %s %s\n' >> Gftan", database_name,database_name,database_name);
        system(sysString);

sprintf(sysString,"chmod +x Gftan");
        system(sysString);



fprintf(stderr,"Ah Bin to Dbase process :>  \n\n");

 list <Station *>::iterator itrStation;
i = 0;

	if (!itsStationList.empty() )
	for(itrStation=itsStationList.begin();
	itrStation!=itsStationList.end();
	itrStation++)  {

              if ((*itrStation)->GetRemDefault() == 1 ||
		  (*itrStation)->GetMarkUser() == 1) continue;

list<Location *> pListLocation = (*itrStation)->GetLocationList();    
list<Location *>::iterator itrLocation;



            		
	if (!pListLocation.empty() )
	for(itrLocation=pListLocation.begin();
	itrLocation!=pListLocation.end();
	itrLocation++) {

              if ((*itrLocation)->GetRemDefault() == 1 ||
		  (*itrLocation)->GetMarkUser() == 1) continue;

		list<Channel *> pListChannel = 
		(*itrLocation)->GetChannelList();    
		list<Channel *>::iterator itrChannel;

		if (!pListChannel.empty() )
		for(itrChannel=pListChannel.begin();
		itrChannel!=pListChannel.end();
		itrChannel++) {

              if ((*itrChannel)->GetRemDefault() == 1 ||
		  (*itrChannel)->GetMarkUser() == 1) continue;

			list<Comp *> pListComp = 
			(*itrChannel)->GetCompList();    
			list<Comp *>::iterator itrComp;

			if (!pListComp.empty() )
			for(itrComp=pListComp.begin();
			itrComp!=pListComp.end();
			itrComp++) {
              if ((*itrComp)->GetRemDefault() == 1 ||
		  (*itrComp)->GetMarkUser() == 1) continue;

			list<Record *> pListRecord = 
			(*itrComp)->GetRecordList();    
			list<Record *>::iterator itrRecord;

			if (!pListRecord.empty() )
			for(itrRecord=pListRecord.begin();
			itrRecord!=pListRecord.end();
			itrRecord++) {

//strcpy(AhBinFileName,PlaceDbase);
if (origin.InputDataType == 0) 
strcpy(AhBinFileName,"wfAh/");
else {
strcpy(AhBinFileName,origin.AhBinDirName);
strcat(AhBinFileName,"/");
}

strcat(AhBinFileName,(*itrRecord)->GetNameFile());

strcpy(OutFileName,(*itrRecord)->GetNameOut());




sprintf(sysString,"fmtAh2Db  %s %s %s %s%s %7.2f %7.2f",database_name , AhBinFileName,OutFileName,(*itrChannel)->GetNameChannel(),(*itrComp)->GetNameComp(),(*itrComp)->GetHang(),
(*itrComp)->GetVang());
    system(sysString);
/*
fprintf(stderr,"fmtAh2Db  %s %s %s %s %7.2f %7.2f",database_name , AhBinFileName,OutFileName,(*itrComp)->GetNameComp(),(*itrComp)->GetHang(),
(*itrComp)->GetVang());
*/
			} //Rec
                 } //Comp
	    } // Chan
       }// Loc
}// Sta



return 0;
}
/*
int 
DirectoryIsEmpty(char *OutErr,char *sourceDir,char *fileMask)
{

 DIR              *dirp;
   struct dirent    *dp;
   struct stat       s_buf;
   int cnt = 0;
   int lenFileMask = strlen(fileMask);
   
   char *ptr = 0;
   if (stat(sourceDir, &s_buf) == -1 || !(s_buf.st_mode & S_IREAD))
{ sprintf(OutErr,"System error. '%s' Directory. \n    Try again or Quit\n",sourceDir) ;  return -1;   } 

if (s_buf.st_mode & S_IFDIR )    {

     if (!(dirp = opendir(sourceDir))) {
      sprintf (OutErr,"Error: Can't open %s Directory ",sourceDir); 
                         return -1;}

  
    while  ( (dp = readdir(dirp) ) )   
        if (strcmp(dp->d_name, ".") && strcmp(dp->d_name, "..")) { 
          if (lenFileMask > 0) {
             ptr = dp->d_name + strlen(dp->d_name) - lenFileMask;
		if( strncmp(ptr,fileMask,lenFileMask) == 0 ) cnt++;
            } else cnt++;
              
    
            
         }
closedir(dirp);
}

return cnt;
}
*/
///////////////////////////////////////////////////////////////////////
int 
Ah4DbCmdWindow::SeedToAh(char *OutErr){
        vNoticeDialog note(this);
	char str[_MAX_FILE_NAME];
char sysStr[64],backSlash = 0x5c;
int returnCode = DirectoryIsEmpty(OutErr,origin.WorkDirName,"");

    if  ( returnCode == -1)  return 1;

 if  ( returnCode > 0) { 
      	    char  YNnote[2048];
   	    vYNReplyDialog ynd(this);   // make an instance
            int ans;
            sprintf(YNnote," Directory '%s' is not empty. \n Do you want to delete all it's entries?", 
            origin.WorkDirName);
                     
           if ( (ans = ynd.AskYN(YNnote)) == 1) { // OK
           if (chdir(origin.WorkDirName) != 0)	
      {
         sprintf(OutErr, "Error: Unable to chdir to\n  %s",origin.WorkDirName);
	return 1;
      }

	sprintf(sysStr,"%crm -f -r *",backSlash);
	system(sysStr);


	} else {
          sprintf(OutErr," Working Directory %s\n must be empty.\n Choose other directory",origin.WorkDirName);
         return 1;

      }



      

 } //  returnCode > 0


    returnCode = DirectoryIsEmpty(OutErr,origin.AhBinDirName,".seed");
    if  ( returnCode == -1) {
	         note.Notice(OutErr); return 1;

}
   if  ( returnCode == 0 ) {

                   sprintf(OutErr,"Not Find Seed Vol's(*.seed) in\n %s\nChoose other directory",origin.AhBinDirName); 
         return 1;


}


	if (chdir(origin.WorkDirName) == -1) {  	   
            sprintf(OutErr,"Can't change directory %s",origin.WorkDirName);
            return 1;
}

 
          if(mkdir("wfAh", 0777) == -1) {
          sprintf(OutErr, "System Error: Cannot create directory\n   %s/wfAh", 
          origin.WorkDirName);
          return 1;
          } 

	if (chdir("wfAh") == -1) {  	   
            sprintf(OutErr,"Can't change directory %s",origin.WorkDirName);
            return 1;
}


	list <string> SeedVolList;
	list<string>::iterator itr;
  DIR              *dirp;
   struct dirent    *dp;
   struct stat       s_buf;
   char zstr[_MAX_FILE_NAME];

   int cnt = 0;

   if (stat(origin.AhBinDirName, &s_buf) == -1 || !(s_buf.st_mode & S_IREAD))
{ sprintf(OutErr,"System error. '%s' Directory. \n    Try again or Quit\n",origin.AhBinDirName) ;  return 1;   } 

if (s_buf.st_mode & S_IFDIR )    {
     if (!(dirp = opendir(origin.AhBinDirName))) {
      sprintf (OutErr,"Error: Can't open %s Directory with Seed Vol's",origin.AhBinDirName); 
                         return 1;}

  
    while  (  (dp = readdir(dirp) ) )   
        if (strcmp(dp->d_name, ".") && strcmp(dp->d_name, "..")) {
        strcpy(zstr,dp->d_name);
        if (strrchr(zstr,'.') != 0) 
        if ( !strcmp(strrchr(zstr,'.')+1,"seed"))  
              {
      	        cnt++;

		SeedVolList.push_back(dp->d_name);

		}              
          }
     closedir(dirp);
      }
if (cnt == 0) {

sprintf (OutErr,"Error: Not found any file with Seed Vol's \nError: in the Directory '%s'",origin.AhBinDirName); 
                         return 1; }

SeedVolList.sort();


int i = 0;



char *st;
	st = getenv("FMT");

if(st == NULL)			{
	sprintf (OutErr,"Error: Not found FMT enviroment"); 
                         return 1;
				}

FILE *in,*out;
sprintf(str,"%s/bin/fmtRdseed.initial",st);
static int indFirst;
	for(itr=SeedVolList.begin();itr!=SeedVolList.end();itr++) {
	fprintf(stderr,"Vol: %4d  '%s'\n",i++,(*itr).c_str());
                if((in = fopen(str,"r")) == NULL) { 
                   
                sprintf(OutErr,"Fatal Error: Cannot open file \n'%s'",str);   
                               return 1;             
                          }
 
                if((out = fopen("@@@Seed.ini","w")) == NULL) { 
                   
                sprintf(OutErr,"Fatal Error: Cannot open file \n'%s'",str);   
                               return 1;             
                          } 


 indFirst = 0;
char line[256];int errno = 0;
 while (!feof(in)) {
     if ( fgets(line,256,in) == NULL)  {

	    	if( ferror( in ) )      {   
	        sprintf(OutErr, "Fatal Error:  Reading error: %s\n",strerror(errno) );
		return 1;
				} 
		}
                else     {

   if (line[0] != '#') {
      if (indFirst == 1) {
            fprintf(out,"%s",strrchr(line,':') + 1);
      }

      if (indFirst == 0) {
          fprintf(out,"%s/%s\n",origin.AhBinDirName,(*itr).c_str());
          indFirst = 1;
      }

  }
                         } //else

         } // while


fclose(in);
fclose(out);

	sprintf(sysStr,"rdseed < @@@Seed.ini");
	system(sysStr);
fprintf(stderr,"\n\n");
} // itr

                     	
return 0;
}

int
Ah4DbCmdWindow::GetListOfStationChannel(char *OutErr){
 vNoticeDialog note(this);


    ahhed           ah_header;
char *FileNameOut = new char [_MAX_FILE_NAME];

 list <Station *>::iterator itrStation;
	if (!itsStationList.empty() ) {
	for(itrStation=itsStationList.begin();
	itrStation!=itsStationList.end();
	itrStation++)  delete (*itrStation);
	itsStationList.clear();
	}



list<string>::iterator itr;
	for(itr=itsRecordList.begin();itr!=itsRecordList.end();itr++) {

	if (GetRecordInfo(&ah_header,(char *) (*itr).c_str(),OutErr)){
	 note.Notice(OutErr);
         continue;
	} 

        getOutName(&ah_header,&FileNameOut);

	if
(CreateStructureInfo(&ah_header,(char *)(*itr).c_str(),FileNameOut,OutErr)){
	 note.Notice(OutErr);          continue;
	} 





}
	delete [] FileNameOut;
// sort itsStationList

SortStructure();
RemoveDefaultStructureItems();
	

return 0;
}

int 
Ah4DbCmdWindow::CreateStructureInfo(ahhed *ahdr,char *FileNameIn,
		    char *FileNameOut,char *OutErr){
Station * pStation;
char searchStrList[24], searchStrIn[24];
 list <Station *>::iterator itrStation;
 list <Station *>::iterator itrStationEnd;
 bool indNewStation = true;
    char            ahcode[CODESIZE];

    char            *ahnet = new char [CHANSIZE];

    cp2upper(ahcode, ahdr->station.code);
    rmRightZeroes(ahcode);
// XXXXXXXXXXXXXXXXX
/*
if (origin.InputDataType == 0) {

        if ( FindNetCode (FileNameIn,&ahnet)  ) {
        sprintf(OutErr,"Not standart Seed File Name '%s'",FileNameIn);
        delete [] ahnet;
        return 1;
         }
  

} else strcpy(ahnet,noNetLoc);
*/
       if ( FindNetCode (FileNameIn,&ahnet)  ) strcpy(ahnet,noNetLoc);

sprintf(searchStrIn,"%s:%s",ahcode,ahnet);



	if (!itsStationList.empty() )
	for(itrStation=itsStationList.begin();
	itrStation!=itsStationList.end();
	itrStation++) {

sprintf(searchStrList,"%s:%s",(*itrStation)->GetNameStation(),(*itrStation)->GetNameNet());



if (strlen(searchStrList) == strlen(searchStrIn))
if (strncmp(searchStrList, searchStrIn,strlen(searchStrList)) == 0)
	{
         indNewStation = false;

       	    if (AddLocationList(itrStation,
            ahdr,FileNameIn,FileNameOut,OutErr)){
            return 1;
	    } 
	 }

}

if (indNewStation == true) {
pStation = new Station(ahcode  , ahnet );
itsStationList.push_back(pStation);

itrStationEnd = itsStationList.end();
itrStationEnd--;

       	if (AddLocationList(itrStationEnd,
            ahdr,FileNameIn,FileNameOut,OutErr)){
            return 1;
	} 

	
}


        delete [] ahnet;

return 0;
}
int 
Ah4DbCmdWindow::AddLocationList( list <Station *>::iterator itrStation, 
ahhed *ahdr,char * FileNameIn,char *FileNameOut,char *OutErr) {
bool indNewLocation = true;
char *ahLoc = new char[8];
Location * pLocation;

// XXXXXXXXXXXXXXXXX
/*
if (origin.InputDataType == 0) {

        if ( FindLocationCode (FileNameIn,&ahLoc)  ) {
        sprintf(OutErr,"Not standart Seed File Name '%s'",FileNameIn);
        delete [] ahLoc;
        return 1;
         }
  

} else strcpy(ahLoc,noNetLoc);
*/
       if ( FindLocationCode (FileNameIn,&ahLoc)  ) strcpy(ahLoc,noNetLoc);

   list<Location *> pLocationList =    (*itrStation)->GetLocationList();
   list<Location *> pLocationListCur;

   list<Location *>::iterator itrLocation;
   list<Location *>::iterator itrLocationEnd;
        if (!pLocationList.empty() )
	for(itrLocation=pLocationList.begin();
	itrLocation!=pLocationList.end();
		itrLocation++) {
if (strlen(ahLoc) == strlen((*itrLocation)->GetNameLocation()))
		if (strncmp(ahLoc, 
		(*itrLocation)->GetNameLocation(),strlen(ahLoc)) == 0) {
		indNewLocation = false;
       			if (AddChannelList(itrLocation,
          		ahdr,FileNameIn,FileNameOut,OutErr)){
            		return 1;
	        	} 


		 }
	}

		if (indNewLocation == true) {
		pLocation = new Location(ahLoc);
		(*itrStation)->GetLocationList().push_back(pLocation);
pLocationListCur =  (*itrStation)->GetLocationList();
itrLocationEnd = pLocationListCur.end();
itrLocationEnd--;

       			if (AddChannelList(itrLocationEnd,
          		ahdr,FileNameIn,FileNameOut,OutErr)){
            		return 1;
	        	} 


		}


        delete [] ahLoc;

return 0;
}





int 
Ah4DbCmdWindow::AddChannelList( list <Location *>::iterator itrLocation,
ahhed *ahdr,char * FileNameIn,char *FileNameOut,char *OutErr) {

bool indNewChannel = true;
Channel * pChannel;

     char            ahchan[CHANSIZE];

     cp2upper(ahchan, ahdr->station.chan);
     rmRightZeroes(ahchan);
     ahchan[strlen(ahchan) - 1] = '\0';
   list<Channel *> pChannelList =    (*itrLocation)->GetChannelList();
   list<Channel *> pChannelListCur;	
   list<Channel *>::iterator itrChannel;
   list<Channel *>::iterator itrChannelEnd;

        if (!pChannelList.empty() )
	for(itrChannel=pChannelList.begin();
	itrChannel!=pChannelList.end();
		itrChannel++) {
if (strlen(ahchan) == strlen((*itrChannel)->GetNameChannel()))
		if (strncmp(ahchan, 
		(*itrChannel)->GetNameChannel(),strlen(ahchan)) == 0) {
		indNewChannel = false;


       			if (AddCompList(itrChannel,
          		ahdr,FileNameIn,FileNameOut,OutErr)){
            		return 1;
	        	} 


		 }
         }

		if (indNewChannel == true) {
		pChannel = new Channel(ahchan);
		(*itrLocation)->GetChannelList().push_back(pChannel);
pChannelListCur =    (*itrLocation)->GetChannelList();
itrChannelEnd = pChannelListCur.end();
itrChannelEnd--;

       			if (AddCompList(itrChannelEnd,
          		ahdr,FileNameIn,FileNameOut,OutErr)){
            		return 1;
	        	} 

		}





return 0;
}

int 
Ah4DbCmdWindow::AddCompList( list <Channel *>::iterator itrChannel,
ahhed *ahdr,char * FileNameIn,char *FileNameOut,char *OutErr) {
bool indNewComp = true;
Comp * pComp;

     char      ahComp[CHANSIZE];

     cp2upper(ahComp, ahdr->station.chan);
     rmRightZeroes(ahComp);
     ahComp[0] = ahComp[strlen(ahComp) - 1];ahComp[1] = '\0';
   list<Comp *> pCompList =    (*itrChannel)->GetCompList();
   list<Comp *> pCompListCur;	
   list<Comp *>::iterator itrComp;
   list<Comp *>::iterator itrCompEnd;

        if (!pCompList.empty() )
	for(itrComp=pCompList.begin();
	itrComp!=pCompList.end();
		itrComp++) {
if (strlen(ahComp) == strlen((*itrComp)->GetNameComp()))

		if (strncmp(ahComp, 
		(*itrComp)->GetNameComp(),strlen(ahComp)) == 0) {
		indNewComp = false;


       			if (AddRecordList(itrComp,
          		ahdr,FileNameIn,FileNameOut,OutErr)){
            		return 1;
	        	} 


		 }
         }

		if (indNewComp == true) {
		pComp = new Comp(ahComp,&ahdr->record);
		(*itrChannel)->GetCompList().push_back(pComp);

pCompListCur =    (*itrChannel)->GetCompList();
itrCompEnd = pCompListCur.end();
itrCompEnd--;

       			if (AddRecordList(itrCompEnd,
          		ahdr,FileNameIn,FileNameOut,OutErr)){

            		return 1;
	        	} 


		}





return 0;



}
int 
Ah4DbCmdWindow::AddRecordList( list <Comp *>::iterator itrComp,
ahhed *ahdr,char * FileNameIn,char *FileNameOut,char *OutErr)   {

Record * pRecord;

   list<Record *> pRecordList =    (*itrComp)->GetRecordList();
		pRecord = new Record(FileNameIn,FileNameOut,&ahdr->record);
		(*itrComp)->GetRecordList().push_back(pRecord);


return 0;
}
void Ah4DbCmdWindow::SortStructure(){

list <Station *>::iterator itrStation;

	list<Location *>::iterator itrLocation;
		list<Channel *>::iterator itrChannel;
			list<Comp *>::iterator itrComp;
				
	list<Location *> pListLocation;
		list<Channel *> pListChannel;
			list<Comp *> pListComp;
				

itsStationList.sort(sta_Comp());



	if (!itsStationList.empty() )
	for(itrStation=itsStationList.begin();
	itrStation!=itsStationList.end();
	itrStation++)  {

	(*itrStation)->GetLocationList().sort(loc_Comp());
         pListLocation = (*itrStation)->GetLocationList();


	if (!pListLocation.empty() )
	for(itrLocation=pListLocation.begin();
	itrLocation!=pListLocation.end();
	itrLocation++) {

 
      		(*itrLocation)->GetChannelList().sort(chan_Comp());

		pListChannel = (*itrLocation)->GetChannelList();


		if (!pListChannel.empty() )
		for(itrChannel=pListChannel.begin();
		itrChannel!=pListChannel.end();
		itrChannel++) {

      		(*itrChannel)->GetCompList().sort(comp_Comp());

		pListComp = (*itrChannel)->GetCompList();

			if (!pListComp.empty() )
			for(itrComp=pListComp.begin();
			itrComp!=pListComp.end();
			itrComp++) 

      			(*itrComp)->GetRecordList().sort(rec_Comp());


		}



       }



    }
}
 

void Ah4DbCmdWindow::PrintStructure( FILE *out) {

fprintf (out,"# Dbase may contain unique station name and only one location acceptable,\n");
fprintf (out,"# other location must be excluded\n");
fprintf (out,"# Error  appears when  missing vertical component - \n");
fprintf (out,"#                              channel will be excluded, \n");

fprintf (out,"#                      missing one of horizontal components - \n");
fprintf (out,"#                              both horizontal components will be excluded \n");

fprintf (out,"#                      orientation components are not correct\n\n");



fprintf (out,"# acceptable - acceptable for including into the Dbase\n");
fprintf (out,"# error        - not acceptable, see Error List of Data\n");
fprintf (out,"# included     - will be included into the Dbase\n");
fprintf (out,"# excluded     - will be excluded into the Dbase\n\n");



list <Station *>::iterator itrStation;

int i = 0;
	if (!itsStationList.empty() )
	for(itrStation=itsStationList.begin();
	itrStation!=itsStationList.end();
	itrStation++)  {

list<Location *> pListLocation = (*itrStation)->GetLocationList();    
list<Location *>::iterator itrLocation;
int isize = pListLocation.size();
    fprintf (out,"Station # %4d:> '%s:%s' (%d) :",i++ + 1,
    (*itrStation)->GetNameStation(),
    (*itrStation)->GetNameNet(),isize);
              if ((*itrStation)->GetRemDefault() == 0)
            		fprintf (out,"(acceptable)   "); else 
			fprintf (out,"(Error     )   ");

	if (!pListLocation.empty() )
	for(itrLocation=pListLocation.begin();
	itrLocation!=pListLocation.end();
	itrLocation++) {
        fprintf (out,"\n  '%s':> ",(*itrLocation)->GetNameLocation());

              if ((*itrLocation)->GetRemDefault() == 0)
            		fprintf (out,"(acceptable)   "); else 
			fprintf (out,"(error     )   ");
	      if ( (*itrLocation)->GetMarkDefault() == 0 )
            		fprintf (out,"(included  )   \n"); else 
			fprintf (out,"(excluded  )   \n");

		list<Channel *> pListChannel = 
		(*itrLocation)->GetChannelList();    
		list<Channel *>::iterator itrChannel;

		if (!pListChannel.empty() )
		for(itrChannel=pListChannel.begin();
		itrChannel!=pListChannel.end();
		itrChannel++) {
                fprintf (out,"      '%s': ",
		(*itrChannel)->GetNameChannel());
              if ((*itrChannel)->GetRemDefault() == 0)
            		fprintf (out,"(acceptable)   \n"); else 
			fprintf (out,"(error     )   \n");

			list<Comp *> pListComp = 
			(*itrChannel)->GetCompList();    
			list<Comp *>::iterator itrComp;

			if (!pListComp.empty() )
			for(itrComp=pListComp.begin();
			itrComp!=pListComp.end();
			itrComp++) {
            		fprintf (out,"         '%s':",
			(*itrComp)->GetNameComp());
              if ((*itrComp)->GetRemDefault() == 0)
            		fprintf (out,"(acceptable)   "); else 
			fprintf (out,"(error )   ");

////////////////////////////////////////////////////////////////////////////
 fprintf(out,"('%s')\n",(*itrComp)->GetRec_info()->rcomment);

			list<Record *> pListRecord = 
			(*itrComp)->GetRecordList();    
			list<Record *>::iterator itrRecord;

			if (!pListRecord.empty() )
			for(itrRecord=pListRecord.begin();
			itrRecord!=pListRecord.end();
			itrRecord++) {
            		fprintf (out,"           '%s'<-> %s\n",
			(*itrRecord)->GetNameFile(),
			(*itrRecord)->GetNameOut());
			}

////////////////////////////////////////////////////////////////////////////
}

fprintf (out,"\n");


		}
fprintf (out,"\n");
       }


fprintf (out,"\n");

    }





}
void 
Ah4DbCmdWindow::RemoveDefaultStructureItems(){

 char str[_MAX_FILE_NAME];
 char name[_MAX_FILE_NAME];
strcpy(name,origin.ScriptName);
 FILE *out;
   *strrchr(strrchr(name,'/'),'.') = '\0';

    strcat (name,".err_log");


  if ((out = fopen(name, "w")) == NULL)
	   {
	    (void) fprintf(stderr, "\tFatal Error (Write err_log file):  ");
	    (void) fprintf(stderr,
			   "Fatal Error: OutPut file %s is not available for writing.\n",
			   name);


	  }


			struct tm timet;
			struct tm *ttm;
                	long itime;
		itime = time(NULL);
		ttm = &timet;
		ttm = localtime(&itime);


fprintf(out,"%s\n# Date:    %s\n","# Ah to Dbase Transfer err_log wrote by Fmt4Db program",strchr(asctime(ttm),' '));
fprintf(out,"\n     ----  Error List of Data  ----- \n\n");
fprintf(out,"# Sta - Station, \n# Net - Seismic network ( '--'  - no network ), \n# Loc - Location ( instrument position, '--' - no location),\n# Chan - Channel, \n# Comp - Component (1,2,3 - non standart orientation components)\n\n");




fprintf(out,"Sta:Net Loc Chan Comp\n\n");

float hangZ = 0.0, hangE = 90.0,hangN = 0.0;
float vangZ = 0.0, vangE = 90.0,vangN = 90.0;

list <Station *>::iterator itrStation;


	if (!itsStationList.empty() )
	for(itrStation=itsStationList.begin();
	itrStation!=itsStationList.end();
	itrStation++)  {

list<Location *> pListLocation = (*itrStation)->GetLocationList();    
list<Location *>::iterator itrLocation;

bool indAllStation = false;              
	if (!pListLocation.empty() )
	for(itrLocation=pListLocation.begin();
	itrLocation!=pListLocation.end();
	itrLocation++) {
      

		list<Channel *> pListChannel = 
		(*itrLocation)->GetChannelList();    
		list<Channel *>::iterator itrChannel;
	bool indAllChannel = false;

		if (!pListChannel.empty() )
		for(itrChannel=pListChannel.begin();
		itrChannel!=pListChannel.end();
		itrChannel++) {

			list<Comp *> pListComp = 
			(*itrChannel)->GetCompList();    
			list<Comp *>::iterator itrComp;

	list<Comp *>::iterator itrZComp=pListComp.end();
	list<Comp *>::iterator itrEComp=pListComp.end();
	list<Comp *>::iterator itrNComp=pListComp.end();
	list<Comp *>::iterator itr1Comp=pListComp.end();
	list<Comp *>::iterator itr2Comp=pListComp.end();
	list<Comp *>::iterator itr3Comp=pListComp.end();

		int indZcompOrient  = 0;
		int indEcompOrient  = 0;
		int indNcompOrient  = 0;
		int ind1compOrient  = 0;
		int ind2compOrient  = 0;
		int ind3compOrient  = 0;
float dt;

			if (!pListComp.empty() )
			for(itrComp=pListComp.begin();
			itrComp!=pListComp.end();
			itrComp++) {

			strcpy(str,(*itrComp)->GetRec_info()->rcomment);

			dt = (*itrComp)->GetRec_info()->delta;
                         
//////////////////  Comp Z  ////////////////////////////////////////
        		if ((*itrComp)->GetNameComp()[0] == 'Z') {


if (strstr(str,"Comp") == 0 ) {
        hangZ = 0.0;       vangZ = 0.0;
} else {
hangZ = GetHang(str); vangZ = GetVang(str);
}
(*itrComp)->GetHang() = hangZ;
(*itrComp)->GetVang() = vangZ;
			itrZComp = itrComp;

if ( !(fabs(vangZ - (float)180.0) < (float) 1.0e-3   ||  
fabs(vangZ) < (float) 1.0e-3  ) ) indZcompOrient = 1;

if ( !( fabs(hangZ) < (float) 1.0e-3 ) ) indZcompOrient = 1;

			}

//////////////////  Comp E  ////////////////////////////////////////

			if ((*itrComp)->GetNameComp()[0] == 'E' ) {
if (strstr(str,"Comp") == 0 ) {
	    hangE = 90.0;	    vangE = 90.0;

} else {
hangE = GetHang(str); vangE = GetVang(str);
} 
(*itrComp)->GetHang() = hangE;
(*itrComp)->GetVang() = vangE;
			itrEComp = itrComp;
if ( !(fabs(vangE - (float)90.0) < (float) 1.0e-3 )) indEcompOrient = 1;

			}

//////////////////  Comp N  ////////////////////////////////////////

			if ((*itrComp)->GetNameComp()[0] == 'N'){
if (strstr(str,"Comp") == 0 ) {
	    hangN = 0.0;	    vangN = 90.0;
} else {
hangN = GetHang(str); vangN = GetVang(str);
} 
(*itrComp)->GetHang() = hangN;
(*itrComp)->GetVang() = vangN;
			itrNComp = itrComp;
if ( !(fabs(vangN - (float)90.0) < (float) 1.0e-3 )) indNcompOrient = 1;
			}

//////////////////  Comp 3  ////////////////////////////////////////
        		if ((*itrComp)->GetNameComp()[0] == '3') {
if (strstr(str,"Comp") == 0 ) {
        hangZ = 0.0;       vangZ = 0.0;
} else {
hangZ = GetHang(str); vangZ = GetVang(str);
}
(*itrComp)->GetHang() = hangZ;
(*itrComp)->GetVang() = vangZ;
			itr3Comp = itrComp;

if ( !(fabs(vangZ - (float)180.0) < (float) 1.0e-3   ||  
fabs(vangZ) < (float) 1.0e-3  ) ) ind3compOrient = 1;

if ( !( fabs(hangZ) < (float) 1.0e-3 ) ) ind3compOrient = 1;

			}

//////////////////  Comp 1 (N)  ////////////////////////////////////////
			  if ((*itrComp)->GetNameComp()[0] == '1') {
if (strstr(str,"Comp") == 0 ) {
	    hangN = 0.0;	    vangN = 90.0;
} else {
hangN = GetHang(str); vangN = GetVang(str);
} 
(*itrComp)->GetHang() = hangN;
(*itrComp)->GetVang() = vangN;
			itr1Comp = itrComp;
if ( !(fabs(vangN - (float)90.0) < (float) 1.0e-3 ) ) ind1compOrient = 1;

		          }

//////////////////  Comp 2 (E) ////////////////////////////////////////

			  if ((*itrComp)->GetNameComp()[0] == '2') {
if (strstr(str,"Comp") == 0 ) {
	 	hangE = 90.0;	    vangE = 90.0;
} else {
hangE = GetHang(str); vangE = GetVang(str);
}
(*itrComp)->GetHang() = hangE;
(*itrComp)->GetVang() = vangE;
			itr2Comp = itrComp;
if ( !(fabs(vangE - (float)90.0) < (float) 1.0e-3 )) ind2compOrient = 1;

			  }




		} // itrComp


		if(itrZComp == pListComp.end() && itr3Comp == pListComp.end()) {
(*itrChannel)->GetRemDefault() = 1; 
strcpy(	(*itrChannel)->GetErrComent(),"Err: No Z component ");
fprintf(out,"%s:%s %s %s    :>\n",
(*itrStation)->GetNameStation(),
(*itrStation)->GetNameNet(),
(*itrLocation)->GetNameLocation(),
(*itrChannel)->GetNameChannel());
fprintf(out,"                     No Z component\n");
			continue;
}


if (itrZComp != pListComp.end() && indZcompOrient == 1) {
(*itrChannel)->GetRemDefault() = 1; 
strcpy(	(*itrChannel)->GetErrComent(),"Err: 'Z' component is not vertical ");
fprintf(out,"%s:%s %s %s  %s :>\n",
(*itrStation)->GetNameStation(),
(*itrStation)->GetNameNet(),
(*itrLocation)->GetNameLocation(),
(*itrChannel)->GetNameChannel(),(*itrZComp)->GetNameComp());
fprintf(out,"                    'Z' component is not vertical\n");
			continue;
}

if (itr3Comp != pListComp.end() && ind3compOrient == 1) {
(*itrChannel)->GetRemDefault() = 1; 
strcpy(	(*itrChannel)->GetErrComent(),"Err: 'Z(3)' component is not vertical ");
fprintf(out,"%s:%s %s %s  %s :>\n",
(*itrStation)->GetNameStation(),
(*itrStation)->GetNameNet(),
(*itrLocation)->GetNameLocation(),
(*itrChannel)->GetNameChannel(),(*itr3Comp)->GetNameComp());
fprintf(out,"                     'Z(3)' component is not vertical\n");
			continue;
}

if (itr3Comp != pListComp.end() && ind3compOrient == 0) {


(*itr3Comp)->GetNameComp()[0] = 'Z';


}

////////////////// VERiFY   DT ////////////////////////////////


if (itr3Comp != pListComp.end() ) itrComp = itr3Comp;
if (itrZComp != pListComp.end() ) itrComp = itrZComp;
if (origin.OutDtValue == 0)
if ((*itrComp)->GetNameComp()[0] == 'Z') {
if ( (fabs(dt) < (float) 1.0e-5) ) {
(*itrChannel)->GetRemDefault() = 1; 
strcpy(	(*itrChannel)->GetErrComent(),"Err: 'Z' dt is ZERO  ");
fprintf(out,"%s:%s %s %s  %s :>\n",
(*itrStation)->GetNameStation(),
(*itrStation)->GetNameNet(),
(*itrLocation)->GetNameLocation(),
(*itrChannel)->GetNameChannel(),(*itr3Comp)->GetNameComp());
fprintf(out,"                     'Z'  dt is ZERO \n");
			continue;

}      else   {
float samprate = (float)1.0/dt;
char infoStr[64];
bool changeIs = false;
////////////////////////////////////  L  Channel /////////////////////////
if ( samprate >= (float) 79.99999 && (*itrChannel)->GetNameChannel()[0] == 'L')  {
(*itrChannel)->GetNameChannel()[0] = 'E';
sprintf(infoStr,"%s","Warn: Change Channel L to E ");
changeIs = true; 
}
if ( samprate < 80 &&  samprate >= (float) 9.99999 && (*itrChannel)->GetNameChannel()[0] == 'L')  {
(*itrChannel)->GetNameChannel()[0]= 'B';
sprintf(infoStr,"%s","Warn: Change Channel L to B ");
changeIs = true; 
}

if ( samprate < 10 &&  samprate > 1 && (*itrChannel)->GetNameChannel()[0] == 'L')  {
(*itrChannel)->GetNameChannel()[0]= 'M';
sprintf(infoStr,"%s","Warn: Change Channel L to M ");
changeIs = true; 
}
if ( fabs(samprate - (float)0.1) < (float) 1.0e-5  &&
     (*itrChannel)->GetNameChannel()[0] == 'L')  {
(*itrChannel)->GetNameChannel()[0] = 'V';
sprintf(infoStr,"%s","Warn: Change Channel L to V ");
changeIs = true; 
}
if ( fabs(samprate - (float)0.01) < (float) 1.0e-5  &&
     (*itrChannel)->GetNameChannel()[0] == 'L')  {
(*itrChannel)->GetNameChannel()[0] = 'U';
sprintf(infoStr,"%s","Warn: Change Channel L to U ");
changeIs = true; 
}
////////////////////////////////////  B  Channel /////////////////////////
if ( samprate >= (float) 79.99999 && (*itrChannel)->GetNameChannel()[0] == 'B')  {
(*itrChannel)->GetNameChannel()[0] = 'E';
sprintf(infoStr,"%s","Warn: Change Channel B to E ");
changeIs = true; 
}
if ( fabs(samprate - (float)1.0) < (float) 1.0e-5 &&  (*itrChannel)->GetNameChannel()[0] == 'B')  {
(*itrChannel)->GetNameChannel()[0] = 'L';
sprintf(infoStr,"%s","Warn: Change Channel B to L ");
changeIs = true; 
}

if ( samprate < 10 &&  samprate > 1 && (*itrChannel)->GetNameChannel()[0] == 'B')  {
(*itrChannel)->GetNameChannel()[0]= 'M';
sprintf(infoStr,"%s","Warn: Change Channel B to M ");
changeIs = true; 
}
if ( fabs(samprate - (float)0.1) < (float) 1.0e-5  &&
     (*itrChannel)->GetNameChannel()[0] == 'B')  {
(*itrChannel)->GetNameChannel()[0] = 'V';
sprintf(infoStr,"%s","Warn: Change Channel B to V ");
changeIs = true; 
}

if ( fabs(samprate - (float)0.01) < (float) 1.0e-5  &&
     (*itrChannel)->GetNameChannel()[0] == 'B')  {
(*itrChannel)->GetNameChannel()[0] = 'U';
sprintf(infoStr,"%s","Warn: Change Channel B to U ");
changeIs = true; 
}
////////////////////////////////////  M Channel /////////////////////////
if ( samprate >= (float) 79.99999 && (*itrChannel)->GetNameChannel()[0] == 'M')  {
(*itrChannel)->GetNameChannel()[0] = 'E';
sprintf(infoStr,"%s","Warn: Change Channel M to E ");
changeIs == true; 
}
if ( samprate < 80 &&  samprate >= (float) 9.99999 && (*itrChannel)->GetNameChannel()[0] == 'M')  {
(*itrChannel)->GetNameChannel()[0]= 'B';
sprintf(infoStr,"%s","Warn: Change Channel M to B ");
changeIs = true; 
}

if ( fabs(samprate - (float)1.0) < (float) 1.0e-5 &&  (*itrChannel)->GetNameChannel()[0] == 'M')  {
(*itrChannel)->GetNameChannel()[0] = 'L';
sprintf(infoStr,"%s","Warn: Change Channel M to L ");
changeIs = true; 
}

if ( fabs(samprate - (float)0.1) < (float) 1.0e-5  &&
     (*itrChannel)->GetNameChannel()[0] == 'M')  {
(*itrChannel)->GetNameChannel()[0] = 'V';
sprintf(infoStr,"%s","Warn: Change Channel M to V ");
changeIs = true; 
}

if ( fabs(samprate - (float)0.01) < (float) 1.0e-5  &&
     (*itrChannel)->GetNameChannel()[0] == 'M')  {
(*itrChannel)->GetNameChannel()[0] = 'U';
sprintf(infoStr,"%s","Warn: Change Channel M to U ");
changeIs = true; 
}



if ( changeIs == true ) {

strcpy(	(*itrChannel)->GetErrComent(),infoStr);
fprintf(out,"%s:%s %s %s    :>\n",
(*itrStation)->GetNameStation(),
(*itrStation)->GetNameNet(),
(*itrLocation)->GetNameLocation(),
(*itrChannel)->GetNameChannel());
fprintf(out,"                     %s\n",infoStr);

fprintf ( stderr,"Warn: %s:%s:%s dt = %e %s\n",
(*itrStation)->GetNameStation(),
(*itrLocation)->GetNameLocation(),
(*itrChannel)->GetNameChannel(),dt,infoStr);
}


} // else (fabs(dt) < (float) 1.0e-5) 
}

////////////////// VERiFY   DT ////////////////////////////////


if  (  itrNComp != pListComp.end()  && itrEComp == pListComp.end() ) {
	strcpy(	(*itrChannel)->GetErrComent(),"Note: No E component ");
(*itrNComp)->GetRemDefault() = 1; 
fprintf(out,"%s:%s %s %s  %s :>\n",
(*itrStation)->GetNameStation(),
(*itrStation)->GetNameNet(),
(*itrLocation)->GetNameLocation(),
(*itrChannel)->GetNameChannel(),(*itrNComp)->GetNameComp());
fprintf(out,"                     No 'E' component\n");

}

if  (  itrNComp ==pListComp.end()  && itrEComp != pListComp.end() ) {
	strcpy(	(*itrChannel)->GetErrComent(),"Note: No N component ");
(*itrEComp)->GetRemDefault() = 1;
fprintf(out,"%s:%s %s %s  %s :>\n",
(*itrStation)->GetNameStation(),
(*itrStation)->GetNameNet(),
(*itrLocation)->GetNameLocation(),
(*itrChannel)->GetNameChannel(),(*itrEComp)->GetNameComp());
fprintf(out,"                     No 'N' component\n"); 
}
if  (  itr1Comp != pListComp.end()  && itr2Comp == pListComp.end() ) {
	strcpy(	(*itrChannel)->GetErrComent(),"Note: No E(2) component ");
(*itr1Comp)->GetRemDefault() = 1; 
fprintf(out,"%s:%s %s %s  %s :>\n",
(*itrStation)->GetNameStation(),
(*itrStation)->GetNameNet(),
(*itrLocation)->GetNameLocation(),
(*itrChannel)->GetNameChannel(),(*itr1Comp)->GetNameComp());
fprintf(out,"                     No 'E(2)' component\n");
}
if  (  itr1Comp == pListComp.end()  && itr2Comp != pListComp.end() ) {
	strcpy(	(*itrChannel)->GetErrComent(),"Note: No N(1) component ");
(*itr2Comp)->GetRemDefault() = 1; 
fprintf(out,"%s:%s %s %s  %s :>\n",
(*itrStation)->GetNameStation(),
(*itrStation)->GetNameNet(),
(*itrLocation)->GetNameLocation(),
(*itrChannel)->GetNameChannel(),(*itr2Comp)->GetNameComp());
fprintf(out,"                     No 'N(1)' component\n");
}
if  (  itrNComp != pListComp.end()  && itrEComp != pListComp.end() ) {


	if ( indNcompOrient == 1 && indEcompOrient == 0 ) {
	strcpy(	(*itrChannel)->GetErrComent(),"Err: N component is not horizontal ");
			(*itrNComp)->GetRemDefault() = 1;
			(*itrEComp)->GetRemDefault() = 1;
fprintf(out,"%s:%s %s %s  %s :>\n",
(*itrStation)->GetNameStation(),
(*itrStation)->GetNameNet(),
(*itrLocation)->GetNameLocation(),
(*itrChannel)->GetNameChannel(),(*itrNComp)->GetNameComp());
fprintf(out,"                     'N' component is not horizontal\n");

	}
	if ( indNcompOrient == 0 && indEcompOrient == 1 ) {
	strcpy(	(*itrChannel)->GetErrComent(),"Err: E component is not horizontal ");
			(*itrNComp)->GetRemDefault() = 1;
			(*itrEComp)->GetRemDefault() = 1;
fprintf(out,"%s:%s %s %s  %s :>\n",
(*itrStation)->GetNameStation(),
(*itrStation)->GetNameNet(),
(*itrLocation)->GetNameLocation(),
(*itrChannel)->GetNameChannel(),(*itrEComp)->GetNameComp());
fprintf(out,"                     'E' component is not horizontal\n");
	}
	if ( indNcompOrient == 1 && indEcompOrient == 1 ) {
	strcpy(	(*itrChannel)->GetErrComent(),"Err: E & N component are not horizontal ");
			(*itrNComp)->GetRemDefault() = 1;
			(*itrEComp)->GetRemDefault() = 1;
fprintf(out,"%s:%s %s %s   %s:%s  :>\n",
(*itrStation)->GetNameStation(),
(*itrStation)->GetNameNet(),
(*itrLocation)->GetNameLocation(),
(*itrChannel)->GetNameChannel(),(*itrEComp)->GetNameComp(),(*itrNComp)->GetNameComp());
fprintf(out,"                     'E' & 'N' component are not horizontal \n");
	}



	if ( indEcompOrient == 0 && indEcompOrient == 0 ) {

	float fl90 = fabs(hangE - hangN);
	if ( !(  ( (int )fl90 / 90 )*90 == (int )fl90    )) {
	strcpy(	(*itrChannel)->GetErrComent(),"Err: E N components are not ortogonal ");
			(*itrNComp)->GetRemDefault() = 1;
			(*itrEComp)->GetRemDefault() = 1;
fprintf(out,"%s:%s %s %s   %s:%s  :>\n",
(*itrStation)->GetNameStation(),
(*itrStation)->GetNameNet(),
(*itrLocation)->GetNameLocation(),
(*itrChannel)->GetNameChannel(),(*itrEComp)->GetNameComp(),(*itrNComp)->GetNameComp());
fprintf(out,"                     'E' & 'N'  components are not ortogonal \n");
	}

	float sinFi = sin(hangE*Pi2/(float)360 - hangN*Pi2/(float)360);
	if ( !( fabs(sinFi - (float) 1.0) < (float) 1.0e-3 ) ) { //sinFi != 1

	strcpy(	(*itrChannel)->GetErrComent(),"Err: E N component orientation ");
			(*itrNComp)->GetRemDefault() = 1;
			(*itrEComp)->GetRemDefault() = 1;
fprintf(out,"%s:%s %s %s   %s:%s  :>\n",
(*itrStation)->GetNameStation(),
(*itrStation)->GetNameNet(),
(*itrLocation)->GetNameLocation(),
(*itrChannel)->GetNameChannel(),(*itrEComp)->GetNameComp(),(*itrNComp)->GetNameComp());
fprintf(out,"                     'E' & 'N'  component orientation error \n");
	}
    } // indEcompOrient == 0 && indEcompOrient == 0

}	// itrNComp != 0  && itrEComp != 0

if  (  itr1Comp != pListComp.end()  && itr2Comp != pListComp.end() ) {

	if ( ind1compOrient == 1 && ind2compOrient == 0 ) {
	strcpy(	(*itrChannel)->GetErrComent(),"Err: N(1) component is not horizontal ");
			(*itr1Comp)->GetRemDefault() = 1;
			(*itr2Comp)->GetRemDefault() = 1;
fprintf(out,"%s:%s %s %s   %s  :>\n",
(*itrStation)->GetNameStation(),
(*itrStation)->GetNameNet(),
(*itrLocation)->GetNameLocation(),
(*itrChannel)->GetNameChannel(),(*itr1Comp)->GetNameComp());
fprintf(out,"                      'N(1)' component is not horizontal \n");
	}
	if ( ind1compOrient == 0 && ind2compOrient == 1 ) {
	strcpy(	(*itrChannel)->GetErrComent(),"Err: E(2) component is not horizontal ");
			(*itr1Comp)->GetRemDefault() = 1;
			(*itr2Comp)->GetRemDefault() = 1;

fprintf(out,"%s:%s %s %s   %s  :>\n",
(*itrStation)->GetNameStation(),
(*itrStation)->GetNameNet(),
(*itrLocation)->GetNameLocation(),
(*itrChannel)->GetNameChannel(),(*itr2Comp)->GetNameComp());
fprintf(out,"                      'E(2)' component is not horizontal \n");
	}
	if ( ind1compOrient == 1 && ind2compOrient == 1 ) {
	strcpy(	(*itrChannel)->GetErrComent(),"Err: N(1) & E(2) component are not horizontal ");
			(*itr1Comp)->GetRemDefault() = 1;
			(*itr2Comp)->GetRemDefault() = 1;
fprintf(out,"%s:%s %s %s   %s:%s  :>\n",
(*itrStation)->GetNameStation(),
(*itrStation)->GetNameNet(),
(*itrLocation)->GetNameLocation(),
(*itrChannel)->GetNameChannel(),(*itr1Comp)->GetNameComp(),(*itr2Comp)->GetNameComp());
fprintf(out,"                     'N(1)' & 'E(2)' component are not horizontal \n");
	}




	if ( ind1compOrient == 0 && ind2compOrient == 0 ) {

	float fl90 = fabs(hangE - hangN);
	if ( !(  ( (int )fl90 / 90 )*90 == (int )fl90    )) {
	strcpy(	(*itrChannel)->GetErrComent(),"Err: N(1) E(2) components are not ortogonal ");
			(*itr1Comp)->GetRemDefault() = 1;
			(*itr2Comp)->GetRemDefault() = 1;
fprintf(out,"%s:%s %s %s   %s:%s  :>\n",
(*itrStation)->GetNameStation(),
(*itrStation)->GetNameNet(),
(*itrLocation)->GetNameLocation(),
(*itrChannel)->GetNameChannel(),(*itr1Comp)->GetNameComp(),(*itr2Comp)->GetNameComp());
fprintf(out,"                     'N(1)' & 'E(2)' components are not ortogonal \n");
	} else {

	float sinFi = sin(hangN*Pi2/(float)360 - hangE*Pi2/(float)360);
	if ( !( fabs(sinFi - (float) 1.0) < (float) 1.0e-3 ) ){ //sinFi != 1
	(*itr1Comp)->GetNameComp()[0] = 'N';
	(*itr2Comp)->GetNameComp()[0] = 'E';
	} else {
	(*itr1Comp)->GetNameComp()[0] = 'E';
	(*itr2Comp)->GetNameComp()[0] = 'N';

	}
     }
   }// ind1compOrient == 0 && ind2compOrient == 0


}	// itr1Comp != 0  && itr2Comp != 0



} // itrChannel


		if (!pListChannel.empty() )
		for(itrChannel=pListChannel.begin();
		itrChannel!=pListChannel.end();
		itrChannel++)
		if ( (*itrChannel)->GetRemDefault() == 0) indAllChannel = true;

		if (indAllChannel == false) (*itrLocation)->GetRemDefault() = 1;

       } // itrLocation

	if (!pListLocation.empty() )
	for(itrLocation=pListLocation.begin();
	itrLocation!=pListLocation.end();
	itrLocation++) 


	if ( (*itrLocation)->GetRemDefault() == 0) indAllStation = true;

if (indAllStation == false) (*itrStation)->GetRemDefault() = 1;

int indNotMarked = 0;
	if ( !pListLocation.empty() )
	for(itrLocation=pListLocation.begin();
	itrLocation!=pListLocation.end();
	itrLocation++) {
        (*itrLocation)->GetMarkDefault() = 1;
        (*itrLocation)->GetMarkUser() = 1;

        if (indNotMarked == 0) 
        if ( (*itrLocation)->GetRemDefault() == 0)    {
	(*itrLocation)->GetMarkDefault() = 0; 
	(*itrLocation)->GetMarkUser() = 0;
	indNotMarked = 1;
	}
}      

///// Resort Comp ( '1' == N ,'2' == E ) & Add Excldes & RemDefault////////////

	if ( !pListLocation.empty() )
	for(itrLocation=pListLocation.begin();
	itrLocation!=pListLocation.end();
	itrLocation++) {
       

		list<Channel *> pListChannel = 
		(*itrLocation)->GetChannelList();    
		list<Channel *>::iterator itrChannel;

		if (!pListChannel.empty() )
		for(itrChannel=pListChannel.begin();
		itrChannel!=pListChannel.end();
		itrChannel++) 
		(*itrChannel)->GetCompList().sort(comp_Comp());

		pListChannel = (*itrLocation)->GetChannelList();

		if (!pListChannel.empty() )
		for(itrChannel=pListChannel.begin();
		itrChannel!=pListChannel.end();
		itrChannel++) {
	if ( (*itrChannel)->GetRemDefault() == 1) continue;

        if ( (*itrLocation)->GetRemDefault() == 1)
	(*itrChannel)->GetRemDefault() = 1; 


        if ( (*itrLocation)->GetMarkDefault() == 1)    {
	(*itrChannel)->GetMarkDefault() = 1; 
	(*itrChannel)->GetMarkUser() = 1;
	}

			list<Comp *> pListComp = 
			(*itrChannel)->GetCompList();    
			list<Comp *>::iterator itrComp;

			if (!pListComp.empty() )
			for(itrComp=pListComp.begin();
			itrComp!=pListComp.end();
			itrComp++) {

	        if ( (*itrComp)->GetRemDefault() == 1) continue;

	        if ( (*itrChannel)->GetRemDefault() == 1)
		(*itrComp)->GetRemDefault() = 1; 


	        if ( (*itrChannel)->GetMarkDefault() == 1)    {
		(*itrComp)->GetMarkDefault() = 1; 
		(*itrComp)->GetMarkUser() = 1;
		}


         } // itrComp

      } // itrChannel
   } // itrLocation

} // itrStation

fprintf(out,"\n     ----  Full List of Data  ----- \n\n");

PrintStructure(out);

fclose (out);


}

