//	fmt4cmdw.h:	Header for Ah4Dbcmdw class
//=======================================================================

#ifndef Ah4DbCMDW_H
#define Ah4DbCMDW_H

#include <v/vcmdwin.h>	// So we can use vCmdWindow
#include <v/vmenu.h>	// For the menu pane
#include <v/vutil.h>	// For V Utilities
#include <v/vcmdpane.h> // command pane
#include <v/vstatusp.h>	// For the status pane
#include <v/vtimer.h>	// Timer
#include <v/vfilesel.h>
#include <v/vynreply.h>
#include <v/vnotice.h>	// for vNoticeDialog

#ifdef vDEBUG
#include <v/vdebug.h>
#endif

#include "fmt4class.h"
#include "fmt4cnv.h"	// Ah4DbTextCanvasPane
#include "fmt4dlg.h"	// Ah4DbDialog
#include "fmt4mdlg.h"	// Ah4DbModalDialog
#include "fmt4Recmdlg.h"	// fmtRecListModalDialog
#include "fmtdirsel.h"
#include "origin.h"
#include "fmtdirsel.h"

#include <string.h>
int Is_Digit(char *);
int Is_ZDigit(char *);
int Is_Integer(char *);
/*
#include <list>
#include <string>

using namespace std;


int DirectoryIsEmpty(char *OutErr,char *sourceDir,char *fileMask);

class Record {
public:
char *itsNameFile;
char *itsNameOut;
struct record_info *rec_info;
Record(char *str,char *str1,record_info *rr){
   itsNameFile = new char[strlen(str)+1];
   strcpy(itsNameFile,str);
   itsNameOut = new char[strlen(str1)+1];
   strcpy(itsNameOut,str1);
   rec_info = new record_info;
   memcpy(rec_info,rr,sizeof(record_info));
}
 virtual ~Record(){
//   fprintf(stderr,"Destructor Record %s\n",itsNameOut);

delete [] itsNameFile;
delete [] itsNameOut;
delete rec_info;

	}
   char*  &GetNameFile()  {return itsNameFile;}
   char*  &GetNameOut()   {return itsNameOut;}
   record_info* &GetRec_info()  {return rec_info;}
   };

class Comp {
private:
int itsNumberRecord;
int itsRemDefault;
int itsMarkDefault;
int itsMarkUser;
float itsHang;
float itsVang;
protected:
	list<Record *> itsRecordList;  
	list<Record *>::iterator itsItrRecord;

struct record_info *rec_info;
public:
char *itsNameComp;
   Comp(char *str, record_info *rr):itsNumberRecord(0),itsRemDefault(0), 
	itsMarkDefault(0),itsMarkUser(0){
   itsNameComp = new char[strlen(str)+1];
   strcpy(itsNameComp,str);
   rec_info = new record_info;
   memcpy(rec_info,rr,sizeof(record_info));

   }
   virtual ~Comp(){
  // fprintf(stderr,"Destructor Comp %s\n",itsNameComp);
   delete [] itsNameComp;
   delete rec_info;
	if (!itsRecordList.empty() ) {
	    for(itsItrRecord=itsRecordList.begin();
	    itsItrRecord!=itsRecordList.end();itsItrRecord++)   
            delete (*itsItrRecord);

	itsRecordList.clear();
   }
}
   char* &GetNameComp()    {return itsNameComp;}
   int &GetNumberRecord()  {return itsNumberRecord;}
   float &GetHang()        {return itsHang;}
   float &GetVang()        {return itsVang;}

   int &GetRemDefault()    {return itsRemDefault;}
   int &GetMarkDefault()       {return itsMarkDefault;}
   int &GetMarkUser()          {return itsMarkUser;}
   list<Record *> &GetRecordList() {return itsRecordList;}
   record_info* &GetRec_info()  {return rec_info;}
};


class Channel {
private:
int itsNumberComp;
int itsRemDefault;
int itsMarkDefault;
int itsMarkUser;
	char *itsErrComent;

protected:
	list<Comp *> itsCompList;  
	list<Comp *>::iterator itsItrComp;
public:
char *itsNameChannel;
   Channel(char *str):itsNumberComp(0),itsRemDefault(0),
   itsMarkDefault(0),itsMarkUser(0){
   itsNameChannel = new char[strlen(str)+1];
   strcpy(itsNameChannel,str);
  itsErrComent = new char[80];
   strcpy(itsErrComent," ");
 
   }
   virtual ~Channel(){
  // fprintf(stderr,"Destructor Channel %s\n",itsNameChannel);
   delete [] itsNameChannel;
   delete [] itsNameChannel;
	if (!itsCompList.empty() ) {
	    for(itsItrComp=itsCompList.begin();
	    itsItrComp!=itsCompList.end();itsItrComp++)   
            delete (*itsItrComp);

	itsCompList.clear();
   }

}
   char* &GetNameChannel()     {return itsNameChannel;}
   char* &GetErrComent()       {return itsErrComent;}

   int &GetNumberComp()        {return itsNumberComp;}
   int &GetRemDefault()        {return itsRemDefault;}
   int &GetMarkDefault()       {return itsMarkDefault;}
   int &GetMarkUser()          {return itsMarkUser;}

   list<Comp *> &GetCompList() {return itsCompList;}
};


class Location{
private:
int itsNumberChannel;
int itsRemDefault;
int itsMarkDefault;
int itsMarkUser;

protected:

	list<Channel *> itsChannelList;  
	list<Channel *>::iterator itsItrChannel;
public:
char *itsNameLocation;
   Location(char *str):itsNumberChannel(0),itsRemDefault(0),
itsMarkDefault(0),itsMarkUser(0){
//fprintf(stderr,"Location Constructor '%s'\n",str);
   itsNameLocation = new char[strlen(str)+1];
   strcpy(itsNameLocation,str);
   }
   virtual ~Location(){
 //  fprintf(stderr,"Destructor Location %s\n",itsNameLocation);
   delete [] itsNameLocation;
	if (!itsChannelList.empty() ) {
	    for(itsItrChannel=itsChannelList.begin();
	    itsItrChannel!=itsChannelList.end();itsItrChannel++)   
            delete (*itsItrChannel);

	itsChannelList.clear();
   }

}
   char* &GetNameLocation()  {return itsNameLocation;}
   int &GetNumberChannel()  {return itsNumberChannel;}
   int &GetRemDefault()    {return itsRemDefault;}
   int &GetMarkDefault()       {return itsMarkDefault;}
   int &GetMarkUser()       {return itsMarkUser;}
   list<Channel *> &GetChannelList() {return itsChannelList;}
};
class Station
{
private:
	int itsNumberLocation;
	int itsRemDefault;
	int itsMarkDefault;
	int itsMarkUser;

protected:
	list<Location *> itsLocationList;  
	list<Location *>::iterator itsItrLocation;  
public:
	char *itsNameStation;
	char *itsNameNet;

   Station(char *str,char *str1):itsNumberLocation(0),itsRemDefault(0),
itsMarkDefault(0),itsMarkUser(0){
itsNameStation = new char[strlen(str)+1];
strcpy(itsNameStation,str);
itsNameNet = new char[strlen(str1)+1];
strcpy(itsNameNet,str1);

}
   virtual ~Station(){
//   fprintf(stderr,"Destructor Station %s:%s\n",itsNameStation,itsNameNet);
   delete [] itsNameStation;
   delete [] itsNameNet;
	if (!itsLocationList.empty() ) {
	    for(itsItrLocation=itsLocationList.begin();
	    itsItrLocation!=itsLocationList.end();itsItrLocation++)   
            delete (*itsItrLocation);

	itsLocationList.clear();
   }

}
   char* &GetNameStation()     {return itsNameStation;}
   char* &GetNameNet()         {return itsNameNet;}
   int &GetNumberLocation()    {return itsNumberLocation;}
   int &GetRemDefault()        {return itsRemDefault;}
   int &GetMarkDefault()       {return itsMarkDefault;}
   int &GetMarkUser()          {return itsMarkUser;}
   list<Location *> &GetLocationList() {return itsLocationList;}

};

*/
    class Ah4DbCmdWindow;

    class Ah4DbTimer : public vTimer
      {
      public:		//---------------------------------------- public
	Ah4DbTimer(Ah4DbCmdWindow* cw) { cmdw = cw; }
	~Ah4DbTimer() {}
	virtual void TimerTick();
      private:		//--------------------------------------- private
	Ah4DbCmdWindow* cmdw;
      };

    class Ah4DbAuxTimer : public vTimer
      {
      public:		//---------------------------------------- public
	Ah4DbAuxTimer(Ah4DbCmdWindow* cw) { cmdw = cw; }
	~Ah4DbAuxTimer() {}
	virtual void TimerTick();
      private:		//--------------------------------------- private
	Ah4DbCmdWindow* cmdw;
      };

    class Ah4DbCmdWindow : public vCmdWindow
      {
	friend int AppMain(int, char**);	// allow AppMain access

      public:		//---------------------------------------- public
	Ah4DbCmdWindow(char*, int, int);
	virtual ~Ah4DbCmdWindow();
	virtual void WindowCommand(ItemVal id, ItemVal val, CmdType cType);
	virtual void KeyIn(vKey keysym, unsigned int shift);
	Ah4DbAuxTimer* GetAh4DbAuxTimer() {return _auxTimer;}// Aux Timer

  ORIG origin,saveor;


		void EmptyOrigin();
		void SetEndTime();
                void CopyOr2Or(ORIG *,ORIG *);
		int WriteScript(char *);
		int ReadScript(char *);
		void PrintToCanvas();
		int SaveProject(char *OutErr);
		int OpenProject(char *OutErr);
		int GetListOfAhRecords(char *PlaceDbase,char *OutErr);
		int MakeJustDbase(char *PlaceDbase,char *OutErr);
		int SeedToAh(char *ErrorReturnCode);
		int GetListOfStationChannel(char *OutErr);
		int CreateStructureInfo(ahhed *ah_header,char *FileNameIn,
		    char *FileNameOut,char *OutErr);

		int AddLocationList( list <Station *>::iterator itrStation,
 		ahhed *ahdr,char * FileNameIn,char *FileNameOut,char *OutErr);

		int AddChannelList( list <Location *>::iterator itrLocation,
		ahhed *ahdr,char * FileNameIn,char *FileNameOut,char *OutErr);

		int AddCompList( list <Channel *>::iterator itrComp,
		ahhed *ahdr,char * FileNameIn,char *FileNameOut,char *OutErr);

		int AddRecordList( list <Comp *>::iterator itrComp,
		ahhed *ahdr,char * FileNameIn,char *FileNameOut,char *OutErr);

		void SortStructure();
		void RemoveDefaultStructureItems();
		void PrintStructure(FILE *out);

      protected:	//--------------------------------------- protected

      private:		//--------------------------------------- private

	// Standard elements
	vMenuPane* Ah4DbMenu;		// For the menu bar
	Ah4DbTextCanvasPane* Ah4DbCanvas;		// For the canvas
	vCommandPane* Ah4DbCmdPane;	// for the command pane
	vStatusPane* Ah4DbStatus;		// For the status bar
	Ah4DbTimer* _timer;	// Timer for Date/Time
	Ah4DbAuxTimer* _auxTimer;	// Aux Timer

	// Dialogs associated with CmdWindow

	Ah4DbDialog* Ah4DbDlg;
	Ah4DbModalDialog* Ah4DbMDlg;
        fmtRecListModalDialog* RecListMdlg;

	list <string> itsRecordList;
	list <Station *> itsStationList;
bool indGetListOfStation;
       
      };
#endif
