#include "db2ascii.h" 
#include "stachan.h" 
#define _MAX_FILE_NAME 2048
int linuxPlatphorm;
int   DecoderPcUnix(int inInt) {
unSet inSet;
//  0 1 2 3 
//  3 2 1 0
inSet.val = inInt;
char wch[2];
wch[0]= inSet.ch[0];
wch[1]= inSet.ch[1];
inSet.ch[0] = inSet.ch[3];
inSet.ch[1] = inSet.ch[2];
inSet.ch[2] = wch[1];
inSet.ch[3] = wch[0];
return inSet.val;
}
float DecoderPcUnix(float inFloat){
unSet inSet;
char wch[2];
inSet.fal = inFloat;
wch[0]= inSet.ch[0];
wch[1]= inSet.ch[1];
inSet.ch[0] = inSet.ch[3];
inSet.ch[1] = inSet.ch[2];
inSet.ch[2] = wch[1];
inSet.ch[3] = wch[0];
return inSet.fal;
}
void TransformFloatArray(float *s,long n){
    for(long i = 0; i < n; i++) s[i] = DecoderPcUnix(s[i]);
}

int main(int             argc, char          **argv) {
    QApplication app(argc, argv);
    if ( argc < 7) {
    //                                            indAhOrAscii  0 - ASCII  1 - AH-bin
	qWarning ( "usage: db2asc dbin dbroot dborigin numOriginRow dirout indAhOrAscii");
	qWarning ( "usage: numOriginRow: number of row in origin db table, usually -   1");
	qWarning ( "usage: indAhOrAscii:  0 - AH ascii  1 - AH binary");
	return 1;
    }   
    qWarning ("\ndb2asc:>");
    char* dbin          = argv[1];
    char* dbroot        = argv[2];
    char* dborigin      = argv[3];
    char* numoriginrow  = argv[4];    
    char* dirout        = argv[5];
    char* indAhOrAscii = argv[6];
    int numOfOriginRow = QString( numoriginrow).toInt() -1;
    char *st =getenv("FMT_ARCHITECTURE_");
    linuxPlatphorm = 0;
    if(st == NULL)		{
	qWarning( "Fatal Error:> It is not define env varuable 'FMT_ARCHITECTURE_'");			
	return false;
    }
    else	{
	if (strstr(st,"linux") !=0)	linuxPlatphorm = 1;
	else linuxPlatphorm = 0;
	 
    }	
//qWarning("dbin '%s' dbroot '%s' dborigin '%s' numoriginrow '%s' dirout '%s' indAhOrAscii '%s'",
//dbin,dbroot,dborigin,numoriginrow,dirout,indAhOrAscii);    

    CDbeSeis *pCDbeSeis = new CDbeSeis(dbin, dbroot, dborigin);

    char str[4096] ;  
    if ( pCDbeSeis->OpenDBase(str,numOfOriginRow) ) {
	qWarning (" %s",str);return 1;
       }

    SET_SEI *ps = pCDbeSeis->ps;
    	SEI **WFSEI = ps->sei;
	SEI *wf;
    vector<StaValue* > stations;
    int n_sei = ps->n;

    for (int i = 0; i < n_sei; i++) {
	wf = WFSEI[i];	
	QString recName = getRecordName(wf);
	QString idName = recName.right(recName.length()  - recName.indexOf("_") - 1);
	idName = idName.left(idName.lastIndexOf ('.') );
	QString sta(wf->sta);
	QString chan(wf->LRchan);
	vStaIt itSta; 
	if ( (itSta = GetStaIterator(sta,&stations)) != stations.end() ) 
	    (*itSta)->GetChans().push_back(new ChanValue(chan,idName,wf));
	else {
	    stations.push_back(new StaValue(sta));
	    itSta = stations.end(); itSta--; 
	    (*itSta)->GetChans().push_back(new ChanValue(chan,idName,wf));
	}
	
    }
    
    vStaIt itSta; 
     for  (  itSta = stations.begin();  itSta != stations.end(); itSta++) {
	 vChan Chan = (*itSta)->GetChans();
	 vChanIt itChan, itC;
	 for  ( itChan = Chan.begin();  itChan != Chan.end(); itChan++) {
	     QString chan = (*itChan )->GetIdName();
	     if (chan[chan.length() -1] == 'Z' || chan[chan.length() -1] == 'z' )  {
		 if ( !getRecordData((*itChan )->GetRecWf(),dbin) ) return 1;
		 if ( !writeAsciiRecord((*itChan )->GetRecWf(),dirout,indAhOrAscii) ) return 2;
		  delete [] (*itChan )->GetRecWf()->s; (*itChan )->GetRecWf()->s = 0;
		 //qWarning("     done: '%s'",(*itChan )->GetIdName().ascii());
	     
	     }
	     if (chan[chan.length() -1] == 'N' || chan[chan.length() -1] == 'n' ) {
		 QString idName =  (*itChan )->GetIdName(); idName =  idName.left(idName.length() -1);
		 bool idHoriz = false;
		 for  ( itC = Chan.begin();  itC != Chan.end(); itC++) {
		     QString chan1 = (*itC )->GetIdName();
		     QString cha1 =  chan1.left(chan1.length() -1);
		     QString idName1 =  (*itC )->GetIdName(); idName1 =  idName1.left(idName1.length() -1);
		     if  ( (chan1[chan1.length() -1] == 'E' || chan1[chan1.length() -1] == 'e' ) && 
			   idName == idName1 ) { idHoriz = true;break;}

		 }
		 if (idHoriz == true) {
		     
		      if ( !getRecordData((*itChan )->GetRecWf(),(*itC )->GetRecWf(),dbin) ) return 1;
		     if ( !writeAsciiRecord((*itChan )->GetRecWf(),dirout,indAhOrAscii) ) return 3;
		     delete [] (*itChan )->GetRecWf()->s; (*itChan )->GetRecWf()->s = 0;
		     if ( !writeAsciiRecord((*itC )->GetRecWf(),dirout,indAhOrAscii) ) return 4;
		     delete [] (*itC )->GetRecWf()->s; (*itC )->GetRecWf()->s = 0;
		    // qWarning("     done: '%s'  '%s'",(*itChan )->GetIdName().ascii(),(*itC)->GetIdName().ascii());
		 }
	     }
	     

	 }
     
     }

     
    for_each(stations.begin(),stations.end(),deleteStationAndNullify);
    stations.erase(remove(stations.begin(),stations.end(),
			  static_cast<StaValue*>(0)),
		   stations.end());

}
QString getRecordName(SEI *wf){
   int year;
   int month;
   int day;
   int doy;
   int hour;
   int minute;
   float second;	
   char wstr[50];	    
   fmtetoh(wf->lddate,&year,&month,&day,&doy,&hour,&minute,&second);     
   QString dfile = wf->dfile;
   QString norbit = dfile.section ('.',1,1);
  
   sprintf(  wstr,"%s_%2d.%2d.%4d_%2d:%2d:%2d",norbit.toAscii().data(),
	     day,month,year,hour,minute,(int)(second) );
  QString tmp = wstr;
  tmp.replace(' ','0');
  return  tmp.sprintf( "cl_%s_%s_%s.ASC",wf->sta,tmp.toAscii().data(),wf->LRchan);
  	
}
bool writeAsciiRecord(SEI *wf,char * dirout,char *  indAhOrAscii) {

	QString recName = getRecordName(wf);
	QString recFileName = QString("%1/%2").arg(dirout).arg(recName);
	QFile f( recFileName );
	if ( !f.open( QIODevice::WriteOnly) ) {
	   qWarning (" Can't open file '%s' for writing",recFileName.toAscii().data()); 
	    return false;    
	}
	QTextStream t( &f ); 
	QString tmp;	
	  float max_amplitude = -FLT_MAX;
                  for (long m=0; m < wf->nsampl ;m++) 
		      if (wf->s[m] > max_amplitude) max_amplitude = wf->s[m];	 

		  
	tmp.sprintf("station information\n");      /* station info */ 
	t << tmp ; 
	tmp.sprintf("code:\t%s\n",wf->sta);   
	t << tmp ; 
	tmp.sprintf("channel:\t%s\n",wf->LRchan); 
	t << tmp ; 
	tmp.sprintf("type:\t%s\n","no info"); 
	t << tmp ; 
	tmp.sprintf("latitude:\t%f\n",wf->slat);
	t << tmp ; 
	tmp.sprintf("longitude:\t%f\n",wf->slong); 
	t << tmp ; 
	tmp.sprintf("elevation:\t%f\n",wf->elevation); 
	t << tmp ; 
	if(wf->amp > 0.0)
	tmp.sprintf("gain:\t%e\n",1.0/wf->amp);   /* DS */
	else {
	tmp.sprintf("gain:\t%e\n",1.0);   /* DS */
	qWarning("Warning:> Recalculation gain is zero for record\n      '%s' ",recFileName.toAscii().data()); 
	}
	
	t << tmp ; 
	tmp.sprintf("normaliztion:\t%e\n",wf->amp1);   /* AO */
	t << tmp ; 
	tmp.sprintf("calibration information\n"); 
	t << tmp ; 
	tmp.sprintf("pole.re\t\tpole.im\t\tzero.re\t\tzero.im\n"); 
	t << tmp ; 
	             ahhed   ahhead; 
	             int i1 = 0;
     ahhead.station.cal[0].pole.r   = (float)wf->npol; 
     ahhead.station.cal[0].pole.i   = (float)0.0; 
     ahhead.station.cal[0].zero.r   = (float)wf->nzer; 
     ahhead.station.cal[0].zero.i   = (float)0.0; 
     for (i1=0; i1< wf->npol; i1++) {
      ahhead.station.cal[i1+1].pole.r   = wf->pol[i1][0]; 
      ahhead.station.cal[i1+1].pole.i   = wf->pol[i1][1]; 

       }
                    for(i1 = wf->npol + 1; i1 < NOCALPTS;i1++) { 
     ahhead.station.cal[i1].pole.r   = (float)0.0; 
     ahhead.station.cal[i1].pole.i   = (float)0.0; 
     }
                    for (i1=0; i1< wf->nzer; i1++) {
     ahhead.station.cal[i1+1].zero.r   = wf->zer[i1][0]; 
     ahhead.station.cal[i1+1].zero.i   = wf->zer[i1][1]; 

     } 



                  for(i1 = wf->nzer + 1; i1 < NOCALPTS;i1++)  { 
     ahhead.station.cal[i1].zero.r   = (float)0.0; 
     ahhead.station.cal[i1].zero.i   = (float)0.0; 
                              } 	
	
		  for(i1=0; i1<NOCALPTS; ++i1) {
		      tmp.sprintf("%e\t%e\t%e\t%e\n",
			      ahhead.station.cal[i1].pole.r,ahhead.station.cal[i1].pole.i,
			      ahhead.station.cal[i1].zero.r,ahhead.station.cal[i1].zero.i); 
		      t << tmp ;
		  }
         
                tmp.sprintf("event information\n");        /* event info   */ 
		t << tmp ;
                tmp.sprintf("latitude:\t%f\n",wf->elat); 
		t << tmp ;
                tmp.sprintf("longitude:\t%f\n",wf->elong); 
		t << tmp ;
	tmp.sprintf("depth:\t%f\n",wf->depth); 
	t << tmp ;
                tmp.sprintf("origin_time:\t%ld\t%ld\t%ld\t%ld\t%ld\t%f\n",wf->year, 
                        wf->month,wf->day,wf->hour,wf->minute,wf->sec); 
	t << tmp ;
                tmp.sprintf("comment:\t%s\n","null"); 
	t << tmp ;	
         
                tmp.sprintf("record information\n");       /* record info  */ 
	t << tmp ;
                tmp.sprintf("type:\t%d\n",1); 
	t << tmp ;
                tmp.sprintf("ndata:\t%ld\n",wf->nsamp); 
	t << tmp ;	
                tmp.sprintf("delta:\t%e\n",wf->dt); 
	t << tmp ;	
                tmp.sprintf("max_amplitude:\t%e\n",max_amplitude);  
	t << tmp ;	

   int year;
   int month;
   int day;
   int doy;
   int hour;
   int minute;
   float second;		    
   fmtetoh(wf->time,&year,&month,&day,&doy,&hour,&minute,&second);     	 
                tmp.sprintf("start_time:\t%d\t%d\t%d\t%d\t%d\t%f\n",year, 
                        month,day,hour, minute,second); 
	t << tmp ;	
               /// tmp.sprintf("abscissa_min:\t%e\n",wf->t0); 
	tmp.sprintf("abscissa_min:\t%e\n",0.0); 	
	t << tmp ;	
                tmp.sprintf("comment:\t%s\n","null"); 
	t << tmp ;	
                tmp.sprintf("log:\t%s\n","null"); 
	t << tmp ;	
 
                tmp.sprintf("extras:\n"); 
	t << tmp ;	
	for(i1=0; i1<NEXTRAS; ++i1) {
                        tmp.sprintf("%d:\t%e\n",i1,0.0); 
	        t << tmp ;
	    }
	tmp.sprintf("data:\n"); 
	 t << tmp ;
	 long  n= wf->nsampl; 
                 float * fptr= (float *)wf->s; 
                        while( n-- ) 
                        { 
                                tmp.sprintf("%e\n", *fptr );  t << tmp ;
                                ++fptr; 
                        } 
	f.close();
	if (indAhOrAscii[0]=='0') {
	    qWarning ("done: '%s'",strrchr(recFileName.toAscii().data(),'/') +1);
	    return true;
	}	
	if (indAhOrAscii[0]=='1') {
	    QString ascName = recFileName;
	    QString ahName = ascName;
	    ahName.replace(ahName.lastIndexOf (".ASC") ,4,".AH");
	    QString systemStr = QString ("asc2ah < %1 >%2 ").arg(ascName).arg(ahName);
	    system(systemStr.toAscii().data());
	    systemStr = QString ("\\rm %1 ").arg(ascName);
	    system(systemStr.toAscii().data());	    
	    qWarning ("done: '%s'",strrchr(ahName.toAscii().data(),'/') +1);
	    return true;
	} 
	return false;
    }
bool	getRecordData(SEI *wf,char* dbin ) {

    FILE	*in;
    char work[_MAX_FILE_NAME];
    wf->s = new float [wf->nsampl];  
    strcpy(work,dbin);	    
    *strrchr(work,'/') = '\0'; 
    strcat(work,"/");
    strcat(work,wf->dir);
    strcat(work,"/");
    strcat(work,wf->dfile); 
    if ((in = fopen(work, "r")) == NULL)
    {
	qWarning (" Can't open file '%s' for reading",work);  
	return false;
    }
    fread(wf->s,sizeof(float),wf->nsampl,in);
    if (linuxPlatphorm  == 1) {
	TransformFloatArray(wf->s,wf->nsampl);
    }
    fclose ( in ) ; 	
    if ( fabs(wf->vang) < (float) 1.0e-6 )  return true;
    float psi = (float)((float)4.*(float)atan(1.)/(float)180.)*wf->vang;
    for(long mi = 0; mi < wf->nsampl; mi++) wf->s[mi] *= cos(psi);
    
    return true;
      }

bool getRecordData(SEI *wfn,SEI *wfe,char *dbin){
    FILE	*in;
    char work[_MAX_FILE_NAME];
    wfn->s = new float [wfn->nsampl];  
    strcpy(work,dbin);	    
    *strrchr(work,'/') = '\0'; 
    strcat(work,"/");
    strcat(work,wfn->dir);
    strcat(work,"/");
    strcat(work,wfn->dfile); 
    if ((in = fopen(work, "r")) == NULL)
    {
	qWarning (" Can't open file '%s' for reading",work);  
	return false;
    }
    fread(wfn->s,sizeof(float),wfn->nsampl,in);
    if (linuxPlatphorm  == 1) {
	TransformFloatArray(wfn->s,wfn->nsampl);
    }
    fclose ( in ) ; 	
  
    wfe->s = new float [wfe->nsampl];  
    strcpy(work,dbin);	    
    *strrchr(work,'/') = '\0'; 
    strcat(work,"/");
    strcat(work,wfe->dir);
    strcat(work,"/");
    strcat(work,wfe->dfile); 
    if ((in = fopen(work, "r")) == NULL)
    {
	qWarning (" Can't open file '%s' for reading",work);  
	return false;
    }
    fread(wfe->s,sizeof(float),wfe->nsampl,in);
    if (linuxPlatphorm  == 1) {
	TransformFloatArray(wfe->s,wfe->nsampl);
    }
    fclose ( in ) ; 	    
    
    float hangN = wfn->hang;
    float hangE = wfe->hang;
    if ( fabs(hangN) < (float) 1.0e-6 && fabs(hangE  - (float)90.0) < (float) 1.0e-6 ) return true;
    long m,m1,q,q1;
    long RTNSampl;
    if (wfe->nsampl > wfn->nsampl)RTNSampl =   wfe->nsampl;
    else RTNSampl = wfn->nsampl; 
    float *rSei = new float [RTNSampl];
    float *tSei = new float [RTNSampl]; 
    float *nSei = wfn->s;
    float *eSei = wfe->s;
    float Rad = (float)((float)4.*(float)atan(1.)/(float)180.); 
    float dt0; 
    long st_dt0; 
  
    
    float ampe = wfe->amp;
    float ampn =  wfn->amp;
    float maxamp =   1.0;
    if (ampe > ampn) maxamp = ampe; else maxamp = ampn;
    ampn = maxamp/ampn;    
    ampe = maxamp/ampe;
    float cosHangN  = (float)cos(wfn->hang  * Rad) * ampn;
    float sinHangN  = (float)sin(wfn->hang  * Rad) * ampn;
    float cosHangE  = (float)cos(wfe->hang  * Rad) * ampe;
    float sinHangE  = (float)sin(wfe->hang  * Rad) * ampe;
    float xnn, xee;
    // N == T E == R 
    if (wfe->t0 > wfn->t0 ) { 
	dt0 = wfe->t0 - wfn->t0; 
	st_dt0 =  (long)(dt0/wfe->dt + (float)0.5); 
	for (m = 0; m < st_dt0 ;m++) { 
	    tSei[m] =   (float)0.0; 
	} 
	for (m = st_dt0,q=0; m < wfn->nsampl ;m++,q++) { 
	    if (q >= wfe->nsampl) break;
	    xnn = nSei[m] * cosHangN + eSei[q] * cosHangE;
	    xee = nSei[m] * sinHangN + eSei[q] * sinHangE;
	    tSei[m] =   xnn; 
	    rSei[q] =   xee;  
	} 	                        
	for (q1 = q; q1 < wfe->nsampl ;q1++)     
	    rSei[q1] =   (float)0.0;                  
	for (m1 = m; m1 < wfn->nsampl ;m1++)     
	    tSei[m1] =   (float)0.0; 
    }  else { 
	dt0 = wfn->t0 - wfe->t0; 
	st_dt0 =  (long)(dt0/wfn->dt + (float)0.5); 
	for (m = 0; m < st_dt0 ;m++) { 
	    rSei[m] =   (float)0.0;   
	} 
	for (m = st_dt0,q=0; m < wfe->nsampl ;m++,q++) { 
	    if (q >= wfn->nsampl) break; 
	    xnn = nSei[m] * cosHangN + eSei[q] * cosHangE;
	    xee = nSei[m] * sinHangN + eSei[q] * sinHangE;
	    tSei[m] =   xnn;
	    rSei[q] =   xee; 
	} 	                        
	
	for (m1 = m; m1 < wfe->nsampl;m1++)     
	    rSei[m1] =   (float)0.0;                  
	for (q1 = q; q1 < wfn->nsampl;q1++)     
	    tSei[q1] =   (float)0.0;                  
    }        

                //N == T E == R   

    for (m = 0; m < wfn->nsampl ;m++) nSei[m] = tSei[m]; 
    for (m = 0; m < wfe->nsampl ;m++) eSei[m] = rSei[m];
    
    delete  [] tSei;
    delete  [] rSei; 
    
    
 return true;   
}
