#ifndef STATION_CHAN_H
#define STATION_CHAN_H
#include <qstring.h> 
#include <vector>
#include <algorithm>
#include <functional>
#include "seis.h"
using namespace std;

class RowValue
{ 
public:
    RowValue();
    RowValue(QString name);
    virtual     ~RowValue();
    const bool GetMarkDelete          () const        { return markDelete;    } 
    const QString GetName              () const        { return name;               } 
    void SetMarkDelete     (const bool i              )     { markDelete = i;      } 
    void SetName               (const QString val)     { name = val;                } 
private:  
    QString name; 
    bool markDelete; // false - Include   true- Exclude
};
class ChanValue : public RowValue
{ 
public:
    ChanValue();
    ChanValue(QString name,QString id,SEI * wwf);
    virtual     ~ChanValue();
    QString &GetIdName () { return idName;   } 
     SEI *  &GetRecWf ()          { return wf;               } 
private:  
QString idName;
SEI *wf;
};

class StaValue : public RowValue
{     
public:
    StaValue();
    StaValue(QString name);
    virtual     ~StaValue();
    vector<ChanValue* >  &GetChans(){return chans;}
private:
   vector<ChanValue* > chans;

};
   typedef vector<ChanValue* > vChan;
   typedef vector<ChanValue* >::iterator vChanIt;   
   typedef vector<StaValue* > vSta;
   typedef vector<StaValue* >::iterator vStaIt;  
#endif
