//	fmts2dcmdw.h:	Header for FmtSd2Dbcmdw class
//=======================================================================

#ifndef FmtSd2DbCMDW_H
#define FmtSd2DbCMDW_H



#include <v/vcmdwin.h>	// So we can use vCmdWindow
#include <v/vmenu.h>	// For the menu pane
#include <v/vutil.h>	// For V Utilities
#include <v/vcmdpane.h> // command pane
#include <v/vstatusp.h>	// For the status pane
#include <v/vtimer.h>	// Timer
#include <v/vfilesel.h>
#include <ctype.h>
#include <string.h>

#ifdef vDEBUG
#include <v/vdebug.h>
#endif

#include "fmts2dcnv.h"	// FmtSd2DbTextCanvasPane
#include "fmts2ddlg.h"	// FmtSd2DbDialog
#include "fmts2dmdlg.h"	// FmtSd2DbModalDialog
#include "fmtdirsel.h"
#include "origin.h"

int Is_Digit(char *);
int Is_ZDigit(char *);
int Is_Integer(char *);
 
    class FmtSd2DbCmdWindow;

    class FmtSd2DbTimer : public vTimer
      {
      public:		//---------------------------------------- public
	FmtSd2DbTimer(FmtSd2DbCmdWindow* cw) { cmdw = cw; }
	~FmtSd2DbTimer() {}
	virtual void TimerTick();
      private:		//--------------------------------------- private
	FmtSd2DbCmdWindow* cmdw;
      };

    class FmtSd2DbAuxTimer : public vTimer
      {
      public:		//---------------------------------------- public
	FmtSd2DbAuxTimer(FmtSd2DbCmdWindow* cw) { cmdw = cw; }
	~FmtSd2DbAuxTimer() {}
	virtual void TimerTick();
      private:		//--------------------------------------- private
	FmtSd2DbCmdWindow* cmdw;
      };

    class FmtSd2DbCmdWindow : public vCmdWindow
      {
	friend int AppMain(int, char**);	// allow AppMain access

      public:		//---------------------------------------- public
	FmtSd2DbCmdWindow(char*, int, int);
	virtual ~FmtSd2DbCmdWindow();
	virtual void WindowCommand(ItemVal id, ItemVal val, CmdType cType);
	virtual void KeyIn(vKey keysym, unsigned int shift);
	FmtSd2DbAuxTimer* GetFmtSd2DbAuxTimer() {return _auxTimer;}// Aux Timer
 
  ORIG origin,saveor;



		void EmptyOrigin();
		void SetEndTime();
                void CopyOr2Or(ORIG *,ORIG *);
		int WriteScript(char *);
		int ReadScript(char *);
		void PrintToCanvas();

      protected:	//--------------------------------------- protected

      private:		//--------------------------------------- private

	// Standard elements
	vMenuPane* FmtSd2DbMenu;		// For the menu bar
	FmtSd2DbTextCanvasPane* FmtSd2DbCanvas;		// For the canvas
	vCommandPane* FmtSd2DbCmdPane;	// for the command pane
	vStatusPane* FmtSd2DbStatus;		// For the status bar
	FmtSd2DbTimer* _timer;	// Timer for Date/Time
	FmtSd2DbAuxTimer* _auxTimer;	// Aux Timer

	// Dialogs associated with CmdWindow

	FmtSd2DbDialog* FmtSd2DbDlg;
	FmtSd2DbModalDialog* FmtSd2DbMDlg;

      };
#endif
