//
// C++ Implementation: creationdb
//
// Description:
//
//
// Author: fmt <fmt@localhost.localdomain>, (C) 2008
//
// Copyright: See COPYING file that comes with this distribution
//
//

#include <QtGui>
#include "mainwindow.h"
#include "creationdb.h"
#include "document.h"
#include "default.h"
#include "fmt4cmdw.h"
#include <fstream>
#include <iostream>
extern "C" {
    int SaveOrigin (char *Origin_name, ORIG *origin,char *ErrorString);
}
void error(QString s, QString s2 );
void error(QString s, QString s2 ) {
    QString tmp = s;
    tmp = tmp + " ";
    tmp = tmp + s2;
    QMessageBox::critical(0,mainWindowCaption(),tmp);

}
bool CopyFile(QString &source,QString &distination);
bool CopyFile(QString &source,QString &distination) {
    ofstream outfile(distination.toAscii(), ios::binary | ios::out);
    if (!(outfile)) {
        error(QString("cannot open output file"),distination);
        return false;
    }
    fstream in(source.toAscii(),ios::binary | ios::in);
    if (!(in)) {
        error(QString("cannot open input file"),source);
        return false;
    }
    outfile << in.rdbuf();
    outfile.close();
    in.close();
    return true;
}
///========================================================================================
ProcessKonsole::~ProcessKonsole() {
};
ProcessKonsole::ProcessKonsole(QWidget* parent,FDocument* doc,ProcessType type)
        : QProcess(),parent(parent),doc(doc),type(type) {
    setProcessChannelMode(QProcess::MergedChannels);

    connect(this, SIGNAL( readyReadStandardOutput () ), this, SLOT(ReadStandardOutput ()));
    connect(this, SIGNAL( readyReadStandardError () ), this, SLOT(ReadStandardError ()));

//    connect(this, SIGNAL( readyRead () ), this, SLOT(ReadyRead ()));

}
void ProcessKonsole::ReadyRead() {
    AppKonsole* wd = (AppKonsole*) parent;
    wd->SetStandardOutput(readAllStandardOutput ());
}
void ProcessKonsole::ReadStandardOutput() {
    AppKonsole* wd = (AppKonsole*) parent;
    QByteArray bytearray = readAllStandardOutput ();
    wd->SetStandardOutput(bytearray);
//    if (type == SeedToAh) wd->SetProgressSeedToAh(bytearray);
}
void ProcessKonsole::ReadStandardError() {
    AppKonsole* wd = (AppKonsole*) parent;
    QByteArray bytearray = readAllStandardError ();
    wd->SetStandardOutput(bytearray);
//    if (type == SeedToAh) wd->SetProgressSeedToAh(bytearray);
}
bool ProcessKonsole::StartProcess(const QString & workingDirectory,const QString & seedFileName) {
    QString name = "";
    if (type == SeedToAh) {
        name = "Seed to ah";
        program =QString("%1/bin/rdseed").arg(rootPath());
        if (!QFileInfo(program).exists () ) {
            QMessageBox::warning ( 0, "Create ah files from seed vol's" ,
                                   tr ( "Can't find program rdseed %1" )
                                   .arg (program));
            return false;


        }

        QString tmp = QString("%1/@@@Seed.ini").arg(workingDirectory);

        QString tmp1 = QString("seed volume:\n%1\n").arg(seedFileName);
        AppKonsole* wd = (AppKonsole*) parent;

        wd->textCursor().insertText(tmp1);

        setStandardInputFile(tmp);
    }
    if (type == SeedStaList) {
        name = "Get station list";
        program =QString("%1/bin/rdseed").arg(rootPath());
        if (!QFileInfo(program).exists () ) {
            QMessageBox::warning ( 0, "Create ah files from seed vol's" ,
                                   tr ( "Can't find program rdseed %1" )
                                   .arg (program));
            return false;


        }

        QString tmp = QString("%1/@@@Seed.staini").arg(workingDirectory);

        QString tmp1 = QString("seed volume:\n%1\n").arg(seedFileName);
        AppKonsole* wd = (AppKonsole*) parent;

        wd->textCursor().insertText(tmp1);

        setStandardInputFile(tmp);
    }

    setWorkingDirectory (workingDirectory);

    start (program);

    if (!waitForStarted()) {
        QMessageBox::warning ( 0,name + "process",
                               tr ( "The process %1 was not started." )
                               .arg (name));
        return false;
    }

    if (!waitForFinished()) {
        QMessageBox::warning ( 0,name + "process",
                               tr ( "The process %1 was not finished." )
                               .arg (name));
        return false;
    }



//    progress->cancel();
    return true;
}

bool ProcessKonsole::AhToDbProcess(const QString & workingDirectory,const QStringList & argumentList) {
    QString name = "Ah to db";
    program =QString("%1/bin/fmtAh2Db").arg(rootPath());
    if (!QFileInfo(program).exists () ) {
        QMessageBox::warning ( 0, "Create dbase from ah files" ,
                               tr ( "Can't find program fmtAh2Db %1" )
                               .arg (program));
        return false;


    }

    setWorkingDirectory (workingDirectory);
    start (program,argumentList);
    if (!waitForStarted(30000)) {
        QMessageBox::warning ( 0,name + "process",
                               tr ( "The process %1 was not started." )
                               .arg (name));
        return false;
    }

    if (!waitForFinished()) {
        QMessageBox::warning ( 0,name + "process",
                               tr ( "The process %1 was not finished." )
                               .arg (name));
        return false;
    }

    return true;
}
bool ProcessKonsole::DecimationProcess(const QString & workingDirectory,QString & scriptName) {
    QString name = "Decimation of dbase records";
    setWorkingDirectory (workingDirectory);
    QString program = "./"+scriptName;
    setWorkingDirectory (workingDirectory);

    start (program);

    if (!waitForStarted(30000)) {
        QMessageBox::warning ( 0,name + "process",
                               tr ( "The process %1 was not started." )
                               .arg (name));
        return false;
    }

    if (!waitForFinished()) {
        QMessageBox::warning ( 0,name + "process",
                               tr ( "The process %1 was not finished." )
                               .arg (name));
        return false;
    }
    return true;
}
///=====================================================================================
AppKonsole::~AppKonsole() {
    if (proc != 0) {
        delete proc;
        proc = 0;
    }
}
AppKonsole::AppKonsole(QWidget* parent)
        : QTextEdit(parent) {

    QFont f = parent->font();
    setFont( f );
    proc = 0;
}
void AppKonsole::SetDateTimeKonsole() {

    clear ();
    QString tmp = QString();
    QDateTime dt =  QDateTime::currentDateTime ();
    QString date = QString("%1\n\n").arg( dt.toString(Qt::ISODate));
    date.replace('-','/');
    date.replace('T',' ');
    tmp +="SeedToDb program konsole created on " + date;

    setAlignment ( Qt::AlignRight );//Qt::AlignCenter
    setTextColor (QColor("darkBlue") );
    textCursor().insertText(tmp);
    setAlignment (Qt::AlignLeft);
    setTextColor (QColor("black") );

}
void AppKonsole::SetStandardOutput(const QByteArray & outputArray) {
    textCursor().insertText(outputArray.data());
}
bool AppKonsole::AhCopyToTempDirectory(FDocument* doc) {
    //SetDateTimeKonsole();
    QDir inputSeedDirectory(doc->GetDataDirectoryName()->GetValue());
    QStringList filters;
    filters << "*" + ahFilterLocator();

    inputSeedDirectory.setNameFilters(filters);
    QStringList list = inputSeedDirectory.entryList(filters,QDir::Files);
    list.sort();
    QString tempDirectoryPath = MainWindow::self->tempDirectoryPath;
    QString ahDirectory = tempDirectoryPath + "/wfAh";
    ahDirectory = QDir::toNativeSeparators(ahDirectory);
    QDir tempDirectory = MainWindow::self->tempDirectory;
    if (!tempDirectory.mkdir(ahDirectory)) {
        QMessageBox::warning ( 0, "Create ah files from seed vol's" ,
                               tr ( "Can't create the working directory %1" )
                               .arg (ahDirectory));
        return false;

    }
    int num = list.size();
    int numAhFiles = 0;
    foreach (QString str, list) {
        QString source = doc->GetDataDirectoryName()->GetValue();//  + "/" + str;
    if (!(source[source.size() -1] == '/')) source = source + "/";
        source = source + str;


        source = QDir::toNativeSeparators(source);

        QString distination = ahDirectory;//  + "/" + str;

        if (!(distination[distination.size() -1] == '/')) distination = distination + "/";
        distination = distination + str;
        distination = QDir::toNativeSeparators(distination);

//        QMessageBox::critical(0,"", QString("AhCopyToTempDirectory\nsource '%1'\n distination '%2'").arg(source).arg(distination));
        CopyFile(source,distination);
    }


    return true;
}

void AppKonsole::SetProgressSeedToAh(const QByteArray & outputArray) {
    /*
        if (outputArray.indexOf(':') == -1) return;
        if (curNumStations > numStations-1)  return;
        QString tmp;
        tmp = staList.at(curNumStations);
    //QMessageBox::critical(0,"", QString("sta %1 sta %2").arg(tmp).arg(outputArray.data()));
        if ( outputArray.indexOf(tmp.toAscii()) != -1) {
            QString progressTitle = QString("Station %1 (# %2 of %3 )").arg(tmp).arg(++curNumStations).arg(numStations);
            progress->setLabelText (progressTitle);
            progress->setValue(curNumStations);
        }
    */
}
bool AppKonsole::SeedToAh(FDocument* doc) {

    //SetDateTimeKonsole();
    QString rdseedInitial = rootPath() + "/bin/fmtRdseed.initial";

//    QString rdseedStalist = rootPath() + "/bin/fmtRdseed.stalist";
    rdseedInitial = QDir::toNativeSeparators(rdseedInitial);

    QString tempDirectoryPath = MainWindow::self->tempDirectoryPath;
    QString ahDirectory = tempDirectoryPath + "/wfAh";
    QDir tempDirectory = MainWindow::self->tempDirectory;
    ahDirectory = QDir::toNativeSeparators(ahDirectory);
    if (!tempDirectory.mkdir(ahDirectory)) {
        QMessageBox::warning ( 0, "Create ah files from seed vol's" ,
                               tr ( "Can't create the working directory %1" )
                               .arg (ahDirectory));
        return false;

    }

    QDir inputSeedDirectory(doc->GetDataDirectoryName()->GetValue());
    QStringList filters;
    filters << "*" + seedFilterLocator();
    inputSeedDirectory.setNameFilters(filters);
    QStringList list = inputSeedDirectory.entryList(filters,QDir::Files);
    list.sort();
    /*
    ///===============================================================================


        numStations = 0;
        curNumStations = 0;
        staList.clear();
        foreach (QString str, list) {
            QString seedFile = doc->GetDataDirectoryName()->GetValue() + str;
            QFile in(rdseedStalist);
            if (!in.open(QIODevice::ReadOnly | QIODevice::Text)) {
                QMessageBox::warning ( 0, "Create ah files from seed vol's" ,
                                       tr ( "Can't open rdseed stations list initial file for reading %1" )
                                       .arg (rdseedStalist));
                return false;
            }
            QString seedIniFile = QString("%1/@@@Seed.staini").arg(ahDirectory);
            seedIniFile = QDir::toNativeSeparators(seedIniFile);
            QString staFile = QString("%1/rdseed.stations").arg(ahDirectory);
            staFile = QDir::toNativeSeparators(staFile);
            QFile out(seedIniFile);
            if (!out.open(QIODevice::WriteOnly | QIODevice::Text)) {
                QMessageBox::warning ( 0, "Create ah files from seed vol's" ,
                                       tr ( "Can't open rdseed temporary stations list initial file for writing %1" ).arg (seedIniFile));
                return false;
            }
            out.write ( seedFile.toAscii());
            out.write ("\n");
            while (!in.atEnd()) {
                QByteArray line = in.readLine();
                if (line[0] == '#') continue;
                if (line.indexOf("Input") != -1) continue;
                QByteArray lout = line.right(line.length () - line.lastIndexOf(":") - 1);
                out.write (lout);
            }
            out.write (" Quit\n");
            in.close ();
            out.close ();

            if (proc != 0) {
                delete proc;
                proc = 0;
            }
            proc = new ProcessKonsole(this,doc,ProcessKonsole::SeedStaList);
            if (!proc->StartProcess(ahDirectory,seedFile)) {
                return false;
            }

            if (!proc->waitForFinished()) {
                return false;
            }
            textCursor().insertText("\n");
            int n = 0;
            QStringList list;
            if (((n = GetNumStaFromSeedVol(staFile,list)) == -1)) return false;
            for (int i = 0; i < list.size(); ++i) staList << list.at(i);
            numStations += n;
        }
        progress->setRange (0,numStations);
        QString progressTitle = "Seed to ah.";
        progress->setWindowTitle (progressTitle);
        progress->show();


    ///======================================================================================
    */
    foreach (QString str, list) {
        QString seedFile = doc->GetDataDirectoryName()->GetValue() + str;
        QFile in(rdseedInitial);
        if (!in.open(QIODevice::ReadOnly | QIODevice::Text)) {
            QMessageBox::warning ( 0, "Create ah files from seed vol's" ,
                                   tr ( "Can't open rdseed initial file for reading %1" )
                                   .arg (rdseedInitial));
            return false;
        }
        QString seedIniFile = QString("%1/@@@Seed.ini").arg(ahDirectory);
        seedIniFile = QDir::toNativeSeparators(seedIniFile);
        QFile out(seedIniFile);
        if (!out.open(QIODevice::WriteOnly | QIODevice::Text)) {
            QMessageBox::warning ( 0, "Create ah files from seed vol's" ,
                                   tr ( "Can't open rdseed temporary initial file for writing %1" ).arg (seedIniFile));
            return false;
        }
        out.write ( seedFile.toAscii());
        out.write ("\n");
        while (!in.atEnd()) {
            QByteArray line = in.readLine();
            if (line[0] == '#') continue;
            if (line.indexOf("Input") != -1) continue;
            QByteArray lout = line.right(line.length () - line.lastIndexOf(":") - 1);
            out.write (lout);
        }
        out.write (" Quit\n");
        in.close ();
        out.close ();

        if (proc != 0) {
            delete proc;
            proc = 0;
        }
        proc = new ProcessKonsole(this,doc,ProcessKonsole::SeedToAh);
        if (!proc->StartProcess(ahDirectory,seedFile)) {
            return false;
        }
textCursor().insertText("\n");
        textCursor().insertText("\n");
    }
    ensureCursorVisible ();

    return true;
}

void AppKonsole::SetErrLogFileToKonsole(QString & name) {
    QFile in(name);
    if (!in.open(QIODevice::ReadOnly | QIODevice::Text)) {
        QMessageBox::warning ( 0, "Create ah files from seed vol's" ,
                               tr ( "Can't Error Log File file for reading %1" )
                               .arg (name));
        return;
    }
    while (!in.atEnd()) {
        QByteArray line = in.readLine();
        if (line.contains ("----  List of Data  -----")) break;
        textCursor().insertText(line.data());
    }
    in.close();
    ensureCursorVisible ();
}
int AppKonsole::GetNumStaFromSeedVol(QString & name,QStringList &staList) {
    QFile in(name);
    if (!in.open(QIODevice::ReadOnly | QIODevice::Text)) {
        QMessageBox::warning ( 0, "Create ah files from seed vol's" ,
                               tr ( "Can't Error station list file for reading %1" )
                               .arg (name));
        return -1;
    }
    int n = 0;

    while (!in.atEnd()) {
        QByteArray line =   in.readLine();
        int ind = line.indexOf(' ');
        int ind1 = line.indexOf(' ',6);
        QString tmp = line.mid(6, ind1-6) + ": ";
        tmp += line.left(ind).data();
        staList << tmp;
        n++;
    }

    in.close();
    return n;
}

bool AppKonsole::DecimateDbase(FDocument* doc,Ah4DbCmdWindow* ahsta) {
    char ErrorString[2048];

    QString workDirectory = MainWindow::self->tempDirectoryPath;
    QDir::setCurrent(workDirectory);
    if (ahsta->WriteScript(ErrorString) != 0) {
        QMessageBox::warning ( 0, "Dbase Decimation" ,
                               tr ( "Error of writing of decimation script" ));

        return false;
    }

    QString scriptName = QString("%1").arg((ahsta->origin).ScriptName);
    QFile script(scriptName);
    if (!script.exists ()) {
        QMessageBox::warning ( 0, "Dbase Decimation" ,
                               tr ( "Script '%1' dos not exist." ).arg(scriptName));

        return false;
    }

    script.setPermissions(QFile::ExeUser | QFile::ReadOwner);

    QDir::setCurrent(rootPath() + "/bin");
    setAlignment ( Qt::AlignCenter );//Qt::AlignCenter
    textCursor().insertText("Decimation dbase records ( 1 and 10 sec. )\n\n");
    setAlignment (Qt::AlignLeft);
    if (proc != 0) {
        delete proc;
        proc = 0;
    }

    proc = new ProcessKonsole(this,doc,ProcessKonsole::DbDecimate);

    if (!proc->DecimationProcess(workDirectory,scriptName)) {
        textCursor().insertText("\n");
        ensureCursorVisible ();
        return false;
    }

    textCursor().insertText("\n");
    ensureCursorVisible ();

    return true;
}
bool AppKonsole::MakeOriginTable(FDocument* doc,Ah4DbCmdWindow* ahsta) {
    ORIG origin = ahsta->origin;
    QString tempDirectoryPath = MainWindow::self->tempDirectoryPath;
    if (doc->GetOutputDeltaTime()->GetValue() == "1")
        tempDirectoryPath = doc->GetDbaseDirectoryName()->GetValue();
    QString originTable = doc->GetDbaseName()->GetValue();
    if (!(tempDirectoryPath[tempDirectoryPath.size() -1] == '/'))
    tempDirectoryPath = tempDirectoryPath + "/";
    originTable = tempDirectoryPath + originTable;

    char ErrorString[2048];
    //char* originName = originTable.toAscii().data();

    char * buf = new char[4096];
    ::snprintf(buf, 4096, "%s", originTable.toAscii().data());
    QString originTableFileName = originTable + ".origin";
    QFile file(originTableFileName);
    if (file.exists ()) if (!file.remove ()) {
            QMessageBox::warning ( 0, "Create the origin table" ,
                                   tr ( "Can't remove temporary origin table file\n%1" )
                                   .arg (originTableFileName));
        }

    if (SaveOrigin (buf, &origin,ErrorString)!= 0) {
        QMessageBox::warning ( 0, "Create the origin table" ,
                               tr ( "Error the origin table creation\n%1" )
                               .arg (ErrorString));
        delete [] buf;
        return false;
    }

    delete [] buf;
    return true;

}

bool AppKonsole::MakeDbaseFromAhFiles(FDocument* doc,QStringList &fmt2dbScriptlist) {

    if (proc != 0) {
        delete proc;
        proc = 0;
    }

    QString workDirectory = MainWindow::self->tempDirectoryPath;
    if (doc->GetOutputDeltaTime()->GetValue() == "1")
        workDirectory = doc->GetDbaseDirectoryName()->GetValue();
    QDir dir(workDirectory);
    dir.mkdir("wf");
    setAlignment ( Qt::AlignCenter );//Qt::AlignCenter
    textCursor().insertText("Transformation ah files to dbase:\n\n");
    setAlignment (Qt::AlignLeft);
    proc = new ProcessKonsole(this,doc,ProcessKonsole::AhToDb);

    foreach(QString str, fmt2dbScriptlist) {

        QStringList argumentList = str.split(' ');
        if (!proc->AhToDbProcess(workDirectory,argumentList)) {
            textCursor().insertText("\n");
            ensureCursorVisible ();
            return false;
        }
    }

    textCursor().insertText("\n");
    ensureCursorVisible ();
    return true;
}


