//
// C++ Interface: creationdb
//
// Description:
//
//
// Author: fmt <fmt@localhost.localdomain>, (C) 2008
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef CREATION_DBASE_H
#define CREATION_DBASE_H
#include <QTextEdit>
#include <QProcess>
class FDocument;
class ProcessKonsole;
class QProgressDialog;
class Ah4DbCmdWindow;
class AppKonsole : public QTextEdit {
    Q_OBJECT
public:
    AppKonsole(QWidget* parent);
    ~AppKonsole();
    bool SeedToAh(FDocument* doc);
    bool AhCopyToTempDirectory(FDocument* doc);
    void SetStandardOutput(const QByteArray & outputArray);
    void SetErrLogFileToKonsole(QString & name);
    int  GetNumStaFromSeedVol(QString & name,QStringList &staList);
    void SetProgressSeedToAh(const QByteArray & outputArray);
    bool MakeOriginTable(FDocument* doc,Ah4DbCmdWindow* ahsta);
    bool DecimateDbase(FDocument* doc,Ah4DbCmdWindow* ahsta);
    bool MakeDbaseFromAhFiles(FDocument* doc,QStringList &fmt2dbScriptlist);
    void SetDateTimeKonsole();
public slots:
protected:
protected slots:
private:
    ProcessKonsole* proc;
    int numStations;
    int curNumStations;
    QStringList staList;
    int step;
};

class ProcessKonsole : public QProcess {
    Q_OBJECT
public:
    enum ProcessType {
        SeedStaList,
        SeedToAh,
        AhToDb,
        DbDecimate
    };

    ProcessKonsole(QWidget* parent,FDocument* doc,ProcessType type);
    ~ProcessKonsole();
    bool StartProcess(const QString & workingDirectory,const QString & seedFileName);
    bool AhToDbProcess(const QString & workingDirectory,const QStringList & argumentList);
    bool DecimationProcess(const QString & workingDirectory,QString & scriptName);
    ProcessType GetProcessType() {
        return type;
    }
public slots:
protected:
protected slots:
    void ReadStandardOutput();
    void ReadStandardError();
    void ReadyRead();

private:
    QWidget* parent;
    FDocument* doc;
    ProcessType type;
    QString program;
};


#endif



