//
// C++ Implementation: default
//
// Description: 
//
//
// Author: fmt <fmt@localhost.localdomain>, (C) 2008
//
// Copyright: See COPYING file that comes with this distribution
//
//
#include <QString>
#include <QVector>
#include <QDir>
#include <float.h>
extern  QString ROOT_PATH;
extern  QString SEARCH_HELP_PATH;
 
static const  QString USER_HOME_PATH = QDir::homePath();

const QString  userHomePath()               { return USER_HOME_PATH;}

const QString  rootPath()               { return ROOT_PATH;}
const QString  searchHelpPath()            { return SEARCH_HELP_PATH;}

static const  QString MAIN_WINDOW_CAPTION = "Seed Vol's to DBase Panel";
const QString  mainWindowCaption()                  { return MAIN_WINDOW_CAPTION; }

	
static const  QString TEMPORARY_SYSTEM_DIRECTORY_PATH = QDir::temp().absolutePath ();
const QString  temporarySystemDirectoryPath()    { return TEMPORARY_SYSTEM_DIRECTORY_PATH; }

static const QString TEMPORARY_DIRECTORY_PREFIX    = "seedToDb-";
const QString  temporaryDirectoryPrifix()    { return TEMPORARY_DIRECTORY_PREFIX; }


static const  QString  SeedToDb_Current_Version = "111"; 
static const  QString  SeedToDb_Versions_For_Qt4 = "110 120";
 
const QString  SeedToDbCurrentVersion()   { return  SeedToDb_Current_Version;  }
const QString  SeedToDbVersionsForQt4()   { return  SeedToDb_Versions_For_Qt4; }

static const  QString SEED_FILE_FILTER_LOCATOR = ".seed";
const QString seedFilterLocator()   { return SEED_FILE_FILTER_LOCATOR; }

static const  QString AH_FILE_FILTER_LOCATOR = ".ah";
const QString ahFilterLocator()   { return AH_FILE_FILTER_LOCATOR; }

static const  QString PROJECT_FILE_FILTER_LOCATOR = ".sd2dbpro";
const QString projectFileFilterLocator() { return PROJECT_FILE_FILTER_LOCATOR;   }

static const  QString PROTOCOL_FILE_FILTER_LOCATOR = ".sd2dbprotocol";
const QString protocolFileFilterLocator()   { return PROTOCOL_FILE_FILTER_LOCATOR; }

//========================== SeedToDb parameters ======================================

///----------------------------------- Input Data Type -----------------------------
static const int     INPUT_DATA_TYPE_ID               = 1;
static const QString INPUT_DATA_TYPE                      = "Input Data Type";
static const QString INPUT_DATA_TYPE_DEFAULT               = "0";
static const QString INPUT_DATA_TYPE_ENUM           = "Seed Ah";
int     idInputDataType()       { return INPUT_DATA_TYPE_ID;      }
const QString nameInputDataType()     { return INPUT_DATA_TYPE;         }
const QString defaultInputDataType()  { return INPUT_DATA_TYPE_DEFAULT; }
const QString enumInputDataType()     { return INPUT_DATA_TYPE_ENUM;    }

///----------------------------------- Output DeltA Time -----------------------------
static const int     OUTPUT_DELTA_TIME_ID               = 2;
static const QString OUTPUT_DELTA_TIME                      = "Output DeltA Time";
static const QString OUTPUT_DELTA_TIME_DEFAULT               = "0";
static const QString OUTPUT_DELTA_TIME_ENUM           = "Decimate Origin";
int     idOutputDeltaTime()       { return OUTPUT_DELTA_TIME_ID;      }
const QString nameOutputDeltaTime()     { return OUTPUT_DELTA_TIME;         }
const QString defaultOutputDeltaTime()  { return OUTPUT_DELTA_TIME_DEFAULT; }
const QString enumOutputDeltaTime()     { return OUTPUT_DELTA_TIME_ENUM;    }

///----------------------------------- Data Directory Name --------------------------
static const int     DATA_DIRECTORY_NAME_ID         = 3;
static const QString DATA_DIRECTORY_NAME                      = "DBase Directory Name";
static const QString DATA_DIRECTORY_NAME_DEFAULT               = QString();
int     idDataDirectoryName()       { return DATA_DIRECTORY_NAME_ID;      }
const QString nameDataDirectoryName()     { return DATA_DIRECTORY_NAME;         }
const QString defaultDataDirectoryName()  { return DATA_DIRECTORY_NAME_DEFAULT; }

///----------------------------------- DBase Name -----------------------------
static const int     DBASE_NAME_ID         = 5;
static const QString DBASE_NAME                      = "DBase Name";
static const QString DBASE_NAME_DEFAULT               = QString();
int     idDbaseName()       { return DBASE_NAME_ID;      }
const QString nameDbaseName()     { return DBASE_NAME;         }
const QString defaultDbaseName()  { return DBASE_NAME_DEFAULT; }

///----------------------------------- DBase Directory Name -----------------------------
static const int     DBASE_DIRECTORY_NAME_ID         = 6;
static const QString DBASE_DIRECTORY_NAME                      = "DBase Directory Name";
static const QString DBASE_DIRECTORY_NAME_DEFAULT               = QString();
int     idDbaseDirectoryName()       { return DBASE_DIRECTORY_NAME_ID;      }
const QString nameDbaseDirectoryName()     { return DBASE_DIRECTORY_NAME;         }
const QString defaultDbaseDirectoryName()  { return DBASE_DIRECTORY_NAME_DEFAULT; }

///---------------------------------- Origin Data ------------------------------------------

//------------------------------------ OriginYear -------------------------------------
static const int     ORIGIN_YEAR_ID            = 7; 
static const QString ORIGIN_YEAR               = "Year";
static const QString ORIGIN_YEAR_DEFAULT       = "2000";
static const int     ORIGIN_YEAR_MIN           = 1950;
static const int     ORIGIN_YEAR_MAX           = 2050;
static const bool    ORIGIN_YEAR_SIGNED_VALUE  = FALSE;
int      idOriginYear()            { return ORIGIN_YEAR_ID;           }
const QString  nameOriginYear()          { return ORIGIN_YEAR;              }
const QString  defaultOriginYear()       { return ORIGIN_YEAR_DEFAULT;      }
int      minOriginYear()           { return ORIGIN_YEAR_MIN;          }
int      maxOriginYear()           { return ORIGIN_YEAR_MAX;          }
bool     signedOriginYear()        { return ORIGIN_YEAR_SIGNED_VALUE; }

//------------------------------------ OriginMonth -------------------------------------
static const int     ORIGIN_MONTH_ID            = 8; 
static const QString ORIGIN_MONTH               = "OriginMonth";
static const QString ORIGIN_MONTH_DEFAULT       = "1";
static const int     ORIGIN_MONTH_MIN           = 1;
static const int     ORIGIN_MONTH_MAX           = 12;
static const bool    ORIGIN_MONTH_SIGNED_VALUE  = FALSE;
int      idOriginMonth()            { return ORIGIN_MONTH_ID;           }
const QString  nameOriginMonth()          { return ORIGIN_MONTH;              }
const QString  defaultOriginMonth()       { return ORIGIN_MONTH_DEFAULT;      }
int      minOriginMonth()           { return ORIGIN_MONTH_MIN;          }
int      maxOriginMonth()           { return ORIGIN_MONTH_MAX;          }
bool     signedOriginMonth()        { return ORIGIN_MONTH_SIGNED_VALUE; }

//------------------------------------ OriginDay -------------------------------------
static const int     ORIGIN_DAY_ID            = 9; 
static const QString ORIGIN_DAY               = "OriginDay";
static const QString ORIGIN_DAY_DEFAULT       = "1";
static const int     ORIGIN_DAY_MIN           = 1;
static const int     ORIGIN_DAY_MAX           = 31;
static const bool    ORIGIN_DAY_SIGNED_VALUE  = FALSE;
int      idOriginDay()            { return ORIGIN_DAY_ID;           }
const QString  nameOriginDay()          { return ORIGIN_DAY;              }
const QString  defaultOriginDay()       { return ORIGIN_DAY_DEFAULT;      }
int      minOriginDay()           { return ORIGIN_DAY_MIN;          }
int      maxOriginDay()           { return ORIGIN_DAY_MAX;          }
bool     signedOriginDay()        { return ORIGIN_DAY_SIGNED_VALUE; }

//------------------------------------ OriginHour -------------------------------------
static const int     ORIGIN_HOUR_ID            = 10; 
static const QString ORIGIN_HOUR               = "OriginHour";
static const QString ORIGIN_HOUR_DEFAULT       = "1";
static const int     ORIGIN_HOUR_MIN           = 0;
static const int     ORIGIN_HOUR_MAX           = 23;
static const bool    ORIGIN_HOUR_SIGNED_VALUE  = FALSE;
int      idOriginHour()            { return ORIGIN_HOUR_ID;           }
const QString  nameOriginHour()          { return ORIGIN_HOUR;              }
const QString  defaultOriginHour()       { return ORIGIN_HOUR_DEFAULT;      }
int      minOriginHour()           { return ORIGIN_HOUR_MIN;          }
int      maxOriginHour()           { return ORIGIN_HOUR_MAX;          }
bool     signedOriginHour()        { return ORIGIN_HOUR_SIGNED_VALUE; }

//------------------------------------ OriginMinute -------------------------------------
static const int     ORIGIN_MINUTE_ID            = 11; 
static const QString ORIGIN_MINUTE               = "OriginMinute";
static const QString ORIGIN_MINUTE_DEFAULT       = "1";
static const int     ORIGIN_MINUTE_MIN           = 1;
static const int     ORIGIN_MINUTE_MAX           = 59;
static const bool    ORIGIN_MINUTE_SIGNED_VALUE  = FALSE;
int      idOriginMinute()            { return ORIGIN_MINUTE_ID;           }
const QString  nameOriginMinute()          { return ORIGIN_MINUTE;              }
const QString  defaultOriginMinute()       { return ORIGIN_MINUTE_DEFAULT;      }
int      minOriginMinute()           { return ORIGIN_MINUTE_MIN;          }
int      maxOriginMinute()           { return ORIGIN_MINUTE_MAX;          }
bool     signedOriginMinute()        { return ORIGIN_MINUTE_SIGNED_VALUE; }

///---------------------- OriginSecond -------------------------------------

static const int      ORIGIN_SECOND_ID        = 12; 
static const QString  ORIGIN_SECOND           = "OriginSecond";
static const QString  ORIGIN_SECOND_DEFAULT   = "0.00"  ;
static const float    ORIGIN_SECOND_MIN       = 0.00;
static const float    ORIGIN_SECOND_MAX       = 59.99;
static const int      ORIGIN_SECOND_DECIMAL   = 2;
int        idOriginSecond()        { return ORIGIN_SECOND_ID;        }
const QString    nameOriginSecond()      { return ORIGIN_SECOND;           }
const QString    defaultOriginSecond()   { return ORIGIN_SECOND_DEFAULT;   }
float      minOriginSecond()       { return ORIGIN_SECOND_MIN;       }
float      maxOriginSecond()       { return ORIGIN_SECOND_MAX;       }
int        decimalDOriginSecond()  { return ORIGIN_SECOND_DECIMAL;   }

//------------------------------------ Output Record Duration -------------------------------------
static const int     OUTPUT_RECORD_DURATION_ID            = 14; 
static const QString OUTPUT_RECORD_DURATION               = "Output Record Duration";
static const QString OUTPUT_RECORD_DURATION_DEFAULT       = "120";
static const int     OUTPUT_RECORD_DURATION_MIN           = 120;
static const int     OUTPUT_RECORD_DURATION_MAX           = 240;
static const bool    OUTPUT_RECORD_DURATION_SIGNED_VALUE  = FALSE;
int      idRecordDuration()            { return OUTPUT_RECORD_DURATION_ID;           }
const QString  nameRecordDuration()          { return OUTPUT_RECORD_DURATION;              }
const QString  defaultRecordDuration()       { return OUTPUT_RECORD_DURATION_DEFAULT;      }
int      minRecordDuration()           { return OUTPUT_RECORD_DURATION_MIN;          }
int      maxRecordDuration()           { return OUTPUT_RECORD_DURATION_MAX;          }
bool     signedRecordDuration()        { return OUTPUT_RECORD_DURATION_SIGNED_VALUE; }

///---------------------- OriginLatitude -------------------------------------

static const int      ORIGIN_LATITUDE_ID        = 15; 
static const QString  ORIGIN_LATITUDE           = "OriginLatitude";
static const QString  ORIGIN_LATITUDE_DEFAULT   = "0.000"  ;
static const float    ORIGIN_LATITUDE_MIN       = -90.000;
static const float    ORIGIN_LATITUDE_MAX       = 90.000;
static const int      ORIGIN_LATITUDE_DECIMAL   = 3;
int        idOriginLatitude()        { return ORIGIN_LATITUDE_ID;        }
const QString    nameOriginLatitude()      { return ORIGIN_LATITUDE;           }
const QString    defaultOriginLatitude()   { return ORIGIN_LATITUDE_DEFAULT;   }
float      minOriginLatitude()       { return ORIGIN_LATITUDE_MIN;       }
float      maxOriginLatitude()       { return ORIGIN_LATITUDE_MAX;       }
int        decimalDOriginLatitude()  { return ORIGIN_LATITUDE_DECIMAL;   }

///---------------------- OriginLongitude -------------------------------------

static const int      ORIGIN_LONGITUDE_ID        = 16; 
static const QString  ORIGIN_LONGITUDE           = "OriginLongitude";
static const QString  ORIGIN_LONGITUDE_DEFAULT   = "0.000"  ;
static const float    ORIGIN_LONGITUDE_MIN       = -180.000;
static const float    ORIGIN_LONGITUDE_MAX       = 180.000;
static const int      ORIGIN_LONGITUDE_DECIMAL   = 3;
int        idOriginLongitude()        { return ORIGIN_LONGITUDE_ID;        }
const QString    nameOriginLongitude()      { return ORIGIN_LONGITUDE;           }
const QString    defaultOriginLongitude()   { return ORIGIN_LONGITUDE_DEFAULT;   }
float      minOriginLongitude()       { return ORIGIN_LONGITUDE_MIN;       }
float      maxOriginLongitude()       { return ORIGIN_LONGITUDE_MAX;       }
int        decimalDOriginLongitude()  { return ORIGIN_LONGITUDE_DECIMAL;   }

///---------------------- OriginDepth -------------------------------------

static const int      ORIGIN_DEPTH_ID        = 17; 
static const QString  ORIGIN_DEPTH           = "OriginDepth";
static const QString  ORIGIN_DEPTH_DEFAULT   = "0.0"  ;
static const float    ORIGIN_DEPTH_MIN       = -10.0;
static const float    ORIGIN_DEPTH_MAX       = 900.0;
static const int      ORIGIN_DEPTH_DECIMAL   = 1;
int        idOriginDepth()        { return ORIGIN_DEPTH_ID;        }
const QString    nameOriginDepth()      { return ORIGIN_DEPTH;           }
const QString    defaultOriginDepth()   { return ORIGIN_DEPTH_DEFAULT;   }
float      minOriginDepth()       { return ORIGIN_DEPTH_MIN;       }
float      maxOriginDepth()       { return ORIGIN_DEPTH_MAX;       }
int        decimalDOriginDepth()  { return ORIGIN_DEPTH_DECIMAL;   }

///---------------------- OriginMb -------------------------------------

static const int      ORIGIN_MB_ID        = 18; 
static const QString  ORIGIN_MB           = "OriginMb";
static const QString  ORIGIN_MB_DEFAULT   = "0.00"  ;
static const float    ORIGIN_MB_MIN       = 0.00;
static const float    ORIGIN_MB_MAX       = 10.00;
static const int      ORIGIN_MB_DECIMAL   = 2;
int        idOriginMb()        { return ORIGIN_MB_ID;        }
const QString    nameOriginMb()      { return ORIGIN_MB;           }
const QString    defaultOriginMb()   { return ORIGIN_MB_DEFAULT;   }
float      minOriginMb()       { return ORIGIN_MB_MIN;       }
float      maxOriginMb()       { return ORIGIN_MB_MAX;       }
int        decimalDOriginMb()  { return ORIGIN_MB_DECIMAL;   }

///---------------------- OriginMs -------------------------------------

static const int      ORIGIN_MS_ID        = 19; 
static const QString  ORIGIN_MS           = "OriginMs";
static const QString  ORIGIN_MS_DEFAULT   = "0.00"  ;
static const float    ORIGIN_MS_MIN       = 0.00;
static const float    ORIGIN_MS_MAX       = 10.00;
static const int      ORIGIN_MS_DECIMAL   = 2;
int        idOriginMs()        { return ORIGIN_MS_ID;        }
const QString    nameOriginMs()      { return ORIGIN_MS;           }
const QString    defaultOriginMs()   { return ORIGIN_MS_DEFAULT;   }
float      minOriginMs()       { return ORIGIN_MS_MIN;       }
float      maxOriginMs()       { return ORIGIN_MS_MAX;       }
int        decimalDOriginMs()  { return ORIGIN_MS_DECIMAL;   }

///---------------------- OriginMl -------------------------------------

static const int      ORIGIN_ML_ID        = 20; 
static const QString  ORIGIN_ML           = "OriginMl";
static const QString  ORIGIN_ML_DEFAULT   = "0.00"  ;
static const float    ORIGIN_ML_MIN       = 0.00;
static const float    ORIGIN_ML_MAX       = 10.00;
static const int      ORIGIN_ML_DECIMAL   = 2;
int        idOriginMl()        { return ORIGIN_ML_ID;        }
const QString    nameOriginMl()      { return ORIGIN_ML;           }
const QString    defaultOriginMl()   { return ORIGIN_ML_DEFAULT;   }
float      minOriginMl()       { return ORIGIN_ML_MIN;       }
float      maxOriginMl()       { return ORIGIN_ML_MAX;       }
int        decimalDOriginMl()  { return ORIGIN_ML_DECIMAL;   }
