//
// C++ Interface: stationlist
//
// Description:
//
//
// Author: fmt <fmt@localhost.localdomain>, (C) 2008
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef STATION_LIST_H
#define STATION_LIST_H
#include <QTreeView>
#include <QItemDelegate>
#include <QModelIndex>
#include <QObject>
#include <QStandardItemModel>
#include <QDialog>
#include "origin.h"
#include <list>
#include <string>
using namespace std;
class FDocument;
class Station;
class Location;
class Channel;
class Comp;
class Record;
class TreePropertyModel;
class TreeProfileDelegate;
class Ah4DbCmdWindow;
class ProfileTreeView : public QTreeView {
    Q_OBJECT
public:
    ProfileTreeView(int numCol,QWidget* parent);
    ~ProfileTreeView();
    void SetStationTree(Ah4DbCmdWindow* ahsta,const QString &tempCurFileName);
    bool CheckStationTree();
    void MarkDoubleStationName();
    void SetMarkStationForDbase(FDocument* doc,QStringList &fmt2dbScriptlist);
    TreePropertyModel* GetModel() {
        return model;
    }
    TreeProfileDelegate* GetDelegate() {
        return delegate;
    }
    QIcon iconAccept;
    QIcon iconReject;
    QIcon iconLocation;
    QIcon iconDouble;
public slots:

protected:
    void drawBranches(QPainter *painter, const QRect &rect, const QModelIndex &index) const;
protected slots:
    void clicked(const QModelIndex & index);
private:
    TreePropertyModel* model;
    TreeProfileDelegate *delegate;
//----------------------------------------------------
    ORIG *origin;
    list <Station *> *itsStationList;
    void InitTreeView(const QString &tempCurFileName);


    list <Station  *>::iterator itrStation;
    list <Location *>::iterator itrLocation;
    list <Channel  *>::iterator itrChannel;
    list <Comp     *>::iterator itrComp;
    list <Record   *>::iterator itrRecord;

    int itLocationVal, itChannelVal, itCompVal;
    Ah4DbCmdWindow* ahsta;

//---------------------------------------------------
};
///========================================================================================
class TreePropertyModel : public QStandardItemModel {
    Q_OBJECT

public:
    TreePropertyModel(int columns, QWidget * parent = 0);
    ~TreePropertyModel();
    ProfileTreeView* parentWindow;
    void SetColumns(int rowFirst);
    void SetColumns(int rowFirst,int rowSecond);
    void SetColumns(int rowFirst,int rowSecond,int rowThird);
    void SetColumns(int rowFirst,int rowSecond,int rowThird,int rowForth);
    QModelIndex SetItem(int rowFirst,const QString value,QString value2 = QString());
    QModelIndex SetItem(int rowFirst,int rowSecond,const QString value,QString value2 = QString());
    QModelIndex SetItem(int rowFirst,int rowSecond,int rowThird,const QString value,QString value2 = QString());
    QModelIndex SetItem(int rowFirst,int rowSecond,int rowThird,int rowForth,const QString value,QString value2 = QString());
    QModelIndex SetItem(int rowFirst,int rowSecond,int rowThird,int rowForth,int rowFiveth,const QString value,QString value2 = QString());
    void clicked(const QModelIndex & index);
private:
    void CheckedStation(const QModelIndex & index);
    void UnCheckedStation(const QModelIndex & index);
    void CheckedLocation(const QModelIndex & index);
    void UnCheckedLocation(const QModelIndex & index);
    void CheckedChannel(const QModelIndex & index);
    void UnCheckedChannel(const QModelIndex & index);
    void CheckedComp(const QModelIndex & index);
    void UnCheckedComp(const QModelIndex & index);
    QModelIndex hasStationDouble(QModelIndex & indexstation,int & numDouble);
    void SetHorizontalHeader();
    int NumRows;
    int NumCols;


};
///========================================================================================
class TreeProfileDelegate : public QItemDelegate {
    Q_OBJECT

public:
    TreeProfileDelegate(QObject *parent = 0);
//    QWidget *createEditor(QWidget *parent, const QStyleOptionViewItem &option,
//                         const QModelIndex &index) const;

//    void setEditorData(QWidget *editor, const QModelIndex &index) const;
//    void setModelData(QWidget *editor, QAbstractItemModel *model,
//                    const QModelIndex &index) const;
    void paint(QPainter *painter, const QStyleOptionViewItem &option,
               const QModelIndex &index) const;
private slots:

private:
};

#endif
