#ifndef Fmt4class_H
#define Fmt4class_H
#include "ahhead.h"
#include <list>
#include <string>

using namespace std;


int DirectoryIsEmpty(char *OutErr,char *sourceDir,char *fileMask);

class Record {
public:
char *itsNameFile;
char *itsNameOut;
struct record_info *rec_info;
Record(char *str,char *str1,record_info *rr){
   itsNameFile = new char[strlen(str)+1];
   strcpy(itsNameFile,str);
   itsNameOut = new char[strlen(str1)+1];
   strcpy(itsNameOut,str1);
   rec_info = new record_info;
     memcpy(rec_info,rr,sizeof(record_info));
}
 virtual ~Record(){
//   fprintf(stderr,"Destructor Record %s\n",itsNameOut);

delete [] itsNameFile;
delete [] itsNameOut;
delete rec_info;

	}
   char*  &GetNameFile()  {return itsNameFile;}
   char*  &GetNameOut()   {return itsNameOut;}
   record_info* &GetRec_info()  {return rec_info;}
   };

class Comp {
private:
int itsNumberRecord;
int itsRemDefault;
int itsMarkDefault;
int itsMarkUser;
float itsHang;
float itsVang;
protected:
	list<Record *> itsRecordList;  
	list<Record *>::iterator itsItrRecord;

struct record_info *rec_info;
public:
char *itsNameComp;
   Comp(char *str, record_info *rr):itsNumberRecord(0),itsRemDefault(0), 
	itsMarkDefault(0),itsMarkUser(0){
   itsNameComp = new char[strlen(str)+1];
   strcpy(itsNameComp,str);
   rec_info = new record_info;
   memcpy(rec_info,rr,sizeof(record_info));

   }
   virtual ~Comp(){
  // fprintf(stderr,"Destructor Comp %s\n",itsNameComp);
   delete [] itsNameComp;
   delete rec_info;
	if (!itsRecordList.empty() ) {
	    for(itsItrRecord=itsRecordList.begin();
	    itsItrRecord!=itsRecordList.end();itsItrRecord++)   
            delete (*itsItrRecord);

	itsRecordList.clear();
   }
}
   char* &GetNameComp()    {return itsNameComp;}
   int &GetNumberRecord()  {return itsNumberRecord;}
   float &GetHang()        {return itsHang;}
   float &GetVang()        {return itsVang;}

   int &GetRemDefault()    {return itsRemDefault;}
   int &GetMarkDefault()       {return itsMarkDefault;}
   int &GetMarkUser()          {return itsMarkUser;}
   list<Record *> &GetRecordList() {return itsRecordList;}
   record_info* &GetRec_info()  {return rec_info;}
};


class Channel {
private:
int itsNumberComp;
int itsRemDefault;
int itsMarkDefault;
int itsMarkUser;
	char *itsErrComent;

protected:
	list<Comp *> itsCompList;  
	list<Comp *>::iterator itsItrComp;
public:
char *itsNameChannel;
   Channel(char *str):itsNumberComp(0),itsRemDefault(0),
   itsMarkDefault(0),itsMarkUser(0){
   itsNameChannel = new char[strlen(str)+1];
   strcpy(itsNameChannel,str);
  itsErrComent = new char[80];
   strcpy(itsErrComent," ");
 
   }
   virtual ~Channel(){
  // fprintf(stderr,"Destructor Channel %s\n",itsNameChannel);
   delete [] itsNameChannel;
   delete [] itsNameChannel;
	if (!itsCompList.empty() ) {
	    for(itsItrComp=itsCompList.begin();
	    itsItrComp!=itsCompList.end();itsItrComp++)   
            delete (*itsItrComp);

	itsCompList.clear();
   }

}
   char* &GetNameChannel()     {return itsNameChannel;}
   char* &GetErrComent()       {return itsErrComent;}

   int &GetNumberComp()        {return itsNumberComp;}
   int &GetRemDefault()        {return itsRemDefault;}
   int &GetMarkDefault()       {return itsMarkDefault;}
   int &GetMarkUser()          {return itsMarkUser;}

   list<Comp *> &GetCompList() {return itsCompList;}
};


class Location{
private:
int itsNumberChannel;
int itsRemDefault;
int itsMarkDefault;
int itsMarkUser;

protected:

	list<Channel *> itsChannelList;  
	list<Channel *>::iterator itsItrChannel;
public:
char *itsNameLocation;
   Location(char *str):itsNumberChannel(0),itsRemDefault(0),
itsMarkDefault(0),itsMarkUser(0){
//fprintf(stderr,"Location Constructor '%s'\n",str);
   itsNameLocation = new char[strlen(str)+1];
   strcpy(itsNameLocation,str);
   }
   virtual ~Location(){
 //  fprintf(stderr,"Destructor Location %s\n",itsNameLocation);
   delete [] itsNameLocation;
	if (!itsChannelList.empty() ) {
	    for(itsItrChannel=itsChannelList.begin();
	    itsItrChannel!=itsChannelList.end();itsItrChannel++)   
            delete (*itsItrChannel);

	itsChannelList.clear();
   }

}
   char* &GetNameLocation()  {return itsNameLocation;}
   int &GetNumberChannel()  {return itsNumberChannel;}
   int &GetRemDefault()    {return itsRemDefault;}
   int &GetMarkDefault()       {return itsMarkDefault;}
   int &GetMarkUser()       {return itsMarkUser;}
   list<Channel *> &GetChannelList() {return itsChannelList;}
};
class Station
{
private:
	int itsNumberLocation;
	int itsRemDefault;
	int itsMarkDefault;
	int itsMarkUser;

protected:
	list<Location *> itsLocationList;  
	list<Location *>::iterator itsItrLocation;  
public:
	char *itsNameStation;
	char *itsNameNet;

   Station(char *str,char *str1):itsNumberLocation(0),itsRemDefault(0),
itsMarkDefault(0),itsMarkUser(0){
itsNameStation = new char[strlen(str)+1];
strcpy(itsNameStation,str);
itsNameNet = new char[strlen(str1)+1];
strcpy(itsNameNet,str1);

}
   virtual ~Station(){
//   fprintf(stderr,"Destructor Station %s:%s\n",itsNameStation,itsNameNet);
   delete [] itsNameStation;
   delete [] itsNameNet;
	if (!itsLocationList.empty() ) {
	    for(itsItrLocation=itsLocationList.begin();
	    itsItrLocation!=itsLocationList.end();itsItrLocation++)   
            delete (*itsItrLocation);

	itsLocationList.clear();
   }

}
   char* &GetNameStation()     {return itsNameStation;}
   char* &GetNameNet()         {return itsNameNet;}
   int &GetNumberLocation()    {return itsNumberLocation;}
   int &GetRemDefault()        {return itsRemDefault;}
   int &GetMarkDefault()       {return itsMarkDefault;}
   int &GetMarkUser()          {return itsMarkUser;}
   list<Location *> &GetLocationList() {return itsLocationList;}

};


#endif
