#include <stdio.h>
#include <sys/types.h>
#if TIME_WITH_SYS_TIME
# include <sys/time.h>
# include <time.h>
#else
# if HAVE_SYS_TIME_H
#  include <sys/time.h>
# else
#  include <time.h>
# endif
#endif
#if HAVE_STRING_H
#  include <string.h>
#else
#  include <strings.h>
#endif
#  include <stdlib.h>
#  include <unistd.h>
#include <errno.h>
#include <limits.h>
typedef short ftnlen;
typedef short ftnint;
int lnblnk_ (char *str, ftnlen str_len);
void fdate_ (char *ret_val, ftnlen ret_val_len);
int access_ (char *name, const char *mode, ftnlen Lname, ftnlen Lmode);
void fdate_0 (char *ret_val, ftnlen ret_val_len);
int access_0 (char *name, const char *mode, ftnlen Lname, ftnlen Lmode);
double r_sign (float * a, float * b);
void s_copy ( char *a, char *b, ftnlen la, ftnlen lb);

//-----------------------------------------------------------
int lnblnk_ (char *str, ftnlen str_len) {
  int ret_val;
  int i_len ();

  for (ret_val = str_len; ret_val >= 1; --ret_val)
    {
      if (*(unsigned char *) &str[ret_val - 1] != ' ')
	{
	  return ret_val;
	}
    }
  return ret_val;
}
//------------------------------------------------------------------------------
void fdate_ (char *ret_val, ftnlen ret_val_len) {
    
    fdate_0 (ret_val, ret_val_len);
}
//----------------------------------------------------------------------
/* Character *24 */ 
void fdate_0 (char *ret_val, ftnlen ret_val_len)
{
  //int s_copy ();
  time_t tloc;
  tloc = time (NULL);
  /* Allow a length other than 24 for compatibility with what other
     systems do, despite it being documented as 24. */
  s_copy (ret_val, ctime ((time_t *) & tloc), ret_val_len, 24);
} 

//------------------------------------------------------------------------

int access_ ( char *name, const char *mode, ftnlen Lname, ftnlen Lmode) {
   
   return access_0 (name, mode, Lname, Lmode);


}
//----------------------------------------------------------------------------

int
access_0 (char *name, const char *mode, ftnlen Lname, ftnlen Lmode)
{
  char *buff;
  int amode, i;
  buff = (char *)malloc (Lname + 1);
  if (!buff)
    return -1;
  g_char (name, Lname, buff);
  amode = 0;
  for (i = 0; i < Lmode; i++)
    {
      switch (mode[i])
	{
	case 'r':
	  amode |= R_OK;
	  break;
	case 'w':
	  amode |= W_OK;
	  break;
	case 'x':
	  amode |= X_OK;
	  break;
	case ' ':
	  amode |= F_OK;
	  break;		/* as per Sun, at least */
	default:
	  return EINVAL;
	}
    }
  i = access (buff, amode);
  free (buff);
  return i;
}
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
void s_copy ( char *a, char *b, ftnlen la, ftnlen lb)
{
  char *aend, *bend;

  aend = a + la;

  if (la <= lb)
#ifndef NO_OVERWRITE
    if (a <= b || a >= b + la)
#endif
      while (a < aend)
	*a++ = *b++;
#ifndef NO_OVERWRITE
    else
      for (b += la; a < aend;)
	*--aend = *--b;
#endif

  else
    {
      bend = b + lb;
#ifndef NO_OVERWRITE
      if (a <= b || a >= bend)
#endif
	while (b < bend)
	  *a++ = *b++;
#ifndef NO_OVERWRITE
      else
	{
	  a += lb;
	  while (b < bend)
	    *--a = *--bend;
	  a += lb;
	}
#endif
      while (a < aend)
	*a++ = ' ';
    }
}
//---------------------------------------------------------------------------
double r_sign (float * a, float * b)
{
  double x;
  x = (*a >= 0 ? *a : -*a);
  return (*b >= 0 ? x : -x);
}
//---------------------------------------------------------------------------