	subroutine decimate(d,nin,dout,nout,idecfac,isf)

c		decimation routine using reftek digital 
c		convolution filters. can decimate by factors
c		of 2, 4, or 5.

c		d - input data array
c		nin - length of d
c		dout - ouput data array
c		nout - length of dout
c		idecfac - decimation factor (2,4, or 5)
c		isf - slow/fast - 1: fast, else: slow.

c	 calls subroutine: reftekfilters
c						mhr 3/17/93

	implicit integer(i-n), real(a-h,o-z)
	dimension filter(6,118), npts(6), conv(118)
	dimension d(*), dout(*)
	real filter, conv, d, dout
	integer nout, idecfac, isf, npts
	real*8 sum
c MOSTINSKY
c	print * ,'IN ',d(1),d(10),d(20)
c		fill array filter with reftek digital filter coeffs
	call reftekfilter(filter,npts)

	if(idecfac.ne.2.and.idecfac.ne.4.and.idecfac.ne.5) then
	 print *,'ERROR: can only decimate by a factor of 2,4, or 5.'
	 stop
	endif

c		find index n to correct filter
	if(idecfac.eq.2.and.isf.ne.1) n=1
	if(idecfac.eq.2.and.isf.eq.1) n=2
	if(idecfac.eq.4.and.isf.ne.1) n=3
	if(idecfac.eq.4.and.isf.eq.1) n=4
	if(idecfac.eq.5.and.isf.ne.1) n=5
	if(idecfac.eq.5.and.isf.eq.1) n=6
c		store filter in conv and length in n
	npt=npts(n)
	do j=1,npt	
	 conv(j)=filter(n,j)
	enddo
c		decimate: set to 0 if within half-width of end
	k=0
	do i=1,nin,idecfac
	 k=k+1	 
	 if(i.lt.npt.or.i.gt.nin-npt) then
	  dout(k)=0.
	 else
	  sum=d(i)*conv(1)
	  do j=1,npt-1
	   sum=sum+conv(j+1)*(d(i+j)+d(i-j))
	  enddo
	  dout(k)=sum
	 endif
	enddo
	nout=k
c MOSTINSKY
c	print * ,'OUT ',d(1),d(10),d(20)
c	print * ,'OUT ',dout(1),dout(10),dout(20)
	return
	end
		
