/*  convert ah-xdr format files to css3.0 w/DSAP schema current as of 11/94
  Modified from sac2db, 11/21/94 G Abers
 */
#include <sys/param.h>
 
#include "ahhead.h"
#include "stock.h"
#include "db.h"
#include "coords.h"
#include "response.h"
#include <stdio.h>

#include <rpc/rpc.h>
#include <math.h>
#include <memory.h>
#include <ctype.h>

#define _MAX_FILE_NAME   2048
float GetVang(char *str);
float GetHang(char *str);
int xdr_gogethead();
int xdr_gogetrecord();
int xdr_putdata();
int getchan();
int putinst();
int getorig();
int ah2db();
void  getOutName(ahhed          *ah,char **ah_name_out);
float 
GetHang(char *str){
float hang;
char *ptr;
ptr = strstr(str,"azm=") + 4;
sscanf(ptr,"%f",&hang); 

return hang;
}
float 
GetVang(char *str){
float vang;
char *ptr;
ptr = strstr(str,"inc=") + 4; 
sscanf(ptr,"%f",&vang); vang += 90;
return vang;
}

void cp2upper();
double          ah_2_epoch();


Response_group *
new_response_group();
char           *progname;

void
usage()
{
    fprintf(stderr, "Usage: %s works only under FmtAh4Db program conduct \n",
	    Program_Name);
    exit(1);
}


void
cp2upper(out, in)
char           *out,
               *in;
{
    while ((*out++ = toupper(*in++)) != 0);
}


int main(argc, argv)
int             argc;
char          **argv;
{

    int             i,j,jday1;
    char            database_name[_MAX_FILE_NAME],
                    ah_name[_MAX_FILE_NAME];
    char            ah_name_out[_MAX_FILE_NAME];
    char            wstr[_MAX_FILE_NAME],zstr[24];
    ahhed           ah_header;
    XDR             xdr_in,xdr_out;
    FILE           *file;
    Dbptr           db;
 
    char*             absflag,
                    ii;
    double          time,
                    timemin= 0;
float *sei;
long nsample;
long jk;
float sampling;
char chan[12];
float hang,vang;
    Program_Name = argv[0];

    if (argc < 3)
	usage();

     strcpy(database_name,argv[1]);
     strcpy(ah_name,argv[2]);
     strcpy(ah_name_out,argv[3]);
     strcpy(chan,argv[4]);

//      chan = argv[4][0];
     sscanf(argv[5],"%f",&hang);
     sscanf(argv[6],"%f",&vang);


/*
fprintf(stderr,"#####  database_name = %s\n ah_name = %s\n ah_name_out = %s\n ch = %s h = %7.2f v = %7.2f \n",
	database_name,ah_name,ah_name_out,chan,hang,vang);
*/
    /* flag for absolute path's in wfdisc */


  	if ((file = fopen(ah_name, "r")) == 0)
	    complain(1, "Can't open ah file for reading: '%s'\n", ah_name);
	else
	  {

	    xdrstdio_create(&xdr_in, file, XDR_DECODE);
	    ii = 1;
	    if (xdr_gogethead(ii, &ah_header, &xdr_in) != 0)
		complain(1, "Can't read ah header %s\n", ah_name);

	    time = ah_2_epoch(&ah_header.record.abstime);
	    if (i == 1)
		timemin = time;
	    if (time < timemin)
		timemin = time;
	    xdr_destroy(&xdr_in);
	    fclose(file);

	  }
   


    /* Load database now */
    dbopen(database_name, "r+", &db);

	if ((file = fopen(ah_name, "r")) == 0)
	    complain(1, "Can't open ah file for reading: '%s\n", ah_name);
	else
	  {
	    xdrstdio_create(&xdr_in, file, XDR_DECODE);
	    ii = 1;
	    if (xdr_gogethead(ii, &ah_header, &xdr_in) != 0)
		complain(1, "Can't read ah header %s\n", ah_name);
	    else {
                if (ah2db(&xdr_in, &ah_header, ah_name, ah_name_out,timemin, db,
			chan,hang,vang) != 0)
		complain(0, "AH file %s not incorporated.\n",
			 ah_name);

}

/*   !! Read digital   */ 

nsample = ah_header.record.ndata;
sampling =  ah_header.record.delta;
if  ( !(sei = malloc (sizeof(float ) * nsample) ) ) {
  fprintf(stderr,"Syst: (ah2db): Not free memory for sei");
  exit(0);
  }

ii = 1;

xdr_gogetrecord(ii,&ah_header,sei,&xdr_in);
/*
fprintf(stderr,"\nDigital data:> nsample = %ld \n",nsample);
for (jk = 0; jk < 5; jk++) {
fprintf(stderr,"%ld   %e\n",jk+1,sei[jk]);
}
fprintf(stderr,"...........\n");
fprintf(stderr,"...........\n");
fprintf(stderr,"...........\n");

fprintf(stderr,"%ld   %e\n",nsample-2,sei[nsample-3]);
fprintf(stderr,"%ld   %e\n",nsample-1,sei[nsample-2]);
fprintf(stderr,"%ld   %e\n",nsample  ,sei[nsample-1]);

*/
/*   !! Read digital  */


	    xdr_destroy(&xdr_in);
	    fclose(file);


/*   !! Write digital  */

// getOutName(&ah_header,&ah_name_out);
    sprintf(wstr,"wf/%s",ah_name_out);


	if ((file = fopen(wstr, "w")) == 0)
	    complain(1, "Can't open ah file for writing: '%s'\n", ah_name_out);
	else
	  {
	    xdrstdio_create(&xdr_out, file, XDR_ENCODE);

/* xdr_putrecord(&ah_header,sei,&xdr_out); */
xdr_putdata(&ah_header,sei,&xdr_out);
	    xdr_destroy(&xdr_out);
	    fclose(file);
fprintf(stderr,"AH file '%s'    (%ld) incorporated\n",ah_name_out,nsample);

}
free (sei);

/*   !! Write digital  */
	  }
 dbclose(db);


    return 0;
}

 /* size of header in ah- xdr */
#define AH_XDR_HEAD_SIZE 1080

int
ah2db(xdr_name, ah, ah_name, ah_name_out, timemin, db,channel,hangg,vangg)
XDR            *xdr_name;
ahhed          *ah;
Dbptr           db;
char           *ah_name;
double          timemin;
char* channel;
float hangg,vangg;
{
char str[1024];
    double          samprate,
                    time,
                    evtime,
                    endtime,
                    calib;
    int             nsamp;
    char            sta[15],
                    chan[15];
    double          hang,
                    vang;
    char            dir[STRSZ],
                    base[STRSZ];
    Dbptr           dbe,
                    dbo,
                    dbw,
                    dbsen,
                    dba;
    int             comsz,
                    jday1,
                    irec;
    double          lat,
                    lon,
                    depth;
    int             evid,
                    chanid,
                    inid,
                    orid,
                    nev1;
    char            instype[20],
                    evname[20];
    char           *segtype;
    char            ahcode[CODESIZE];
    char            ahchan[CHANSIZE];
    Dbvalue         dval;
    char            wstr[24],zstr[24];
    int j;


hang = (float)hangg;
vang = (float)vangg;

 //getOutName(ah,&ah_name_out);
    time = ah_2_epoch(&ah->record.abstime);
    jday1 = yearday(timemin);

    nsamp = ah->record.ndata;


    if (ah->record.delta == 0.0)
      {
	complain(0, "Sample rate (1/delta) undefined \n");
	return -1;
      }
    samprate = rint(10000. / ah->record.delta) / 10000.;	/* some rounding off */

    endtime = time + (nsamp - 1) / samprate;

    calib = 0.0;		       /* calib is supposed to be nm/count;
				        * just for fun assume DS is count/m */
    if (ah->station.DS != 0.0)
	calib = 1e+9 / ah->station.DS;

   // dirbase(ah_name, dir, base);
strcpy(base,ah_name_out);
strcpy(dir,"wf");
    cp2upper(ahcode, ah->station.code);
    cp2upper(ahchan, ah->station.chan);
    copystrip(sta, ahcode, CODESIZE - 1);
    copystrip(chan, ahchan, CHANSIZE - 1);
    copystrip(instype, ah->station.stype, STYPESIZE - 1);
/* Comment Mostinsk segtype = "-";don't usually know units of AH data 
This comment from origin ah2db program*/

/* This comment from rdseed source v4.17: programm output_ah.c Line ~ 244 

  place the azimuth and the dip into record 
		 * comment. Units is always DISP (m)
		 */

/*    segtype = "D";   	*/
    segtype = " ";   		       
	       
//chan[strlen(chan) - 1] = channel;
strcpy(chan,channel);

    dbw = dblookup(db, 0, "wfdisc", 0, 0);
    dbw.record = dbaddv(db, "wfdisc",
			"sta", sta,
			"chan", chan,
			"time", time,
			"jdate", yearday(time),
			"endtime", endtime,
			"nsamp", nsamp,
			"instype", instype,
			"segtype", segtype,
			"samprate", samprate,
			"calib", calib,
			"datatype", "t4",
			"dir", dir,
			"dfile", base,
			"foff", 0,
		/*	"foff", AH_XDR_HEAD_SIZE, */
			0);
    if (dbw.record < 0)
      {
	complain(0, "couldn't add %s to wfdisc\n", ah_name);
	return (-1);
      }

    dba = dblookup(db, 0, "site", "sta", sta);
    if (dba.record == dbINVALID)
      {
	if (dbaddv(db, "site",
		   "sta", sta,
		   "ondate", jday1,
		   "lat", (double) ah->station.slat,
		   "lon", (double) ah->station.slon,
		   "elev", (double) ah->station.elev / 1000.,
		   0) < 0)
	    complain(0, "couldn't add %s to site\n", ah_name);
	else
	    clear_register(0);
      }

    /* try to figure out channel */
    dba = dblookup(db, 0, "sitechan", 0, 0);
    irec = getchan(dba, chan, sta);
    if (irec < 0)
      {

	dba = dblookup(db, 0, "sitechan", 0, 0);
	dba.record = dbaddv(db, "sitechan",
			    "sta", sta,
			    "chan", chan,
			    "hang", hang,
			    "vang", vang,
			    "ondate", jday1,
			    0);
	if (dba.record < 0)
	    complain(0, "couldn't add %s to sitechan\n", ah_name);
	else
	  {
	    clear_register(0);
	    dbgetv(dba, 0, "chanid", &chanid, 0);
	    dbputv(dbw, "wfdisc", "chanid", chanid, 0);
	  }
      }
    else
      {
	dba.record = irec;
	dbgetv(dba, 0, "chanid", &chanid, 0);
	dbputv(dbw, "wfdisc", "chanid", chanid, 0);
      }

    /* RESPONSE Information */
    if (((int) (ah->station.cal[0].pole.r) > 0) || ((int) (ah->station.cal[0].zero.r) > 0))
      {
	dbsen = dblookup(db, 0, "sensor", 0, 0);
	irec = getchan(dbsen, chan, sta);
	if (irec < 0)
	  {
	    dbsen.record = dbaddv(db, "sensor",
				  "sta", sta,
				  "chan", chan,
				  "time", epoch(jday1),
				  "jdate", jday1,
				  "instant", "y",
				  0);
	    if (dbsen.record < 0)
		complain(0, "couldn't add %s to sensor\n", ah_name);
	    else
	      {
		clear_register(0);
		if (dba.record >= 0)
		    dbputv(dbsen, "sensor", "chanid", chanid, 0);
	      }

	    /* Put In Instrument response:  Only if this is a new STA/CHAN in
	     * sensor */
	    inid = putinst(ah, timemin, db);
	    if ((dbsen.record >= 0) && (inid > 0))
		dbputv(dbsen, "sensor", "inid", inid, 0);
	  }
      }

    /* EVENT Information */
 /*   if (ah->event.ot.yr > 0) */
/* Comment Mostinsk  If event info is exist in seed vol This info 
does not input in dbase table origin*/
if ( 2 == 1)
      {
	lat = ah->event.lat;
	lon = ah->event.lon;
	depth = ah->event.dep;
	evtime = ah_2_epoch(&ah->event.ot);
	irec = getorig(db, lat, lon, depth, evtime);
	if (irec < 0)
	  {
	    dbo = dblookup(db, 0, "origin", 0, 0);
	    dbquery(dbo, dbRECORD_COUNT, &dval);
	    nev1 = dval.i;
	    dbo.record = dbaddv(dbo, 0,
				"time", evtime,
				"lat", lat,
				"lon", lon,
				"depth", depth,
				"jdate", yearday(evtime),
				0);
	    if (dbo.record < 0)
		complain(0, "couldn't add %s to origin\n", ah_name);
	    else
	      {
		clear_register(0);
		dbquery(dbo, dbRECORD_COUNT, &dval);
		if (nev1 != dval.i)
		  {
		    dbgetv(dbo, 0, "orid", &orid, 0);
		    comsz = (int) COMSIZE - 1;
		    comsz = 19;	       /* hack to try to avoid memory
				        * trashing */
		    copystrip(evname, ah->event.ecomment, comsz);
		    dbe = dblookup(db, 0, "event", 0, 0);
		    dbe.record = dbaddv(dbe, 0,
					"evname", evname,
					"prefor", orid,
					0);
		    if (dbe.record < 0)
			complain(0, "couldn't add %s to event\n", ah_name);
		    else
		      {
			clear_register(0);
			dbgetv(dbe, 0, "evid", &evid, 0);
			dbputv(dbo, "origin", "evid", evid, 0);
		      }
		  }
	      }
	  }
      }
    else
	orid = -1;


    return 0;
}

/* -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=- *
   ah_2_epoch - change the time from ah format to epoch
 * -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=- */

double
ah_2_epoch(time)

struct ah_time *time;

{
    return h2e((int) time->yr,
	       mday2doy((int) time->yr,
			(int) time->mo,
			(int) time->day),
	       (int) time->hr,
	       (int) time->mn,
	       (double) time->sec);
}

Response_group *
paz_group_fill(ah)
ahhed          *ah;
{
    /* This allocates the memory and fills in the poles and zero (paz)
     * structure. From DanQ 1/9/95 */

    Response_group *group;
    Paz            *paz;
    int             i;

    group = new_response_group();
    allot(Paz *, paz, 1);
    group->id = PAZ;
    group->private = (void *) paz;
    group->srcid = THEORETICAL;
    strcpy(group->description, "ahPoleZero");	/* maximum 12 characters */
    strcpy(group->author, "From ah2db");	/* maximum 44 characters */

    paz->normalization = ah->station.A0;	/* normalization factor */
    paz->frequency = 0.;	       /* frequency (hz) at which stage is
				        * normalized; UNKNOWN */

    paz->npoles = (int) (ah->station.cal[0].pole.r);
    paz->nzeros = (int) (ah->station.cal[0].zero.r);
    if ((paz->npoles == 0) && (paz->nzeros == 0))
      {
	complain(0, "No calibration info present");
	return group;
      }
    allot(Complex *, paz->poles, paz->npoles);
    allot(Complex *, paz->zeros, paz->nzeros);
    allot(Complex *, paz->zero_errors, paz->nzeros);
    allot(Complex *, paz->pole_errors, paz->npoles);

    for (i = 0; i < paz->npoles; i++)
      {
	paz->poles[i].real = (double) ah->station.cal[i + 1].pole.r;
	paz->poles[i].imag = (double) ah->station.cal[i + 1].pole.i;
	paz->pole_errors[i].real = 0.0;
	paz->pole_errors[i].imag = 0.0;
      }

    for (i = 0; i < paz->nzeros; i++)
      {
	paz->zeros[i].real = (double) ah->station.cal[i + 1].zero.r;
	paz->zeros[i].imag = (double) ah->station.cal[i + 1].zero.i;
	paz->zero_errors[i].real = 0.0;
	paz->zero_errors[i].imag = 0.0;
      }

    return group;
}

int 
putinst(ah, timemin, db)
ahhed          *ah;
Dbptr           db;
double          timemin;
{
    Dbptr           dbi;
    double          samprate;
    char            insname[STRSZ];
    int             stypesz;
    double          calib;
    int             inid;
    char            dir[STRSZ], 
		    base[STRSZ], 
		    filename[STRSZ],
                    response_fbase[STRSZ];
    char	   *response_dir = "response" ;
    FILE           *file;
    Response       *response;
    Response_group *group;

    stypesz = (int) STYPESIZE - 1;
    copystrip(insname, ah->station.stype, stypesz);
    samprate = rint(100. / ah->record.delta) / 100.;	/* ROUNDED off */
    /* calib is supposed to be nm/count; just for fun assume DS is count/m */
    calib = 0.0;
    if (ah->station.DS != 0.0)
	calib = 1e+9 / ah->station.DS;

    dbi = dblookup(db, 0, "instrument", 0, 0);
    dbi.record = dbaddv(dbi, 0,
			"insname", insname,
			"samprate", samprate,
			"ncalib", calib,
		        0);
    if (dbi.record < 0)
      {
	complain(0, "Could not make instrument entry\n");
	return (-1);
      }
    else
      {
	clear_register(0);
	dbgetv(dbi, 0, "inid", &inid, 0);
      }

    sprintf(response_fbase, "resp_ah_%d%c", inid,'\0');
    dbputv(dbi, 0,
	    "dir", response_dir,
	    "dfile", response_fbase,
/* Comment Mostinsk rsptype", "D    " was absent into origin ah2db programm
see comment Line ~370
*/

	    "rsptype", "D    ",
	    0);

    /* get new response */
    response = new_response();
    group = paz_group_fill(ah);
    add_response_group(response, group);

    /* Set up/get output file */
    dbfilename (dbi, filename ) ; 
    dirbase (filename, dir, base ) ; 
    if (makedir(dir) != 0)
      {
	complain(1, "Unable to open/create response directory %s\n", dir);
	return (-1);
      }

    if ((file = fopen(filename, "w+")) == 0)
      {
	complain(1, "Could not open response file %s\n", filename);
	return (-2);
      }
    if (write_response(file, response) < 0)
      {
	complain(1, "Can't write response file '%s'\n", filename);
	return (-3);
      }
    fclose(file);

    return (inid);
}

int 
getchan(db, chan, sta)
Dbptr           db;
char           *chan;
char           *sta;

/* returns record # for first sta/chan combo.  dba must already point to appropriate
	table.  e.g., run
	db = dblookup(db,0, "sitechan", 0, 0);
	irec = getchan(db, chan, sta);
*/
{
    Dbptr           dba;
    int             i,
                    n,
                    iret;
    Dbvalue         dval;
    char            sta1[15],
                    chan1[15];

    iret = -1;
    dba = db;
    dbquery(dba, dbRECORD_COUNT, &dval);
    n = dval.i;
    if (n == 0)
	return (-1);
    for (i = 0; i < n; i++)
      {
	dba.record = i;
	dbgetv(dba, 0,
	       "sta", sta1,
	       "chan", chan1,
	       0);
	if (!(strcmp(sta1, sta) || strcmp(chan1, chan)))
	  {
	    return (i);
	  }
      }
    return (iret);
}

int 
getorig(db, lat, lon, dep, ot)
Dbptr           db;
double          lat;
double          lon;
double          dep;
double          ot;

/* returns record # for first event match.
*/
{
    Dbptr           dba;
    int             i,
                    n,
                    iret;
    Dbvalue         dval;
    double          alat,
                    alon,
                    adep,
                    aot;

    iret = -1;
    dba = dblookup(db, 0, "origin", 0, 0);
    dbquery(dba, dbRECORD_COUNT, &dval);
    n = dval.i;
    if (n == 0)
	return (-1);
    for (i = 0; i < n; i++)
      {
	dba.record = i;
	dbgetv(dba, 0,
	       "lat", &alat,
	       "lon", &alon,
	       "depth", &adep,
	       "time", &aot,
	       0);
	if ((alat == lat) && (alon == lon) && (adep == dep) && (aot = ot))
	    return (i);
      }
    return (iret);
}

void getOutName(ahhed          *ah,char **ah_name_out)
 {
    char   wstr[24],zstr[24],name[_MAX_FILE_NAME];
    int jday1,j;
jday1 = mday2doy((int) ah->record.abstime.yr,
			(int) ah->record.abstime.mo,
			(int)ah->record.abstime.day);

strcpy(wstr,ah->station.code);

for (j = 0;j < strlen(wstr);j++) if (wstr[j] == ' ') {wstr[j] = '\0'; break;}

strcpy(zstr,ah->station.chan);
for (j = 0;j < strlen(zstr);j++) if (zstr[j] == ' ') {zstr[j] = '\0'; break;}

sprintf(name,"%4d.%3d.%2d.%2d.%3.2f.%s.%s",
ah->record.abstime.yr,
jday1,
ah->record.abstime.hr,
ah->record.abstime.mn,
ah->record.abstime.sec,
wstr,
zstr
);

strcpy(ah_name_out,name);
}

/* $Id: ah2db.c,v 1.1.1.1 1997/04/12 04:17:00 danq Exp $ */
