
 /****  Standard include files  ****/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <memory.h>
  
 /****  Local include files  ****/
#include "origin.h"
#include "tmpl.h"
#include "elog.h"
#include "csstime.h"
#include "db.h"
#include "stock.h"
       
int etoh();
double e2h();
int mday2doy();
int
OpenOrigin(char *Origin_name, ORIG*** origin,int* reccount,char *ErrorString)
{
    char output_name[256];
    Dbptr db;
    Dbvalue value;
    struct date_time time;	       /* Time information */
    int doy;
    double epoph;
    double latitude,longitude,dep,mb,ms,ml;
    int recCount;
    int i =0;
strcpy(output_name,Origin_name);
*strrchr(output_name,'.') = '\0';

	
	if (dbopen (output_name, "r", &db) == dbINVALID) {
		sprintf (ErrorString, "Error: Unable to open database. <%s>\n",output_name);
        dbclose(db);
        dbfree(db);

		return 1;
	}

	db = dblookup (db, 0, "origin", 0, 0);
	recCount = dbquery (db, dbRECORD_COUNT, &value);

	if  ( !(*origin = malloc (sizeof(ORIG *)* recCount) )){
	    sprintf( ErrorString,"Error:> Not free memory for   ORIG typedef \n");     
	    return 7;
	}
	
	for (i = 0; i< recCount; i++ ) {
	    if  ( !((*origin)[i] = malloc (sizeof(ORIG )) )){
		sprintf( ErrorString,"Error:> Not free memory for [%d]    ORIG typedef \n",i);
		return 8;
	    }  
	}
	    for (i = 0; i< recCount; i++ ) {
		db.field = dbALL;
		db.record = i; 
 		if (	dbgetv (db, 0, 	
                                "lat", &latitude,
				"lon", &longitude,
				"depth",&dep,
				"time",&epoph,
				"mb", &mb,
				"ms", &ms,
				"ml", &ml,
			
				0) == dbINVALID ) {
	sprintf (ErrorString, "Error: Unable dbgetv for database. <%s>\n",output_name);
        dbclose(db);
        dbfree(db);

		return 2;
}
	time.epoch = epoph; 
	etoh(&time);
	doy = mday2doy (time.year, time.month, time.day);
	(*origin)[i]->year = time.year;
	(*origin)[i]->month = time.month;
	(*origin)[i]->doy= doy;
	(*origin)[i]->day = time.day;
	(*origin)[i]->hour = time.hour;
	(*origin)[i]->minute = time.minute;
	(*origin)[i]->second = time.second;
	(*origin)[i]->latitude = latitude;
	(*origin)[i]->longitude = longitude;
	(*origin)[i]->dep = dep;
	(*origin)[i]->mb = mb;
	(*origin)[i]->ms = ms;
	(*origin)[i]->ml = ml;
	//fprintf(stderr,"ZZZ %d %d %d %d %d %d %e\n",time.year,doy,time.month,time.day,time.hour,time.minute,latitude);
    }
	    dbclose(db);
	    dbfree(db);
	    *reccount = recCount;
	    return 0;
	
}
void freeOriginStructure(ORIG*** origin,int recCount){
    int i = 0;
    for (i = 0; i<recCount;i++)  free((*origin)[i]);  free(*origin);  *origin = 0;
}
