#include <qstring.h>
#include <QDir>
#include <float.h>     
extern QString FTAN_ROOT_PATH;
extern QString FTAN_SEARCH_HELP_PATH;

static const  QString USER_HOME_PATH = QDir::homePath();

const QString  userHomePath()               { return USER_HOME_PATH;}

const QString  rootPath()                  { return FTAN_ROOT_PATH;}
const QString  searchHelpPath()            { return FTAN_SEARCH_HELP_PATH;}

static const  QString MAIN_WINDOW_CAPTION = "Ftan Control Panel";
const QString  mainWindowCaption()                  { return MAIN_WINDOW_CAPTION;                   }
///------------- QDataStream version read-write constants : ------------------------------------------- 
//static const  QString  Ftan_Current_Version = "111"; 
static const  QString  Ftan_Current_Version = "122"; 
// version "111" contains  addition member numOriginRow; version "110" is not!

static const  QString   Version_QDataStream_Qt332 = "6";   // Qt 3.3.2
static const  QString  Ftan_Versions_For_Qt6 = "110 120";
static const  QString  Ftan_Versions_For_Qt433 = "121 130";
 
const QString  FtanCurrentVersion()                  { return Ftan_Current_Version;                   }
const QString VersionQDataStreamQt332()     { return Version_QDataStream_Qt332;      }
const QString  FtanVersionsForQt6()                 { return  Ftan_Versions_For_Qt6;               }

const QString  FtanVersionsForQt433()                 { return  Ftan_Versions_For_Qt433;               }
 
QByteArray  trarr(QString & str) { return str.toAscii();} 
QByteArray  trarr(const char* str) { return QByteArray(str);}
// When Qt with next QDataStream version will come then change
//  Qt_Current_Version = 7 
// and put   real limits for Ftan_Versions_For_ Qt6 and make next
// Ftan_Versions_For_ Qt7 for example
//  Ftan_Versions_For_ Qt6 = "110 117"; 
//Ftan_Current_Version = 118
// Ftan_Versions_For_ Qt7 = "118 130";
// !!  and put correction code to  FDocument::loadBinary

//             Parameter Properties Declarations :
// FTAN_ is common prefix; To it the name actually parameter
// is added. It becomes  a prefix of parametr.

//               PropertyBoolValue:>
// just Default: "0" is no(false); "1" is  yes(true)

//               PropertyFloatValue:>
// prefix for  Default; prefix_MIN for minimum; prefix_MAX for maximum

//               PropertyEnumValue:>
// prefix for  Default; prefix_ENUM  for Enumeration  
// Default "0" is no(false);"1" is  yes(true)

///-----------------------------------------  Window characteristic: -----------------------------------------
//   2.) postscript file root name....................   *
//   3.) window size (1-large).............(toggle)...  0
//   4.) mode (0-portrait).................(toggle)...  1
//   5.) postscript output?..(1-y).........(toggle)...  0
 

static const int FTAN_WINDOW_SIZE_ID                          = 1; 
static const QString FTAN_WINDOW_SIZE                                     = "window size"; 
static const QString FTAN_WINDOW_SIZE_DEFAULT                = "1"; 
static const QString FTAN_WINDOW_SIZE_ENUM                       = "Small Large"; 
int     idWindowSize()                                          { return FTAN_WINDOW_SIZE_ID;                   }
const QString nameWindowSize()                              { return FTAN_WINDOW_SIZE;                          }
const QString defaultWindowSize()                            { return FTAN_WINDOW_SIZE_DEFAULT;     }
const QString enumWindowSize()                              { return FTAN_WINDOW_SIZE_ENUM;            }

static const int  FTAN_WINDOW_MODE_ID                       = 2;  
static const QString FTAN_WINDOW_MODE                                  = "mode"; 
static const QString FTAN_WINDOW_MODE_DEFAULT             = "1"; 
static const QString FTAN_WINDOW_MODE_ENUM                    = "Portrait Landscape"; 
int     idWindowMode()                                          { return FTAN_WINDOW_MODE_ID;                   }
const QString nameWindowMode()                             { return FTAN_WINDOW_MODE;                          }
const QString defaultWindowMode()                           { return FTAN_WINDOW_MODE_DEFAULT;     }
const QString enumWindowMode()                             { return FTAN_WINDOW_MODE_ENUM;            }

static const int  FTAN_POSTSCRIPT_ID                        = 3;  
static const QString FTAN_POSTSCRIPT                                    = "postscript output"; 
static const QString FTAN_POSTSCRIPT_DEFAULT               = "1"; 
static const QString FTAN_POSTSCRIPT_ENUM                       = "No Yes"; 
int     idPostscript()                                         { return FTAN_POSTSCRIPT_ID;                   }
const QString namePostscript()                             { return FTAN_POSTSCRIPT;                          }
const QString defaultPostscript()                           { return FTAN_POSTSCRIPT_DEFAULT;     }
const QString enumPostscript()                             { return FTAN_POSTSCRIPT_ENUM;            }

///----------------------------------------- Plot characteristic:  ----------------------------------------
//   7.) foreground color.............................  blue         *
//   8.) background color.............................  seashell  *
//   9.) wave type for overplot.(R-Ray,L-Love,B-both).  B
//  10.) plot PREM group vels.(R-Ray,L-Love,B-both,N-no) B
//  50.) X-axis scaling: periods (T) or frequencies(F)    T
static const int FTAN_WAVE_TYPE_OVER_PLOT_ID                       = 4; 
static const QString FTAN_WAVE_TYPE_OVER_PLOT         = "Wave type for overplot";
static const QString FTAN_WAVE_TYPE_OVER_PLOT_DEFAULT  = "2";
static const QString FTAN_WAVE_TYPE_OVER_PLOT_ENUM             
	= "Rayleigh Love Rayleigh&Love";
int          idFtaWaveTypeOverPlot()                   { return FTAN_WAVE_TYPE_OVER_PLOT_ID;               }
const QString nameFtaWaveTypeOverPlot()            { return FTAN_WAVE_TYPE_OVER_PLOT;                      }
const QString defaultFtaWaveTypeOverPlot()          { return FTAN_WAVE_TYPE_OVER_PLOT_DEFAULT; }
const QString enumFtaWaveTypeOverPlot()            { return FTAN_WAVE_TYPE_OVER_PLOT_ENUM;        }

static const int  FTAN_GROUP_VELOCITY_PLOT_ID                       = 5; 
static const QString FTAN_GROUP_VELOCITY_PLOT         = "Plot PREM group vels";
static const QString FTAN_GROUP_VELOCITY_PLOT_DEFAULT  = "2";
static const QString FTAN_GROUP_VELOCITY_PLOT_ENUM             
	= "Rayleigh Love Rayleigh&Love No";
int          idFtaGroupVelocityPlot()                   { return FTAN_GROUP_VELOCITY_PLOT_ID ;               }
const QString nameFtaGroupVelocityPlot()            { return FTAN_GROUP_VELOCITY_PLOT;                       }
const QString defaultFtaGroupVelocityPlot()          { return FTAN_GROUP_VELOCITY_PLOT_DEFAULT;  }
const QString enumFtaGroupVelocityPlot()            { return FTAN_GROUP_VELOCITY_PLOT_ENUM;         }

static const int  FTAN_XAXIS_SCALING_ID                         = 6; 
static const QString FTAN_XAXIS_SCALING                       = "X-axis scaling";
static const QString FTAN_XAXIS_SCALING_DEFAULT  = "0";
static const QString FTAN_XAXIS_SCALING_ENUM             
	= "Periods Frequencies";
int          idXaxisScaling()                   { return FTAN_XAXIS_SCALING_ID ;               }
const QString nameXaxisScaling()            { return FTAN_XAXIS_SCALING;                       }
const QString defaultXaxisScaling()          { return FTAN_XAXIS_SCALING_DEFAULT;  }
const QString enumXaxisScaling()            { return FTAN_XAXIS_SCALING_ENUM;         }
///-----------------------------------------Edit handling:  ----------------------------------------
//  11.) if edits are applied..............(toggle)...  n
//  12.) if interpolate on nomimal grid....(toggle)...  n
static const int  FTAN_EDIT_APPLIED_ID                         = 7; 
static const QString FTAN_EDIT_APPLIED                       = "If edits are applied"; 
static const QString FTAN_EDIT_APPLIED_DEFAULT               = "1"; 
static const QString FTAN_EDIT_APPLIED_ENUM                       = "No Yes"; 
int          idEditApplied()                                   { return FTAN_EDIT_APPLIED_ID ;                    }
const QString nameEditApplied()                             { return FTAN_EDIT_APPLIED;                          }
const QString defaultEditApplied()                           { return FTAN_EDIT_APPLIED_DEFAULT;     }
const QString enumEditApplied()                             { return FTAN_EDIT_APPLIED_ENUM;            }

static const int  FTAN_INTERPOLATE_NOMINAL_GRID_ID                         = 8; 
static const QString FTAN_INTERPOLATE_NOMINAL_GRID                       = "If interpolate on nomimal grid"; 
static const QString FTAN_INTERPOLATE_NOMINAL_GRID_DEFAULT               = "0"; 
static const QString FTAN_INTERPOLATE_NOMINAL_GRID_ENUM                       = "No Yes"; 
int          idInterpolateNominalGrid()                                   { return FTAN_INTERPOLATE_NOMINAL_GRID_ID ;                    }
const QString nameInterpolateNominalGrid()                             { return FTAN_INTERPOLATE_NOMINAL_GRID;                          }
const QString defaultInterpolateNominalGrid()                           { return FTAN_INTERPOLATE_NOMINAL_GRID_DEFAULT;     }
const QString enumInterpolateNominalGrid()                             { return FTAN_INTERPOLATE_NOMINAL_GRID_ENUM;            }

///-----------------------------------------Waveform:  ----------------------------------------
//??.) record components to be plotted...................  znert  ???
// 13.) waveform filter specs..(t01,tc1,tc2,t02 (s)).   5.0   10.0  400.0  500.0
static const int  FTAN_PLOT_COMPTS_ID                         = 9; 
static const QString FTAN_PLOT_COMPTS                 = "Record components to be plotted";
static const QString FTAN_PLOT_COMPTS_DEFAULT         = "1 0 0 1 1";
static const QString FTAN_PLOT_COMPTS_ENUM            = "z n e r t";
int          idPlotCompts()                  { return FTAN_PLOT_COMPTS_ID ;                }
const QString namePlotCompts()           { return FTAN_PLOT_COMPTS;                        }
const QString defaultPlotCompts()         { return FTAN_PLOT_COMPTS_DEFAULT;   }
const QString enumPlotCompts()           { return FTAN_PLOT_COMPTS_ENUM;          }

///-----------------------------------------Waveform filter specification:  ----------------------------------------
static const int  FTAN_SHORT_PERIOD_ZERO_ID                         = 10; 
static const QString FTAN_SHORT_PERIOD_ZERO           = "Short period zero";
static const QString FTAN_SHORT_PERIOD_ZERO_DEFAULT   = "10.00"  ;
static const float   FTAN_SHORT_PERIOD_ZERO_MIN       = 0;
static const float   FTAN_SHORT_PERIOD_ZERO_MAX       = FLT_MAX;
static int   FTAN_SHORT_PERIOD_ZERO_DECIMAL    = 2;
int          idShortPeriodZero()                  { return FTAN_SHORT_PERIOD_ZERO_ID ;                }
const QString nameShortPeriodZero()      { return FTAN_SHORT_PERIOD_ZERO;                         }
const QString defaultShortPeriodZero()    { return FTAN_SHORT_PERIOD_ZERO_DEFAULT;    }
float   minShortPeriodZero()              { return FTAN_SHORT_PERIOD_ZERO_MIN;               }
float   maxShortPeriodZero()             { return FTAN_SHORT_PERIOD_ZERO_MAX;              }
int     decimalShortPeriodZero()        { return FTAN_SHORT_PERIOD_ZERO_DECIMAL;     }

static const int  FTAN_SHORT_PERIOD_CORNER_ID                  = 11; 
static const QString FTAN_SHORT_PERIOD_CORNER         = "Short period corner" ;
static const QString FTAN_SHORT_PERIOD_CORNER_DEFAULT = "15.00" ;
static const float   FTAN_SHORT_PERIOD_CORNER_MIN     = 0;
static const float   FTAN_SHORT_PERIOD_CORNER_MAX     = FLT_MAX;
static const int       FTAN_SHORT_PERIOD_CORNER_DECIMAL    = 2;
int          idShortPeriodCorner()           { return FTAN_SHORT_PERIOD_CORNER_ID ;                }
const QString nameShortPeriodCorner()    { return FTAN_SHORT_PERIOD_CORNER;                       }
const QString defaultShortPeriodCorner()  { return FTAN_SHORT_PERIOD_CORNER_DEFAULT;  }
float   minShortPeriodCorner()            { return FTAN_SHORT_PERIOD_CORNER_MIN;              }
float   maxShortPeriodCorner()           { return FTAN_SHORT_PERIOD_CORNER_MAX;             }
int     decimalShortPeriodCorner()      { return FTAN_SHORT_PERIOD_CORNER_DECIMAL ;   }

static const int  FTAN_LONG_PERIOD_CORNER_ID                  = 12; 
static const QString FTAN_LONG_PERIOD_CORNER          = "Long period corner";
static const QString FTAN_LONG_PERIOD_CORNER_DEFAULT  = "300.00";
static const float   FTAN_LONG_PERIOD_CORNER_MIN      = 0;
static const float   FTAN_LONG_PERIOD_CORNER_MAX      = FLT_MAX;
static const int       FTAN_LONG_PERIOD_CORNER_DECIMAL    = 2;
int          idLongPeriodCorner()            { return FTAN_LONG_PERIOD_CORNER_ID  ;                }
const QString nameLongPeriodCorner()      { return FTAN_LONG_PERIOD_CORNER;                       }
const QString defaultLongPeriodCorner()    { return FTAN_LONG_PERIOD_CORNER_DEFAULT;   }
float   minLongPeriodCorner()             { return FTAN_LONG_PERIOD_CORNER_MIN;               }
float   maxLongPeriodCorner()             { return FTAN_LONG_PERIOD_CORNER_MAX;             }
int     decimalLongPeriodCorner()        { return FTAN_LONG_PERIOD_CORNER_DECIMAL ;   }

static const int  FTAN_LONG_PERIOD_ZERO_ID                  = 13; 
static const QString FTAN_LONG_PERIOD_ZERO            = "Long period zero";
static const QString FTAN_LONG_PERIOD_ZERO_DEFAULT    = "350.00";
static const float   FTAN_LONG_PERIOD_ZERO_MIN        = 0;
static const float   FTAN_LONG_PERIOD_ZERO_MAX        = FLT_MAX;
static const int       FTAN_LONG_PERIOD_ZERO_DECIMAL    = 2;
int          idLongPeriodZero()             { return FTAN_LONG_PERIOD_ZERO_ID  ;                }
const QString nameLongPeriodZero()       { return FTAN_LONG_PERIOD_ZERO;                        }
const QString defaultLongPeriodZero()     { return FTAN_LONG_PERIOD_ZERO_DEFAULT;    }
float   minLongPeriodZero()              { return FTAN_LONG_PERIOD_ZERO_MIN;                }
float   maxLongPeriodZero()             { return FTAN_LONG_PERIOD_ZERO_MAX;               }
int     decimalLongPeriodZero()        { return FTAN_LONG_PERIOD_ZERO_DECIMAL ;     }

///-----------------------------------------Measurement specification:  ----------------------------------------
//14.) output image phase?...............(toggle)...  F
//15.) apply instrument response?........(toggle)...  T
//16.) change alpha filter parameters?..............  F
//17.) components to be processed...................  ZT  
//18.) polarization measurements?...................  T
static const int  FTAN_OUTPUT_IMAGE_PHASE_ID                  = 14; 
static const QString FTAN_OUTPUT_IMAGE_PHASE                             = "Output image phase"; 
static const QString FTAN_OUTPUT_IMAGE_PHASE_DEFAULT        = "0"; 
static const QString FTAN_OUTPUT_IMAGE_PHASE_ENUM               = "False True"; 
int          idOutPutImagePhase()                                              { return FTAN_OUTPUT_IMAGE_PHASE_ID  ;                }
const QString nameOutPutImagePhase()                                        { return FTAN_OUTPUT_IMAGE_PHASE;                                }
const QString defaultOutPutImagePhase()                                      { return FTAN_OUTPUT_IMAGE_PHASE_DEFAULT;           }
const QString enumOutPutImagePhase()                                        { return FTAN_OUTPUT_IMAGE_PHASE_ENUM;                  }

static const int  FTAN_INSTRUMENT_RESPONSE_ID                  = 15; 
static const QString FTAN_INSTRUMENT_RESPONSE                           = "Apply instrument response"; 
static const QString FTAN_INSTRUMENT_RESPONSE_DEFAULT      = "1"; 
static const QString FTAN_INSTRUMENT_RESPONSE_ENUM             = "False True"; 
int          idInstrumentResponse()                                                { return FTAN_INSTRUMENT_RESPONSE_ID  ;                }
const QString nameInstrumentResponse()                                        { return FTAN_INSTRUMENT_RESPONSE;                         }
const QString defaultInstrumentResponse()                                      { return FTAN_INSTRUMENT_RESPONSE_DEFAULT;    }
const QString enumInstrumentResponse()                                        { return FTAN_INSTRUMENT_RESPONSE_ENUM;           }

static const int  FTAN_CHANGE_ALPHA_FILTER_ID                  = 16; 
static const QString FTAN_CHANGE_ALPHA_FILTER                               = "Change alpha filter parameters"; 
static const QString FTAN_CHANGE_ALPHA_FILTER_DEFAULT          = "0"; 
static const QString FTAN_CHANGE_ALPHA_FILTER_ENUM                 = "False True"; 
int          idChangeAlphaFilter()                                                { return FTAN_CHANGE_ALPHA_FILTER_ID  ;                      }
const QString nameChangeAlphaFilter()                                        { return FTAN_CHANGE_ALPHA_FILTER;                                }
const QString defaultChangeAlphaFilter()                                      { return FTAN_CHANGE_ALPHA_FILTER_DEFAULT;           }
const QString enumChangeAlphaFilter()                                        { return FTAN_CHANGE_ALPHA_FILTER_ENUM;                  }

static const int  FTAN_FTA_COMPTS_ID                                 = 17; 
static const QString FTAN_FTA_COMPTS                               = "Components to be processed"    ;
static const QString FTAN_FTA_COMPTS_DEFAULT          = "1 0 1"    ;
static const QString FTAN_FTA_COMPTS_ENUM                 = "Z R T";
int          idFtaCompts()                                                { return FTAN_FTA_COMPTS_ID  ;              }
const QString nameFtaCompts()                                         { return FTAN_FTA_COMPTS;                       }
const QString defaultFtaCompts()                                       { return FTAN_FTA_COMPTS_DEFAULT;  }
const QString enumFtaCompts()                                         { return FTAN_FTA_COMPTS_ENUM;         }

static const int  FTAN_POLAR_ID                                              = 18; 
static const QString FTAN_POLAR                                             = "Polarization measurement"; 
static const QString FTAN_POLAR_DEFAULT                        = "1"; 
static const QString FTAN_POLAR_ENUM                               = "False True"; 
int          idPolar()                                                { return FTAN_POLAR_ID ;                       }
const QString namePolar()                                        { return FTAN_POLAR;                                }
const QString defaultPolar()                                      { return FTAN_POLAR_DEFAULT;           }
const QString enumPolar()                                        { return FTAN_POLAR_ENUM;                  }

///-----------------------------------------Phase velocity information:  ----------------------------------------
//  20.) attempt phase velocity measurements.(toggle).  T
//  21.) phase velocity bounds (cmin, cmax (km/s))....    3.50000    5.00000
//  22.) phase velocity reference period (s)..........    80.0000

static const int FTAN_PHASE_VELOCITY_MEGARUMENTS_ID                               = 19; 
static const QString FTAN_PHASE_VELOCITY_MEGARUMENTS                             = "Attempt phase velocity measurements"; 
static const QString FTAN_PHASE_VELOCITY_MEGARUMENTS_DEFAULT        = "1"; 
static const QString FTAN_PHASE_VELOCITY_MEGARUMENTS_ENUM               = "False True"; 
int          idPhaseVelocityMeasurement()               { return FTAN_PHASE_VELOCITY_MEGARUMENTS_ID ;                }
const QString namePhaseVelocityMeasurement()        { return FTAN_PHASE_VELOCITY_MEGARUMENTS;                       }
const QString defaultPhaseVelocityMeasurement()      { return FTAN_PHASE_VELOCITY_MEGARUMENTS_DEFAULT;  }
const QString enumPhaseVelocityMeasurement()         { return FTAN_PHASE_VELOCITY_MEGARUMENTS_ENUM;        }
///-----------------------------------------Phase velocity bounds (km/s)  ----------------------------------------
static const int FTAN_PHASE_VEL_BOUND_MINIMUM_ID                               = 20; 
static const QString FTAN_PHASE_VEL_BOUND_MINIMUM                            = "min";
static const QString FTAN_PHASE_VEL_BOUND_MINIMUM_DEFAULT       = "1.50";
static const float       FTAN_PHASE_VEL_BOUND_MINIMUM_MIN                   = 0;
static const float       FTAN_PHASE_VEL_BOUND_MINIMUM_MAX                  = FLT_MAX;
static const int          FTAN_PHASE_VEL_BOUND_MINIMUM_DECIMAL         = 2;
int          idPhaseVelBoundMinimum()               { return FTAN_PHASE_VEL_BOUND_MINIMUM_ID ;                }
const QString namePhaseVelBoundMinimum()       { return FTAN_PHASE_VEL_BOUND_MINIMUM;                        }
const QString defaultPhaseVelBoundMinimum()     { return FTAN_PHASE_VEL_BOUND_MINIMUM_DEFAULT;    }
float   minPhaseVelBoundMinimum()              { return FTAN_PHASE_VEL_BOUND_MINIMUM_MIN;                }
float   maxPhaseVelBoundMinimum()             { return FTAN_PHASE_VEL_BOUND_MINIMUM_MAX;              }
int      decimalPhaseVelBoundMinimum()       { return FTAN_PHASE_VEL_BOUND_MINIMUM_DECIMAL ;   }

static const int          FTAN_PHASE_VEL_BOUND_MAXIMUM_ID                      = 21; 
static const QString FTAN_PHASE_VEL_BOUND_MAXIMUM                            = "max";
static const QString FTAN_PHASE_VEL_BOUND_MAXIMUM_DEFAULT       = "5.00";
static const float       FTAN_PHASE_VEL_BOUND_MAXIMUM_MIN                   = 0;
static const float       FTAN_PHASE_VEL_BOUND_MAXIMUM_MAX                  = FLT_MAX;
static const int          FTAN_PHASE_VEL_BOUND_MAXIMUM_DECIMAL         = 2;
int          idPhaseVelBoundMaximum()               { return FTAN_PHASE_VEL_BOUND_MAXIMUM_ID ;                }
const QString namePhaseVelBoundMaximum()       { return FTAN_PHASE_VEL_BOUND_MAXIMUM;                        }
const QString defaultPhaseVelBoundMaximum()     { return FTAN_PHASE_VEL_BOUND_MAXIMUM_DEFAULT;    }
float   minPhaseVelBoundMaximum()              { return FTAN_PHASE_VEL_BOUND_MAXIMUM_MIN;                }
float   maxPhaseVelBoundMaximum()             { return FTAN_PHASE_VEL_BOUND_MAXIMUM_MAX;              }
int      decimalPhaseVelBoundMaximum()       { return FTAN_PHASE_VEL_BOUND_MAXIMUM_DECIMAL ;   }

static const int          FTAN_PHASE_VEL_REF_PERIOD_ID                      = 22; 
static const QString FTAN_PHASE_VEL_REF_PERIOD                            = "phase velocity reference period (s)";
static const QString FTAN_PHASE_VEL_REF_PERIOD_DEFAULT       = "20.00";
static const float       FTAN_PHASE_VEL_REF_PERIOD_MIN                   = 0;
static const float       FTAN_PHASE_VEL_REF_PERIOD_MAX                  = FLT_MAX;
static const int          FTAN_PHASE_VEL_REF_PERIOD_DECIMAL         = 2;
int          idPhaseVelRefPeriod()               { return FTAN_PHASE_VEL_REF_PERIOD_ID;                }
const QString namePhaseVelRefPeriod()       { return FTAN_PHASE_VEL_REF_PERIOD;                        }
const QString defaultPhaseVelRefPeriod()     { return FTAN_PHASE_VEL_REF_PERIOD_DEFAULT;    }
float   minPhaseVelRefPeriod()              { return FTAN_PHASE_VEL_REF_PERIOD_MIN;                }
float   maxPhaseVelRefPeriod()             { return FTAN_PHASE_VEL_REF_PERIOD_MAX;              }
int      decimalPhaseVelRefPeriod()       { return FTAN_PHASE_VEL_REF_PERIOD_DECIMAL ;   }

///-----------------------------------------Analysis limits:  ----------------------------------------
//  23.) min and max group velocity (km/sec)..........    1.50000    5.00000
//  24.) min and max period (sec).....................   10.00000    400.000
//  25.) numbers of orbit and mode....................  1  0
//  26.) raw spectrum: group velocity and width (s)...    3.57700    1800.00

///-----------------------------------------Group velocity bounds (km/s)  ----------------------------------------
static const int          FTAN_GROUP_VEL_BOUND_MINIMUM_ID                      = 23; 
static const QString FTAN_GROUP_VEL_BOUND_MINIMUM                            = "min";
static const QString FTAN_GROUP_VEL_BOUND_MINIMUM_DEFAULT       = "2.00";
static const float       FTAN_GROUP_VEL_BOUND_MINIMUM_MIN                   = 0;
static const float       FTAN_GROUP_VEL_BOUND_MINIMUM_MAX                  = FLT_MAX;
static const int          FTAN_GROUP_VEL_BOUND_MINIMUM_DECIMAL         = 2;
int          idGroupVelBoundMinimum()               { return FTAN_GROUP_VEL_BOUND_MINIMUM_ID ;                }
const QString nameGroupVelBoundMinimum()       { return FTAN_GROUP_VEL_BOUND_MINIMUM;                        }
const QString defaultGroupVelBoundMinimum()     { return FTAN_GROUP_VEL_BOUND_MINIMUM_DEFAULT;    }
float   minGroupVelBoundMinimum()              { return FTAN_GROUP_VEL_BOUND_MINIMUM_MIN;                }
float   maxGroupVelBoundMinimum()             { return FTAN_GROUP_VEL_BOUND_MINIMUM_MAX;              }
int      decimalGroupVelBoundMinimum()       { return FTAN_GROUP_VEL_BOUND_MINIMUM_DECIMAL ;   }

static const int          FTAN_GROUP_VEL_BOUND_MAXIMUM_ID                      = 24; 
static const QString FTAN_GROUP_VEL_BOUND_MAXIMUM                            = "max";
static const QString FTAN_GROUP_VEL_BOUND_MAXIMUM_DEFAULT       = "6.00";
static const float       FTAN_GROUP_VEL_BOUND_MAXIMUM_MIN                   = 0;
static const float       FTAN_GROUP_VEL_BOUND_MAXIMUM_MAX                  = FLT_MAX;
static const int          FTAN_GROUP_VEL_BOUND_MAXIMUM_DECIMAL         = 2;
int          idGroupVelBoundMaximum()               { return FTAN_GROUP_VEL_BOUND_MAXIMUM_ID ;                }
const QString nameGroupVelBoundMaximum()       { return FTAN_GROUP_VEL_BOUND_MAXIMUM;                        }
const QString defaultGroupVelBoundMaximum()     { return FTAN_GROUP_VEL_BOUND_MAXIMUM_DEFAULT;    }
float   minGroupVelBoundMaximum()              { return FTAN_GROUP_VEL_BOUND_MAXIMUM_MIN;                }
float   maxGroupVelBoundMaximum()             { return FTAN_GROUP_VEL_BOUND_MAXIMUM_MAX;              }
int      decimalGroupVelBoundMaximum()       { return FTAN_GROUP_VEL_BOUND_MAXIMUM_DECIMAL ;   }

///-----------------------------------------Period bounds (sec)  ----------------------------------------
static const int          FTAN_PERIOD_BOUND_MINIMUM_ID                      = 25; 
static const QString FTAN_PERIOD_BOUND_MINIMUM                            = "min";
static const QString FTAN_PERIOD_BOUND_MINIMUM_DEFAULT       = "10.00";
static const float       FTAN_PERIOD_BOUND_MINIMUM_MIN                   =0;
static const float       FTAN_PERIOD_BOUND_MINIMUM_MAX                  = FLT_MAX;
static const int          FTAN_PERIOD_BOUND_MINIMUM_DECIMAL         = 2;
int          idPeriodBoundMinimum()               { return FTAN_PERIOD_BOUND_MINIMUM_ID;                }
const QString namePeriodBoundMinimum()       { return FTAN_PERIOD_BOUND_MINIMUM;                        }
const QString defaultPeriodBoundMinimum()     { return FTAN_PERIOD_BOUND_MINIMUM_DEFAULT;    }
float   minPeriodBoundMinimum()              { return FTAN_PERIOD_BOUND_MINIMUM_MIN;                }
float   maxPeriodBoundMinimum()             { return FTAN_PERIOD_BOUND_MINIMUM_MAX;              }
int      decimalPeriodBoundMinimum()       { return FTAN_PERIOD_BOUND_MINIMUM_DECIMAL ;   }

static const int           FTAN_PERIOD_BOUND_MAXIMUM_ID                      = 26; 
static const QString FTAN_PERIOD_BOUND_MAXIMUM                            = "max";
static const QString FTAN_PERIOD_BOUND_MAXIMUM_DEFAULT       = "350.00";
static const float       FTAN_PERIOD_BOUND_MAXIMUM_MIN                   = 0;
static const float       FTAN_PERIOD_BOUND_MAXIMUM_MAX                  = FLT_MAX;
static const int          FTAN_PERIOD_BOUND_MAXIMUM_DECIMAL         = 2;
int          idPeriodBoundMaximum()               { return FTAN_PERIOD_BOUND_MAXIMUM_ID;                }
const QString namePeriodBoundMaximum()       { return FTAN_PERIOD_BOUND_MAXIMUM;                        }
const QString defaultPeriodBoundMaximum()     { return FTAN_PERIOD_BOUND_MAXIMUM_DEFAULT;    }
float   minPeriodBoundMaximum()              { return FTAN_PERIOD_BOUND_MAXIMUM_MIN;                }
float   maxPeriodBoundMaximum()             { return FTAN_PERIOD_BOUND_MAXIMUM_MAX;              }
int      decimalPeriodBoundMaximum()       { return FTAN_PERIOD_BOUND_MAXIMUM_DECIMAL ;   }

///-----------------------------------------numbers of orbit and mode ----------------------------------------
static const int           FTAN_ORBIT_ID                      = 27; 
static const QString FTAN_ORBIT          = "Number of orbit";
static const QString FTAN_ORBIT_DEFAULT  = "1";
static const int            FTAN_ORBIT_MIN      = 1;
static const int            FTAN_ORBIT_MAX                     = 16;
static const bool          FTAN_ORBIT_SIGNED_VALUE    = FALSE;
int          idOrbit()                     { return FTAN_ORBIT_ID;                                   }
const QString nameOrbit()               { return FTAN_ORBIT;                                         }
const QString defaultOrbit()             { return FTAN_ORBIT_DEFAULT;                    }
int   minOrbit()                          { return FTAN_ORBIT_MIN;                               }
int   maxOrbit()                         { return FTAN_ORBIT_MAX;                              }
bool     signedOrbit()               { return FTAN_ORBIT_SIGNED_VALUE;        }

static const int           FTAN_MODE_ID                      = 28; 
static const QString FTAN_MODE          = "Number of mode";
static const QString FTAN_MODE_DEFAULT  = "0";
static const int            FTAN_MODE_MIN      = 0;
static const int            FTAN_MODE_MAX                     = 4;
static const bool          FTAN_MODE_SIGNED_VALUE    = FALSE;
int          idMode()                       { return FTAN_MODE_ID;                                   }
const QString nameMode()               { return FTAN_MODE;                                         }
const QString defaultMode()             { return FTAN_MODE_DEFAULT;                    }
int   minMode()                          { return FTAN_MODE_MIN;                               }
int   maxMode()                         { return FTAN_MODE_MAX;                              }
bool     signedMode()               { return FTAN_MODE_SIGNED_VALUE;       }

///-----------------------------------------Raw spectrum: group velocity and width (s)  ----------------------------------------
static const int           FTAN_ROW_SPECTRUM_GROUP_VELOCITY_ID                      = 29; 
static const QString FTAN_ROW_SPECTRUM_GROUP_VELOCITY                            = "Group velocity";
static const QString FTAN_ROW_SPECTRUM_GROUP_VELOCITY_DEFAULT       = "3.60";
static const float       FTAN_ROW_SPECTRUM_GROUP_VELOCITY_MIN                   = 0;
static const float       FTAN_ROW_SPECTRUM_GROUP_VELOCITY_MAX                  = FLT_MAX;
static const int          FTAN_ROW_SPECTRUM_GROUP_VELOCITY_DECIMAL         = 2;
int          idRowSpectrumGroupVelocity()              { return FTAN_ROW_SPECTRUM_GROUP_VELOCITY_ID;                  }
const QString nameRowSpectrumGroupVelocity()       { return FTAN_ROW_SPECTRUM_GROUP_VELOCITY;                        }
const QString defaultRowSpectrumGroupVelocity()     { return FTAN_ROW_SPECTRUM_GROUP_VELOCITY_DEFAULT;    }
float   minRowSpectrumGroupVelocity()               { return FTAN_ROW_SPECTRUM_GROUP_VELOCITY_MIN;                }
float   maxRowSpectrumGroupVelocity()             { return FTAN_ROW_SPECTRUM_GROUP_VELOCITY_MAX;              }
int      decimalRowSpectrumGroupVelocity()       { return FTAN_ROW_SPECTRUM_GROUP_VELOCITY_DECIMAL ;   }

static const int           FTAN_ROW_SPECTRUM_WIDTH_ID                      = 30; 
static const QString FTAN_ROW_SPECTRUM_WIDTH                            = "Width";
static const QString FTAN_ROW_SPECTRUM_WIDTH_DEFAULT       = "1800.00";
static const float       FTAN_ROW_SPECTRUM_WIDTH_MIN                   = 0;
static const float       FTAN_ROW_SPECTRUM_WIDTH_MAX                  = FLT_MAX;
static const int          FTAN_ROW_SPECTRUM_WIDTH_DECIMAL         = 2;
int          idRowSpectrumWidth()              { return FTAN_ROW_SPECTRUM_WIDTH_ID;                  }
const QString nameRowSpectrumWidth()       { return FTAN_ROW_SPECTRUM_WIDTH;                        }
const QString defaultRowSpectrumWidth()     { return FTAN_ROW_SPECTRUM_WIDTH_DEFAULT;    }
float   minRowSpectrumWidth()               { return FTAN_ROW_SPECTRUM_WIDTH_MIN;               }
float   maxRowSpectrumWidth()              { return FTAN_ROW_SPECTRUM_WIDTH_MAX;              }
int      decimalRowSpectrumWidth()        { return FTAN_ROW_SPECTRUM_WIDTH_DECIMAL ;   }

///-----------------------------------------Event information:  ----------------------------------------
//  32.) read centryd and moment relations..(toggle)..  n
static const int           FTAN_READ_CENTRID_MOMENT_RELATION_ID                      = 31; 
static const QString FTAN_READ_CENTRID_MOMENT_RELATION                      = "Read centryd and moment relations"; 
static const QString FTAN_READ_CENTRID_MOMENT_RELATION_DEFAULT = "0"; 
static const QString FTAN_READ_CENTRID_MOMENT_RELATION_ENUM        = "No Yes"; 
int          idReadCentridMomentRelation()                { return FTAN_READ_CENTRID_MOMENT_RELATION_ID;              }
const QString nameReadCentridMomentRelation()         { return FTAN_READ_CENTRID_MOMENT_RELATION;                     }
const QString defaultReadCentridMomentRelation()       { return FTAN_READ_CENTRID_MOMENT_RELATION_DEFAULT;}
const QString enumReadCentridMomentRelation()         { return FTAN_READ_CENTRID_MOMENT_RELATION_ENUM;       }

static const int          FTAN_INDICATOR_READ_LIST_STATION_ID                      = 777; 
int          idIndicatorReadStation()                { return FTAN_INDICATOR_READ_LIST_STATION_ID;      }
static const QString FTAN_INDICATOR_READ_LIST_STATION_NO  = "No"; 
static const QString FTAN_INDICATOR_READ_LIST_STATION_YES = "Yes"; 
const QString nameIndicatorReadStationNo()         { return FTAN_INDICATOR_READ_LIST_STATION_NO;                     }
const QString nameIndicatorReadStationYes()        { return FTAN_INDICATOR_READ_LIST_STATION_YES;                     }
///------------------------------ period list tree view ------------------------------
static const QString FTAN_FORMAT_COLUMN_PERIOD_LIST    = "[ %1 , %2 ]";
const QString formatColumnPeriod()         { return FTAN_FORMAT_COLUMN_PERIOD_LIST; }
/////




