#ifndef _FTAN_DEFAULTS_H
#define _FTAN_DEFAULTS_H
QByteArray  trarr(QString & str);
QByteArray  trarr(const char* str);
const QString  userHomePath();

const QString  rootPath();
const QString  searchHelpPath();
const QString  mainWindowCaption();
///------------- QDataStream version read-write constants : -------------------------------------------
const QString  FtanCurrentVersion();
const QString VersionQDataStreamQt332();
const QString  FtanVersionsForQt6();
const QString  FtanVersionsForQt433();
///-----------------------------------------  Window characteristic: -----------------------------------------
int          idWindowSize();
const QString nameWindowSize() ;
const QString defaultWindowSize() ;
const QString enumWindowSize() ;

int          idWindowMode() ;
const QString nameWindowMode() ;
const QString defaultWindowMode() ;
const QString enumWindowMode() ;

int          idPostscript();  
const QString namePostscript();
const QString defaultPostscript() ; 
const QString enumPostscript();


///----------------------------------------- Plot characteristic:  ----------------------------------------
int          idFtaWaveTypeOverPlot() ;
const QString nameFtaWaveTypeOverPlot();
const QString defaultFtaWaveTypeOverPlot() ;
const QString enumFtaWaveTypeOverPlot();

int          idFtaGroupVelocityPlot() ;
const QString nameFtaGroupVelocityPlot();
const QString defaultFtaGroupVelocityPlot() ;
const QString enumFtaGroupVelocityPlot() ;

int          idXaxisScaling() ;
const QString nameXaxisScaling();
const QString defaultXaxisScaling();
const QString enumXaxisScaling();

///-----------------------------------------Edit handling:  ----------------------------------------
int          idEditApplied() ;
const QString nameEditApplied();
const QString defaultEditApplied() ;
const QString enumEditApplied();

int          idInterpolateNominalGrid() ;
const QString nameInterpolateNominalGrid() ;
const QString defaultInterpolateNominalGrid();
const QString enumInterpolateNominalGrid() ;

///-----------------------------------------Waveform:  ----------------------------------------
int          idPlotCompts() ;
const QString namePlotCompts();
const QString defaultPlotCompts();
const QString enumPlotCompts();

int          idShortPeriodZero();
const QString nameShortPeriodZero();
const QString defaultShortPeriodZero();
float   minShortPeriodZero();
float   maxShortPeriodZero();
int     decimalShortPeriodZero() ;

int          idShortPeriodCorner() ;
const QString nameShortPeriodCorner();
const QString defaultShortPeriodCorner();
float   minShortPeriodCorner();
float   maxShortPeriodCorner();
int     decimalShortPeriodCorner(); 

int          idLongPeriodCorner() ;
const QString nameLongPeriodCorner();
const QString defaultLongPeriodCorner();
float   minLongPeriodCorner();
float   maxLongPeriodCorner();
int     decimalLongPeriodCorner();

int          idLongPeriodZero() ;
const QString nameLongPeriodZero();
const QString defaultLongPeriodZero();
float   minLongPeriodZero();
float   maxLongPeriodZero();
int     decimalLongPeriodZero();


///-----------------------------------------Measurement specification:  ----------------------------------------
int          idOutPutImagePhase();
const QString nameOutPutImagePhase() ;
const QString defaultOutPutImagePhase();
const QString enumOutPutImagePhase();

int          idInstrumentResponse();
const QString nameInstrumentResponse() ;
const QString defaultInstrumentResponse() ;
const QString enumInstrumentResponse();

int          idChangeAlphaFilter();
const QString nameChangeAlphaFilter() ;
const QString defaultChangeAlphaFilter();
const QString enumChangeAlphaFilter() ;

int          idFtaCompts() ;
const QString nameFtaCompts();
const QString defaultFtaCompts();
const QString enumFtaCompts();

int          idPolar();
const QString namePolar();
const QString defaultPolar();
const QString enumPolar();

///-----------------------------------------Phase velocity information:  ----------------------------------------
int          idPhaseVelocityMeasurement();
const QString namePhaseVelocityMeasurement() ;
const QString defaultPhaseVelocityMeasurement();
const QString enumPhaseVelocityMeasurement() ;

int          idPhaseVelBoundMinimum();
const QString namePhaseVelBoundMinimum() ;
const QString defaultPhaseVelBoundMinimum();
float   minPhaseVelBoundMinimum();
float   maxPhaseVelBoundMinimum();
int      decimalPhaseVelBoundMinimum();

int          idPhaseVelBoundMaximum();
const QString namePhaseVelBoundMaximum();
const QString defaultPhaseVelBoundMaximum();
float   minPhaseVelBoundMaximum() ;
float   maxPhaseVelBoundMaximum();
int      decimalPhaseVelBoundMaximum();

int          idPhaseVelRefPeriod() ;
const QString namePhaseVelRefPeriod();
const QString defaultPhaseVelRefPeriod();
float   minPhaseVelRefPeriod();
float   maxPhaseVelRefPeriod();
int      decimalPhaseVelRefPeriod();

///-----------------------------------------Analysis limits:  ----------------------------------------
int          idGroupVelBoundMinimum();
const QString nameGroupVelBoundMinimum() ;
const QString defaultGroupVelBoundMinimum();
float   minGroupVelBoundMinimum();
float   maxGroupVelBoundMinimum() ;
int      decimalGroupVelBoundMinimum();

int          idGroupVelBoundMaximum();
const QString nameGroupVelBoundMaximum();
const QString defaultGroupVelBoundMaximum();
float   minGroupVelBoundMaximum();
float   maxGroupVelBoundMaximum();
int      decimalGroupVelBoundMaximum();

int          idPeriodBoundMinimum();
const QString namePeriodBoundMinimum() ;
const QString defaultPeriodBoundMinimum() ;
float   minPeriodBoundMinimum();
float   maxPeriodBoundMinimum() ;
int      decimalPeriodBoundMinimum();

int          idPeriodBoundMaximum();
const QString namePeriodBoundMaximum() ;
const QString defaultPeriodBoundMaximum();
float   minPeriodBoundMaximum() ;
float   maxPeriodBoundMaximum();
int      decimalPeriodBoundMaximum();

int          idOrbit();
const QString nameOrbit();
const QString defaultOrbit();
int   minOrbit();
int   maxOrbit();
bool     signedOrbit();

int          idMode();
const QString nameMode();
const QString defaultMode();
int   minMode();
int   maxMode();
bool     signedMode();

int          idRowSpectrumGroupVelocity();
const QString nameRowSpectrumGroupVelocity();
const QString defaultRowSpectrumGroupVelocity();
float   minRowSpectrumGroupVelocity();
float   maxRowSpectrumGroupVelocity();
int      decimalRowSpectrumGroupVelocity();

int          idRowSpectrumWidth();
const QString nameRowSpectrumWidth();
const QString defaultRowSpectrumWidth();
float   minRowSpectrumWidth();
float   maxRowSpectrumWidth();
int      decimalRowSpectrumWidth();

///-----------------------------------------Event information:  ----------------------------------------
int          idReadCentridMomentRelation() ;
const QString nameReadCentridMomentRelation() ;
const QString defaultReadCentridMomentRelation() ;
const QString enumReadCentridMomentRelation() ;

/////
int          idIndicatorReadStation() ;
const QString nameIndicatorReadStationNo();
const QString nameIndicatorReadStationYes();

///------------------------------ period list tree view ------------------------------
const QString formatColumnPeriod();
#endif
