#ifndef _EDIT_LINE_PROPERTY_H
#define _EDIT_LINE_PROPERTY_H
#include <QObject>
#include <QLineEdit>
class QWidget;
class QSpinBox;
class QDoubleValidator;
class PropertyValue;

class LineEditor : public QLineEdit
{
    Q_OBJECT
public:
    LineEditor(PropertyValue* prop,QString val,QWidget *parent = 0,bool isTreeView = false);
    ~LineEditor();
PropertyValue* GetProperty(){return prop;}
void FinishEditLine(){editFinish();}
void SetEditedValue(QString val){editedValue = val;}
void SetProp(PropertyValue* p){prop = p;}
QDoubleValidator* vld;
void SetEditedProperty();
protected:
void keyPressEvent ( QKeyEvent * event );
void focusOutEvent ( QFocusEvent * event );
protected slots:
    void setValue( const QString  &v );
    void editFinish();
private:
void editEsc();
PropertyValue* prop;
QString editedValue;
bool isTreeView;
};
 
class LineDocProperty : public QObject
{
    Q_OBJECT
public:
    LineDocProperty(QWidget * widget,PropertyValue* prop);
virtual    ~LineDocProperty();
void SetValueFromDoc();
QWidget *GetEditor() {return widget;}
PropertyValue* GetProp(){return prop;}
void SetProp(PropertyValue* p){prop = p;}
void ReplaceProperty(PropertyValue* newProp);
void FinishEditLine(){editFinish();}
void SetEditedValue(QString val){editedValue = val;}
QSpinBox * spin;
LineEditor *editor;
protected slots:
    void setValue( const QString  &v );
    void editFinish();

private:
    QWidget *widget;
    PropertyValue* prop;
	QString editedValue;
    bool isTreeView;
};

#endif
