#include <qstring.h>
#include <qpushbutton.h>
#include <qlabel.h>
#include <qlayout.h>
#include <qlineedit.h> 
#include <qfont.h>
#include <qpixmap.h>
#include <qtable.h> 
#include <qmessagebox.h> 
#include "mainwindow.h"
#include "filterspecimpl.h"
#include "document.h"
#include "propertyeditor.h"
FilterSpec::~FilterSpec(){
delete  lineEditTo1; lineEditTo1 = 0;
delete  lineEditTc1; lineEditTc1 = 0;
delete  lineEditTo2; lineEditTo2 = 0;
delete  lineEditTc2; lineEditTc2 = 0;  
}
FilterSpec::FilterSpec( QWidget *parent, FDocument* dc )
    : FilterSpecBase( parent, 0 ),doc(dc)
{
    setFont( parent->font() );
  
    lineEditTo1 = new LineEditDouble(this,"LineEditDouble1", 
				  doc->GetShortPeriodZero()->GetMin(), 
				  doc->GetShortPeriodZero()->GetMax(),
				  doc->GetShortPeriodZero()->GetDecimal(),FALSE); 
     lineEditTc1 = new LineEditDouble(this,"LineEditDouble2", 
				  doc->GetShortPeriodCorner()->GetMin(), 
				  doc->GetShortPeriodCorner()->GetMax(),
				  doc->GetShortPeriodCorner()->GetDecimal(),FALSE); 
     lineEditTo2 = new LineEditDouble(this,"LineEditDouble3", 
				  doc->GetLongPeriodZero()->GetMin(), 
				  doc->GetLongPeriodZero()->GetMax(),
				  doc->GetLongPeriodZero()->GetDecimal(),FALSE); 
     lineEditTc2 = new LineEditDouble(this,"LineEditDouble4", 
				  doc->GetLongPeriodCorner()->GetMin(), 
				  doc->GetLongPeriodCorner()->GetMax(),
				  doc->GetLongPeriodCorner()->GetDecimal(),FALSE);     

     lineEditTo1->setFrame( FALSE );    
     lineEditTc1->setFrame( FALSE );       
     lineEditTo2->setFrame( FALSE );       
     lineEditTc2->setFrame( FALSE );  
     
//     lineEditTo1->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)5, (QSizePolicy::SizeType)5, 0, 0, 
//					      lineEditTo1->sizePolicy().hasHeightForWidth() ) );
   
     lineEditTo1->setText(doc->GetShortPeriodZero()->GetValue());
     lineEditTc1->setText(doc->GetShortPeriodCorner()->GetValue());
     lineEditTo2->setText( doc->GetLongPeriodZero()->GetValue() );
     lineEditTc2->setText( doc->GetLongPeriodCorner()->GetValue());       
     defaultShort = new QPushButton( this, "defaultShort" );       
     defaultLong =  new QPushButton( this, "defaultLong" );   
     defaultShort->setPixmap(QPixmap::fromMimeSource("ftan_default.png") );     
     defaultLong->setPixmap(QPixmap::fromMimeSource("ftan_default.png") );     
     table->setCellWidget ( 0,2, defaultShort) ;
     table->setCellWidget ( 1,2, defaultLong) ;

    
     table->setCellWidget ( 0,0, lineEditTo1) ;
     table->setCellWidget ( 0,1, lineEditTc1) ;
     table->setCellWidget ( 1,0, lineEditTo2) ;
     table->setCellWidget ( 1,1, lineEditTc2) ;
     
     table->horizontalHeader()->setLabel( 2, " " ) ;
     table->verticalHeader()->setLabel( 0, tr( "Short period " ) );
     table->verticalHeader()->setLabel( 1, tr( "Long period  " ) );
     table->adjustColumn ( 2 );
     table->setColumnStretchable ( 0, TRUE );
     table->setColumnStretchable ( 1, TRUE );   
     table->adjustRow ( 0 ); table->adjustRow ( 1 );
//     table->adjustSize();
//     adjustSize();
//     resize( sizeHint () );
     connect( defaultShort, SIGNAL( clicked() ),
		this, SLOT( setDefaultShort() ) );
     connect( defaultLong, SIGNAL( clicked() ),
		this, SLOT( setDefaultLong() ) );
}

void FilterSpec::accept()
{
//qWarning("FilterSpec::accept()");  
doc->GetShortPeriodZero()->SetValue(
QString::number( lineEditTo1->text().toDouble(),'f',doc->GetShortPeriodZero()->GetDecimal()));
doc->GetShortPeriodCorner()->SetValue(
QString::number( lineEditTc1->text().toDouble(),'f',doc->GetShortPeriodCorner()->GetDecimal()));
doc->GetLongPeriodZero()->SetValue(
QString::number( lineEditTo2->text().toDouble(),'f',doc->GetLongPeriodZero()->GetDecimal()));
doc->GetLongPeriodCorner()->SetValue(
QString::number(lineEditTc2->text().toDouble(),'f',doc->GetLongPeriodCorner()->GetDecimal()));

doc->GetShortPeriodZero()->SetValueToResetvalue();
doc->GetShortPeriodCorner()->SetValueToResetvalue();
doc->GetLongPeriodZero()->SetValueToResetvalue();
doc->GetLongPeriodCorner()->SetValueToResetvalue();

doc->GetShortPeriodZero()->setChanged();
doc->GetShortPeriodCorner()->setChanged();
doc->GetLongPeriodZero()->setChanged();
doc->GetLongPeriodCorner()->setChanged();
done( Accepted ); 
}
void FilterSpec::reject()
{
//qWarning("FilterSpec::reject()");   
doc->GetShortPeriodZero()->SetResetvalueToValue();
doc->GetShortPeriodCorner()->SetResetvalueToValue();
doc->GetLongPeriodZero()->SetResetvalueToValue();
doc->GetLongPeriodCorner()->SetResetvalueToValue();
done( Rejected );    
}
void FilterSpec::setDefaultShort(){
//qWarning("FilterSpec::setDefaultShort()");      
     lineEditTo1->setText(doc->GetShortPeriodZero()->GetDefaultvalue());
     lineEditTc1->setText(doc->GetShortPeriodCorner()->GetDefaultvalue());
}
void FilterSpec::setDefaultLong(){
//qWarning("FilterSpec::setDefaultLong()");      
     lineEditTo2->setText( doc->GetLongPeriodZero()->GetDefaultvalue() );
     lineEditTc2->setText( doc->GetLongPeriodCorner()->GetDefaultvalue());  
}

