#include <q3popupmenu.h>
#include <qtoolbutton.h>
#include <q3process.h>
#include <qtimer.h>
#include <qmessagebox.h>
#include <q3progressdialog.h>
#include <qapplication.h>
#include <qpushbutton.h>
#include <qfile.h>
#include <qfileinfo.h>
#include <q3textstream.h>
#include <qdir.h>
#include <qaction.h>
#include <qstatusbar.h>
#include "mainwindow.h"
#include "stationlisteditor.h"
#include "propertydialogImpl.h"
#include "toolbarsetimpl.h"
#include "stationlistimpl.h"
#include "document.h"
#include "defaults.h"
#include "setting.h"
//----------------------------------------------------------------------------------------------------------------------------------------
QString  MainWindow::GetPlotCompString() {
    QString temp = "";
    QStringList words =  doc->GetPlotCompt()->GetList   () ;
    QStringList valuelist = QStringList::split (' ',doc->GetPlotCompt()->GetValue());
    QStringList::iterator it;
    int i = 0;
    for (i = 0, it = words.begin() ; it != words.end(); ++it ,i++)
        if (valuelist[i]  == "1")  temp += words[i];
    return temp;
}
QString MainWindow::GetToBeProcessedCompString() {
    QString temp = "";
    QStringList words =  doc->GetFtaCompt()->GetList   () ;
    QStringList valuelist = QStringList::split (' ',doc->GetFtaCompt()->GetValue());
    QStringList::iterator it;
    int i = 0;
    for (i = 0, it = words.begin() ; it != words.end(); ++it ,i++)
        if (valuelist[i]  == "1")  temp += words[i];
    return temp;

}
void FtanSettingView() {

}
void  MainWindow::showDialogHelp() {
    pageHelp("Ftan_In_Tab.html");
    process->writeToStdin(trarr ("v\n"));
    process->writeToStdin(trarr("x\n"));
}
void  MainWindow::showDialogHelpOut() {
    pageHelp("Ftan_Out_Tab.html");

}
//----------------------------------------------------------------------------------------------------------------------------------------
void  MainWindow::closeFtan() {
    process->writeToStdin(trarr("q\n"));
    process->writeToStdin(trarr("y\n"));
    //QMessageBox::warning(0,mainWindowCaption(),"Ftan program is just closed");
    int num = 10000;
    int delay = 500;
    Q3ProgressDialog progress( "Ftan process terminated in progress.", "Cancel", num, this, "progress", TRUE );
    progress.setTotalSteps ( num);
    progress.show () ;
    QTime t;
    t.start();
    while (t.elapsed() < num) {
        int tm =  t.elapsed();
        if ( (tm/delay)*delay == tm)
            progress.setProgress(tm);
        ( (QApplication*)parentWidget())->processEvents();
        if (process == 0 )  break;//num -= delay;
    }

    if (stdinlog) fstd->close();

    if (process!=0) {
        process->tryTerminate();
        QTimer::singleShot( 5000, process, SLOT( kill() ) );
        delete process;
        process= 0;
    }

}

void  MainWindow::startFtan(QString workingDirectory) {
//qWarning("MainWindow::startFtan ");
    if (process!=0)  closeFtan();

    process = new Q3Process(this);
    process->addArgument("ftan_sol");
    process->addArgument(GetRelativePath(workingDirectory, doc->GetWfdiscAbsPath()));
    process->addArgument(tempDir+"/" + FTAN_TABLE_OUT_NAME );
    process->addArgument(GetRelativePath(workingDirectory, doc->GetRootAbsPath()));
    process->addArgument(GetRelativePath(workingDirectory, doc->GetOriginAbsPath()));

    /*
    QString atemp = GetRelativePath(workingDirectory, doc->GetWfdiscAbsPath()); atemp += "\n";
    atemp += tempDir+"/" + FTAN_TABLE_OUT_NAME; atemp += "\n";
    atemp += GetRelativePath(workingDirectory, doc->GetRootAbsPath());atemp += "\n";
    atemp += GetRelativePath(workingDirectory, doc->GetOriginAbsPath()); atemp += "\n";

    QMessageBox::warning(0,0,atemp);
    */
    connect(process, SIGNAL(readyReadStderr()),
            this, SLOT(updateStdOut()));
    connect(process, SIGNAL(readyReadStdout()),
            this, SLOT(updateStdOut()));
    connect(process, SIGNAL(wroteToStdin()),
            this, SLOT(WroteToStdin()));
    connect(process, SIGNAL(processExited()),
            this, SLOT(processExited()));
    QStringList list = process->arguments();
    // QStringList::Iterator it = list.begin();
    qWarning("Relative Dbase Table Pathes:>\nwfdisc: '%s.wfdisc' \ninstrument: '%s.instrument' \norigin '%s.origin'\n",
             list[1].ascii(),list[3].ascii(),list[4].ascii());
//    while( it != list.end() ) {
//	qWarning("Arg List '%s'",(*it).ascii());
//        ++it;
//    }
//   	process->setCommunication(QProcess::Stdin|QProcess::Stdout);
    process->setCommunication(Q3Process::Stdin);
    if ( !process->start() ) {
        qWarning("Ftan process abnormal started");
    }

    fstd = new QFile ( tempDir+"/stdinlog.txt" );
    if ( !fstd->open( QIODevice::WriteOnly ) ) {
        QMessageBox::warning(0,mainWindowCaption(),"Can't open file 'stdinlog.txt'");
        stdinlog = false;
    } else {
        stdinlog = true;
        tlog.setDevice (fstd );
    }

    QFile fil(  "list_stachan" );
    if ( fil.exists())
        if (!fil.remove()) {
            QMessageBox::warning(0,mainWindowCaption(),"Can't remove file 'list_stachan'");
        }


    setInitialValues();
    process->writeToStdin(trarr ("sc *:.*Z\n"));
    if (stdinlog) tlog << "sc *:.*Z\n";
    process->writeToStdin(trarr ("wls\n"));
    if (stdinlog) tlog << "wls\n";

    process->writeToStdin(trarr ("me\n"));
    if (stdinlog) tlog << "me\n";
    process->writeToStdin(trarr ("2\n"));
    if (stdinlog) tlog << "2\n";
    process->writeToStdin(trarr(tempDir + "/\n"));
    if (stdinlog) tlog << "ftan_\n";
    process->writeToStdin(trarr ("r\n"));
    if (stdinlog) tlog << "r\n";
    process->writeToStdin(trarr ("me\n"));
    if (stdinlog) tlog << "me\n";
    process->writeToStdin(trarr ("30\n"));
    if (stdinlog) tlog << "30\n";
    // !!!!!
    QString tmp = FTAN_WFOUT_DIRECTORY_NAME; //fwoutDir;

    process->writeToStdin(trarr (tmp + "\n"));
    if (stdinlog) tlog << (tmp + "\n").ascii();
    process->writeToStdin(trarr("r\n"));
    if (stdinlog) tlog << "r\n";
    process->writeToStdin(trarr("me\n"));
    if (stdinlog) tlog << "me\n";
    process->writeToStdin(trarr("31\n"));
    if (stdinlog) tlog << "31\n";

    tmp =  tempDir + "/"+ FTAN_DISPOUT_DIRECTORY_NAME;  //temPrefix + "disp.dir";
    process->writeToStdin(trarr(tmp + "\n"));
    if (stdinlog) tlog << (tmp+ "\n").ascii();
    process->writeToStdin(trarr("r\n"));
    if (stdinlog) tlog << "r\n";

    process->writeToStdin(trarr("me\n"));
    if (stdinlog) tlog << "me\n";
    process->writeToStdin(trarr("33\n"));
    if (stdinlog) tlog << "33\n";
    process->writeToStdin(trarr(doc->GetEventInfo() + "\n"));
    if (stdinlog) tlog << (doc->GetEventInfo()+ "\n").ascii();
    process->writeToStdin(trarr("q\n"));
    if (stdinlog) tlog << "q\n";
    fstd->flush ();


    int num = 10000;
    int delay = 50;
    QFile file(  "list_stachan" );

    Q3ProgressDialog progress( "Ftan process starting in progress.", "Cancel", num, this, "progress", TRUE );
    progress.setTotalSteps ( num);
    progress.show () ;
    do {
        QTime t;
        t.start();
        while (t.elapsed() < num) {
            int tm =  t.elapsed();
            if ( (tm/delay)*delay == tm)
                progress.setProgress(tm);
            ( (QApplication*)parentWidget())->processEvents();
            if ( file.exists()) break;

        }

    } while (!file.exists());


}
void  MainWindow::SetStateStartToolBarButton(Q3ListViewItem * item) {
    RowPropertyItem * it =  dynamic_cast<RowPropertyItem *>(item);

    if (dynamic_cast<RowPropertyItem *>(item) == dynamic_cast<StationItem *>(item ) ) {
        EnableFtanWinAction(FALSE);
        SetImageToIconSet(startIconSet,"ftan_Stop.png","ftan_Stop.png" );
        modLabel->setText("Stop");
    }

    if ( stationlist->GetItemInProcess() == item) {
        Q3ListViewItem * parent = item->parent ();
        RowPropertyItem * itt =   dynamic_cast<RowPropertyItem *>(parent);
        //RowValue* rwParent = itt->GetPropvalue();
        //locationLabel->setText(itt->GetPropvalue()->GetName());
        formulaLabel->setText(itt->GetPropvalue()->GetName() + ":"+it->GetPropvalue()->GetName() );
        modLabel->setText("Run");
        SetImageToIconSet(startIconSet,"ftan_Start.png","ftan_Stop.png" );
        EnableFtanWinAction(TRUE);
        if (isCleanedRecordSaved) EnableFtanWinActionAfterSaveRecord(FALSE);
    } else
        if (dynamic_cast<RowPropertyItem *>(item) == dynamic_cast<ChanItem *>(item) ) {
            EnableFtanWinAction(FALSE);
            SetImageToIconSet(startIconSet,"ftan_Wait.png","ftan_Stop.png" );
            modLabel->setText("Wait");
        }
    startAct->setIconSet(*startIconSet);

}

void  MainWindow::startSlot              () {
//qWarning("MainWindow::startSlot ");
    int i = stationlist->GetIdChannal();
//!!!!!!!!!!!!!!!!!!!!!
//doc->printFDocument();

    if (i == 0) {
        QMessageBox::warning(0,mainWindowCaption(),"No Selected Channel");
        return;
    }

    QDir dirTemp( tempDir);
    QStringList lst = dirTemp.entryList();
    for ( QStringList::Iterator it = lst.begin(); it != lst.end(); ++it )
        if ( ( *it ).contains( ".ps" ) && !( *it ).contains( ":" ) ) dirTemp.remove ((*it));

    QString tmp = QString("go %1\n").arg(i);
    process->writeToStdin(trarr(tmp));
    if (stdinlog) tlog << QString("%1\n").arg(i).ascii();
    process->writeToStdin(trarr("ro\n"));
    if (stdinlog) tlog << "ro\n";
    QString temp = "p";
    QString comps = GetPlotCompString();
    process->writeToStdin(trarr(temp + comps + "\n"));
    if (stdinlog) tlog << (temp + comps + "\n").ascii();
    process->writeToStdin(trarr("fg\n"));
    if (stdinlog) tlog << "fg\n";
    fstd->flush ();

    SetImageToIconSet(startIconSet,"ftan_Start.png","ftan_Stop.png" );
    startAct->setIconSet(*startIconSet);
    isCleanedRecordSaved = FALSE;
    SetStateStartToolBarButton(stationlist->GetItemInProcess());
}
void MainWindow::updateStdOut() {
}
void MainWindow::WroteToStdin() {
}
void MainWindow::processExited() {
    if (process->normalExit()) {
        qWarning("Ftan process normal exited");
    } else {
        qWarning("Ftan process abnormal exited");
    }
    delete process;
    process = 0;
}
void  MainWindow::waveSlot            () {
    process->writeToStdin(trarr("ro\n"));
    QString temp = "p";
    QString comps = GetPlotCompString();
    process->writeToStdin(trarr(temp + comps +"\n"));
    if (stdinlog) tlog << (temp + comps +"\n").ascii();
    fstd->flush ();
}
void  MainWindow::filterSlot              () {
    process->writeToStdin(trarr("fil\nro\nfg\n"));
// Reload ??

    if (stdinlog) tlog << "fil\nro\nfg\n";
    fstd->flush ();
}
void  MainWindow::ftaSlot                  () {
    QString temp = "fta ";
    QString comps = GetToBeProcessedCompString();
    process->writeToStdin(trarr(temp + comps +"\n"));
    if (stdinlog) tlog << (temp + comps +"\n").ascii();
    fstd->flush ();
}
void  MainWindow::velSlot                 () {
    process->writeToStdin(trarr("gg\n"));
    if (stdinlog) tlog << "gg\n";
    fstd->flush ();
}
void  MainWindow::ampSlot              () {
    process->writeToStdin(trarr("ga\n"));
    if (stdinlog) tlog << "ga\n";
    fstd->flush ();
}
void  MainWindow::polarSlot             () {
    process->writeToStdin(trarr("gp\n"));
    if (stdinlog) tlog << "gp\n";
    fstd->flush ();
}
void  MainWindow::ovrSlot                 () {
    process->writeToStdin(trarr("ro\n"));
    QString temp = "po";
    QString comps = GetPlotCompString();
    process->writeToStdin(trarr(temp + comps +"\n"));
    if (stdinlog) tlog << (temp + comps +"\n").ascii();
    fstd->flush ();
}
void  MainWindow::imageSlot            () {
    process->writeToStdin(trarr("fti\n"));
    if (stdinlog) tlog << "fti\n";
    fstd->flush ();
}
void  MainWindow::saveRecSlot       () {
    SVCompt  dialog(this,doc,0);
    if (dialog.exec()) {
        QFile fil(  "list_stachan" );
        if ( fil.exists())
            if (!fil.remove()) {
                QMessageBox::warning(0,mainWindowCaption(),"Can't remove file 'list_stachan'");
            }
        process->writeToStdin(trarr(dialog.GetStringToAct()));

        if (stdinlog) tlog << dialog.GetStringToAct().ascii();
        fstd->flush ();

        process->writeToStdin(trarr("sc *:.*Z\n"));

        process->writeToStdin(trarr("wls\n"));


        int num = 10000;
        int delay = 500;
        QFile file(  "list_stachan" );
        Q3ProgressDialog progress( "Saving filtered record in progress.", "Cancel", num, this, "progress", TRUE );
        progress.setTotalSteps ( num);
        progress.show () ;
        do {
            QTime t;
            t.start();
            while (t.elapsed() < num) {
                int tm =  t.elapsed();
                if ( (tm/delay)*delay == tm)
                    progress.setProgress(tm);
                ( (QApplication*)parentWidget())->processEvents();
                if ( file.exists())break;
            }
        } while (!file.exists());

///----------------------------------------------------------------------------------------
 //       periodListDialog->list->SavePeriodListInfoToStaChanOutList();
///----------------------------------------------------------------------------------------
        QString tempWfDiscName =  tempDir + "/" + FTAN_TABLE_OUT_NAME + ".wfdisc";
        //QMessageBox::warning(0,mainWindowCaption(),"tempWfDiscName:>"+tempWfDiscName );
        QStringList newRecordForOutlist = savedFilteringRecord;

//      for ( QStringList::Iterator it = savedFilteringRecord.begin(); it != savedFilteringRecord.end(); ++it )
//      	   qWarning("old record : '%s'",(*it).ascii());

        if ( !GetSavedRecordNames(tempWfDiscName,savedFilteringRecord) ) return;

        if (!savedFilteringRecord.isEmpty()) {
            for ( QStringList::Iterator it = savedFilteringRecord.begin(); it != savedFilteringRecord.end(); ++it ) {
                bool ind = false;
                QStringList::Iterator itt = newRecordForOutlist.begin();
                while ( itt != newRecordForOutlist.end() ) {
                    if ( (*it) == (*itt)  ) {
                        ind = true;
                        break;
                    }
                    ++itt;
                }
                if (ind) newRecordForOutlist.remove (itt);
                else      {
                    newRecordForOutlist.append ( (*it) );
                }
            }

            QStringList newPsName;
            stationlist->SetChanToOutList(newRecordForOutlist,newPsName);
            QDir dirTemp( tempDir);
            QStringList lst = dirTemp.entryList();
            QDir dirDsp( QString(tempDir) + "/" + FTAN_DISPOUT_DIRECTORY_NAME);
            QStringList lstDsp = dirDsp.entryList();
            for ( QStringList::Iterator itt = newPsName.begin(); itt != newPsName.end(); ++itt ) {
                QString sta = (*itt).left((*itt).find('_'));
                for ( QStringList::Iterator it = lst.begin(); it != lst.end(); ++it ) {
                    if ( ( *it ).contains( sta) && !( *it ).contains( ":" ) ) {
                        QString oldPsName   = (*it);
                        QString tmp = oldPsName.right(oldPsName.length()  -oldPsName.findRev('_') );
                        QString newPsName = (*itt) +tmp;
                        dirTemp.rename ( oldPsName,newPsName);
                    }
                }
                for ( QStringList::Iterator it = lstDsp.begin(); it!= lstDsp.end(); ++it ) {
                    if ( ( *it ).contains( sta) && !( *it ).contains( ":" ) && ( *it ).contains( FTAN_DISP_EXPORT_PREFIX )) {
                        QString oldDispName   = (*it);
                        QString tmp1 =  oldDispName.section( '.', 0, 0 );
                        QString tmp2 =  oldDispName.section( '.', 1, 1 );
                        QString tmp3 =  oldDispName.section( '.', 4, 4 );
                        QString tmp4 = (*itt);
                        tmp4 = tmp4.right(tmp4.length()  - tmp4.find('_') -1);
                        tmp4 = tmp4.right(tmp4.length()  - tmp4.find('_') );
                        QString newDispName =  tmp1 + "_" + tmp2 +  tmp4	 + "_" + tmp3;
                        dirDsp.rename ( oldDispName,newDispName);
                    }
                }

            }

            modifiedFlt = true;
            EnableFtanWinActionAfterSaveRecord(FALSE);
            isCleanedRecordSaved = TRUE;

            if ( periodListDialog != 0 ) {
                delete periodListDialog;
                periodListDialog=0;
            }

/// ------------------------------------  !!!!!!!!!!!!!!! ---------------------------------------
            periodListDialog = new SettingImpl ( doc,this );
            periodListDialog->list->showSavedStation();
            periodListDialog->list->SavePeriodListInfoToStaChanOutList();
            //periodListDialog->show();
/// ------------------------------------  !!!!!!!!!!!!!!! ---------------------------------------
        }
    }
}
void  MainWindow:: cleanRecSlot     () {
    SVCompt  dialog(this,doc,1);
    if (dialog.exec()) {
        process->writeToStdin(trarr(dialog.GetStringToAct()));
        if (stdinlog) tlog << dialog.GetStringToAct().ascii();
        fstd->flush ();

    }
}

void  MainWindow::pscriptOnOffSlot  () {
//    qWarning("MainWindow::pscriptOnOffSlot");
    doc->GetPostScript()->setChanged();
    if ( doc->isModified()) modified = true;
    else modified = false;
    SendChangedValueToFtan(doc->GetPostScript()->GetId());

}
void  MainWindow::polarOnOffSlot    () {
//    qWarning("MainWindow::polarOnOffSlot");
    doc->GetPolar()->setChanged();
    if ( doc->isModified()) modified = true;
    else modified = false;
    SendChangedValueToFtan(doc->GetPolar()->GetId());
}
void  MainWindow::originSlot              ()  {}

void  MainWindow::filterSpecSlot        () {
    FilterSpec  dialog(this,doc);
    if (dialog.exec()) {
        if ( doc->isModified()) modified = true;
        else modified = false;
        /*
                if ( periodListDialog != 0 ) {
                    delete periodListDialog;
                    periodListDialog=0;
                }
                periodListDialog = new SettingImpl ( doc,this );
                periodListDialog->show();
        */
        periodListDialog->ChangeDialogEditLines();
    }

}
void  MainWindow::ftaSpecSlot           () {
    FtanWindow  dialog(this,doc);
    if (dialog.exec()) {
        if ( doc->isModified()) modified = true;
        else modified = false;

        /*
                if ( periodListDialog != 0 ) {
                    delete periodListDialog;
                    periodListDialog=0;
                }
                periodListDialog = new SettingImpl ( doc,this );
                periodListDialog->show();
        */
        periodListDialog->ChangeDialogEditLines();
    }

}

void  MainWindow::plotCompSlot       () {
    PlotComp  dialog(this,doc);
    if (dialog.exec()) {
        if ( doc->isModified()) modified = true;
        else modified = false;
    }
}
void  MainWindow::ftaCompSlot         () {
    FtanComp  dialog(this,doc);
    if (dialog.exec()) {
        if ( doc->isModified()) modified = true;
        else modified = false;
        periodListDialog->InitDialogFtaComponent();
    }
}

void  MainWindow::orbitSlot         (int numOrbit) {
    QString temp = QString("ftan_orbit%1.png").arg( numOrbit+ 1);
    QIcon tempIcon;
    SetImageToIconSet(&tempIcon,temp,temp );
    orbitToolButton->setIconSet(tempIcon);
    temp = QString(" %1").arg(numOrbit+ 1);
    QString tp = settingsMenu->text (idItemOrbitOfSettingMenu);
    tp.replace(tp.findRev (' ') + 1,100,temp);
    settingsMenu->changeItem (idItemOrbitOfSettingMenu, tempIcon, tp  );
    temp.remove ( ' ');
    doc->GetFtaOrbit()->SetValue(temp);
    if ( doc->GetFtaOrbit()->isReseted()  )
        SendChangedValueToFtan(doc->GetFtaOrbit()->GetId());
    doc->SetValueToResetvalue();

    doc->GetFtaOrbit()->setChanged();
    if ( doc->isModified()) modified = true;
    else modified = false;

}

void  MainWindow::modeSlot                     () {
    ModeSet  dialog(this,doc);
    if (dialog.exec()) {
        if ( doc->isModified()) modified = true;
        else modified = false;
    }
}
void  MainWindow::SettingsAllParameters        () {
    PropertyDialog  dialog(this,doc,0,curDirectory,propx,propy,propw,proph);
    dialog.move(propx,propy);
    dialog.resize(propw,proph);
    if (dialog.exec()) {
        setPostscriptPolarOrbitActions();
        if ( doc->isModified()) modified = true;
        else modified = false;
    }


    propx  =  dialog.x();
    propy = dialog.y();
    propw = dialog.width();
    proph = dialog.height();
}
void  MainWindow::SettingsMainParameters       () {
    PropertyDialog  dialog(this,doc,1,curDirectory,mpropx,mpropy,mpropw,mproph);

    dialog.move(mpropx,mpropy);
    dialog.resize(mpropw,mproph);
    if (dialog.exec()) {
        setPostscriptPolarOrbitActions();
        if ( doc->isModified()) modified = true;
        else modified = false;
    }
    mpropx  =  dialog.x();
    mpropy = dialog.y();
    mpropw = dialog.width();
    mproph = dialog.height();
    /*
        MainSettings* dialog = new MainSettings(this,"tempMainSettingsDialog");
        if (dialog->exec()) {

        }
        delete dialog;
    */
}
void MainWindow::setInitialValues() {
//   3.) window size (1-large).............(toggle)... 0         id  =     1
//   4.) mode (0-portrait).................(toggle)... 1           id =    2
//   5.) postscript output?..(1-y).........(toggle)... 1         id =    3
    const QString ftanDefault_windowSize = "0";
    const QString ftanDefault_mode            = "1";
    const QString ftanDefault_postscript     = "1";

//  11.) if edits are applied..............(toggle)...  y   id  = 7
    const QString ftanDefault_editApplied  = "1";
//  12.) if interpolate on nomimal grid....(toggle)...  n   id = 8
    const QString ftanDefault_interpolateNominalGrid = "0";
//  14.) output image phase?...............(toggle)... F   id  = 14
//  15.) apply instrument response?........(toggle)... T   id = 15
    const QString ftanDefault_outPutImagePhase = "1";
    const QString ftanDefault_instrumentResponse = "1";
//16.) change alpha filter parameters?.............. F   id 16
    const QString ftanDefault_changeAlphaFilter = "0";
//  18.) polarization measurements?................... T                        id = 18
    const QString ftanDefault_polar = "1";
//   20.) attempt phase velocity measurements.(toggle). T  id = 19
    const QString ftanDefault_phaseVelocityMeasurement = "1";
//  32.) read centryd and moment relations..(toggle)..  n id = 31
    const QString ftanDefault_ReadCentridMomentRelation = "0";
//50.) X-axis scaling: periods (T) or frequencies(F)   T   id = 6
    const QString ftanDefault_XaxisScaling  = "0";

    vector<PropertyValue* >::iterator it = doc->GetValues().begin();
    while (it != doc->GetValues().end()) {
        int id = (*it)->GetId();
        const QString val = (*it)->GetValue() ;
        switch (id) {
        case 1:
            if (val != ftanDefault_windowSize)
                SendChangedValueToFtan(id);
            break;
        case 2:
            if (val != ftanDefault_mode)
                SendChangedValueToFtan(id);
            break;
        case 3:
            if (val != ftanDefault_postscript)
                SendChangedValueToFtan(id);
            break;
        case 6:
            if (val != ftanDefault_XaxisScaling )
                SendChangedValueToFtan(id);
            break;
        case 7:
            if (val != ftanDefault_editApplied)
                SendChangedValueToFtan(id);
            break;
        case 8:
            if (val !=  ftanDefault_interpolateNominalGrid)
                SendChangedValueToFtan(id);
            break;
        case 14:
            if (val ==  ftanDefault_outPutImagePhase)
                SendChangedValueToFtan(id);
            break;

        case 15:
            if (val !=  ftanDefault_instrumentResponse)
                SendChangedValueToFtan(id);
            break;
        case 16:
            if (val !=  ftanDefault_changeAlphaFilter)
                SendChangedValueToFtan(id);
            break;
        case 18:
            if (val !=  ftanDefault_polar)
                SendChangedValueToFtan(id);
            break;
        case 19:
            if (val !=  ftanDefault_phaseVelocityMeasurement)
                SendChangedValueToFtan(id);
            break;
        case 31:
            if (val !=  ftanDefault_ReadCentridMomentRelation)
                SendChangedValueToFtan(id);
            break;

        case 4:
        case 5:
        case 9:
        case 10:
        case 11:
        case 12:
        case 13:
        case 17:
        case 20:
        case 21:
        case 22:
        case 23:
        case 24:
        case 25:
        case 26:
        case 27:
        case 28:
        case 29:
        case 30:
            SendChangedValueToFtan(id);
            break;

        default:
            QMessageBox::warning(0,mainWindowCaption(),
                                 QString("No Ftan Command for id %1").arg(id));

            break;

        }


        it++;
    }

}
void MainWindow::SetWidowSize() {
//   qWarning("XXX changed id me: 3 '%s'",doc->GetWidowSize()->GetValue().ascii());
    process->writeToStdin(trarr("me\n"));
    process->writeToStdin(trarr("3\n"));
    process->writeToStdin(trarr("r\n"));
    if (stdinlog) tlog << "me\n3\nr\n";
    fstd->flush ();
}
void MainWindow::SetWidowMode() {
//    qWarning("XXX changed id me: 4 '%s'",doc->GetWidowMode()->GetValue().ascii());
    process->writeToStdin(trarr("me\n"));
    process->writeToStdin(trarr("4\n"));
    process->writeToStdin(trarr("r\n"));
    if (stdinlog) tlog << "me\n4\nr\n";
    fstd->flush ();
}
void MainWindow::SetPostscript() {
//			    qWarning("XXX changed id  me: 5");
//    process->writeToStdin("pst\n");
    process->writeToStdin(trarr("me\n"));
    process->writeToStdin(trarr("5\n"));
    process->writeToStdin(trarr("r\n"));
    if (stdinlog) tlog << "me\n5\nr\n";
    fstd->flush ();
}
void MainWindow::SetTypeForOverplot() {
//			    qWarning("XXX changed id me: 9");

    QString temp = "R";
    if (doc->GetFtaWaveTypeOverPlot()->GetValue() == "1") temp = "L";
    if (doc->GetFtaWaveTypeOverPlot()->GetValue() == "2") temp = "B";
    process->writeToStdin(trarr("me\n"));
    process->writeToStdin(trarr("9\n"));
    process->writeToStdin(trarr(temp +"\n"));
    process->writeToStdin(trarr("r\n"));
    if (stdinlog) tlog << "me\n9\n" <<
        (temp +"\n").ascii()<< "r\n";
    fstd->flush ();
}
void MainWindow::SetGroupVelocity() {
//			    qWarning("XXX changed id me: 10");
    QString temp = "R";
    if (doc->GetFtaGroupVelocityPlot()->GetValue() == "1") temp = "L";
    if (doc->GetFtaGroupVelocityPlot()->GetValue() == "2") temp = "B";
    if (doc->GetFtaGroupVelocityPlot()->GetValue() == "3") temp = "N";
    process->writeToStdin(trarr("me\n"));
    process->writeToStdin(trarr("10\n"));
    process->writeToStdin(trarr(temp +"\n"));
    process->writeToStdin(trarr("r\n"));
    if (stdinlog) tlog << "me\n10\n" <<
        (temp +"\n").ascii()<< "r\n";
    fstd->flush ();
}
void MainWindow::SetXaxisScaling() {
//			    qWarning("XXX changed id  me: 50");
    process->writeToStdin(trarr("me\n"));
    process->writeToStdin(trarr("50\n"));
    process->writeToStdin(trarr("r\n"));
    if (stdinlog) tlog << "me\n50\nr\n";
    fstd->flush ();
}
void MainWindow::SetEditApplied() {
//			    qWarning("XXX changed id me: 11");
    process->writeToStdin(trarr("me\n"));
    process->writeToStdin(trarr("11\n"));
    process->writeToStdin(trarr("r\n"));
    if (stdinlog) tlog << "me\n11\nr\n";
    fstd->flush ();
}
void MainWindow::SetInterpolateNominalGrid() {
//			    qWarning("XXX changed id me: 12");
    process->writeToStdin(trarr("me\n"));
    process->writeToStdin(trarr("12\n"));
    process->writeToStdin(trarr("r\n"));
    if (stdinlog) tlog << "me\n12\nr\n";
    fstd->flush ();
}
void MainWindow::CommandPlotsCopts() {
//	Empty Slot . It's just command  !!!!

}
void MainWindow::SetWaveformFilter() {
    //  qWarning("\nXXX 0 changed id  me: 13 ");
    QString temp = doc->GetShortPeriodZero()->GetValue();
    temp += " ";
    temp += doc->GetShortPeriodCorner()->GetValue();
    temp += " ";
    temp += doc->GetLongPeriodCorner()->GetValue();
    temp += " ";
    temp += doc->GetLongPeriodZero()->GetValue();
//  qWarning("\nXXX 0 '%s' ",temp.ascii());
    process->writeToStdin(trarr("me\n"));
    process->writeToStdin(trarr("13\n"));
    process->writeToStdin(trarr( (temp +"\n")));
    process->writeToStdin(trarr("q\n"));

    if (stdinlog) tlog << "me\n13\n" <<
        (temp +"\n").ascii()<< "q\n";
    fstd->flush ();

    //  qWarning("XXX 1 changed id  me: 13 ");
}
void MainWindow::SetOutputImagePhase() {
//			    qWarning("XXX changed id me: 14");
    process->writeToStdin(trarr("me\n"));
    process->writeToStdin(trarr("14\n"));
    process->writeToStdin(trarr("r\n"));
    if (stdinlog) tlog << "me\n14\nr\n";
    fstd->flush ();
}
void MainWindow::SetItstrumentResponse() {
//			    qWarning("XXX changed id me: 15");
    process->writeToStdin(trarr("me\n"));
    process->writeToStdin(trarr("15\n"));
    process->writeToStdin(trarr("r\n"));
    if (stdinlog) tlog << "me\n15\nr\n";
    fstd->flush ();
}
void MainWindow::SetChangeAlphaFilter() {
//			    qWarning("XXX changed id  me: 16");
    //    Does not work. Result SEGMENTATION FAULT
    /*
    process->writeToStdin("me\n");
    process->writeToStdin("16\n");
    process->writeToStdin("r\n");
    */
}

void MainWindow::SetComptsToBeProcessed() {
//			    qWarning("XXX changed id  me: 17");
    process->writeToStdin(trarr("me\n"));
    process->writeToStdin(trarr("17\n"));
    QString temp = GetToBeProcessedCompString();
    process->writeToStdin(trarr(temp + "\n"));
    process->writeToStdin(trarr("r\n"));
    if (stdinlog) tlog << "me\n17\n" <<
        (temp +"\n").ascii()<< "r\n";
    fstd->flush ();
}
void MainWindow::SetFtanPolarMeasurements() {
//			    qWarning("XXX changed id  me: 18");
    process->writeToStdin(trarr("me\n"));
    process->writeToStdin(trarr("18\n"));
    process->writeToStdin(trarr("r\n"));
    if (stdinlog) tlog << "me\n18\nr\n";
    fstd->flush ();
}
void MainWindow::SetPhaseVelocityMesarumenrs() {
//			    qWarning("XXX changed id me: 20");
    process->writeToStdin(trarr("me\n"));
    process->writeToStdin(trarr("20\n"));
    process->writeToStdin(trarr("r\n"));
    if (stdinlog) tlog << "me\n20\nr\n";
    fstd->flush ();
}
void MainWindow::SetPhaseVelocityBounds() {
//			    qWarning("XXX changed id  me: 21");
    QString temp = doc->GetPhaseVelBoundMinimum()->GetValue();
    temp += " ";
    temp += doc->GetPhaseVelBoundMaximum()->GetValue();
    process->writeToStdin(trarr("me\n"));
    process->writeToStdin(trarr("21\n"));
    process->writeToStdin(trarr(temp +"\n"));
    process->writeToStdin(trarr("r\n"));
    if (stdinlog) tlog << "me\n21\n" <<
        (temp +"\n").ascii()<< "r\n";
    fstd->flush ();
}
void MainWindow::SetPhaseVelocityReference() {
//			    qWarning("XXX changed id me: 22");
    QString temp = doc->GetPhaseVelRefPeriod()->GetValue();
    process->writeToStdin(trarr("me\n"));
    process->writeToStdin(trarr("22\n"));
    process->writeToStdin(trarr(temp +"\n"));
    process->writeToStdin(trarr("r\n"));
    if (stdinlog) tlog << "me\n22\n" <<
        (temp +"\n").ascii()<< "r\n";
    fstd->flush ();
}
void MainWindow::SetGroupVelBound() {
//			    qWarning("XXX changed id me: 23");
    QString temp = doc->GetGroupVelBoundMinimum()->GetValue();
    temp += " ";
    temp += doc->GetGroupVelBoundMaximum()->GetValue();
    process->writeToStdin(trarr("me\n"));
    process->writeToStdin(trarr("23\n"));
    process->writeToStdin(trarr(temp +"\n"));
    process->writeToStdin(trarr("r\n"));
    if (stdinlog) tlog << "me\n23\n" <<
        (temp +"\n").ascii()<< "r\n";
    fstd->flush ();
}
void MainWindow::SetPeriodBound() {
//			    qWarning("XXX changed id me: 24");
    QString temp = doc->GetPeriodBoundMinimum()->GetValue();
    temp += " ";
    temp += doc->GetPeriodBoundMaximum()->GetValue();
    process->writeToStdin(trarr("me\n"));
    process->writeToStdin(trarr("24\n"));
    process->writeToStdin(trarr(temp +"\n"));
    process->writeToStdin(trarr("r\n"));
    if (stdinlog) tlog << "me\n24\n" <<
        (temp +"\n").ascii()<< "r\n";
    fstd->flush ();
}
void MainWindow::SetNumberOrbitMode() {
//			    qWarning("XXX changed id me: 25");
    QString temp = doc->GetFtaOrbit()->GetValue() + " " + doc->GetFtaMode()->GetValue() ;
    process->writeToStdin(trarr("me\n"));
    process->writeToStdin(trarr("25\n"));
    process->writeToStdin(trarr(temp +"\nme\nq\nfg\n"));
    if (stdinlog) tlog << "me\n25\n" <<
        (temp +"\nme\nq\nfg\n").ascii();
    fstd->flush ();
}
void MainWindow::SetRawSpectrumVelWidth() {
//			    qWarning("XXX changed id me: 26");
    QString temp = doc->GetRowSpectrumGroupVelocity()->GetValue();
    temp += " ";
    temp += doc->GetRowSpectrumWidth()->GetValue();
    process->writeToStdin(trarr("me\n"));
    process->writeToStdin(trarr("26\n"));
    process->writeToStdin(trarr(temp +"\n"));
    process->writeToStdin(trarr("r\n"));
    if (stdinlog) tlog << "me\n26\n" <<
        (temp +"\n").ascii()<< "r\n";
    fstd->flush ();
}
void MainWindow::SetReadCentrydMomentRelations() {
//			    qWarning("XXX changed id  me: 32");
    process->writeToStdin(trarr("me\n"));
    process->writeToStdin(trarr("32\n"));
    process->writeToStdin(trarr("r\n"));
    if (stdinlog) tlog << "me\n32\nr\n";
    fstd->flush ();
}
void MainWindow::SendChangedValueToFtan(int idValue) {

    switch (idValue) {
    case 1:
        SetWidowSize();
        break;
    case 2:
        SetWidowMode();
        break;
    case 3:
        SetPostscript();
        break;
    case 4:
        SetTypeForOverplot();
        break;
    case 5:
        SetGroupVelocity();
        break;
    case 6:
        SetXaxisScaling();
        break;
    case 7:
        SetEditApplied();
        break;
    case 8:
        SetInterpolateNominalGrid();
        break;
    case 9:
        CommandPlotsCopts();
        break;
    case 10:
    case 11:
    case 12:
    case 13:
        SetWaveformFilter();
        break;
    case 14:
        SetOutputImagePhase();
        break;

    case 15:
        SetItstrumentResponse();
        break;

    case 16:
        SetChangeAlphaFilter();
        break;

    case 17:
        SetComptsToBeProcessed();
        break;

    case 18:
        SetFtanPolarMeasurements();
        break;

    case 19:
        SetPhaseVelocityMesarumenrs();
        break;

    case 20:
    case 21:
        SetPhaseVelocityBounds();
        break;

    case 22:
        SetPhaseVelocityReference();
        break;
    case 23:
    case 24:
        SetGroupVelBound();
        break;
    case 25:
    case 26:
        SetPeriodBound();
        break;
    case 27:
    case 28:
        SetNumberOrbitMode();
        break;

    case 29:
    case 30:
        SetRawSpectrumVelWidth();
        break;
    case 31:
        SetReadCentrydMomentRelations();

        break;

    default:
        QMessageBox::warning(0,mainWindowCaption(),
                             QString("No Ftan Command for id %1").arg(idValue));

        break;

    }
}
void MainWindow::SaveWorkingMaterials(QString DirectoryName) {
    QApplication::setOverrideCursor(Qt::waitCursor);
    int num = 4;
    Q3ProgressDialog progress( "Saving session temporary materials.", "Cancel", num, this, "progress", TRUE );
    progress.setTotalSteps ( num);
    progress.show () ;
    QDir dirTmp(tempDir);
    if (dirTmp.exists(FTAN_DISPOUT_DIRECTORY_NAME)) {
        do {
            ( (QApplication*)parentWidget())->processEvents();
            QString systemStr =
                "cp -r " + tempDir + "/" + FTAN_WFOUT_DIRECTORY_NAME + " " + DirectoryName;
            system(systemStr.ascii());
            progress.setProgress(1);
            systemStr =
                "cp -r " + tempDir + "/" + FTAN_DISPOUT_DIRECTORY_NAME + " " + DirectoryName;
            system(systemStr.ascii());
            progress.setProgress(2);

            systemStr =
                "cp " + tempDir + "/" + FTAN_TABLE_OUT_NAME + ".*  " + DirectoryName;
            system(systemStr.ascii());
            progress.setProgress(3);
            systemStr =
                "cp " + tempDir + "/*.ps "  + DirectoryName;
            system(systemStr.ascii());
            progress.setProgress(4);

        } while (1 == 0);

        QString dispOutNewName = FTAN_DISPOUT_DIRECTORY_NAME;
        QString ftDiscName =   DirectoryName + "/" + FTAN_TABLE_OUT_NAME + ".ftdisc" ;
        ChangeDbTable( ftDiscName,dispOutNewName,161, 64);
        QString dispDiscName =   DirectoryName + "/" + FTAN_TABLE_OUT_NAME + ".disp" ;
        ChangeDbTable(dispDiscName,dispOutNewName,168, 64);

       // if (modifiedFlt) {
            QString exportDirectoryName =   DirectoryName + "/"+FTAN_EXPORT_DISP_DIRECTORY_NAME ;
            QDir d( DirectoryName);
            d.mkdir (exportDirectoryName);
            exportDispersionCurves(exportDirectoryName);

            exportDirectoryName =   DirectoryName + "/"+FTAN_EXPORT_AH_DIRECTORY_NAME ;
            d.mkdir (exportDirectoryName);
            exportAhAsciiRecord(exportDirectoryName,"1");

            exportDirectoryName =   DirectoryName + "/"+ FTAN_EXPORT_ASCII_DIRECTORY_NAME ;
            d.mkdir (exportDirectoryName);
            exportAhAsciiRecord(exportDirectoryName,"0");

       // }

    }
    QApplication::restoreOverrideCursor();
}
void MainWindow::setTemporaryMaterials(QString DirectoryName) {
    int num = 4;
    Q3ProgressDialog progress( "Creating session temporary materials.", "Cancel", num, this, "progress", TRUE );
    progress.setTotalSteps ( num);
    progress.show () ;
    QDir nameDir( DirectoryName);
    if (nameDir.exists(FTAN_DISPOUT_DIRECTORY_NAME )) {
        do {
            ( (QApplication*)parentWidget())->processEvents();
            QString systemStr =
                "cp -r " + DirectoryName + "/" + FTAN_WFOUT_DIRECTORY_NAME + " " + tempDir;
            system(systemStr.ascii());
            progress.setProgress(1);
            systemStr =
                "cp -r " + DirectoryName + "/" + FTAN_DISPOUT_DIRECTORY_NAME + " " + tempDir;
            system(systemStr.ascii());
            progress.setProgress(2);

            systemStr =
                "cp " + DirectoryName + "/" + FTAN_TABLE_OUT_NAME + ".*  " + tempDir;
            system(systemStr.ascii());
            progress.setProgress(3);
            systemStr =
                "cp " + DirectoryName + "/*.ps "  + tempDir;
            system(systemStr.ascii());
            progress.setProgress(4);

        } while (1 == 0);
    }

    // QMessageBox::warning(0,mainWindowCaption(),"POINT 1");
}
void MainWindow::ChangeDbTable(QString dbTableName,QString newValue,int index,int lenght) {

    QStringList lines;
    QFile file(dbTableName);
    if ( file.open( QIODevice::ReadOnly ) ) {
        Q3TextStream stream( &file );
        QString line;
        while ( !stream.atEnd() ) {
            line = stream.readLine(); // line of text excluding '\n'
            //printf( "%3d: %s\n", i++, line.latin1() );
            lines += line;
        }
        file.close();
    } else {

        QMessageBox::warning(0,mainWindowCaption(),QString("ChangeDbTable:> Can't open flle for reading\n%1'").arg(dbTableName));
        return;
    }
    uint ln = newValue. length ();
    for (uint i = 0; i < lenght - ln ; i++) 	newValue.append( ' ' );
    for ( QStringList::Iterator it = lines.begin(); it != lines.end(); ++it ) {
        QString temp = *it ;
        temp.replace ( index, lenght, newValue ) ;
        *it = temp;
    }

    QFile fileOut( dbTableName);
    if ( fileOut.open( QIODevice::WriteOnly ) ) {
        Q3TextStream streamOut( &fileOut );
        for ( QStringList::Iterator it = lines.begin(); it != lines.end(); ++it )
            streamOut << *it << "\n";
        fileOut.close();
    } else {
        QMessageBox::warning(0,mainWindowCaption(),QString("ChangeDbTable:> Can't open flle for writing\n%1'").arg(dbTableName));
        return;
    }

}
bool MainWindow::GetSavedRecordNames(QString tempWfDiscName,QStringList &savedFilteringRecord) {

    if (!savedFilteringRecord.isEmpty()) savedFilteringRecord.clear();

    QFile wfd( tempWfDiscName);
    if ( wfd.open( QIODevice::ReadOnly ) ) {
        Q3TextStream stream( &wfd );
        QString line;
        QString dateTime;
        while ( !stream.atEnd() ) {
            line = stream.readLine(); // line of text excluding '\n'
            dateTime = line.right(line.length()  - line.findRev(' ') -1);
            line = line.right(line.length()  - line.findRev("cl_"));
            line = line.left(line.find(' ') );
            if (line[line.length()-1] != 'E') {
                savedFilteringRecord.append(dateTime + line);
            }
        }
        wfd.close();
    } else {
        QMessageBox::warning(0,mainWindowCaption(),QString("The filtering was not perfomed"));
        return false;
    }

    return true;
}
void  MainWindow:: GetListPS(QString  prefixPs,QStringList &listPs) {
    QDir dirTemp( tempDir);
    QStringList lst = dirTemp.entryList();
    for ( QStringList::Iterator it = lst.begin(); it != lst.end(); ++it ) {
        if (( *it ).contains( prefixPs) ) {
            listPs.append(tempDir + "/" + ( *it ));
        }
    }

}
void MainWindow::DeleteExcludedStachanMaterials(QString  prefixPs,QString  cleanedWf,QString cleanedDisp,QString dispName) {
//   qWarning("\n XXX '%s'  '%s' '%s' '%s'" ,prefixPs.ascii() ,cleanedWf.ascii(),cleanedDisp.ascii(),dispName.ascii());
    modifiedFlt = true;

    QString wfdiscTable =  tempDir +"/" + FTAN_TABLE_OUT_NAME +".wfdisc";
    QString wfdiscDir      =  tempDir +"/" + FTAN_WFOUT_DIRECTORY_NAME;
    QString dispTable     =  tempDir +"/" + FTAN_TABLE_OUT_NAME +".disp";
    QString ftdiscTable   =  tempDir +"/" + FTAN_TABLE_OUT_NAME +".ftdisc";
    QString dispDir          =  tempDir +"/" + FTAN_DISPOUT_DIRECTORY_NAME;
    QString ps                   = tempDir +"/" + prefixPs + "*";
    QString clWf               = cleanedWf;

    QString dispDisp        = QString(cleanedDisp).replace("cl_","disp.");
    QString cl_ftDisp        = QString(cleanedDisp).replace("cl_","cl_ft.");
    QString ra_ftDisp        = QString(cleanedDisp).replace("cl_","ra_ft.");

//     qWarning ("wfdiscTable '%s' wfdiscDir '%s'",wfdiscTable.ascii(),wfdiscDir.ascii());
//    qWarning ("dispTable '%s' ftdiscTable '%s'  dispDir '%s' ",dispTable.ascii(),ftdiscTable.ascii(),dispDir.ascii());
    QString systemStr;


    if (!prefixPs.isEmpty()) {
//	 qWarning ("ps '%s' ",ps.ascii());
        systemStr =  "\\rm " + ps;
        system(systemStr.ascii());
    }
//    else  qWarning ("NO Delete ps files");

//     qWarning ("clWf  '%s' ",clWf.ascii());
    RemoveRecordsFromTableAndDir(wfdiscTable,wfdiscDir,clWf);

    if (clWf[clWf.length()-1] == 'N') {
        QString clWfE =  clWf;
        clWfE[clWfE.length()-1] = 'E';
//      qWarning ("clWfE '%s' ",clWfE.ascii());
        RemoveRecordsFromTableAndDir(wfdiscTable,wfdiscDir,clWfE);
    }
    RemoveRecordsFromTableAndDir(dispTable,dispDir,dispDisp,dispName);
//     qWarning ("cl_ftDisp  '%s' ",cl_ftDisp.ascii());
    RemoveRecordsFromTableAndDir(ftdiscTable,dispDir,cl_ftDisp);
//     qWarning ("ra_ftDisp '%s' ",ra_ftDisp.ascii());
    RemoveRecordsFromTableAndDir(ftdiscTable,dispDir,ra_ftDisp);

    if ( !GetSavedRecordNames(wfdiscTable,savedFilteringRecord) ) return;
}
void MainWindow:: RemoveRecordsFromTableAndDir(QString dbTableName,QString dirName,QString recordName,QString fileName) {
//    qWarning(  "Change table:>  '%s' val '%s'\n",dbTableName.ascii(),newValue.ascii());

    QStringList lines;
    QFile file(dbTableName);
    if ( file.open( QIODevice::ReadOnly ) ) {
        Q3TextStream stream( &file );
        QString line;
        while ( !stream.atEnd() ) {
            line = stream.readLine();
            if (line.contains(recordName)  ) continue;
            lines += line;
        }
        file.close();
    } else {
        QMessageBox::warning(0,mainWindowCaption(),QString("RemoveRecordsFromTableAndDir:> Can't open flle for reading\n%1'").arg(dbTableName));
        return;
    }


    QFile fileOut( dbTableName);
    if ( fileOut.open( QIODevice::WriteOnly ) ) {
        Q3TextStream streamOut( &fileOut );
        for ( QStringList::Iterator it = lines.begin(); it != lines.end(); ++it )
            streamOut << *it << "\n";
        fileOut.close();
    } else {
        QMessageBox::warning(0,mainWindowCaption(),QString("RemoveRecordsFromTableAndDir:> Can't open flle for writing\n%1'").arg(dbTableName));
        return;
    }
    QString systemStr;
    systemStr = "\\rm " + dirName +"/" + recordName;
    system(systemStr.ascii());
    if (fileName != "") {
        systemStr = "\\rm " + dirName +"/" + fileName;
        system(systemStr.ascii());
    }
}
void MainWindow::exportDispersionCurves(QString dirName) {
    QString inDir = QString(tempDir) + "/" + FTAN_DISPOUT_DIRECTORY_NAME;
    if ( !QDir(inDir).exists ()) {
        QString tmp;
        tmp = QString("Doesn't exist directory which must contain dispersion files.");
        QMessageBox::critical(this,caption(),tmp);
        return ;
    }
    QString systemStr =
        "cp " + inDir + "/" + FTAN_DISP_EXPORT_PREFIX + "* " + dirName;
    system(systemStr.ascii());
}
void MainWindow::exportAhAsciiRecord(QString dirName,QString  indAhOrAscii) {
    QString indb = QString(tempDir) + "/" +  FTAN_TABLE_OUT_NAME;
    indb.append(".wfdisc");
    QFile fil(  indb  );
    if ( !fil.exists()) {
        QString tmp;
        tmp = QString("Doesn't exist dbtable which must contain cleaned records.");
        QMessageBox::critical(this,caption(),tmp);
        return ;
    }
    QString rootdb = QString(doc->GetRootAbsPath());
    rootdb.append(".instrument");
    QString origindb = QString(doc->GetOriginAbsPath());
    origindb.append(".origin");
    QString systemStr = QString ("db2asc  %1 %2 %3 %4 %5 %6").arg(indb).arg(rootdb).arg(origindb).arg(numOriginRow).arg(dirName).arg(indAhOrAscii);
    system(systemStr.ascii());
}

