#include <qstring.h>
#include <qpushbutton.h>
#include <qlabel.h>
#include <qlayout.h>
#include <qlineedit.h> 
#include <qfont.h>
#include <qpixmap.h>
#include <qtable.h> 
#include <qmessagebox.h> 
#include "mainwindow.h"
#include "ftanwindowimpl.h"
#include "document.h"
#include "propertyeditor.h"
FtanWindow::~FtanWindow(){
delete  lineVelMin; lineVelMin = 0;
delete  lineVelMax; lineVelMax = 0;
delete  linePerMin; linePerMin = 0;
delete  linePerMax; linePerMax = 0;  
}
FtanWindow::FtanWindow( QWidget *parent, FDocument* dc )
    : FtanWindowSetBase( parent, 0 ),doc(dc)
{
    setFont( parent->font() );
  
    lineVelMin = new LineEditDouble(this,"LineEditDouble1", 
				  doc->GetGroupVelBoundMinimum()->GetMin(), 
				  doc->GetGroupVelBoundMinimum()->GetMax(),
				  doc->GetGroupVelBoundMinimum()->GetDecimal(),FALSE); 
     lineVelMax = new LineEditDouble(this,"LineEditDouble2", 
				  doc->GetGroupVelBoundMaximum()->GetMin(), 
				  doc->GetGroupVelBoundMaximum()->GetMax(),
				  doc->GetGroupVelBoundMaximum()->GetDecimal(),FALSE); 
     linePerMin = new LineEditDouble(this,"LineEditDouble3", 
				  doc->GetPeriodBoundMinimum()->GetMin(), 
				  doc->GetPeriodBoundMinimum()->GetMax(),
				  doc->GetPeriodBoundMinimum()->GetDecimal(),FALSE); 
     linePerMax = new LineEditDouble(this,"LineEditDouble4", 
				  doc->GetPeriodBoundMaximum()->GetMin(), 
				  doc->GetPeriodBoundMaximum()->GetMax(),
				  doc->GetPeriodBoundMaximum()->GetDecimal(),FALSE);     

     lineVelMin->setFrame( FALSE );    
     lineVelMax->setFrame( FALSE );       
     linePerMin->setFrame( FALSE );       
     linePerMax->setFrame( FALSE );  
     
//     lineVelMin->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)5, (QSizePolicy::SizeType)5, 0, 0, 
//					      lineVelMin->sizePolicy().hasHeightForWidth() ) );
   
     lineVelMin->setText(doc->GetGroupVelBoundMinimum()->GetValue());
     lineVelMax->setText(doc->GetGroupVelBoundMaximum()->GetValue());
     linePerMin->setText( doc->GetPeriodBoundMinimum()->GetValue() );
     linePerMax->setText( doc->GetPeriodBoundMaximum()->GetValue());       
     defaultVel = new QPushButton( this, "defaultVel" );       
     defaultPer =  new QPushButton( this, "defaultPer" );   
     defaultVel->setPixmap(QPixmap::fromMimeSource("ftan_default.png") );     
     defaultPer->setPixmap(QPixmap::fromMimeSource("ftan_default.png") );     
     table->setCellWidget ( 0,2, defaultVel) ;
     table->setCellWidget ( 1,2, defaultPer) ;

    
     table->setCellWidget ( 0,0, lineVelMin) ;
     table->setCellWidget ( 0,1, lineVelMax) ;
     table->setCellWidget ( 1,0, linePerMin) ;
     table->setCellWidget ( 1,1, linePerMax) ;
     
     table->horizontalHeader()->setLabel( 2, " " ) ;
     table->verticalHeader()->setLabel( 0, tr( "Group Vel (km/sec)  " ) );
     table->verticalHeader()->setLabel( 1, tr( "Period (sec)  " ) );
     table->adjustColumn ( 2 );
     table->setColumnStretchable ( 0, TRUE );
     table->setColumnStretchable ( 1, TRUE );   
     table->adjustRow ( 0 ); table->adjustRow ( 1 );
//     table->adjustSize();
//     adjustSize();
//     resize( sizeHint () );
     connect( defaultVel, SIGNAL( clicked() ),
		this, SLOT( setDefaultVel() ) );
     connect( defaultPer, SIGNAL( clicked() ),
		this, SLOT( setDefaultPer() ) );
}

void FtanWindow::accept()
{
//qWarning("FtanWindow::accept()");  
doc->GetGroupVelBoundMinimum()->SetValue(
QString::number( lineVelMin->text().toDouble(),'f',doc->GetGroupVelBoundMinimum()->GetDecimal()));
doc->GetGroupVelBoundMaximum()->SetValue(
QString::number( lineVelMax->text().toDouble(),'f',doc->GetGroupVelBoundMaximum()->GetDecimal()));

doc->GetPeriodBoundMinimum()->SetValue(
QString::number( linePerMin->text().toDouble(),'f',doc->GetPeriodBoundMinimum()->GetDecimal()));
doc->GetPeriodBoundMaximum()->SetValue(
QString::number(linePerMax->text().toDouble(),'f',doc->GetPeriodBoundMaximum()->GetDecimal()));

doc->GetGroupVelBoundMinimum()->SetValueToResetvalue();
doc->GetGroupVelBoundMaximum()->SetValueToResetvalue();
doc->GetPeriodBoundMinimum()->SetValueToResetvalue();
doc->GetPeriodBoundMaximum()->SetValueToResetvalue();

doc->GetGroupVelBoundMinimum()->setChanged();
doc->GetGroupVelBoundMaximum()->setChanged();
doc->GetPeriodBoundMinimum()->setChanged();
doc->GetPeriodBoundMaximum()->setChanged();
done( Accepted ); 
}
void FtanWindow::reject()
{
//qWarning("FtanWindow::reject()");   
doc->GetGroupVelBoundMinimum()->SetResetvalueToValue();
doc->GetGroupVelBoundMaximum()->SetResetvalueToValue();
doc->GetPeriodBoundMinimum()->SetResetvalueToValue();
doc->GetPeriodBoundMaximum()->SetResetvalueToValue();
done( Rejected );    
}
void FtanWindow::setDefaultVel(){
//qWarning("FtanWindow::setDefaultVel()");      
     lineVelMin->setText(doc->GetGroupVelBoundMinimum()->GetDefaultvalue());
     lineVelMax->setText(doc->GetGroupVelBoundMaximum()->GetDefaultvalue());
}
void FtanWindow::setDefaultPer(){
//qWarning("FtanWindow::setDefaultPer()");      
     linePerMin->setText( doc->GetPeriodBoundMinimum()->GetDefaultvalue() );
     linePerMax->setText( doc->GetPeriodBoundMaximum()->GetDefaultvalue());  
}

