#include <QtGui>
#include "listproperty.h"
#include "setting.h"
#include "document.h"
#include "defaults.h"
#include "editline.h"
QModelIndex openEditorIndex = QModelIndex();
static const  QString LEFT_BREAKET = "  [ ";
static const  QString RIGHT_BREAKET = " ]";
static const  QString MIDL_BREAKET = " , ";
PropertyInt::PropertyInt(QModelIndex ind,const QString &initStr,const QString &defStr,PropertyValue* p,int min,int max,bool s )
        : ItemProperty(ind,initStr,defStr,p),
        minimum(min),maximum(max),signedValue(s)  {}
//-------------------------------------------------------------------
PropertyIntSpin::PropertyIntSpin(QModelIndex ind,const QString &initStr,const QString &defStr,PropertyValue* p,int min,int max,int st )
        : ItemProperty(ind,initStr,defStr,p),
        minimum(min),maximum(max),step(st)  {}
//-------------------------------------------------------------------
PropertyDouble::PropertyDouble(QModelIndex ind,const QString &initStr,const QString &defStr,PropertyValue* p,double min,double max,int dec)
        : ItemProperty(ind,initStr,defStr,p),
        minimum(min),maximum(max),decimals(dec)  {}
//-------------------------------------------------------------------
PropertyString::PropertyString(QModelIndex ind,const QString &initStr,const QString &defStr,PropertyValue* p)
        : ItemProperty(ind,initStr,defStr,p) {}
//-------------------------------------------------------------------
PropertyTittle::PropertyTittle(QModelIndex ind,const QString &tittle)
        : ItemProperty(ind,tittle) {}
//-------------------------------------------------------------------

PropertyNotEdit::PropertyNotEdit(QModelIndex ind,const QString &initStr,const QString &defStr,PropertyValue* p)
        : ItemProperty(ind,initStr,defStr,p) {}
//-------------------------------------------------------------------
PropertyDateTime::PropertyDateTime(QModelIndex ind,const QString &initStr,const QString &defStr,PropertyValue* p)
        : ItemProperty(ind,initStr,defStr,p) {}
//-------------------------------------------------------------------
//-------------------------------------------------------------------
TreePropertyModel::~TreePropertyModel() {


}
TreePropertyModel::TreePropertyModel(int columns, QObject * parnt )
        : QStandardItemModel(0, columns,parnt),NumCols(columns) {
    parent = (SettingProperty*)parnt;
    NumRows=0;
    SetHorizontalHeader();
}
void TreePropertyModel::SetHorizontalHeader() {
    setHeaderData(0, Qt::Horizontal,"sta/rec");
    setHeaderData(1, Qt::Horizontal,"number");
    setHeaderData(2, Qt::Horizontal,"bound period interval");
    setHeaderData(3, Qt::Horizontal,"");
    setHeaderData(4, Qt::Horizontal,"comment");
}



void TreePropertyModel::SetItem(int nsta,int nchan,PropertyValue* p,PropertyValue* pmin,PropertyValue* pmax,PropertyValue* pcheck,PropertyValue* pcomment) {

    ItemProperty * ip = 0;
    QModelIndex indexParent0Col0 = index(nsta, 0, QModelIndex());
   int rows = rowCount(indexParent0Col0);
   insertRows ( rows ,1,indexParent0Col0);


    QModelIndex indexCol0 = index(nchan, 0, indexParent0Col0);
    setData(indexCol0, QVariant(p->GetValue()),Qt::DisplayRole);
    itemFromIndex (indexCol0)->setEditable (false);

    QModelIndex indexCol1 = index(nchan, 1, indexParent0Col0);
    setData(indexCol1, QVariant(p->GetName()),Qt::DisplayRole);
    itemFromIndex (indexCol1)->setEditable (false);
///    minimum period
    QModelIndex indexCol2 = index(nchan, 2, indexParent0Col0);
    PropertyFloatValue * pflt =  (PropertyFloatValue *)pmin;
    ip = new   PropertyDouble(indexCol2,pflt->GetValue(),pflt->GetDefaultvalue(),pflt,pflt->GetMin(),pflt->GetMax(),pflt->GetDecimal());
    minMap.insert(indexCol2,(PropertyDouble*)ip);
    pflt =  (PropertyFloatValue *)pmax;
    ip = new   PropertyDouble(indexCol2,pflt->GetValue(),pflt->GetDefaultvalue(),pflt,pflt->GetMin(),pflt->GetMax(),pflt->GetDecimal());
    maxMap.insert(indexCol2,(PropertyDouble*)ip);
    QString format = formatColumnPeriod();
    QString tmp = QString(format).arg(pmin->GetValue()).arg(pmax->GetValue());
    setData(indexCol2, QVariant(tmp),Qt::EditRole );

///    checking confirmation
    QModelIndex indexCol3 = index(nchan, 3, indexParent0Col0);
    QStandardItem* itemCheck = itemFromIndex(indexCol3);
    itemCheck->setCheckable(true);
    if (pcheck->GetValue() == "1") {
        itemCheck->setData(QVariant(true),Qt::CheckStateRole );
        itemCheck->setCheckState(Qt::Checked);
    } else {
        itemCheck->setData(QVariant(false),Qt::CheckStateRole );
        itemCheck->setCheckState(Qt::Unchecked);
    }

    itemCheck->setEditable (false);

///    comment
    QModelIndex indexCol4 = index(nchan, 4, indexParent0Col0);
    setData(indexCol4, QVariant(pcomment->GetValue()));

}
///----------------------------------------------------------------------
void TreePropertyModel::SetItem(vStaIt itSta) {

    insertRows ( NumRows,1);
    int rows =  NumRows;
    QModelIndex indexParent0Col0 = index(rows, 0, QModelIndex());
    setData(indexParent0Col0, QVariant((*itSta)->GetName())); //p->GetValue())
    itemFromIndex (indexParent0Col0)->setEditable (false);

    QModelIndex indexCol1 = index(rows, 1, QModelIndex());
    setData(indexCol1, QVariant((*itSta)->GetTextCol1()));
    itemFromIndex (indexCol1)->setEditable (false);

    indexCol1 = index(rows, 2, QModelIndex());
    itemFromIndex (indexCol1)->setEditable (false);

   QString format = formatColumnPeriod();
   QString tmp = QString(format).arg((*itSta)->GetMinPeriod()).arg((*itSta)->GetMaxPeriod());

    setData(indexCol1, QVariant(),Qt::EditRole );


    indexCol1 = index(rows, 3, QModelIndex());
    itemFromIndex (indexCol1)->setEditable (false);

    indexCol1 = index(rows, 4, QModelIndex());

    setData(indexCol1, QVariant((*itSta)->GetComment()));
    NumRows ++;

}



//-------------------------------------------------------------------
ResetLineEdit::~ResetLineEdit() {

}
ResetLineEdit::ResetLineEdit(PropertyDouble* ipmin,PropertyDouble* ipmax,const QModelIndex & index,QWidget *parent)
        : QWidget(parent),ipmin(ipmin),ipmax(ipmax),index(index) {
    QString iniVal = index.model()->data(index, Qt::DisplayRole).toString();
    QStringList lst = iniVal.split(' ');
    QString valmin = lst.at(1);
    QString valmax = lst.at(3);

    QGridLayout *gridLayout = new QGridLayout(this);
    gridLayout->setMargin(1);
    gridLayout->setSpacing(1);

    labelmin = new QLabel(this);
    QFont fn = font ();
    // fn.setBold(true);
    labelmin->setFont(fn);
    QPalette pl = labelmin->palette ();
    pl.setColor (QPalette::Text, QColor("blue") );
    labelmin->setPalette ( pl );
    gridLayout->addWidget(labelmin, 0, 0, 1, 1);

    linmin = new LineEditor(ipmin->GetPropertyValue(),valmin,this,true);

    gridLayout->addWidget(linmin, 0, 1, 1, 1);

    labelmax = new QLabel(this);
    labelmax->setPalette ( pl );
    gridLayout->addWidget(labelmax, 0, 2, 1, 1);

    linmax = new LineEditor(ipmin->GetPropertyValue(),valmin,this,true);

    gridLayout->addWidget(linmax, 0, 3, 1, 1);

}
void ResetLineEdit::setLine(const QString &value) {

    QStringList lst = value.split(' ');
    QString valmin = lst.at(1);
    QString valmax = lst.at(3);

    labelmin->setText("min:");
    labelmax->setText("max:");
    linmin->setText(valmin);
    linmax->setText(valmax);
}

void ResetLineEdit::emitResetProperty() {
    /*
        TreePropertyModel *mod = (TreePropertyModel *)index.model();
        ItemProperty * p = mod->findProperty(index);
        if (p->GetInitStr() == p->GetDefaultStr()) p->SetChanged(false);
        else p->SetChanged(true);
        setLine(ip->GetDefaultStr());
        mod->setData(index, QVariant(p->GetDefaultStr()));
        if (ip->GetDefaultStr() == index.model()->data(index, Qt::DisplayRole).toString()) button->setEnabled(false);
    */
}
///========================================================================================

QWidget *TreePropertyDelegate::createEditor(QWidget *parent,
        const QStyleOptionViewItem &style,
        const QModelIndex & index) const {

//    TreePropertyModel *mod = (TreePropertyModel *)index.model();
//    ItemProperty * p = mod->findProperty(index);
//    QModelIndex children = index.parent();
    TreePropertyModel *mod = (TreePropertyModel *)index.model();
    QModelIndex parentIndex = index.parent();
    if (parentIndex !=  QModelIndex() && index.column() == 2) {
        ResetLineEdit* editor = new ResetLineEdit(mod->minMap[index],mod->maxMap[index],index,parent);
        return editor;
    } else
        return  QItemDelegate::createEditor(parent,style,index);



}

TreePropertyDelegate::TreePropertyDelegate(QObject *parent)
        : QItemDelegate(parent) {

}
//-------------------------------------------------------------------

void TreePropertyDelegate::setEditorData(QWidget *editor,
        const QModelIndex &index) const {


    TreePropertyModel *mod = (TreePropertyModel *)index.model();
    QModelIndex parentIndex = index.parent();
    if (parentIndex !=  QModelIndex() && index.column() == 2) {

        QString value = mod->data(index, Qt::DisplayRole).toString();
        ResetLineEdit* reditor = static_cast<ResetLineEdit *>(editor);
        reditor->setLine(value);
        openEditorIndex = index;

    } else   QItemDelegate::setEditorData(editor,index);


}


void TreePropertyDelegate::setModelData(QWidget *editor, QAbstractItemModel *model,
                                        const QModelIndex &index) const {


    TreePropertyModel *mod = (TreePropertyModel *)index.model();
    QModelIndex parentIndex = index.parent();
    if (parentIndex !=  QModelIndex() && index.column() == 2) {
        ResetLineEdit *reditor = static_cast<ResetLineEdit*>(editor);
        QString minval = reditor->linmin->text();
        QString maxval = reditor->linmax->text();
        QModelIndex indexChan = mod->index(index.row(),0,parentIndex);

        if ( minval.toFloat() > maxval.toFloat() ) {

            QMessageBox::critical(0,"Periods list panel",
                                  QString("Minumum value ( %1 ) is greater than maximum value ( %2 )").arg(minval).arg(maxval));

            mod->redStaMap[index] = true;
            mod->redStaMap[indexChan] = true;
            mod->redStaMap[parentIndex] = true;

        } else {
            mod->redStaMap[index] = false;
            mod->redStaMap[indexChan] = false;
            mod->redStaMap[parentIndex] = false;
        }
        // if ( value == "") value = p->GetInitStr();
        QString format = formatColumnPeriod();
        QString tmp = QString(format).arg(minval).arg(maxval);
        mod->setData(index, QVariant(tmp),Qt::EditRole);
        openEditorIndex = QModelIndex();
//mod->parent->clearFocus();
    } else  QItemDelegate::setModelData(editor,model,index);



}

void TreePropertyDelegate::paint(QPainter *painter, const QStyleOptionViewItem &opt, const QModelIndex &index) const {
    QStyleOptionViewItem option = opt;
    option.displayAlignment =  Qt::AlignLeft|Qt::AlignVCenter;
    //option.displayAlignment =  Qt::AlignHCenter;
    TreePropertyModel *model = (TreePropertyModel *)index.model();
    QModelIndex parentIndex = index.parent();
/// draw blue
    bool drawBlue = false;
    if (parentIndex ==  QModelIndex()) {
        QStandardItem* itemStation = model->itemFromIndex(index);
        int rowsChan = itemStation->rowCount ();
        for (int  i = 0; i < rowsChan; ++i) {
            QModelIndex checkChanIndex = model->index(i, 3, index);
            QStandardItem * itChan = model->itemFromIndex(checkChanIndex);
            if (itChan->checkState () == Qt::Unchecked) drawBlue = true;
        }
    } else {
        QModelIndex checkChanIndex = model->index(index.row(),3,parentIndex);
        QStandardItem* itChan = model->itemFromIndex(checkChanIndex);

        if (itChan->checkState () == Qt::Unchecked) {
            if (index == model->index(index.row(),0,parentIndex))
                drawBlue = true;
        }
    }

    if (drawBlue) {
        //option.font.setBold(true);
        option.palette.setColor(QPalette::Text,QColor("blue"));
    }


/// draw red
    if (model->redStaMap[index]) {
        //option.font.setBold(true);
        option.palette.setColor(QPalette::Text,QColor("red"));
    }
    /*
        if (parentIndex ==  QModelIndex() && index.column() == 0 ) {

            QModelIndex staIndexCol2 = model->index(index.row(),2,QModelIndex());
            if ( model->redStaMap[staIndexCol2])
                option.palette.setColor(QPalette::Text,QColor("red"));
        }
    */
    /*
            if (p != 0) {
                if (p->GetChanged()) {
                    option.font.setBold(true);
                    option.palette.setColor(QPalette::Text,QColor("blue"));
                }
                if (p->GetInvalid()) {
                    option.font.setBold(true);
                    option.palette.setColor(QPalette::Text,QColor("red"));
                }

                if (dynamic_cast<ItemProperty *>(p) == dynamic_cast<PropertyNotEdit *>(p) ) {
                    if (index.column() == 1)  {
                        PropertyNotEdit * pp =  (PropertyNotEdit *)p;
                        if (pp->edited) paintAct = false;
                    }
                }
                if (dynamic_cast<ItemProperty *>(p) == dynamic_cast<PropertyTittle *>(p) ) {
                    option.font.setItalic(true);
                    option.palette.setColor(QPalette::Text,QColor("blue"));
                }
            }


            //  option.palette.setColor(QPalette::Highlight,QColor(100,160,180)); //QColor(80,132,166)

            if (paintAct)   QItemDelegate::paint(painter, option, index);


         //   if (index.column() == 0 || index.column() == 1 ) {
                painter->drawLine(option.rect.right(), option.rect.y(),
                                  option.rect.right(), option.rect.bottom());
        //    }
        */
//openEditorIndex = QModelIndex();
    if (openEditorIndex != index)
        QItemDelegate::paint(painter, option, index);

    if (index.column() == 0 || index.column() == 1 || index.column() == 2 || index.column() == 3) {
        painter->drawLine(option.rect.right(), option.rect.y(),
                          option.rect.right(), option.rect.bottom());
    }
    painter->drawLine(option.rect.x(), option.rect.bottom(),
                      option.rect.right(), option.rect.bottom());

}

//---------------------------------------------------
