#include "mainwindow.h"
#include "propertydialogImpl.h"
#include "document.h"
#include "defaults.h"
#include <qfont.h>
#include <qpushbutton.h>
#include <qmessagebox.h>
//Added by qt3to4:
#include <QResizeEvent>
PropertyDialog::~PropertyDialog () {
    propList.clear ();
    listvalForFilter.clear ();
    listvalForOrbitMode.clear ();
    listvalForPhasevelocityBound.clear ();
    listvalForGroupVelocityBound.clear ();
    listvalForPeriodBound.clear ();
    listvalForRawSpectrum.clear ();
}
PropertyDialog::PropertyDialog( QWidget *parent,    FDocument* dc,const int idSet,QString namePro,int ,int ,int ,int  )
        : QDialog( parent) {
    setFont( parent->font() );
    setupUi(this);
    doc = dc;
    // qWarning("ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ");
    //  doc->printFDocument();
    idMainOrTotalSet = idSet;
    listView->setSorting( -1 );

    listView->setBackgroundOrigin( Q3ListView::WidgetOrigin );
    listView->setShowSortIndicator( FALSE );
    listView->setResizeMode(Q3ListView::AllColumns);// QListView::AllColumns   QListView::LastColumn
    listView->clear();
    listView->header()->setStretchEnabled (true, 1);
    itemProjectName = new PropertyNoDialogTopItem( listView, 0,listView, "Project",namePro);
    ///-----------------------------------------  Window characteristic: -----------------------------------------
    itemWindowCharacteristic = new PropertyNoDialogTopItem(listView,itemProjectName,listView, "Window characteristic:");
    if (idSet == 0) {
        itemComboWidowSize = new PropertyComboItem(itemWindowCharacteristic,0,listView, "WidowSize",
                doc->GetWidowSize());
        propList.append((PropertyItem*) itemComboWidowSize);
        itemComboWidowMode = new PropertyComboItem(itemWindowCharacteristic,itemComboWidowSize,listView, "WidowMode",
                doc->GetWidowMode());
        propList.append((PropertyItem*) itemComboWidowMode);

        itemComboPostScript = new PropertyComboItem(itemWindowCharacteristic,itemComboWidowMode,listView, "PostScript",
                doc->GetPostScript());
        propList.append((PropertyItem*) itemComboPostScript);
    }
    if (idSet == 1) {   //    MAIN SETTINGS !!!!!!!!!!!!!!!!!!
        itemComboPostScript = new PropertyComboItem(itemWindowCharacteristic,0,listView, "PostScript",
                doc->GetPostScript());
        propList.append((PropertyItem*) itemComboPostScript);
    }
///----------------------------------------- Plot characteristic:  ----------------------------------------
    if (idSet == 0) {
        itemPlotCharacteristic  = new  PropertyNoDialogTopItem(listView,itemWindowCharacteristic,listView, "Plot characteristic:");
        itemComboFtaWaveTypeOverPlot = new PropertyComboItem(itemPlotCharacteristic,0,listView, "FtaWaveTypeOverPlot",
                doc->GetFtaWaveTypeOverPlot());
        propList.append((PropertyItem*) itemComboFtaWaveTypeOverPlot );

        itemCombotFtaGroupVelocityPlot = new PropertyComboItem(itemPlotCharacteristic,itemComboFtaWaveTypeOverPlot ,
                listView, "FtaWaveTypeOverPlot",
                doc->GetFtaGroupVelocityPlot ());
        propList.append((PropertyItem*) itemCombotFtaGroupVelocityPlot );

        itemComboXaxisScaling = new PropertyComboItem(itemPlotCharacteristic,itemCombotFtaGroupVelocityPlot,
                listView, "XaxisScaling",
                doc->GetXaxisScaling ());
        propList.append((PropertyItem*)  itemComboXaxisScaling );

///-----------------------------------------Edit handling:  ----------------------------------------
        /*
        itemEditHandling = new  PropertyNoDialogTopItem(listView,itemPlotCharacteristic ,listView, "Edit handling:");
        itemComboEditApplied = new PropertyComboItem(itemEditHandling,0,listView, "EditApplied",
        				   doc->GetEditApplied());
        propList.append((PropertyItem*) itemComboEditApplied);

        itemCombotInterpolateNominalGrid = new PropertyComboItem(itemEditHandling, itemComboEditApplied,
        						 listView, "InterpolateNominalGrid ",
        						 doc->GetInterpolateNominalGrid());
        propList.append((PropertyItem*) itemCombotInterpolateNominalGrid);
        */
///-----------------------------------------Waveform:  ----------------------------------------

        itemWaveForm = new  PropertyNoDialogTopItem(listView,itemPlotCharacteristic,listView, "Waveform:");
        itemPlotCompt = new  PropertyEnumItem(itemWaveForm ,0 ,listView, "PlotCompt",
                                              doc->GetPlotCompt());
        propList.append((PropertyItem*) itemPlotCompt);
        ///-----------------------------------------Waveform filter specification:  ------------------------
        listvalForFilter.push_back( doc->GetShortPeriodZero());
        listvalForFilter.push_back( doc->GetShortPeriodCorner());
        listvalForFilter.push_back( doc->GetLongPeriodCorner());
        listvalForFilter.push_back( doc->GetLongPeriodZero());
        itemForFilter =  new      PropertySetItem(itemWaveForm,itemPlotCompt,listView, "Waveform filter specification:",
                &listvalForFilter,&propList);
        propList.append((PropertyItem*) itemForFilter);
    }
    if (idSet == 1) {   //    MAIN SETTINGS !!!!!!!!!!!!!!!!!!
///-----------------------------------------Waveform:  ----------------------------------------
        itemWaveForm = new  PropertyNoDialogTopItem(listView,itemWindowCharacteristic,listView, "Waveform:");
        itemPlotCompt = new  PropertyEnumItem(itemWaveForm ,0 ,listView, "PlotCompt",
                                              doc->GetPlotCompt());
        propList.append((PropertyItem*) itemPlotCompt);
        ///-----------------------------------------Waveform filter specification:  ------------------------
        listvalForFilter.push_back( doc->GetShortPeriodZero());
        listvalForFilter.push_back( doc->GetShortPeriodCorner());
        listvalForFilter.push_back( doc->GetLongPeriodCorner());
        listvalForFilter.push_back( doc->GetLongPeriodZero());
        itemForFilter =  new      PropertySetItem(itemWaveForm,itemPlotCompt,listView, "Waveform filter specification:",
                &listvalForFilter,&propList);
        propList.append((PropertyItem*) itemForFilter);

    }
///-----------------------------------------Measurement specification:  ----------------------------------------

    itemMeasurementSpecification = new  PropertyNoDialogTopItem(listView,itemWaveForm ,listView, "Measurement specification:");
    if (idSet == 0) {
        /*
           itemComboOutPutImagePhase = new PropertyComboItem(itemMeasurementSpecification, 0,
           						 listView, "OutPutImagePhase",
           						 doc->GetOutPutImagePhase());
           propList.append((PropertyItem*) itemComboOutPutImagePhase);
         
        */
        itemComboInstrumentResponse = new PropertyComboItem(itemMeasurementSpecification, 0,
                listView, "InstrumentResponse",
                doc->GetInstrumentResponse());
        propList.append((PropertyItem*) itemComboInstrumentResponse);

//    itemChangeAlphaFilter = new PropertyComboItem(itemMeasurementSpecification,itemComboInstrumentResponse,
//							 listView, "ChangeAlphaFilter ",
//							 doc->GetChangeAlphaFilter ());
//    propList.append((PropertyItem*) itemChangeAlphaFilter);

        itemFtaCompt = new  PropertyEnumItem(itemMeasurementSpecification,itemComboInstrumentResponse,listView, "FtaCompt ",
                                             doc->GetFtaCompt ());
        propList.append((PropertyItem*) itemFtaCompt) ;
        itemComboPolar = new PropertyComboItem(itemMeasurementSpecification,itemFtaCompt ,
                                               listView, "Polar",
                                               doc->GetPolar());
        propList.append((PropertyItem*) itemComboPolar);
    }

    if (idSet == 1) {   //    MAIN SETTINGS !!!!!!!!!!!!!!!!!!
        itemFtaCompt = new  PropertyEnumItem(itemMeasurementSpecification,0,listView, "FtaCompt ",
                                             doc->GetFtaCompt ());
        propList.append((PropertyItem*) itemFtaCompt) ;
        itemComboPolar = new PropertyComboItem(itemMeasurementSpecification,itemFtaCompt ,
                                               listView, "Polar",
                                               doc->GetPolar());
        propList.append((PropertyItem*) itemComboPolar);
    }
///-----------------------------------------Phase velocity information:  ----------------------------------------
    if (idSet == 0) {
        /*
            itemPhaseVelocityInformation = new  PropertyNoDialogTopItem(listView,itemMeasurementSpecification,listView, "Phase velocity information:");

            itemPhaseVelocityMeasurement = new PropertyComboItem(itemPhaseVelocityInformation,0,
        							 listView, "PhaseVelocityMeasurement",
        							 doc->GetPhaseVelocityMeasurement());
            propList.append((PropertyItem*) itemPhaseVelocityMeasurement);
                     ///-----------------------------------------Phase velocity bounds (km/s)  ----------------------------
            listvalForPhasevelocityBound.push_back( doc->GetPhaseVelBoundMinimum());
            listvalForPhasevelocityBound.push_back( doc->GetPhaseVelBoundMaximum());
            itemForPhasevelocityBound = new PropertySetItem(itemPhaseVelocityInformation,itemPhaseVelocityMeasurement,
        						    listView, "Phase velocity bounds (km/s):",
        						   &listvalForPhasevelocityBound,&propList);
            propList.append((PropertyItem*) itemForPhasevelocityBound);

            itemPhaseVelRefPeriod = new PropertyDoubleItem(itemPhaseVelocityInformation, itemForPhasevelocityBound,listView,
        						   "PhaseVelRefPeriod",doc->GetPhaseVelRefPeriod());
            propList.append((PropertyItem*)  itemPhaseVelRefPeriod);
        */
///-----------------------------------------Analysis limits:  ----------------------------------------
        itemAnalysisLimit = new  PropertyNoDialogTopItem(listView,itemMeasurementSpecification,listView, "Analysis limits:");
        ///-----------------------------------------Group velocity bounds (km/s)  ----------------------------------------
        listvalForGroupVelocityBound.push_back( doc->GetGroupVelBoundMinimum());
        listvalForGroupVelocityBound.push_back( doc->GetGroupVelBoundMaximum ());
        itemForGroupVelocityBound = new PropertySetItem(itemAnalysisLimit,0,
                listView, "Group velocity bounds (km/s):",
                &listvalForGroupVelocityBound,&propList);
        propList.append((PropertyItem*) itemForGroupVelocityBound);
        ///-----------------------------------------Period bounds (sec)  ----------------------------------------
        listvalForPeriodBound.push_back( doc->GetPeriodBoundMinimum ());
        listvalForPeriodBound.push_back( doc->GetPeriodBoundMaximum());
        itemForGroupVelocityBound = new PropertySetItem(itemAnalysisLimit,itemForGroupVelocityBound,
                listView, "Period bounds (sec):",
                &listvalForPeriodBound,&propList);
        propList.append((PropertyItem*) itemForGroupVelocityBound);
        ///-----------------------------------------Numbers of orbit and mode ----------------------------------------
        listvalForOrbitMode.push_back( doc->GetFtaOrbit());
        listvalForOrbitMode.push_back( doc->GetFtaMode());
        itemForOrbitMode =  new      PropertySetItem(itemAnalysisLimit, itemForGroupVelocityBound ,listView, "Numbers of orbit and mode",
                &listvalForOrbitMode,&propList,FALSE);

        propList.append((PropertyItem*)itemForOrbitMode);

        ///-----------------------------------------Raw spectrum: group velocity and width (s)  ----------------------------------------
        listvalForRawSpectrum.push_back( doc->GetRowSpectrumGroupVelocity ());
        listvalForRawSpectrum.push_back( doc->GetRowSpectrumWidth ());
        itemForRawSpectrum = new PropertySetItem(itemAnalysisLimit,itemForOrbitMode,
                listView, "Raw spectrum: group velocity and width (s) :",
                &listvalForRawSpectrum,&propList,FALSE);
        propList.append((PropertyItem*) itemForRawSpectrum);
    }
    if (idSet == 1) {   //    MAIN SETTINGS !!!!!!!!!!!!!!!!!!
        itemAnalysisLimit = new  PropertyNoDialogTopItem(listView,itemMeasurementSpecification,listView, "Analysis limits:");
        ///-----------------------------------------Group velocity bounds (km/s)  ----------------------------------------
        listvalForGroupVelocityBound.push_back( doc->GetGroupVelBoundMinimum());
        listvalForGroupVelocityBound.push_back( doc->GetGroupVelBoundMaximum ());
        itemForGroupVelocityBound = new PropertySetItem(itemAnalysisLimit,0,
                listView, "Group velocity bounds (km/s):",
                &listvalForGroupVelocityBound,&propList);
        propList.append((PropertyItem*) itemForGroupVelocityBound);
        ///-----------------------------------------Period bounds (sec)  ----------------------------------------
        listvalForPeriodBound.push_back( doc->GetPeriodBoundMinimum());
        listvalForPeriodBound.push_back( doc->GetPeriodBoundMaximum ());
        itemForGroupVelocityBound = new PropertySetItem(itemAnalysisLimit,itemForGroupVelocityBound,
                listView, "Period bounds (sec):",
                &listvalForPeriodBound,&propList);
        propList.append((PropertyItem*) itemForGroupVelocityBound);
        ///-----------------------------------------Numbers of orbit and mode ----------------------------------------
        listvalForOrbitMode.push_back( doc->GetFtaOrbit());
        listvalForOrbitMode.push_back( doc->GetFtaMode());
        itemForOrbitMode =  new      PropertySetItem(itemAnalysisLimit, itemForGroupVelocityBound ,listView, "Numbers of orbit and mode",
                &listvalForOrbitMode,&propList,FALSE);

        propList.append((PropertyItem*)itemForOrbitMode);
    }
///-----------------------------------------Event information:  ----------------------------------------
    /*
    if (idSet == 0) {
    itemEventInformation= new  PropertyNoDialogTopItem(listView,itemAnalysisLimit,listView, "Event information:");
    itemReadCentridMomentRelation  = new PropertyComboItem(itemEventInformation,0,
       					 listView, "ReadCentridMomentRelation",
       					 doc->GetReadCentridMomentRelation());
    propList.append((PropertyItem*) itemReadCentridMomentRelation);

    }
    */
    if (idSet == 0) setCaption( "Total Parameter Settings" );
    else setCaption(  "Main Parameter Settings" );

    buttonHelp->hide();
//   move(propx,propy);
//   resize(propw,proph);

    connect( listView, SIGNAL( collapsed( Q3ListViewItem* ) ), this, SLOT( itemlistViewCollapsed( Q3ListViewItem* ) ) );
    connect( listView, SIGNAL( expanded( Q3ListViewItem* ) ), this, SLOT( itemlistViewExpanded( Q3ListViewItem* ) ) );
    connect( listView, SIGNAL( clicked ( Q3ListViewItem * , const QPoint & , int  ) ), this, SLOT( itemlistViewClicked(Q3ListViewItem * , const QPoint & , int ) ) );
    // signals and slots connections
    connect( buttonCancel, SIGNAL( clicked() ), this, SLOT( reject() ) );
    connect( buttonOk, SIGNAL( clicked() ), this, SLOT( accept() ) );
    connect( buttonDefault, SIGNAL( clicked() ), this, SLOT( defaultButton() ) );
    connect( buttonHelp, SIGNAL( clicked() ), this, SLOT( helpButton() ) );
    connect( buttonReset, SIGNAL( clicked() ), this, SLOT( resetButton() ) );
    connect( buttonInitial, SIGNAL( clicked() ), this, SLOT( initialButton() ) );

}
void PropertyDialog::accept() {
//    qWarning("PropertyDialog::accept ");

    PropertyItem* prop;

    for ( prop = propList.first(); prop; prop = propList.next() )
        if (prop->IsEditorShown()) {
            prop->hideEditor();
            return;
        }

    for ( prop = propList.first(); prop; prop = propList.next() ) {
        if (dynamic_cast<PropertyItem *>(prop) == dynamic_cast<PropertySetItem *>(prop) ) {
            PropertySetItem * it = dynamic_cast<PropertySetItem *>(prop);
            if (it->GetAscending())
                if (!it->CheckAscending()) {
                    QMessageBox::warning(0,caption(),"Items must be sorted in ascending order'");
                    it->setOpen ( TRUE );
                    it->showEditor();
                    return;
                }
        }

    }


    for ( uint i = 0; i < propList.count(); ++i )
        if (propList.at(i)->GetChanged() && propList.at(i)->GetPropvalue() != 0)
            MainWindow::self->SendChangedValueToFtan(propList.at(i)->GetPropvalue()->GetId() );
    doc->SetValueToResetvalue();
    done( QDialog::Accepted );
}

void PropertyDialog::reject() {
    doc->SetResetvalueToValue();
    done( QDialog::Rejected );
}

void PropertyDialog::resizeEvent ( QResizeEvent * ce ) {
    ce =0;
    PropertyItem* prop;
    for ( prop = propList.first(); prop; prop = propList.next() )
        if (prop->IsEditorShown()) prop->showEditor();
}

void PropertyDialog::itemlistViewClicked(Q3ListViewItem * item, const QPoint & pnt, int c)     {

    /*
    if ( !item ) 	 {
    //listView->clearSelection ();
    return;
    }
    */
    QPoint pPoint(0,0);
    pPoint += pnt;
    c =0;

    PropertyItem* prop;
    for ( prop = propList.first(); prop; prop = propList.next() ) {

        if (!prop->IsEditorShown() && item  == prop ) {
            item->setText (1,"");
            prop->showEditor();

        }        else if (prop->IsEditorShown()) prop->hideEditor();

    }

}
void PropertyDialog::itemlistViewExpanded( Q3ListViewItem *item ) {
    if ( !item )
        return;

    PropertyItem* prop;
    for ( prop = propList.first(); prop; prop = propList.next() )
        if (prop->IsEditorShown()) prop->hideEditor();

}
void PropertyDialog::itemlistViewCollapsed( Q3ListViewItem *item ) {
    if ( !item )
        return;

    PropertyItem* prop;
    for ( prop = propList.first(); prop; prop = propList.next() )
        if (prop->IsEditorShown()) prop->hideEditor();
    if (dynamic_cast<PropertyItem *>(item) == dynamic_cast<PropertyNoDialogTopItem  *>(item) )
        item->setOpen( TRUE );
}
void PropertyDialog::defaultButton() {
    doc->SetDefault();
    PropertyItem* prop;
    for ( prop = propList.first(); prop; prop = propList.next()) {
        if (prop->IsEditorShown()) prop->hideEditor();
        if (prop->GetPropvalue() != 0)  prop->setDefault();
    }
    // qWarning("PropertyDialog::defaultButton");
}
void PropertyDialog::resetButton() {
//    qWarning("PropertyDialog::resetButton");
    doc->SetResetvalueToValue();
    PropertyItem* prop;
    for ( prop = propList.first(); prop; prop = propList.next()) {
        if (prop->IsEditorShown()) prop->hideEditor();
        if (prop->GetPropvalue() != 0)  prop->setReset();
    }
}

void PropertyDialog::initialButton() {
//    qWarning("PropertyDialog::initialButton");
    doc->SetInitial();
    PropertyItem* prop;
    for ( prop = propList.first(); prop; prop = propList.next()) {
        if (prop->IsEditorShown()) prop->hideEditor();
        if (prop->GetPropvalue() != 0)  prop->setInitial();
    }
}
void PropertyDialog::helpButton() {
    //qWarning("PropertyDialog::helpButton");
    if (idMainOrTotalSet == 0)  MainWindow::self->pageHelp("Ftan_Total_Setting_Dialog.html");                            // Total Setings
    else    MainWindow::self->pageHelp("Ftan_Main_Settigs_Dialog.html");                // Main Setings
}
