#ifndef PROPERTY_DIALOG_H
#define PROPERTY_DIALOG_H
#include "ui_propertydialogbase.h"
#include "propertyeditor.h"
#include <qvariant.h>
#include <q3ptrlist.h> 
//Added by qt3to4:
#include <QResizeEvent>
class Q3ListViewItem;
class FDocument;

class PropertyItem;
class PropertyFloatValue;
class PropertyNoDialogTopItem;
class PropertyBoolItem;
class PropertyDoubleItem;
class PropertySetItem;
class PropertyEnumItem;
class PropertyIntItem;
class PropertyComboItem;

class PropertyDialog : public QDialog, private Ui::PropertyDialogBase
{

    Q_OBJECT
    typedef vector<PropertyValue* > PropValVector;
private:
    FDocument* doc;

    PropertyNoDialogTopItem*  itemProjectName;
///-----------------------------------------  Window characteristic: -----------------------------------------
    PropertyNoDialogTopItem*  itemWindowCharacteristic;
    
    PropertyComboItem*   itemComboWidowSize;
    PropertyComboItem*   itemComboWidowMode;
    PropertyComboItem*   itemComboPostScript;

    
///----------------------------------------- Plot characteristic:  ----------------------------------------
    PropertyNoDialogTopItem* itemPlotCharacteristic;    
    
    PropertyComboItem*   itemComboFtaWaveTypeOverPlot;
    PropertyComboItem*   itemCombotFtaGroupVelocityPlot ;
    PropertyComboItem*   itemComboXaxisScaling;
    
///-----------------------------------------Edit handling:  ----------------------------------------
    PropertyNoDialogTopItem* itemEditHandling;    
    
    PropertyComboItem*   itemComboEditApplied;
    PropertyComboItem*   itemCombotInterpolateNominalGrid;
 
///-----------------------------------------Waveform:  ----------------------------------------
    PropertyNoDialogTopItem* itemWaveForm;    
    
    PropertyEnumItem* itemPlotCompt;    
          ///-----------------------------------------Waveform filter specification:  ------------------------
    PropertySetItem* itemForFilter;
    PropValVector  listvalForFilter;
    
///-----------------------------------------Measurement specification:  ----------------------------------------
    PropertyNoDialogTopItem* itemMeasurementSpecification;     

    PropertyComboItem*   itemComboOutPutImagePhase;
    PropertyComboItem*   itemComboInstrumentResponse;
    PropertyComboItem*   itemChangeAlphaFilter;
    PropertyEnumItem*     itemFtaCompt;
    PropertyComboItem*   itemComboPolar;
    
///-----------------------------------------Phase velocity information:  ----------------------------------------
    PropertyNoDialogTopItem* itemPhaseVelocityInformation;      
    PropertyComboItem*   itemPhaseVelocityMeasurement;    
             ///-----------------------------------------Phase velocity bounds (km/s)  ----------------------------
    PropertySetItem* itemForPhasevelocityBound;
    PropValVector  listvalForPhasevelocityBound;
 
    PropertyDoubleItem * itemPhaseVelRefPeriod;
    
///-----------------------------------------Analysis limits:  ----------------------------------------
    PropertyNoDialogTopItem* itemAnalysisLimit;
        ///-----------------------------------------Group velocity bounds (km/s)  ----------------------------------------
    PropertySetItem* itemForGroupVelocityBound;
    PropValVector  listvalForGroupVelocityBound;
       ///-----------------------------------------Period bounds (sec)  ----------------------------------------
    PropertySetItem* itemForPeriodBound;
    PropValVector  listvalForPeriodBound;
      ///-----------------------------------------numbers of orbit and mode ----------------------------------------
     PropertySetItem* itemForOrbitMode;
     PropValVector  listvalForOrbitMode;
     ///-----------------------------------------Raw spectrum: group velocity and width (s)  ----------------------------------------
    PropertySetItem* itemForRawSpectrum;
    PropValVector  listvalForRawSpectrum;
///-----------------------------------------Event information:  ----------------------------------------
    PropertyNoDialogTopItem* itemEventInformation;
    PropertyComboItem*   itemReadCentridMomentRelation;    
    int idMainOrTotalSet;

public:
    PropertyDialog( QWidget *parent,    FDocument* dc,const int idSet,QString namePro,int propx,int propy,int propw,int proph);
    ~PropertyDialog();
    Q3PtrList<PropertyItem > propList; 
    void resizeEvent ( QResizeEvent *  );
protected slots:
    void accept();
    void reject();
    void defaultButton();
    void  helpButton();
    void resetButton();
    void initialButton();
    void itemlistViewClicked( Q3ListViewItem * , const QPoint & , int );
    void itemlistViewCollapsed( Q3ListViewItem* );
    void itemlistViewExpanded( Q3ListViewItem* );    
    
};


#endif //PROPERTY_DIALOG_H
