#include "propertyeditor.h"
#include "document.h"
#include "defaults.h"
#include <qlayout.h>
#include <qtooltip.h>
#include <q3whatsthis.h>
#include <qstring.h>
#include <qwidget.h>
#include <qpushbutton.h>
#include <q3hbox.h>
#include <qvalidator.h>
#include <qpushbutton.h>
#include <q3frame.h>
#include <qrect.h>
#include <q3header.h>
#include <qpixmap.h>
#include <qlabel.h>
#include <qcombobox.h>
#include <qfile.h>
#include <qmessagebox.h>
#include <q3frame.h>
#include <qpainter.h>
#include <qcolor.h>
#include <q3datetimeedit.h>
#include <q3ptrlist.h>
#include <qstringlist.h>
#include <qtoolbutton.h>
#include <qcheckbox.h>
#include <Q3MimeSourceFactory>
/*
#ifdef Q_WS_MAC

#include <qwindowsstyle.h>
static void setupStyle(QWidget *w)
{
    static QStyle *windowsStyle = 0;
    if(!windowsStyle)
	windowsStyle = new QWindowsStyle;
    w->setStyle(windowsStyle);
}
#else
#define setupStyle(x)
#endif
*/
PropertyItem::~PropertyItem() {

}
PropertyItem::PropertyItem(Q3ListViewItem * parent, Q3ListViewItem * after, Q3ListView* l, const QString &propName,PropertyValue* propval )
        : Q3ListViewItem( parent, after ), listview( l ), propvalue(propval), propertyName( propName ) {
    backColor1   = new QColor(250, 248, 235);
    backColor2   = new QColor(  255, 255, 255 );
    selectedBack = new QColor(  230, 230, 230 );

    setSelectable(TRUE );
    open = FALSE;
    shown   = FALSE;
    if (propval != 0) setText( 0,propval->GetName() );
    else setText( 0, propertyName );
    changed = FALSE;
    setText( 1, "" );
    defaultButton = 0;
    buttonCancel = 0;
}
PropertyItem::PropertyItem(Q3ListView* parent, Q3ListViewItem * after, Q3ListView* l, const QString &propName,PropertyValue* propval  )
        : Q3ListViewItem( parent, after ), listview( l ), propvalue(propval), propertyName( propName ) {
    backColor1   = new QColor(250, 248, 235);
    backColor2   = new QColor(  255, 255, 255 );
    selectedBack = new QColor(  230, 230, 230 );

    setSelectable(TRUE );
    open = FALSE;
    shown   = FALSE;
    if (propval != 0) setText( 0,propval->GetName() );
    else setText( 0, propertyName );
    changed = FALSE;
    setText( 1, "" );
    defaultButton = 0;
    buttonCancel = 0;
}

PropertyItem::PropertyItem(Q3ListViewItem * parent, Q3ListView* l, const QString &propName,PropertyValue* propval )
        : Q3ListViewItem( parent), listview( l ), propvalue(propval), propertyName( propName ) {
    backColor1   = new QColor(250, 248, 235);
    backColor2   = new QColor(  255, 255, 255 );
    selectedBack = new QColor(  230, 230, 230 );
    setSelectable(TRUE );
    open = FALSE;
    shown   = FALSE;
    if (propval != 0) setText( 0,propval->GetName() );
    else setText( 0, propertyName );
    changed = FALSE;
    setText( 1, "" );
    defaultButton = 0;
    buttonCancel = 0;
}

void PropertyItem::placeEditor( QWidget *w ) {

    QRect r = listview->itemRect( this );
    if ( !r.size().isValid() ) {
        listview->ensureItemVisible( this );
#if defined(Q_WS_WIN)
        listview->repaintContents( FALSE );
#endif
        r = listview->itemRect( this );
    }

    int newHeight = w->height ();
    r.setX( listview->header()->sectionPos( 1 ) );
    r.setWidth( listview->header()->sectionSize( 1 ) - 1);
    r.setY(r.y() + r.height ()/2 - newHeight/2);
    r.setHeight(newHeight);
    r = QRect( listview->viewportToContents( r.topLeft() ), r.size() );
    w->resize( r.size() );
    listview->moveChild( w, r.x(), r.y() );

}
void PropertyItem::showEditor() {
    shown    = TRUE;
    placeEditor( box );
    box->show();

}
void PropertyItem::hideEditor() {
    if (propvalue != 0) {
        if (propvalue->GetValue() == propvalue->GetInitialvalue() ) propvalue->setChanged( FALSE);
        else propvalue->setChanged( TRUE);
    }
    updateDefaultButtonState();
    shown   = FALSE;
    box->hide();

}

void PropertyItem::paintCell( QPainter *p, const QColorGroup &cg, int column, int width, int align ) {

    QColorGroup g( cg );
    g.setColor( QColorGroup::Base, backgroundColor() );
    g.setColor( QColorGroup::Foreground, Qt::black );
    g.setColor( QColorGroup::Text, Qt::black );

    if ( column == 0 ) {

        p->fillRect( 0, 0, width, height(), backgroundColor() );
        p->save();

    }

    if ( isChanged() && column == 0 ) {
        p->save();

        QFont f = p->font();
        if (dynamic_cast<PropertyItem *>(this) == dynamic_cast<PropertyNoDialogTopItem *>(this ) ) {
            f.setItalic( TRUE );
            //    f.setUnderline( TRUE );
            f.setStretch ( 75 );
        } else
            f.setBold( TRUE );
        p->setFont( f );
    }


    if (column == 1 && (text(1) == "unnamed" || text(1) == "unknown") )
        g.setColor( QColorGroup::Text, Qt::red );
//    if (dynamic_cast<PropertyItem *>(this) == dynamic_cast<PropertyNoDialogTopItem *>(this )   && column == 0 )
//	g.setColor( QColorGroup::Text, Qt::blue );

    if ( !hasCustomContents() || column != 1 ) {
        Q3ListViewItem::paintCell( p, g, column, width, align  );
    } else {
        p->fillRect( 0, 0, width, height(), backgroundColor() );

        drawCustomContents( p, QRect( 0, 0, width, height() ) );

    }
    if ( isChanged() && column == 0 )
        p->restore();
    if ( column == 0 )
        p->restore();
    /*
    if ( hasSubItems() && column == 0 ) {
    p->save();
    p->setPen( cg.foreground() );
    p->setBrush( cg.base() );
    p->drawRect( 5, height() / 2 - 4, 9, 9 );
    p->drawLine( 7, height() / 2, 11, height() / 2 );
    if ( !isOpen() )
        p->drawLine( 9, height() / 2 - 2, 9, height() / 2 + 2 );
    p->restore();
    }

    p->save();
    p->setPen( QPen( cg.dark(), 1 ) );
    p->drawLine(0, height() - 1, width, height() - 1 );
    p->drawLine( width - 1, 0, width - 1, height() );

    p->restore();

    if ( column == 0 ) {
     p->save();
    p->drawLine( 0 , 0, 0 , height() );
    p->drawLine(0 , -1, width ,-1);
    p->restore();
    }
    */
    if ( listview->currentItem() == this && column == 0 &&
            !listview->hasFocus() && !listview->viewport()->hasFocus() )
        paintFocus( p, cg, QRect( 0, 0, width, height() ) );

}
void PropertyItem::paintBranches( QPainter * p, const QColorGroup & cg,
                                  int w, int y, int h ) {

    QColorGroup g( cg );
    g.setColor( QColorGroup::Base, backgroundColor() );
    Q3ListViewItem::paintBranches( p, g, w, y, h );

}
bool PropertyItem::isChanged() const {
    return changed;
}
bool PropertyItem::IsEditorShown()  const {
    return shown;
}


QColor PropertyItem::backgroundColor() {
    updateBackColor();
    if ( (Q3ListViewItem*)this == listview->currentItem() )
        return *selectedBack;
    return backColor;
}
void PropertyItem::updateBackColor() {

    if ( itemAbove() && this != listview->firstChild() ) {
        if ( ( ( PropertyItem*)itemAbove() )->backColor == *backColor1 )
            backColor = *backColor2;
        else
            backColor = *backColor1;
    } else {
        backColor = *backColor1;
    }
    if ( listview->firstChild() == this )
        backColor = *backColor1;

}
void PropertyItem::drawCustomContents( QPainter *, const QRect & ) {

}
bool PropertyItem::hasCustomContents() const {
    return FALSE;
}
bool PropertyItem::hasSubItems() const {
    return FALSE;
}
void PropertyItem::setValue( const QString  &v ) {
    setText( 1, v );
}
QVariant PropertyItem::value() const {
    return val;
}
QString PropertyItem::name() const {
    return propertyName;
}
void PropertyItem::setValue( const QVariant &v ) {
    val = v;
}
void PropertyItem::createDefaultButton() {
    if ( defaultButton ) {
        defaultButton->parentWidget()->lower();
        return;
    }
    if ( buttonCancel ) {
        buttonCancel->parentWidget()->lower();
        return;
    }

    if (propvalue != 0) {
        QLineEdit* edit = new QLineEdit(box);
        edit->setFrame( false );
        edit->setReadOnly( TRUE );
        //  edit->setStyle(  Q3Frame::NoFrame);
        QPalette pl = box->palette ();
//QBrush br("blue");

        QColor color= pl.color(QPalette::Background);
        pl.setColor(QPalette::Base,color);// (QPalette::Background, br  );

        edit->setPalette(pl);
        //  edit->setForegroundRole(QPalette::Background);
        buttonCancel = new QPushButton( "", box );
        buttonCancel->setPixmap(QPixmap(qPixmapFromMimeSource("ftan_cancel.png" )));
        buttonCancel->setFixedWidth( buttonCancel->sizeHint().width() );
    }
    defaultButton = new QPushButton( "", box );

    defaultButton->setPixmap(QPixmap(qPixmapFromMimeSource("ftan_default.png")));
    defaultButton->setFixedWidth( defaultButton->sizeHint().width() );
    QToolTip::add( defaultButton,  "Reset the property to its default value"  );
    Q3WhatsThis::add( defaultButton,  "Click this button to reset the property to its default value"  );
    connect( defaultButton, SIGNAL( clicked() ),
             this, SLOT( setDefault() ) );
    if (propvalue != 0) {
        connect( buttonCancel, SIGNAL( clicked() ),
                 this, SLOT( cancel() ) );

        QToolTip::add(buttonCancel,  "Reset the property to its previous value"  );
        Q3WhatsThis::add( buttonCancel,  "Click this button to reset the property to its previous value"  );
    }
    updateDefaultButtonState();
}

void PropertyItem::updateDefaultButtonState() {
    if (propvalue != 0) {
        if (  propvalue->GetResetvalue ()  ==   propvalue->GetValue())  changed = FALSE;
        else changed = TRUE;
        if ( propvalue->GetValue() ==  propvalue->GetDefaultvalue ()) defaultButton->setEnabled( FALSE );
        else defaultButton->setEnabled( TRUE );
    }
    PropertyItem* parent =(PropertyItem*)Q3ListViewItem::parent ();
    if (dynamic_cast<PropertyItem *>(parent) == dynamic_cast<PropertySetItem *>(parent) ) {
        parent->SetTextFromChild();
        parent->isChangedFromChild();
        parent->repaint();
    }
}
//-----------------------------------------------------------------------------------------------------------------------------------------------
LineEditInt::~LineEditInt() {

}
LineEditInt::LineEditInt(QWidget * parent, const char * name,int min,int max,bool s)
        : QLineEdit(parent, name ),minimum(min),maximum(max),signedValue(s) {
    setValidator( new QIntValidator(minimum, maximum,this, "int_validator"));

    setFrame( TRUE );
    setFixedWidth( (int)((double)sizeHint().width()*0.4));
    connect( this, SIGNAL( textChanged( const QString & ) ),
             this, SLOT( setValue(const QString &) ) );
    connect( this, SIGNAL( returnPressed() ),
             this, SLOT( setValue() ) );
}
void LineEditInt::setValue() {
    clearFocus ();
}
void LineEditInt::setValue( const QString   &v ) {
    QString temp = v;
    blockSignals( TRUE );
    int oldCursorPos;
    oldCursorPos = cursorPosition();
    int j = 0;
    QValidator * vld = (QValidator *)validator ();
    if ( vld->validate( temp , j )  != QValidator::Acceptable) {
        temp.remove( temp.length()-1, 1);
    }
    if ( signedValue )
        setText( QString::number( temp.toInt() ) );
    else
        setText( QString::number( temp.toUInt() ) );
    if ( oldCursorPos < (int)text().length() )
        setCursorPosition( oldCursorPos );
    blockSignals( FALSE );
}
//-----------------------------------------------------------------------------------------------------------------------------------------------
LineEditDouble::~LineEditDouble() {

}
LineEditDouble::LineEditDouble(QWidget * parent, const char * name,double min,double max,int dec,bool shortWidht)
        : QLineEdit(parent, name ),minimum(min),maximum(max),decimals(dec) {

    setValidator(new QDoubleValidator(minimum, maximum,decimals ,this, "double_validator"));
    setFrame( TRUE );
    if (shortWidht)
        setFixedWidth( (int)((double)sizeHint().width()*0.5));
    connect( this, SIGNAL( textChanged( const QString & ) ),
             this, SLOT( setValue(const QString &) ) );
    connect( this, SIGNAL( returnPressed() ),
             this, SLOT( setValue() ) );

}

void LineEditDouble::setValue() {
    blockSignals( TRUE );
    clearFocus ();
    blockSignals( FALSE );
}

void LineEditDouble::setValue( const QString   &v ) {


    QString temp = v;

    blockSignals( TRUE );
    int oldCursorPos;
    oldCursorPos = cursorPosition();
    int j = 0;
    QDoubleValidator * vld = (QDoubleValidator *)validator ();
    if ( vld->validate( temp , j )  != QValidator::Acceptable) {
        temp.remove( temp.length()-1, 1);

    }

    setText( temp); //  QString::number( temp.toDouble(),'f',decimals ) temp

    if ( oldCursorPos < (int)text().length() )
        setCursorPosition( oldCursorPos );
    blockSignals( FALSE );
}
//-----------------------------------------------------------------------------------------------------------------------------------------------

PropertyNoDialogTopItem::~PropertyNoDialogTopItem() {

}
PropertyNoDialogTopItem::PropertyNoDialogTopItem(Q3ListView * parent, Q3ListViewItem * after, Q3ListView* l, const QString propName ,QString textCol1 )
        : PropertyItem( parent, after, l, propName ) {
    setSelectable ( FALSE);
    setOpen( TRUE );
    changed = TRUE;
    setText(1,textCol1);
    repaint();
}
PropertyNoDialogTopItem::PropertyNoDialogTopItem(Q3ListViewItem* parent, Q3ListViewItem * after, Q3ListView* l, const QString propName,QString textCol1  )
        : PropertyItem( parent, after, l, propName ) {
    setSelectable ( FALSE);
    setOpen( TRUE );
    changed = TRUE;
    setText(1,textCol1);
    repaint();
}
//------------------------------------------------------------------------------------------------------------------------------------
PropertyBoolItem::~PropertyBoolItem() {
    //  delete (QComboBox*) comboBoxInfo;     comboBoxInfo   = 0;
}

PropertyBoolItem::PropertyBoolItem( Q3ListViewItem* parent, Q3ListViewItem * after, Q3ListView* l, const QString &propName,PropertyBoolValue* boolval  )
        : PropertyItem( parent, after, l, propName, boolval ) {
    listview = l;
    box = new Q3HBox( listview->viewport() );
    box->hide();
    comboBoxInfo = new QComboBox(FALSE, box, "comboBoxInfo");
    comboBoxInfo->clear();
    comboBoxInfo->insertItem( tr( "yes" ) );
    comboBoxInfo->insertItem( tr( "no" ) );
    QLineEdit* edit = new QLineEdit(box);
    edit->setFrame( FALSE );
    edit->setReadOnly( TRUE );
    comboBoxInfo->setLineEdit (edit);

    createDefaultButton();
    box->setFrameStyle(Q3Frame::Box | Q3Frame::Sunken); //QFrame::StyledPanel

    box->setLineWidth(1);
    box->installEventFilter( listview );
    if (propvalue-> GetValue() == "0") {
        setPixmap( 1, (QPixmap(qPixmapFromMimeSource("ftan_no.png") )));
        comboBoxInfo->setCurrentItem ( 1);
    } else {
        setPixmap( 1, (QPixmap(qPixmapFromMimeSource("ftan_yes.png") ) ));
        comboBoxInfo->setCurrentItem (0);
    }

}



void PropertyBoolItem::hideEditor() {
    if (comboBoxInfo->currentItem () ==  0) {
        setPixmap( 1, QPixmap(qPixmapFromMimeSource("ftan_yes.png") ) );
        propvalue->SetValue ("1");
    } else {
        setPixmap( 1, QPixmap(qPixmapFromMimeSource("ftan_no.png") ) );
        propvalue->SetValue ("0");
    }


    PropertyItem::hideEditor();

}
void PropertyBoolItem::cancel() {
    PropertyItem::hideEditor();
}
void PropertyBoolItem::setDefault() {
    if ( propvalue-> GetDefaultvalue () == "0") {
        comboBoxInfo->setCurrentItem ( 1);
    } else {
        comboBoxInfo->setCurrentItem (0);
    }
    hideEditor();

}
void PropertyBoolItem::setReset() {
    if ( propvalue->GetResetvalue() == "0") {
        comboBoxInfo->setCurrentItem ( 1);
    } else {
        comboBoxInfo->setCurrentItem (0);
    }
    hideEditor();

}
void PropertyBoolItem::setInitial() {
    if ( propvalue->GetInitialvalue() == "0") {
        comboBoxInfo->setCurrentItem ( 1);
    } else {
        comboBoxInfo->setCurrentItem (0);
    }
    hideEditor();

}
//------------------------------------------------------------------------------------------------------------------------------------
SpinBoxItem::~SpinBoxItem() {

}

SpinBoxItem::SpinBoxItem(QWidget * parent, const char * name,int min,int max,bool s)
        : QSpinBox(min,max,1,parent, name ),minimum(min),maximum(max),signedValue(s) {
//    setValidator( new QIntValidator(minimum, maximum,this, "int_validator"));
    connect( this, SIGNAL( valueChanged( int ) ),
             this, SLOT( setValue(int ) ) );
}





//------------------------------------------------------------------------------------------------------------------------------------

PropertyIntItem::~PropertyIntItem() {
//  delete spinBox;                         spinBox         = 0;
}

PropertyIntItem::PropertyIntItem( Q3ListViewItem* parent, Q3ListViewItem * after, Q3ListView* l, const QString &propName, PropertyIntValue* intval  )
        : PropertyItem( parent, after, l, propName, intval ) {
    signedValue = intval->GetSignedValuel();
    listview = l;
    box = new Q3HBox( listview->viewport() );
    box->hide();

    spinBox = new SpinBoxItem(box,"spinBoxInt",  intval->GetMin(),  intval->GetMax(),signedValue);
    spinBox ->installEventFilter( listview );

    createDefaultButton();
    box->setFrameStyle( Q3Frame::Box | Q3Frame::Sunken);
    box->setLineWidth( 1);
    box->installEventFilter( listview );

    if ( signedValue )
        spinBox->setValue (propvalue->GetValue().toInt());
    else
        spinBox->setValue (propvalue->GetValue().toUInt());


    setText(1,propvalue->GetValue());

}

void PropertyIntItem::hideEditor() {

    if ( signedValue )
        propvalue->SetValue(QString::number( spinBox->text().toInt() ));
    else
        propvalue->SetValue(QString::number( spinBox->text().toUInt() ));


    setText(1,propvalue->GetValue());
    PropertyItem::hideEditor();

}
void PropertyIntItem::cancel() {
    PropertyItem::hideEditor();
}
void PropertyIntItem::setDefault() {

    if ( signedValue )
        spinBox->setValue (propvalue->GetDefaultvalue().toInt());
    else
        spinBox->setValue (propvalue->GetDefaultvalue().toUInt());
//!!     setText(1,propvalue-> GetValue());
    hideEditor();
}
void PropertyIntItem::setReset() {

    if ( signedValue )
        spinBox->setValue (propvalue->GetResetvalue().toInt());
    else
        spinBox->setValue (propvalue->GetResetvalue().toUInt());
    hideEditor();
}
void PropertyIntItem::setInitial() {

    if ( signedValue )
        spinBox->setValue (propvalue->GetInitialvalue().toInt());
    else
        spinBox->setValue (propvalue->GetInitialvalue().toUInt());
    hideEditor();
}
//------------------------------------------------------------------------------------------------------------------------------------
PropertyDoubleItem::~PropertyDoubleItem() {
//  delete lineEdit;                         lineEdit         = 0;
}

PropertyDoubleItem::PropertyDoubleItem( Q3ListViewItem* parent, Q3ListViewItem * after, Q3ListView* l, const QString &propName, PropertyFloatValue* boolval  )
        : PropertyItem( parent, after, l, propName, boolval ) {
    decimal = boolval->GetDecimal();
    listview = l;
    box = new Q3HBox( listview->viewport() );
    box->hide();
    lineEdit = new LineEditDouble(box,"LineEditDouble", boolval->GetMin(), boolval->GetMax(),decimal);
    lineEdit->installEventFilter( listview );

    createDefaultButton();
    box->setFrameStyle( Q3Frame::Box | Q3Frame::Sunken);
    box->setLineWidth( 1);
    box->installEventFilter( listview );

    lineEdit->setText(propvalue->GetValue() );
    setText(1,propvalue->GetValue());
}

void PropertyDoubleItem::hideEditor() {

    QString tmp =  QString::number( lineEdit->text().toDouble(),'f',decimal );
    propvalue->SetValue (tmp);
    setText(1,propvalue->GetValue());
    PropertyItem::hideEditor();

}
void PropertyDoubleItem::cancel() {
    PropertyItem::hideEditor();
}
void PropertyDoubleItem::setDefault() {
    lineEdit->setText(propvalue->GetDefaultvalue() );
//!!     setText(1,propvalue-> GetValue());
    hideEditor();
}
void PropertyDoubleItem::setReset() {
    lineEdit->setText(propvalue->GetResetvalue() );
    hideEditor();
}
void PropertyDoubleItem::setInitial() {
    lineEdit->setText(propvalue->GetInitialvalue() );
    hideEditor();
}


// ------------------------------------------------------------------------------------------------------------------------
PropertySetItem::~PropertySetItem() {
//   delete (QLineEdit*) lined;      lined = 0;
    propList.clear();
}

PropertySetItem::PropertySetItem( Q3ListViewItem* parent, Q3ListViewItem * after, Q3ListView* l, const QString &propName,  PropValVector*  listv,Q3PtrList<PropertyItem >* mprop,bool ascen )
        : PropertyItem( parent, after, l, propName ) {
    ascending = ascen;
    listval = listv;
    listview = l;
    box = new Q3HBox( listview->viewport() );
    box->hide();

    lined = new QLineEdit( box );

    lined->installEventFilter( listview );
    lined->setFrame( TRUE );
    lined->setReadOnly( TRUE );

    createDefaultButton();

    box->setFrameStyle( Q3Frame::Box | Q3Frame::Sunken);
    box->setLineWidth( 1);
    box->installEventFilter( listview );

    PropValIterator it = listval->begin();
    QString temp = "";
    defaultValue = "";
    while (it != listval->end()) {
        Q3ListViewItem * cit  = this;
        PropertyItem * itemValue = 0;
        PropertyItem* itemNext = 0;
        if (!propList.isEmpty()) itemNext = propList.last();

        if (dynamic_cast<PropertyValue *>(*it) == dynamic_cast<PropertyFloatValue *>(*it) )
            itemValue = new PropertyDoubleItem( cit,itemNext, listview, "float",
                                                (PropertyFloatValue*)  (*it));
        if (dynamic_cast<PropertyValue *>(*it) == dynamic_cast<PropertyIntValue *>(*it) )
            itemValue = new PropertyIntItem( cit,itemNext, listview, "float",
                                             (PropertyIntValue*)  (*it));

        propList.append((PropertyItem*)itemValue);
        mprop->append((PropertyItem*)itemValue);
        temp +=  (*it)->GetValue() + "  ";
        defaultValue +=  (*it)->GetDefaultvalue() + "  ";
        it++;
    }

    setText(1,temp);
    lined->setText(temp);
    if ( text(1) ==  defaultValue)  defaultButton->setEnabled( FALSE );
    else defaultButton->setEnabled( TRUE );
}
void PropertySetItem::SetTextFromChild() {
    QString temp = "";
    PropValIterator it = listval->begin();
    while (it != listval->end()) {
        temp +=  (*it)->GetValue() + "  ";
        it++;
    }
    setText(1,temp);
    lined->setText(temp);

    if ( text(1) ==  defaultValue)  defaultButton->setEnabled( FALSE );
    else defaultButton->setEnabled( TRUE );
}
void PropertySetItem::isChangedFromChild() {
    changed = FALSE;
    for ( uint i = 0; i < propList.count(); ++i ) {
        if (propList.at(i)->GetChanged())  changed = TRUE;
    }

}
bool PropertySetItem::CheckAscending() {
    bool isAscending = true;

    PropValIterator itF = listval->begin();
    if (dynamic_cast<PropertyValue *>((*itF)) == dynamic_cast<PropertyIntValue *>((*itF)) ) {
        int first = (*itF)->GetValue().toInt();
        PropValIterator it = itF++;
        while (it != listval->end()) {
            int second = (*it)->GetValue().toInt();
            if (first > second) isAscending = false;
            first = second;
            it++;
        }
    }
    if (dynamic_cast<PropertyValue *>((*itF)) == dynamic_cast<PropertyFloatValue *>((*itF)) ) {
        float first = (*itF)->GetValue().toFloat();
        PropValIterator it = itF++;
        while (it != listval->end()) {
            float second = (*it)->GetValue().toFloat();
            if (first > second) isAscending = false;
            first = second;
            it++;
        }

    }
    return isAscending;
}
void PropertySetItem::hideEditor() {
    isChangedFromChild();
    PropertyItem::hideEditor();
}
void PropertySetItem::cancel() {
    PropertySetItem::hideEditor();
}
void PropertySetItem::setDefault() {
    QString temp = "";
    for ( uint i = 0; i < propList.count(); ++i ) {
        propList.at(i)->setDefault();
        temp +=  propList.at(i)->GetPropvalue()->GetValue() + "  ";
    }
    setText(1,temp);
    lined->setText(temp);
    hideEditor();
}
//------------------------------------------------------------------------------------------------------------------------------------
PropertyEnumItem::~PropertyEnumItem() {
    enumList.clear();
}

PropertyEnumItem::PropertyEnumItem( Q3ListViewItem* parent, Q3ListViewItem * after, Q3ListView* l, const QString &propName,PropertyEnumValue* enumval  )
        : PropertyItem( parent, after, l, propName, enumval ) {

    listview = l;
    box = new Q3HBox( listview->viewport() );
    box->hide();

    QStringList words =  enumval->GetList   ();
    QStringList valuelist = QStringList::split (' ',enumval->GetValue ());
    QStringList::iterator it;
    int i = 0;
    for ( it = words.begin(), i = 0; it != words.end(); ++it ,i++) {
//QMessageBox::warning(0,0,QString("PropertyEnumItem i %1 v %2").arg(i).arg(words[i]));
        QCheckBox* checkBox = 	new QCheckBox(words[i] + "  ",box,"checkbox");
        enumList.append( checkBox );
        if (valuelist[i] == "1") checkBox->setChecked (TRUE );
        else checkBox->setChecked (FALSE );

    }
    createDefaultButton();
    box->setFrameStyle(Q3Frame::Box | Q3Frame::Sunken);

    box->setLineWidth(1);
    box->installEventFilter( listview );

    QCheckBox *itCheck;
    QString temp = "";
    for ( itCheck = enumList.first(), i = 0; itCheck; itCheck =enumList.next(),++i ) {
        if (itCheck->isChecked ()) temp += words[i] + " ";
    }
    setText(1,temp);
}

void PropertyEnumItem::hideEditor() {
    QCheckBox *itCheck;
    int i = 0;
    for ( itCheck = enumList.first(); itCheck; itCheck =enumList.next()) {
        if ( !itCheck->isChecked ()) i++;
    }
    if (i == (int)enumList.count ()) {
        QMessageBox::warning(0,"Property Editor","One of CheckBox must be checked.'");
        return;
    }
    QStringList words = ( (PropertyEnumValue* )propvalue)->GetList   ();
    QString temp = "";
    QString temp1 = "";
    for ( itCheck = enumList.first(), i = 0; itCheck; itCheck =enumList.next(),++i ) {
        if (itCheck->isChecked ()) {
            temp += words[i] ;
            temp1 +="1";
            temp += " ";
            temp1 += " ";
        } else {
            temp1 += "0";
            temp1 += " ";
        }
    }
    temp.remove(temp.length ()-1,1);
    temp1.remove(temp1.length () -1,1);
    setText(1,temp);
    propvalue->SetValue (temp1);
    PropertyItem::hideEditor();

}
void PropertyEnumItem::cancel() {
    QStringList valuelist = QStringList::split (' ',propvalue->GetValue ());
    QCheckBox *itCheck;
    int i = 0;
    for (itCheck = enumList.first(), i = 0; itCheck; itCheck = enumList.next()  ,++i) {
        if (valuelist[i] == "1") itCheck->setChecked (TRUE );
        else itCheck->setChecked (FALSE );
    }
    PropertyItem::hideEditor();
}
void PropertyEnumItem::setDefault() {
    QStringList valuelist = QStringList::split (' ',propvalue->GetDefaultvalue());
    QCheckBox *itCheck;
    int i = 0;
    for (itCheck = enumList.first(), i = 0; itCheck; itCheck = enumList.next()  ,++i) {
        if (valuelist[i] == "1") itCheck->setChecked (TRUE );
        else itCheck->setChecked (FALSE );
    }
    hideEditor();

}
void PropertyEnumItem::setReset() {
    QStringList valuelist = QStringList::split (' ',propvalue->GetResetvalue());
    QCheckBox *itCheck;
    int i = 0;
    for (itCheck = enumList.first(), i = 0; itCheck; itCheck = enumList.next()  ,++i) {
        if (valuelist[i] == "1") itCheck->setChecked (TRUE );
        else itCheck->setChecked (FALSE );
    }
    hideEditor();

}
void PropertyEnumItem::setInitial() {
    QStringList valuelist = QStringList::split (' ',propvalue->GetInitialvalue());
    QCheckBox *itCheck;
    int i = 0;
    for (itCheck = enumList.first(), i = 0; itCheck; itCheck = enumList.next()  ,++i) {
        if (valuelist[i] == "1") itCheck->setChecked (TRUE );
        else itCheck->setChecked (FALSE );
    }
    hideEditor();

}
//------------------------------------------------------------------------------------------------------------------------------------
PropertyComboItem::~PropertyComboItem() {
//   delete (QComboBox*) comboBoxInfo;     comboBoxInfo   = 0;
}

PropertyComboItem::PropertyComboItem( Q3ListViewItem* parent, Q3ListViewItem * after, Q3ListView* l, const QString &propName,PropertyEnumValue* enumval  )
        : PropertyItem( parent, after, l, propName, enumval ) {
    listview = l;
    box = new Q3HBox( listview->viewport() );
    box->hide();
    comboBoxInfo = new QComboBox(FALSE, box, "comboBoxInfo");
    comboBoxInfo->clear();
    QStringList::iterator it;

    QStringList words =  enumval->GetList   ();
    for ( it = words.begin(); it != words.end(); ++it ) {
        comboBoxInfo->insertItem( *it );
    }

    QLineEdit* edit = new QLineEdit(box);
    edit->setFrame( FALSE );
    edit->setReadOnly( TRUE );
    comboBoxInfo->setLineEdit (edit);

    createDefaultButton();
    box->setFrameStyle(Q3Frame::Box | Q3Frame::Sunken);

    box->setLineWidth(1);
    box->installEventFilter( listview );

    comboBoxInfo->setCurrentItem ( enumval->GetValue().toInt());

    setText(1, comboBoxInfo->currentText ());

}

void PropertyComboItem::hideEditor() {

    setText(1, comboBoxInfo->currentText ());
    propvalue->SetValue (QString("%1").arg(comboBoxInfo->currentItem ()));
    PropertyItem::hideEditor();

}
void PropertyComboItem::cancel() {
    comboBoxInfo->setCurrentItem ( propvalue->GetValue().toInt());
    setText(1, comboBoxInfo->currentText ());
    PropertyItem::hideEditor();
}
void PropertyComboItem::setDefault() {
    comboBoxInfo->setCurrentItem ( propvalue->GetDefaultvalue().toInt());
    hideEditor();

}
void PropertyComboItem::setReset() {
    comboBoxInfo->setCurrentItem ( propvalue->GetResetvalue().toInt());
    hideEditor();

}
void PropertyComboItem::setInitial() {
    comboBoxInfo->setCurrentItem ( propvalue->GetInitialvalue().toInt());
    hideEditor();

}
