#ifndef _SETTING_PARAMETERS_IMPLEMENTATION_H
#define _SETTING_PARAMETERS_IMPLEMENTATION_H
#include "ui_propertylist.h"
#include <QMainWindow>
#include <QTreeView>
#include <vector>
using namespace std;
class QWidget;
class SettingImpl;
class TreePropertyModel;
class TreePropertyDelegate;
class PropertyValue;
class FDocument;
class HelpWindow;
class StaValue;
class ChanValue;
class LineDocProperty;
class PropertyValue;
class SettingProperty : public QTreeView {
    Q_OBJECT

    typedef vector<StaValue* > vSta;
    typedef vector<StaValue* >::iterator vStaIt;
    typedef vector<ChanValue* > vChan;
    typedef vector<ChanValue* >::iterator vChanIt;
public:
    SettingProperty(FDocument* doc,int numCol,QWidget* parent = 0, const char *name = 0);
    ~SettingProperty();

    void  OpenEditor(QModelIndex &index);
    TreePropertyModel* GetModel() {
        return model;
    }
    TreePropertyDelegate * GetDelegate() {
        return delegate;
    }
     void InitTreeView();
    void SavePeriodListInfoToStaChanOutList();
    void showSavedStation();
public slots:
    void clickedRowCol(QModelIndex  );
protected:
    void drawBranches(QPainter *painter, const QRect &rect, const QModelIndex &index) const;
protected slots:
private:
    FDocument* doc;
    int numCol;
    SettingImpl* parentWindow;
    TreePropertyModel* model;
    TreePropertyDelegate *delegate;
    QModelIndex edIndex;
    QModelIndex indexOpenEditor;
    vector<StaValue* >* staouts;
};
class SettingImpl : public QMainWindow, private Ui::SettingBase {
    Q_OBJECT
public:
    SettingImpl(FDocument* doc,QWidget* parent = 0);
    ~SettingImpl();
    SettingProperty* list;
    QPushButton *GetButtonHelp()    {
        return buttonHelp;
    }

    QLabel *GetLabelInfo() { return labelInfo;}
    bool modifed;
    void SetNewChannel(const QString &name);
    void InitDialogFtaComponent();
    void InitDialogEditLines();
    void ChangeDialogEditLines();

    void GetValuesZ(QString &valMin,QString &valMax);
    void GetValuesT(QString &valMin,QString &valMax);
    void GetValuesR(QString &valMin,QString &valMax);
    void GetBoundsOfPeriod(float &validatorMin,float &validatorMax);
protected:
    void closeEvent(QCloseEvent *event);
public slots:
protected slots:
    void Help();
private:
    void InitDialog();
    void RejectCloseImpl();
    FDocument* doc;
    HelpWindow* help;
    QList<LineDocProperty* > propDocLine;
    QList<PropertyValue* > propValues;
};

#endif


