#include <qlayout.h>
#include <qtooltip.h> 
#include <q3whatsthis.h> 
#include <qstring.h>
#include <qwidget.h>
#include <qpushbutton.h>
#include <q3hbox.h> 
#include <qvalidator.h> 
#include <qpushbutton.h> 
#include <q3frame.h> 
#include <qrect.h> 
#include <q3header.h>  
#include <qpixmap.h>
#include <qlabel.h>
#include <qcombobox.h>
#include <qfile.h>
#include <qmessagebox.h>
#include <q3frame.h> 
#include <qpainter.h> 
#include <qcolor.h> 
#include <q3datetimeedit.h>
#include <q3ptrlist.h> 
#include <qstringlist.h> 
#include <qtoolbutton.h> 
#include <qcheckbox.h> 
#include "stationlisteditor.h"
#include "stationlistimpl.h"
#include "document.h"
#ifdef Q_WS_MAC
#include <qwindowsstyle.h>  
static void setupStyle(QWidget *w)
{
    static QStyle *windowsStyle = 0;
    if(!windowsStyle)
	windowsStyle = new QWindowsStyle;
    w->setStyle(windowsStyle);
}
#else 
#define setupStyle(x)
#endif
RowPropertyItem::~RowPropertyItem() { 
    
    delete (Q3HBox*)box; box = 0;
    delete backColor1;
    delete backColor2;
    delete selectedBack;
     if ( defaultButton )
	delete defaultButton->parentWidget();
    defaultButton = 0;   
         if ( buttonCancel )
	delete buttonCancel->parentWidget();
    buttonCancel = 0;   
}

RowPropertyItem::RowPropertyItem(Q3ListView * parent, const QString &propName, Q3ListView* l, RowValue* propval )
    : Q3ListViewItem( parent,propName), listview( l ), propvalue(propval), propertyName( propName )
{
    backColor1   = new QColor(250, 248, 235);
    backColor2   = new QColor(  255, 255, 255 );
    selectedBack = new QColor(  230, 230, 230 );
    
    setSelectable(TRUE );
    open = FALSE;
    shown   = FALSE;
    deleted  = FALSE;
    if(propval != 0) setText( 0,propval->GetName() );
    else setText( 0, propertyName );
    changed = FALSE;
    setText( 1, propval->GetTextCol1() );
    defaultButton = 0;
    buttonCancel = 0;
}
RowPropertyItem::RowPropertyItem(Q3ListViewItem * parent, const QString &propName, Q3ListView* l,  RowValue* propval )
    : Q3ListViewItem( parent,propName), listview( l ), propvalue(propval), propertyName( propName )
{
    backColor1   = new QColor(250, 248, 235);
    backColor2   = new QColor(  255, 255, 255 );
    selectedBack = new QColor(  230, 230, 230 );
    
    setSelectable(TRUE );
    open = FALSE;
    shown   = FALSE;
    deleted  = FALSE;
    if(propval != 0) setText( 0,propval->GetName() );
    else setText( 0, propertyName );
    changed = FALSE;
    setText( 1, propval->GetTextCol1() );
    defaultButton = 0;
    buttonCancel = 0;
}


void RowPropertyItem::placeEditor( QWidget *w )
{    

    QRect r = listview->itemRect( this );
    if ( !r.size().isValid() ) {
	listview->ensureItemVisible( this );
#if defined(Q_WS_WIN)
	listview->repaintContents( FALSE );
#endif
	r = listview->itemRect( this );
 } 
    
    int newHeight = w->height ();
    r.setX( listview->header()->sectionPos( 1 ) );   
    r.setWidth( listview->header()->sectionSize( 1 ) - 1);
    r.setY(r.y() + r.height ()/2 - newHeight/2);      	
    r.setHeight(newHeight); 
    r = QRect( listview->viewportToContents( r.topLeft() ), r.size() ); 
    w->resize( r.size() );
    listview->moveChild( w, r.x(), r.y() );

}
void RowPropertyItem::showEditor()
{     
    shown    = TRUE;
    placeEditor( box );
    box->show();
    
}
void RowPropertyItem::hideEditor()
{
//    if(propvalue != 0) {
//	if (propvalue->GetValue() == propvalue->GetInitialvalue() ) propvalue->setChanged( FALSE);
//	else propvalue->setChanged( TRUE);
//    }
     updateDefaultButtonState();
     shown   = FALSE;
     box->hide();   

}

void RowPropertyItem::paintCell( QPainter *p, const QColorGroup &cg, int column, int width, int align )
{
    
    QColorGroup g( cg );
    g.setColor( QColorGroup::Base, backgroundColor() );
    g.setColor( QColorGroup::Foreground, Qt::black );
    g.setColor( QColorGroup::Text, Qt::black );
 
    if ( column == 0 ) {

	p->fillRect( 0, 0, width, height(), backgroundColor() );
	p->save();

    }
    
    if (( isChanged() || isDeleted() ) && column == 0 ) {
	p->save();
	
	QFont f = p->font();
	if (dynamic_cast<RowPropertyItem *>(this) == dynamic_cast<StationItem *>(this )  ) {
	   f.setItalic( TRUE );
	//    f.setUnderline( TRUE );
	    f.setStretch ( 75 );
	    if (text(1) == OUT_LIST_SELECTED) g.setColor( QColorGroup::Text, Qt::blue );  
	     }
	else
	    f.setBold( TRUE );
	
	p->setFont( f );
    }  

    
    if (column == 1 && (text(1) == "unnamed" || text(1) == "unknown") )
	g.setColor( QColorGroup::Text, Qt::red );    
//    if (dynamic_cast<PropertyItem *>(this) == dynamic_cast<PropertyNoDialogTopItem *>(this )   && column == 0 ) 
//	g.setColor( QColorGroup::Text, Qt::blue );        

    if ( !hasCustomContents() || column != 1 ) { 
	Q3ListViewItem::paintCell( p, g, column, width, align  );
    } else {
	p->fillRect( 0, 0, width, height(), backgroundColor() );
	
	drawCustomContents( p, QRect( 0, 0, width, height() ) );
	
    }
    if ( ( isChanged() || isDeleted() ) && column == 0 )
	p->restore();
    if ( column == 0 )
	p->restore();
  
    if ( listview->currentItem() == this && column == 0 &&
	 !listview->hasFocus() && !listview->viewport()->hasFocus() )
	paintFocus( p, cg, QRect( 0, 0, width, height() ) );   

}
void RowPropertyItem::paintBranches( QPainter * p, const QColorGroup & cg,
				  int w, int y, int h )
{
    
    QColorGroup g( cg );
    g.setColor( QColorGroup::Base, backgroundColor() );
    Q3ListViewItem::paintBranches( p, g, w, y, h );
    
}
bool RowPropertyItem::isChanged() const
{
    return changed;
}
bool RowPropertyItem::isDeleted() const
{
    return deleted;
}
bool RowPropertyItem::IsEditorShown()  const 
{
    return shown;
}


QColor RowPropertyItem::backgroundColor()
{
    updateBackColor();
    if ( (Q3ListViewItem*)this == listview->currentItem() )
	return *selectedBack;
    return backColor;
}
void RowPropertyItem::updateBackColor()
{
    
    if ( itemAbove() && this != listview->firstChild() ) {
	if ( ( ( RowPropertyItem*)itemAbove() )->backColor == *backColor1 )
	    backColor = *backColor2;
	else
	    backColor = *backColor1;
    } else {
	backColor = *backColor1;
    }
    if ( listview->firstChild() == this )
	backColor = *backColor1;
    
}
void RowPropertyItem::drawCustomContents( QPainter *, const QRect & )
{
    
}
bool RowPropertyItem::hasCustomContents() const
{
    return FALSE;
}
bool RowPropertyItem::hasSubItems() const
{
    return FALSE;
}
void RowPropertyItem::setValue( const QString  &v ){
    setText( 1, v );    
}
QVariant RowPropertyItem::value() const
{
    return val;
}
QString RowPropertyItem::name() const
{
    return propertyName;
}
void RowPropertyItem::setValue( const QVariant &v )
{
    val = v;
}

void RowPropertyItem::createDefaultButton()
{
    if ( defaultButton ) {
	defaultButton->parentWidget()->lower();
	return;
    }
    if ( buttonCancel ) {
	buttonCancel->parentWidget()->lower();
	return;
    }    
    
    if(propvalue != 0) {
    QLineEdit* edit = new QLineEdit(box);
    edit->setFrame( TRUE );
    edit->setReadOnly( TRUE );   
    edit->setFrameStyle(  Q3Frame::NoFrame);
    edit->setBackgroundMode(Qt::PaletteBackground );
    
    buttonCancel = new QPushButton( "Ca", box );
    buttonCancel->setPixmap(QPixmap(qPixmapFromMimeSource("ftan_cancel.png") ));    
    buttonCancel->setFixedWidth( buttonCancel->sizeHint().width() );
}
    defaultButton = new QPushButton( "Ok", box );

    defaultButton->setPixmap(QPixmap(qPixmapFromMimeSource("ftan_default.png") ));
    defaultButton->setFixedWidth( defaultButton->sizeHint().width() );
    QToolTip::add( defaultButton,  "Reset the property to its default value"  );
    Q3WhatsThis::add( defaultButton,  "Click this button to reset the property to its default value"  );
    connect( defaultButton, SIGNAL( clicked() ),
		      this, SLOT( setDefault() ) );
   if(propvalue != 0) {   
    connect( buttonCancel, SIGNAL( clicked() ),
		      this, SLOT( cancel() ) );    

    QToolTip::add(buttonCancel,  "Reset the property to its previous value"  );
    Q3WhatsThis::add( buttonCancel,  "Click this button to reset the property to its previous value"  );
}
   updateDefaultButtonState();
}

void RowPropertyItem::updateDefaultButtonState()
{
//    if(propvalue != 0) {
//	if (  propvalue->GetResetvalue ()  ==   propvalue->GetValue())  changed = FALSE;
//	else changed = TRUE;
//	if( propvalue->GetValue() ==  propvalue->GetDefaultvalue ()) defaultButton->setEnabled( FALSE );
//	else defaultButton->setEnabled( TRUE );
//    } 
//    PropertyItem* parent =(PropertyItem*)QListViewItem::parent ();
//    if (dynamic_cast<PropertyItem *>(parent) == dynamic_cast<PropertySetItem *>(parent) ) 
 //   { parent->SetTextFromChild();parent->isChangedFromChild();parent->repaint();} 	
}

//-----------------------------------------------------------------------------------------------------------------------------------------------

ChanItem::~ChanItem() { 
  
}

ChanItem::ChanItem(Q3ListView * parent, const QString &propName, Q3ListView* l,RowValue* propval  )
    : RowPropertyItem( parent, propName, l, propval )
{
    setSelectable ( TRUE);     
    changed = FALSE;
 
    repaint();
}
ChanItem::ChanItem(Q3ListViewItem* parent, const QString &propName, Q3ListView* l,  RowValue* propval )
    : RowPropertyItem( parent, propName, l, propval )
{
    setSelectable ( TRUE);   
    changed = FALSE;  
     
    repaint();
}
//-----------------------------------------------------------------------------------------------------------------------------------------------

StationItem::~StationItem() { 
 
}

StationItem::StationItem(Q3ListView * parent, const QString &propName, Q3ListView* l,RowValue* propval  )
    : RowPropertyItem( parent, propName, l, propval )
{
    setSelectable ( FALSE);
    setOpen( FALSE );       
    changed = TRUE;
    repaint();
}
StationItem::StationItem(Q3ListViewItem* parent, const QString &propName, Q3ListView* l,  RowValue* propval )
    : RowPropertyItem( parent, propName, l, propval )
{
    setSelectable ( FALSE);
    setOpen( FALSE );      
    changed = TRUE;  
    repaint();
}

