#ifndef _STATION_LIST_EDITOR_H
#define _STATION_LIST_EDITOR_H
#include <qvariant.h>
#include <q3listview.h>
#include <qlineedit.h> 
#include <qspinbox.h> 
#include <qpointer.h>
#include <q3ptrlist.h>
//Added by qt3to4:
#include <QLabel>
#include <vector>
using namespace std;
class QString; 
class QPushButton;
class Q3HBox;
class QComboBox;
class QLabel;
class QPainter;
class QColorGroup;
class Q3DateTimeEdit;
class QCheckBox;
class QSpinBox;
class RowValue;
class PropertyValue;
 
//------------------------------------------------------------------------------------------------------------------------------------ 

class RowPropertyItem : public QObject,public Q3ListViewItem
{
        Q_OBJECT
public:
RowPropertyItem (Q3ListView * parent, const QString &propName, Q3ListView* l,RowValue* propval );       
RowPropertyItem (Q3ListViewItem * parent, const QString &propName, Q3ListView* l,  RowValue* propval );
    ~RowPropertyItem(); 

   void placeEditor( QWidget *w );
   virtual void showEditor();


   virtual void SetTextFromChild(){}
   virtual void    isChangedFromChild(){}
   virtual void hideEditor();   
   virtual void setValue( const QString  &v );
    virtual void setValue( const QVariant &v );
   QVariant value() const;
   void paintCell( QPainter *p, const QColorGroup &cg, int column, int width, int align );
   void paintBranches( QPainter * p, const QColorGroup & cg,
			int w, int y, int h );
   bool isChanged() const;
   bool isDeleted() const;   
   bool IsEditorShown()  const;
   bool &GetChanged() {return changed;}
   bool &GetDeleted()   {return deleted;}
   void updateBackColor();
   virtual bool hasSubItems() const;
   virtual bool hasCustomContents() const;
   virtual void drawCustomContents( QPainter *p, const QRect &r );
   virtual QString getTextForCol1() {return text(1);}
   QString name() const;
   RowValue*  GetPropvalue() const {return propvalue; }
protected:
    Q3ListView *listview;      
    QVariant val;
    RowValue*  propvalue;
    QString propertyName;
    bool open, changed,shown,deleted;
    QPointer<Q3HBox> box;
    QColor *backColor1;
    QColor *backColor2;
    QColor *selectedBack;
    void createDefaultButton();
    QPushButton *defaultButton;
    QPushButton *buttonCancel;
public slots:
   virtual void cancel(){}
   virtual void setDefault(){}
   virtual void setReset(){}
   virtual void setInitial(){}
private:
   QColor backgroundColor();
    void updateDefaultButtonState();
private:

    QColor backColor;


};
class StationItem : 
			 public RowPropertyItem
{
    Q_OBJECT

public:
    StationItem( Q3ListView * parent, const QString &propName, Q3ListView* l,RowValue* propval );
    StationItem( Q3ListViewItem * parent, const QString &propName, Q3ListView* l,  RowValue* propval );
    ~StationItem(); 
protected:

private slots:

private:

};
class ChanItem : 
			 public RowPropertyItem
{
    Q_OBJECT

public:
    ChanItem( Q3ListView * parent, const QString &propName, Q3ListView* l,RowValue* propval );
    ChanItem( Q3ListViewItem * parent, const QString &propName, Q3ListView* l,  RowValue* propval );
    ~ChanItem(); 
protected:

private slots:

private:

};

#endif
