#ifndef STATIONLIST_IMPL_H
#define STATIONLIST_IMPL_H
#include <vector>
#include <map>
#include "ui_stationlist.h"
#include "ui_viewpsbase.h"
//Added by qt3to4:
#include <QLabel>
#include <Q3PopupMenu>
using namespace std;
const QString   COMBOBOX_OUT_LOVE = "Love";
const QString   COMBOBOX_OUT_RAYLEIGN = "Rayleign";
const QString   OUT_LIST_SELECTED = "selected";
const QString   OUT_LIST_REJECTED = "rejected";
const  QString  FTAN_DISP_EXPORT_PREFIX = "exportdisp";
class QStringList;
class Q3PopupMenu;
class RowValue;
class StaValue;
class ChanValue;
class FDocument;
class ChanItem;
class StationItem;
class ViewPsImpl : public QDialog, private Ui::ViewPsBase {
    Q_OBJECT

public:
    ViewPsImpl( QWidget *parent,   QString &StaChanName,QStringList  &listPs);
    virtual ~ViewPsImpl();
protected slots:
    void accept();
    void reject();
private:
    map<QString,QString> mapPs;
};
class StationListImpl : public QDialog, private Ui::StationListBase {

    Q_OBJECT
    typedef vector<StaValue* > vSta;
    typedef vector<StaValue* >::iterator vStaIt;
    typedef vector<ChanValue* > vChan;
    typedef vector<ChanValue* >::iterator vChanIt;
public:
    StationListImpl( QWidget * parent,FDocument* doc);
    virtual ~StationListImpl();
    void  SetOutlistItem(int id,QString  sta,QString  chan,QString  textcol1,QString  dfile);
    void  DecorateRowList(Q3ListView* rowlist,QString  chan,vector<StaValue* >* lst,QLabel* lbl);
    void SetComboBoxChan(QComboBox* box,vector<StaValue* >* lst);
    bool isChanInStation(vector<StaValue* >::iterator iteratorSta,QString chan);
    bool isChanInStation(vector<StaValue* >::iterator iteratorSta,QChar chan);
    void SetChanToOutList(QStringList &newRecordForOutlist,QStringList &newPsName);
    int GetIdChannal();
    vector<StaValue* >* GetStaIn() {
        return stations;
    }
    vector<StaValue* >* GetStaOut() {
        return staouts;
    }
    Q3ListViewItem * GetItemInProcess() {
        return itemInProcess;
    };
    QTabWidget * GetTabStaWidget  () {
        return tabStaWidget;
    }
protected:
    Q3PopupMenu* popUpMenuOut;
    Q3PopupMenu* popUpMenuIn;
public slots:
    void GetInBoxText(const QString &);
    void GetOutBoxText(const QString &);
protected slots:
    void HelpSlot();
    void  InlistViewClicked( Q3ListViewItem * , const QPoint & , int );
    void  InlistViewCollapsed( Q3ListViewItem* );
    void  InlistViewExpanded( Q3ListViewItem* );
    void popUpMenuOutSlot(Q3ListViewItem*,const QPoint&,int);
    void popUpMenuInSlot(Q3ListViewItem*,const QPoint&,int);
    void ViewPsMenuOut();
    void DeleteMenuOut();
    void RejectMenuIn();
private:
    FDocument* doc;
    vector<StaValue* >* stations;
    vector<StaValue* >* staouts;
    Q3ListViewItem * itemInProcess;
    ChanItem * chanItemMenuOut;
    ChanItem * chanItemMenuIn;
    StationItem * stationItemMenuIn;
};

#endif
