#include <qstring.h>
#include <qpushbutton.h>
#include <qlabel.h>
#include <qlineedit.h>
#include <qfont.h>
#include <qpixmap.h>
#include <q3table.h>
#include <qmessagebox.h>
#include <qtoolbutton.h>
#include <qlayout.h>
#include "mainwindow.h"
#include "toolbarsetimpl.h"
#include "document.h"
#include "propertyeditor.h"
ModeSet::~ModeSet() {
    delete modeInt;
    modeInt = 0;
}
ModeSet::ModeSet( QWidget *parent, FDocument* dc )
        : QDialog( parent),doc(dc) {
    setFont( parent->font() );
    setupUi(this);
    modeInt = new SpinBoxItem(this,"SpinBoxItem",
                              doc->GetFtaMode()->GetMin(),
                              doc->GetFtaMode()->GetMax(),
                              doc->GetFtaMode()->GetSignedValuel());
    modeInt->setValue (doc->GetFtaMode()->GetValue().toUInt());
    layout()->remove ( spinBox);
    delete spinBox;
    spinBox =0;
//   layout()->removeItem( spacer1);
    layout()->remove ( toolButtonDefault);
    layout()->addWidget( modeInt  );
//    layout()->addItem( spacer1  );
    layout()->addWidget(toolButtonDefault  );

}

void ModeSet::accept() {
    doc->GetFtaMode()->SetValue(  QString::number( modeInt->text().toUInt() ));
    if ( doc->GetFtaMode()->isReseted()  )
        MainWindow::self->SendChangedValueToFtan(doc->GetFtaMode()->GetId());
    doc->GetFtaMode()->SetValueToResetvalue();
    doc->GetFtaMode()->setChanged();

    done( Accepted );
}
void ModeSet::reject() {

    doc->GetFtaMode()->SetResetvalueToValue();

    done( Rejected );
}
void ModeSet::buttonDefault() {
    modeInt->setValue(doc->GetFtaMode()->GetDefaultvalue ().toUInt() );
}
//======================================================================
FilterSpec::~FilterSpec() {

//delete  lineEditTo1; lineEditTo1 = 0;
//delete  lineEditTc1; lineEditTc1 = 0;
//delete  lineEditTo2; lineEditTo2 = 0;
//delete  lineEditTc2; lineEditTc2 = 0;

}
FilterSpec::FilterSpec( QWidget *parent, FDocument* dc )
        : QDialog( parent),doc(dc) {
    setFont( parent->font() );
    setupUi(this);

    lineEditTo1 = new LineEditDouble(this,"LineEditDouble1",
                                     doc->GetShortPeriodZero()->GetMin(),
                                     doc->GetShortPeriodZero()->GetMax(),
                                     doc->GetShortPeriodZero()->GetDecimal(),FALSE);
    lineEditTc1 = new LineEditDouble(this,"LineEditDouble2",
                                     doc->GetShortPeriodCorner()->GetMin(),
                                     doc->GetShortPeriodCorner()->GetMax(),
                                     doc->GetShortPeriodCorner()->GetDecimal(),FALSE);
    lineEditTo2 = new LineEditDouble(this,"LineEditDouble3",
                                     doc->GetLongPeriodZero()->GetMin(),
                                     doc->GetLongPeriodZero()->GetMax(),
                                     doc->GetLongPeriodZero()->GetDecimal(),FALSE);
    lineEditTc2 = new LineEditDouble(this,"LineEditDouble4",
                                     doc->GetLongPeriodCorner()->GetMin(),
                                     doc->GetLongPeriodCorner()->GetMax(),
                                     doc->GetLongPeriodCorner()->GetDecimal(),FALSE);

    lineEditTo1->setFrame( FALSE );
    lineEditTc1->setFrame( FALSE );
    lineEditTo2->setFrame( FALSE );
    lineEditTc2->setFrame( FALSE );

//     lineEditTo1->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)5, (QSizePolicy::SizeType)5, 0, 0,
//					      lineEditTo1->sizePolicy().hasHeightForWidth() ) );

    lineEditTo1->setText(doc->GetShortPeriodZero()->GetValue());
    lineEditTc1->setText(doc->GetShortPeriodCorner()->GetValue());
    lineEditTo2->setText( doc->GetLongPeriodZero()->GetValue() );
    lineEditTc2->setText( doc->GetLongPeriodCorner()->GetValue());
    defaultVal= new QPushButton( this, "defaultVal" );
    defaultVal->setPixmap(QPixmap(qPixmapFromMimeSource("ftan_default.png") ));
    table->setCellWidget ( 0,4, defaultVal) ;
    table->horizontalHeader()->setLabel( 0, "Sh. per.\nzero" ) ;
    table->horizontalHeader()->setLabel( 1, "Sh. per.\ncorner" ) ;
    table->horizontalHeader()->setLabel( 2, "Lon. per.\ncorner" ) ;
    table->horizontalHeader()->setLabel( 3, "Lon. per.\nzero" ) ;
    table->horizontalHeader()->setLabel( 4, " " ) ;
    table->verticalHeader()->setLabel( 0, tr( "Value" ) );
    table->adjustColumn ( 0 );
    table->adjustColumn ( 1 );
    table->adjustColumn ( 2 );
    table->adjustColumn ( 3 );
    table->adjustColumn ( 4 );
    table->setColumnStretchable ( 0, TRUE );
    table->setColumnStretchable ( 1, TRUE );
    table->setColumnStretchable ( 2, TRUE );
    table->setColumnStretchable ( 3, TRUE );
    table->setCellWidget ( 0,0, lineEditTo1) ;
    table->setCellWidget ( 0,1, lineEditTc1) ;
    table->setCellWidget ( 0,2, lineEditTc2) ;
    table->setCellWidget ( 0,3, lineEditTo2) ;
    table->adjustRow ( 0 );
    // table->adjustSize();
    adjustSize();
//     resize( sizeHint () );
    connect( defaultVal, SIGNAL( clicked() ),
             this, SLOT( setDefaultVal() ) );
}

void FilterSpec::accept() {
    double shortPeriodZero     = lineEditTo1->text().toDouble();
    double shortPeriodCorner = lineEditTc1->text().toDouble();
    double longPeriodCorner  = lineEditTc2->text().toDouble();
    double longPeriodZero      = lineEditTo2->text().toDouble();
    if (!(shortPeriodZero < shortPeriodCorner && shortPeriodCorner < longPeriodCorner &&
            longPeriodCorner < longPeriodZero)) {
        QMessageBox::warning(0,caption(),"Items must be sorted in ascending order'");
        return;
    }

    doc->GetShortPeriodZero()->SetValue(
        QString::number(shortPeriodZero ,'f',doc->GetShortPeriodZero()->GetDecimal()));
    doc->GetShortPeriodCorner()->SetValue(
        QString::number(shortPeriodCorner,'f',doc->GetShortPeriodCorner()->GetDecimal()));
    doc->GetLongPeriodCorner()->SetValue(
        QString::number(longPeriodCorner,'f',doc->GetLongPeriodCorner()->GetDecimal()));
    doc->GetLongPeriodZero()->SetValue(
        QString::number( longPeriodZero ,'f',doc->GetLongPeriodZero()->GetDecimal()));

    if ( doc->GetShortPeriodZero()->isReseted() ||
            doc->GetShortPeriodCorner()->isReseted() ||
            doc->GetLongPeriodZero()->isReseted() ||
            doc->GetLongPeriodCorner()->isReseted() )
        MainWindow::self->SendChangedValueToFtan(doc->GetShortPeriodZero()->GetId());


    doc->GetShortPeriodZero()->SetValueToResetvalue();
    doc->GetShortPeriodCorner()->SetValueToResetvalue();
    doc->GetLongPeriodZero()->SetValueToResetvalue();
    doc->GetLongPeriodCorner()->SetValueToResetvalue();

    doc->GetShortPeriodZero()->setChanged();
    doc->GetShortPeriodCorner()->setChanged();
    doc->GetLongPeriodZero()->setChanged();
    doc->GetLongPeriodCorner()->setChanged();


    done( Accepted );

}
void FilterSpec::reject() {
    done( Rejected );
}
void FilterSpec::setDefaultVal() {
//qWarning("FilterSpec::setDefaultShort()");
    lineEditTo1->setText(doc->GetShortPeriodZero()->GetDefaultvalue());
    lineEditTc1->setText(doc->GetShortPeriodCorner()->GetDefaultvalue());
    lineEditTc2->setText( doc->GetLongPeriodCorner()->GetDefaultvalue());
    lineEditTo2->setText( doc->GetLongPeriodZero()->GetDefaultvalue() );
}


FtanWindow::~FtanWindow() {
//delete  lineVelMin; lineVelMin = 0;
//delete  lineVelMax; lineVelMax = 0;
//delete  linePerMin; linePerMin = 0;
//delete  linePerMax; linePerMax = 0;
}
FtanWindow::FtanWindow( QWidget *parent, FDocument* dc )
        : QDialog( parent),doc(dc) {
    setFont( parent->font() );
    setupUi(this);

    lineVelMin = new LineEditDouble(this,"LineEditDouble1",
                                    doc->GetGroupVelBoundMinimum()->GetMin(),
                                    doc->GetGroupVelBoundMinimum()->GetMax(),
                                    doc->GetGroupVelBoundMinimum()->GetDecimal(),FALSE);
    lineVelMax = new LineEditDouble(this,"LineEditDouble2",
                                    doc->GetGroupVelBoundMaximum()->GetMin(),
                                    doc->GetGroupVelBoundMaximum()->GetMax(),
                                    doc->GetGroupVelBoundMaximum()->GetDecimal(),FALSE);
    linePerMin = new LineEditDouble(this,"LineEditDouble3",
                                    doc->GetPeriodBoundMinimum()->GetMin(),
                                    doc->GetPeriodBoundMinimum()->GetMax(),
                                    doc->GetPeriodBoundMinimum()->GetDecimal(),FALSE);
    linePerMax = new LineEditDouble(this,"LineEditDouble4",
                                    doc->GetPeriodBoundMaximum()->GetMin(),
                                    doc->GetPeriodBoundMaximum()->GetMax(),
                                    doc->GetPeriodBoundMaximum()->GetDecimal(),FALSE);

    lineVelMin->setFrame( FALSE );
    lineVelMax->setFrame( FALSE );
    linePerMin->setFrame( FALSE );
    linePerMax->setFrame( FALSE );

//     lineVelMin->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)5, (QSizePolicy::SizeType)5, 0, 0,
//					      lineVelMin->sizePolicy().hasHeightForWidth() ) );

    lineVelMin->setText(doc->GetGroupVelBoundMinimum()->GetValue());
    lineVelMax->setText(doc->GetGroupVelBoundMaximum()->GetValue());
    linePerMin->setText( doc->GetPeriodBoundMinimum()->GetValue() );
    linePerMax->setText( doc->GetPeriodBoundMaximum()->GetValue());
    defaultVel = new QPushButton( this, "defaultVel" );
    defaultPer =  new QPushButton( this, "defaultPer" );
    defaultVel->setPixmap(QPixmap(qPixmapFromMimeSource("ftan_default.png") ));
    defaultPer->setPixmap(QPixmap(qPixmapFromMimeSource("ftan_default.png") ));
    table->setCellWidget ( 0,2, defaultVel) ;
    table->setCellWidget ( 1,2, defaultPer) ;


    table->setCellWidget ( 0,0, lineVelMin) ;
    table->setCellWidget ( 0,1, lineVelMax) ;
    table->setCellWidget ( 1,0, linePerMin) ;
    table->setCellWidget ( 1,1, linePerMax) ;

    table->horizontalHeader()->setLabel( 2, " " ) ;
    table->verticalHeader()->setLabel( 0, tr( "Group Vel (km/sec)  " ) );
    table->verticalHeader()->setLabel( 1, tr( "Period (sec)  " ) );
    table->adjustColumn ( 2 );
    table->setColumnStretchable ( 0, TRUE );
    table->setColumnStretchable ( 1, TRUE );
    table->adjustRow ( 0 );
    table->adjustRow ( 1 );
//     table->adjustSize();
    adjustSize();
//     resize( sizeHint () );
    connect( defaultVel, SIGNAL( clicked() ),
             this, SLOT( setDefaultVel() ) );
    connect( defaultPer, SIGNAL( clicked() ),
             this, SLOT( setDefaultPer() ) );
}

void FtanWindow::accept() {

    double groupVelBoundMinimum     = lineVelMin->text().toDouble();
    double groupVelBoundMaximum    = lineVelMax->text().toDouble();
    double periodBoundMinimum          = linePerMin->text().toDouble();
    double periodBoundMaximum         = linePerMax->text().toDouble();

    if (!(groupVelBoundMinimum < groupVelBoundMaximum )) {
        QMessageBox::warning(0,caption(),"Group velocities:  min > max'");
        return;
    }
    if (!(periodBoundMinimum < periodBoundMaximum)) {
        QMessageBox::warning(0,caption(),"Periods:  min > max");
        return;
    }
    doc->GetGroupVelBoundMinimum()->SetValue(
        QString::number(groupVelBoundMinimum,'f',doc->GetGroupVelBoundMinimum()->GetDecimal()));
    doc->GetGroupVelBoundMaximum()->SetValue(
        QString::number( groupVelBoundMaximum,'f',doc->GetGroupVelBoundMaximum()->GetDecimal()));

    doc->GetPeriodBoundMinimum()->SetValue(
        QString::number(periodBoundMinimum ,'f',doc->GetPeriodBoundMinimum()->GetDecimal()));
    doc->GetPeriodBoundMaximum()->SetValue(
        QString::number(periodBoundMaximum,'f',doc->GetPeriodBoundMaximum()->GetDecimal()));

    if  ( doc->GetGroupVelBoundMinimum()->isReseted() ||
            doc->GetGroupVelBoundMaximum()->isReseted()  )
        MainWindow::self->SendChangedValueToFtan(doc->GetGroupVelBoundMinimum()->GetId());

    if ( doc->GetPeriodBoundMinimum()->isReseted() ||
            doc->GetPeriodBoundMaximum()->isReseted()  )
        MainWindow::self->SendChangedValueToFtan(doc->GetPeriodBoundMinimum()->GetId());

    doc->GetGroupVelBoundMinimum()->SetValueToResetvalue();
    doc->GetGroupVelBoundMaximum()->SetValueToResetvalue();
    doc->GetPeriodBoundMinimum()->SetValueToResetvalue();
    doc->GetPeriodBoundMaximum()->SetValueToResetvalue();

    doc->GetGroupVelBoundMinimum()->setChanged();
    doc->GetGroupVelBoundMaximum()->setChanged();
    doc->GetPeriodBoundMinimum()->setChanged();
    doc->GetPeriodBoundMaximum()->setChanged();
    done( Accepted );
}
void FtanWindow::reject() {
//qWarning("FtanWindow::reject()");
    done( Rejected );
}
void FtanWindow::setDefaultVel() {
//qWarning("FtanWindow::setDefaultVel()");
    lineVelMin->setText(doc->GetGroupVelBoundMinimum()->GetDefaultvalue());
    lineVelMax->setText(doc->GetGroupVelBoundMaximum()->GetDefaultvalue());
}
void FtanWindow::setDefaultPer() {
//qWarning("FtanWindow::setDefaultPer()");
    linePerMin->setText( doc->GetPeriodBoundMinimum()->GetDefaultvalue() );
    linePerMax->setText( doc->GetPeriodBoundMaximum()->GetDefaultvalue());
}
PlotComp::~PlotComp() {

}
PlotComp::PlotComp( QWidget *parent, FDocument* dc )
        : QDialog( parent, 0 ),doc(dc) {
    setFont( parent->font() );
    setupUi(this);
    QStringList valuelist = QStringList::split (' ',doc->GetPlotCompt()->GetValue ());

    if ( valuelist[0] == "1")  toolButtonPlotZ->setOn (TRUE );
    else toolButtonPlotZ->setOn (FALSE);
    if ( valuelist[1] == "1")  toolButtonPlotN->setOn (TRUE );
    else toolButtonPlotN->setOn (FALSE);
    if ( valuelist[2] == "1")  toolButtonPlotE->setOn (TRUE );
    else toolButtonPlotE->setOn (FALSE);
    if ( valuelist[3] == "1")  toolButtonPlotR->setOn (TRUE );
    else toolButtonPlotR->setOn (FALSE);
    if ( valuelist[4] == "1")  toolButtonPlotT->setOn (TRUE );
    else toolButtonPlotT->setOn (FALSE);

}

void PlotComp::accept() {
    if  ( !toolButtonPlotZ->isOn() &&
            !toolButtonPlotN->isOn() &&
            !toolButtonPlotE->isOn() &&
            !toolButtonPlotR->isOn() &&
            !toolButtonPlotT->isOn()
        )   {
        QMessageBox::warning(0,caption(),"One of button must be toggled.'");
        return;
    }
    QString temp = "";
    if (toolButtonPlotZ->isOn()) temp +="1 ";
    else  temp +="0 ";
    if (toolButtonPlotN->isOn()) temp +="1 ";
    else  temp +="0 ";
    if (toolButtonPlotE->isOn ()) temp +="1 ";
    else  temp +="0 ";
    if (toolButtonPlotR->isOn ()) temp +="1 ";
    else  temp +="0 ";
    if (toolButtonPlotT->isOn ()) temp +="1";
    else  temp +="0";

    doc->GetPlotCompt()->SetValue(temp);

    if ( doc->GetPlotCompt()->isReseted()  )
        MainWindow::self->SendChangedValueToFtan(doc->GetPlotCompt()->GetId());

    doc->GetPlotCompt()->SetValueToResetvalue();
    doc->GetPlotCompt()->setChanged();


    done( Accepted );
}
void PlotComp::reject() {

    doc->GetPlotCompt()->SetResetvalueToValue();

    done( Rejected );
}
void PlotComp::buttonDefault() {

    QStringList valuelist = QStringList::split (' ',doc->GetPlotCompt()->GetDefaultvalue());

    if ( valuelist[0] == "1")  toolButtonPlotZ->setOn (TRUE );
    else toolButtonPlotZ->setOn (FALSE);
    if ( valuelist[1] == "1")  toolButtonPlotN->setOn (TRUE );
    else toolButtonPlotN->setOn (FALSE);
    if ( valuelist[2] == "1")  toolButtonPlotE->setOn (TRUE );
    else toolButtonPlotE->setOn (FALSE);
    if ( valuelist[3] == "1")  toolButtonPlotR->setOn (TRUE );
    else toolButtonPlotR->setOn (FALSE);
    if ( valuelist[4] == "1")  toolButtonPlotT->setOn (TRUE );
    else toolButtonPlotT->setOn (FALSE);

}
FtanComp::~FtanComp() {

}
FtanComp::FtanComp( QWidget *parent, FDocument* dc )
        : QDialog( parent),doc(dc) {
    setFont( parent->font() );
    setupUi(this);
    QStringList valuelist = QStringList::split (' ',doc->GetFtaCompt()->GetValue ());

    if ( valuelist[0] == "1")  toolButtonFtaZ->setOn (TRUE );
    else toolButtonFtaZ->setOn (FALSE);
    if ( valuelist[1] == "1")  toolButtonFtaR->setOn (TRUE );
    else toolButtonFtaR->setOn (FALSE);
    if ( valuelist[2] == "1")  toolButtonFtaT->setOn (TRUE );
    else toolButtonFtaT->setOn (FALSE);

}

void FtanComp::accept() {
    if  ( !toolButtonFtaZ->isOn() &&
            !toolButtonFtaR->isOn() &&
            !toolButtonFtaT->isOn()
        )   {
        QMessageBox::warning(0,caption(),"One of button must be toggled.'");
        return;
    }

    QString temp = "";
    if (toolButtonFtaZ->isOn()) temp +="1 ";
    else  temp +="0 ";
    if (toolButtonFtaR->isOn ()) temp +="1 ";
    else  temp +="0 ";
    if (toolButtonFtaT->isOn ()) temp +="1";
    else  temp +="0";

    doc->GetFtaCompt()->SetValue(temp);
    if ( doc->GetFtaCompt()->isReseted()  )
        MainWindow::self->SendChangedValueToFtan(doc->GetFtaCompt()->GetId());
    doc->GetFtaCompt()->SetValueToResetvalue();
    doc->GetFtaCompt()->setChanged();


    done( Accepted );
}
void FtanComp::reject() {

    doc->GetFtaCompt()->SetResetvalueToValue();

    done( Rejected );
}
void FtanComp::buttonDefault() {

    QStringList valuelist = QStringList::split (' ',doc->GetFtaCompt()->GetDefaultvalue());

    if ( valuelist[0] == "1")  toolButtonFtaZ->setOn (TRUE );
    else toolButtonFtaZ->setOn (FALSE);
    if ( valuelist[1] == "1")  toolButtonFtaR->setOn (TRUE );
    else toolButtonFtaR->setOn (FALSE);
    if ( valuelist[2] == "1")  toolButtonFtaT->setOn (TRUE );
    else toolButtonFtaT->setOn (FALSE);


}
SVCompt::~SVCompt() {

}
SVCompt::SVCompt( QWidget *parent, FDocument* dc,int ind )
        : QDialog( parent),doc(dc),indSaveClean(ind) {
    setFont( parent->font() );
    setupUi(this);
    QStringList valuelist = QStringList::split (' ',doc->GetFtaCompt()->GetValue ());
//    QPushButton* pushButtonAll;

    if ( valuelist[0] == "0")  pushButtonZ->hide();
    if ( valuelist[1] == "0")  pushButtonR->hide();
    if ( valuelist[2] == "0")  pushButtonT->hide();
    QString temp = "Z";
    if ( valuelist[1] == "1")  temp += "R";
    if ( valuelist[2] == "1")  temp += "T";
    pushButtonAll->setText(temp);
    pushButtonAll->setOn (TRUE);
    pushButtonAll->setFocus();

    if   (indSaveClean == 0) setCaption( "Save Dialog"  );
    else  setCaption( "Clean Dialog"  );
}

void SVCompt::accept() {
    if   (indSaveClean == 0)  svcomp = "save";
    else  svcomp = "cl";
    if  (pushButtonAll->isShown() && pushButtonAll->isOn()) {
        svcomp += "\n";
        svcompout ="Z";
        if  (pushButtonR->isShown() )   svcompout += " R";
        if  (pushButtonT->isShown() )   svcompout += " T";
    }
    /*
    {
       svcomp = "save Z\n";
       if  (pushButtonR->isShown() )   svcomp += "save R\n";
       if  (pushButtonT->isShown() )   svcomp += "save T\n";
    }
    */
    if  (pushButtonZ->isShown() && pushButtonZ->isOn()) {
        svcomp += " Z\n";
        svcompout  ="Z";
    }
    if  (pushButtonR->isShown() && pushButtonR->isOn()) {
        svcomp += " R\n";
        svcompout = "R";
    }
    if  (pushButtonT->isShown() && pushButtonT->isOn())  {
        svcomp += " T\n";
        svcompout = "T";
    }
    done( Accepted );
}
void SVCompt::reject() {


    done( Rejected );
}
void SVCompt::buttonAll() {
    if  (pushButtonZ->isShown() && pushButtonZ->isOn())   pushButtonZ->setOn ( FALSE );
    if  (pushButtonR->isShown() && pushButtonR->isOn())   pushButtonR->setOn ( FALSE );
    if  (pushButtonT->isShown() && pushButtonT->isOn())   pushButtonT->setOn ( FALSE );
}
void SVCompt:: buttonZ() {
    if  (pushButtonAll->isShown() && pushButtonAll->isOn())   pushButtonAll->setOn ( FALSE );
    if  (pushButtonR->isShown() && pushButtonR->isOn())   pushButtonR->setOn ( FALSE );
    if  (pushButtonT->isShown() && pushButtonT->isOn())   pushButtonT->setOn ( FALSE );
}
void SVCompt::buttonR() {
    if  (pushButtonZ->isShown() && pushButtonZ->isOn())   pushButtonZ->setOn ( FALSE );
    if  (pushButtonAll->isShown() && pushButtonAll->isOn())   pushButtonAll->setOn ( FALSE );
    if  (pushButtonT->isShown() && pushButtonT->isOn())   pushButtonT->setOn ( FALSE );
}
void SVCompt::buttonT() {
    if  (pushButtonZ->isShown() && pushButtonZ->isOn())   pushButtonZ->setOn ( FALSE );
    if  (pushButtonR->isShown() && pushButtonR->isOn())   pushButtonR->setOn ( FALSE );
    if  (pushButtonAll->isShown() && pushButtonAll->isOn())   pushButtonAll->setOn ( FALSE );
}
