#ifndef TOOL_BAR_SETTINGS_IMPLEMENTATION_H
#define TOOL_BAR_SETTINGS_IMPLEMENTATION_H
#include "ui_filterspecbase.h"
#include "ui_ftanwindowsetbase.h"
#include "ui_plotcompset.h"
#include "ui_ftancompsetbase.h"
#include "ui_savecleanbase.h"
#include "ui_modesetbase.h"
class FDocument;
class LineEditDouble;
class SpinBoxItem;
class QPushButton;
class ModeSet : public QDialog, private Ui::ModeSetBase
{
    Q_OBJECT

public:
    ModeSet( QWidget *parent,   FDocument* dc);
    ~ModeSet();

    
protected slots:
    void accept(); 
    void reject();
    void buttonDefault();
private:
    SpinBoxItem* modeInt;
    FDocument* doc;
};
class FilterSpec : public QDialog, private Ui::FilterSpecBase
{
    Q_OBJECT

public:
    FilterSpec( QWidget *parent,   FDocument* dc);
    ~FilterSpec();

    
protected slots:
    void accept(); 
    void reject();
    void setDefaultVal();
private:
    FDocument* doc;
    LineEditDouble* lineEditTo1;
    LineEditDouble* lineEditTc1;
    LineEditDouble* lineEditTo2;
    LineEditDouble* lineEditTc2;
    QPushButton* defaultVal;    

};
class FtanWindow : public QDialog, private Ui::FtanWindowSetBase
{
    Q_OBJECT

public:
    FtanWindow( QWidget *parent,   FDocument* dc);
    ~FtanWindow();

    
protected slots:
    void accept(); 
    void reject();
    void setDefaultVel();
    void setDefaultPer();	
private:
    FDocument* doc;
    LineEditDouble* lineVelMin;
    LineEditDouble* lineVelMax;
    LineEditDouble* linePerMin;
    LineEditDouble* linePerMax;
    QPushButton* defaultVel;    
    QPushButton* defaultPer;
};
class PlotComp : public QDialog, private Ui::PlotCompSetBase
{
    Q_OBJECT

public:
    PlotComp( QWidget *parent,   FDocument* dc);
    ~PlotComp();

    
protected slots:
    void accept(); 
    void reject();
    void buttonDefault();
private:
    FDocument* doc;
};
class FtanComp : public QDialog, private Ui::FtanCompSetBase
{
    Q_OBJECT

public:
    FtanComp( QWidget *parent,   FDocument* dc);
    ~FtanComp();

    
protected slots:
    void accept(); 
    void reject();
    void buttonDefault();
private:
    FDocument* doc;
};
class SVCompt : public QDialog, private Ui::SaveCleanBase
{
    Q_OBJECT

public:
    SVCompt( QWidget *parent,   FDocument* dc,int ind = 0);
    ~SVCompt();
    QString GetStringToAct(){return svcomp;}
    QString GetStringToOutList(){return svcompout;}
protected slots:
    void accept(); 
    void reject();
    void buttonAll();
    void buttonZ();
    void buttonR();
    void buttonT();    
private:
    FDocument* doc;
    int indSaveClean;
    QString svcomp;
    QString svcompout;
};
#endif
