c		variable names are chosen to be identical to the CSS 3.0
c		attribute names with the relation name appended preceded
c		by an underscore (e.g., lat_centryd, lat_origin, sta_wfdisc, etc).
c
c		declarations and common blocks are included for the 
c		following relations:
c
c		  affiliation, arrival, assoc, centryd (hybrid 2.8), event, 
c		  gregion, instrument, network, moment (hybrid 2.8), origin,
c		  remark, sensor, site, sitechan, sregion, wfdisc
c
c		additional relations include: select, wfedit, spdisc, tape,
c			tapefile, tapedata, ftdisc, disp
c
c		in addition there are declarations for: db io and filter files.
c
c		the dimensions of all variables except those for the event 
c		relations are declared so that entire tables are stored.
c		the event relations are: 
c			centryd, event, origin, gregion, moment, sregion
c
c		order of variables in common blocks differ slightly from
c		in the definition of the relation in order to minimize 
c		misalignment complaints during compilation.


c	implicit integer(i-n), real(a-h,o-z)

c		data base io declarations (3.0)
	character*80 dbin, dbout, dbcmt, dbegn, dbwfdisc
	integer idbin, idbout, idbcmt, idbegn, idbwfdisc
	common/c_dbio/idbin,idbout,dbin,dbout,dbcmt,idbcmt,
     +   dbegn,idbegn,
     +    dbwfdisc,idbwfdisc


c		affiliation declarations (3.0)
	parameter (maffiliation = 200)
	character*6 sta_affiliation
	character*8 net_affiliation
	character*17 lddate_affiliation
	common/c_affiliation/net_affiliation(maffiliation), 
     +      sta_affiliation(maffiliation),
     +      lddate_affiliation(maffiliation), nrowaffiliation


c		arrival declarations (3.0)
	parameter (marrival = 10000)
	character stype_arrival, clip_arrival, qual_arrival
	character*2 fm_arrival
	character*6 sta_arrival
	character*8 chan_arrival, iphase_arrival
	character*15 auth_arrival
	character*17 lddate_arrival
	integer arid_arrival, jdate_arrival, stassid_arrival,
     +    chanid_arrival, 
     +     commid_arrival
	real deltim_arrival, azimuth_arrival, delaz_arrival, 
     +   slow_arrival,
     +     delslo_arrival, ema_arrival, rect_arrival, 
     +  amp_arrival,
     +    per_arrival, 
     +     logat_arrival, snr_arrival
	real*8 time_arrival
	common/c_arrival/sta_arrival(marrival), 
     +   time_arrival(marrival),
     +	  arid_arrival(marrival), jdate_arrival(marrival),
     +    stassid_arrival(marrival),
     +    chanid_arrival(marrival), chan_arrival(marrival),
     +    iphase_arrival(marrival), 
     +    stype_arrival(marrival), deltim_arrival(marrival), 
     +   azimuth_arrival(marrival), 
     +    delaz_arrival(marrival), slow_arrival(marrival),
     +    delslo_arrival(marrival), 
     +    ema_arrival(marrival), rect_arrival(marrival), 
     +   amp_arrival(marrival), 
     +    per_arrival(marrival), logat_arrival(marrival),
     +    clip_arrival(marrival), 
     +    fm_arrival(marrival), snr_arrival(marrival), 
     +   qual_arrival(marrival), 
     +    auth_arrival(marrival), commid_arrival(marrival), 
     +   lddate_arrival(marrival), 
     +    nrowarrival
	


c		assoc declarations (3.0)
	parameter (massoc = 10000)
	character timedef_assoc, azdef_assoc, slodef_assoc
	character*6 sta_assoc
	character*8 phase_assoc
	character*15 vmodel_assoc
	character*17 lddate_assoc
	integer arid_assoc, orid_assoc, commid_assoc
	real belief_assoc, delta_assoc, seaz_assoc, esaz_assoc, 
     +   timeres_assoc,
     +     azres_assoc, slores_assoc, emares_assoc, wgt_assoc
	common/c_assoc/arid_assoc(massoc), orid_assoc(massoc),
     +    sta_assoc(massoc),
     +     phase_assoc(massoc), belief_assoc(massoc), 
     +   delta_assoc(massoc), 
     +     seaz_assoc(massoc), esaz_assoc(massoc), 
     +   timeres_assoc(massoc), 
     +     timedef_assoc(massoc), azres_assoc(massoc),
     +    azdef_assoc(massoc), 
     +     slores_assoc(massoc), slodef_assoc(massoc),
     +    emares_assoc(massoc), 
     +     wgt_assoc(massoc), vmodel_assoc(massoc), 
     +   commid_assoc(massoc), 
     +     lddate_assoc(massoc), nrowassoc
	


c		centryd declarations (2.8 with modifications)
c			modifications are:
c			remark has been replaced with commid_centryd
c			lddate_centryd added at end
c			nrlpb interpreted as no. records of LP body waves
c			nrmw interpreted as no. records of mantle waves
	character*10 dused_centryd
	character*15 auth_centryd
	character*17 lddate_centryd
	integer orid_centryd, jdate_centryd, nslpb_centryd,
     +    nrlpb_centryd,
     +    tmnlpb_centryd, nsmw_centryd, nrmw_centryd, 
     +   tmnmw_centryd, commid_centryd
	real lat_centryd, lon_centryd, depth_centryd,
     +    coterr_centryd, claerr_centryd, 
     +    cloerr_centryd, cdperr_centryd, durat_centryd
	real*8 time_centryd
	common/c_centryd/orid_centryd, jdate_centryd,
     +    time_centryd,
     +    lat_centryd, lon_centryd, depth_centryd,
     +    coterr_centryd, claerr_centryd, 
     +    cloerr_centryd, cdperr_centryd, durat_centryd,
     +    nslpb_centryd, nrlpb_centryd,
     +    tmnlpb_centryd, nsmw_centryd, nrmw_centryd,
     +    tmnmw_centryd, commid_centryd, 
     +    dused_centryd, auth_centryd, lddate_centryd

c		egn and get_egn declarations 
	parameter (megn = 10000, mnumegn = 6, mknots2 = 250)
	character typemode_egn
	character*17 lddate_egn
	character*32 efile_egn
	character*64 dir_egn
	integer egnid_egn, nmode_egn, lmode_egn, fileno_egn, 
     +    commid_egn, numegns_egn, numknots_egn, foff_egn
	real fmode_egn, qmode_egn, cgmode_egn, amode_egn, 
     +    bmode_egn, cmode_egn, egnfcn_egn
	common/c_egn/egnid_egn(megn), nmode_egn(megn), 
     +    typemode_egn(megn), lmode_egn(megn), fmode_egn(megn), 
     +    qmode_egn(megn), cgmode_egn(megn), amode_egn(megn), 
     +    bmode_egn(megn), cmode_egn(megn), numegns_egn(megn), 
     +    numknots_egn(megn), foff_egn(megn), fileno_egn(megn), 
     +   dir_egn(megn), 
     +    efile_egn(megn), commid_egn(megn), lddate_egn(megn),
     +    nrowegn
        common/c_getegn/egnfcn_egn(mnumegn, mknots2)
c		egndbl declarations
	parameter (megndbl = 1500)
	character typemode_egndbl
	character*17 lddate_egndbl
	character*32 efile_egndbl
	character*64 dir_egndbl
	integer egnid_egndbl, nmode_egndbl, lmode_egndbl, 
     +   fileno_egndbl, 
     +    commid_egndbl, numegns_egndbl, numknots_egndbl,
     +    foff_egndbl
	real amode_egndbl, bmode_egndbl, cmode_egndbl
	real*8 fmode_egndbl, qmode_egndbl, cgmode_egndbl
	common/c_egndbl/egnid_egndbl(megndbl), 
     +   nmode_egndbl(megndbl), 
     +    typemode_egndbl(megndbl), lmode_egndbl(megndbl), 
     +   fmode_egndbl(megndbl), 
     +    qmode_egndbl(megndbl), cgmode_egndbl(megndbl),
     +    amode_egndbl(megndbl), 
     +    bmode_egndbl(megndbl), cmode_egndbl(megndbl),
     +    numegns_egndbl(megndbl),    
     +    numknots_egndbl(megndbl), foff_egndbl(megndbl),
     +    fileno_egndbl(megndbl), dir_egndbl(megndbl), 
     +    efile_egndbl(megndbl), commid_egndbl(megndbl),
     +    lddate_egndbl(megndbl), nrowegndbl



c		event declarations (3.0)
	character*15 evname_event, auth_event
	character*17 lddate_event
	integer evid_event, prefor_event, commid_event
	common/c_event/evid_event, prefor_event, commid_event,
     +     auth_event, lddate_event, evname_event



c		filter declarations (3.0)
	parameter (mpz = 100, mfir = 500, mstages = 20)
	character*4 type_filter
	character*80 dfile_filter
	integer np_filter, nz_filter, nstages_filter
	real a0_filter, coefn_filter, coefd_filter,
     +   coefnerr_filter, 
     +    coefderr_filter
	complex zero_filter, pole_filter, zererr_filter,
     +    polerr_filter
	common/c_filter/a0_filter(mstages), nz_filter(mstages), 
     +   np_filter(mstages), 
     +    zero_filter(mstages, mpz), zererr_filter(mstages, mpz), 
     +    pole_filter(mstages, mpz), polerr_filter(mstages, mpz), 
     +    nnum_filter(mstages), nden_filter(mstages), 
     +   srate_filter(mstages),
     +    coefn_filter(mstages,mfir),coefnerr_filter(mstages,mfir),
     +    coefd_filter(mstages,mfir),coefderr_filter(mstages,mfir),
     +    type_filter(mstages),nstages_filter, dfile_filter, 
     +   iresp_filter


c		geographical region (gregion) declarations (3.0)
	character*17 lddate_gregion
	character*40 grname_gregion
	integer grn_gregion
	common/c_gregion/grn_gregion, grname_gregion, 
     +  lddate_gregion



c		instrument declarations (3.0)
	parameter (minstrument = 5500)
	character band_instrument, digital_instrument
	character*6 instype_instrument, rsptype_instrument
	character*17 lddate_instrument
	character*32 dfile_instrument
	character*50 insname_instrument
	character*64 dir_instrument
	integer inid_instrument
	real samprate_instrument, ncalib_instrument, 
     +   ncalper_instrument
	common/c_instrument/inid_instrument(minstrument), 
     +     insname_instrument(minstrument), 
     +   instype_instrument(minstrument), 
     +     band_instrument(minstrument), 
     +   digital_instrument(minstrument), 
     +     samprate_instrument(minstrument), 
     +   ncalib_instrument(minstrument), 
     +     ncalper_instrument(minstrument),
     +    dir_instrument(minstrument), 
     +     dfile_instrument(minstrument),
     +    rsptype_instrument(minstrument),
     +     lddate_instrument(minstrument),
     +    nrowinstrument



c		network declarations (3.0)
	parameter (mnetwork = 20)
	character*4 nettype_network
	character*8 net_network
	character*15 auth_network
	character*17 lddate_network
	character*80 netname_network
	integer commid_network
	common/c_network/net_network(mnetwork), 
     +   netname_network(mnetwork), 
     +     nettype_network(mnetwork), commid_network(mnetwork),
     +    auth_network(mnetwork),
     +     lddate_network(mnetwork), nrownetwork



c		moment declarations (2.8 with modifications)
c			modifications are:
c			remark has been replaced with commid_moment
c			lddate_moment added at end
c			nslpb, nrlpb, tmnlpb, nsmw, nrmw, tmnmw have
c			   been left out since they're in centryd
c			slips have been replaced with rakes
	character*10 dused_moment
	character*15 auth_moment
	character*17 lddate_moment
	integer orid_moment, mexpon_moment, commid_moment
	real bestdc_moment, mrr_moment, mtt_moment, 
     +   mff_moment, mrt_moment,
     +    mrf_moment, mtf_moment, mrrerr_moment,
     +    mtterr_moment, mfferr_moment,
     +    mrterr_moment, mrferr_moment, mtferr_moment,
     +    paxval_moment, paxplg_moment, 
     +    paxazm_moment, naxval_moment, naxplg_moment,
     +    naxazm_moment, taxval_moment, 
     +    taxplg_moment, taxazm_moment, str1_moment,
     +    dip1_moment, rake1_moment, 
     +    str2_moment, dip2_moment, rake2_moment
	common/c_moment/orid_moment, mexpon_moment,
     +    bestdc_moment, 
     +    mrr_moment, mtt_moment, mff_moment, mrt_moment,
     +    mrf_moment, mtf_moment,
     +    mrrerr_moment, mtterr_moment, mfferr_moment,
     +    mrterr_moment, mrferr_moment,
     +    mtferr_moment, paxval_moment, paxplg_moment,
     +    paxazm_moment, naxval_moment, 
     +    naxplg_moment, naxazm_moment, taxval_moment,
     +    taxplg_moment, taxazm_moment, 
     +    str1_moment, dip1_moment, rake1_moment,
     +    str2_moment, dip2_moment, rake2_moment, 
     +    commid_moment, dused_moment, auth_moment,
     +    lddate_moment


c		origin declarations (3.0)
	character dtype_origin
	character*7 etype_origin
	character*15 algorithm_origin, auth_origin 
	character*17 lddate_origin
	integer orid_origin, evid_origin, jdate_origin, 
     +   nass_origin,
     +    ndef_origin, ndp_origin, grn_origin, srn_origin,
     +    mbid_origin, 
     +    msid_origin, mlid_origin, commid_origin
	real lat_origin, lon_origin, depth_origin, depdp_origin,
     +    mb_origin,
     +    ms_origin, ml_origin
	real*8 time_origin
	common/c_origin/time_origin, lat_origin, lon_origin,
     +    depth_origin,
     +    orid_origin, evid_origin, jdate_origin, 
     +   nass_origin, ndef_origin, 
     +    ndp_origin, grn_origin, srn_origin,
     +    depdp_origin, mb_origin,
     +    mbid_origin, ms_origin, msid_origin,
     +    ml_origin, mlid_origin, 
     +    commid_origin, algorithm_origin,
     +    auth_origin, lddate_origin, 
     +    dtype_origin, etype_origin 



c		remark declarations (3.0)
	parameter (mremark = 10000)
	character*17 lddate_remark
	character*80 remark_remark
	integer commid_remark, lineno_remark
	common/c_remark/commid_remark(mremark), 
     +   lineno_remark(mremark), 
     +      remark_remark(mremark), lddate_remark(mremark),
     +    nrowremark

c		select declarations (mhr)
	parameter (mselect=5000)	
	integer selid_select, nmode_select, lmode_select, 
     +   commid_select
	character st_select
	character*6 sta_select
	character*8 chan_select
	character*15 author_select
	character*16 comment_select
	character*17 lddate_select
	character*32 dbwfdisc_select
	character*64 dir_select
	common/c_select/selid_select(mselect),
     +    sta_select(mselect), 
     +    chan_select(mselect), nmode_select(mselect),
     +    st_select(mselect),
     +    lmode_select(mselect), comment_select(mselect), 
     +    dir_select(mselect), dbwfdisc_select(mselect), 
     +    author_select(mselect), commid_select(mselect), 
     +    lddate_select(mselect), nrowselect



c		sensor declarations (3.0)
	parameter(msensor=8000)
	character instant_sensor
	character*6 sta_sensor
	character*8 chan_sensor
	character*17 lddate_sensor
	integer inid_sensor, chanid_sensor, jdate_sensor
	real calratio_sensor, calper_sensor, tshift_sensor
	real*8 time_sensor, endtime_sensor
	common/c_sensor/sta_sensor(msensor), chan_sensor(msensor),
     +      time_sensor(msensor), endtime_sensor(msensor),
     +      inid_sensor(msensor), chanid_sensor(msensor), 
     +   jdate_sensor(msensor),
     +      calratio_sensor(msensor), calper_sensor(msensor), 
     +   tshift_sensor(msensor),
     +      instant_sensor(msensor), lddate_sensor(msensor),
     +    nrowsensor



c		site declarations (3.0)
	parameter (msite = 500)
	character*4 statype_site 
	character*6 sta_site, refsta_site
	character*17 lddate_site 
	character*50 staname_site
	integer ondate_site, offdate_site	
	real lat_site, lon_site, elev_site, deast_site, 
     +   dnorth_site
	common/csite/sta_site(msite), ondate_site(msite), 
     +   offdate_site(msite),
     +     lat_site(msite), lon_site(msite), elev_site(msite), 
     +   staname_site(msite), 
     +     statype_site(msite), refsta_site(msite),
     +    dnorth_site(msite), 
     +     deast_site(msite), lddate_site(msite), 
     +   nrowsite



c		sitechan declarations (3.0)
	parameter(msitechan=6500)
	character*4 ctype_sitechan
	character*6 sta_sitechan
	character*8 chan_sitechan
	character*17 lddate_sitechan
	character*50 descrip_sitechan
	integer ondate_sitechan, offdate_sitechan, 
     +   chanid_sitechan
	real edepth_sitechan, hang_sitechan, vang_sitechan
	common/csitechan/sta_sitechan(msitechan), 
     +   chan_sitechan(msitechan),
     +     ondate_sitechan(msitechan), chanid_sitechan(msitechan), 
     +     offdate_sitechan(msitechan), ctype_sitechan(msitechan), 
     +     edepth_sitechan(msitechan), hang_sitechan(msitechan), 
     +     vang_sitechan(msitechan), descrip_sitechan(msitechan),
     +     lddate_sitechan(msitechan), nrowsitechan

c		spdisc declarations (mhr)
	parameter (mspdisc = 1000)
	character segtypef_spdisc, segtypet_spdisc
	character*2 datatype_spdisc
	character*6 sta_spdisc
	character*8 chan_spdisc, taper_spdisc
	character*17 lddate_spdisc
	character*32 dfile_spdisc
	character*64 dir_spdisc
	integer spid_spdisc, chanid_spdisc, jdate_spdisc, 
     +    commid_spdisc, nfreqs_spdisc, nsamp_spdisc,
     +    foff_spdisc
	real samprate_spdisc, freq_spdisc, endfreq_spdisc,
     +    df_spdisc, calib_spdisc, calper_spdisc
c           Mostinski   real*16   
	real*8 time_spdisc, endtime_spdisc
	common/c_spdisc/sta_spdisc(mspdisc), chan_spdisc(mspdisc),
     +     spid_spdisc(mspdisc), chanid_spdisc(mspdisc), 
     +     jdate_spdisc(mspdisc), freq_spdisc(mspdisc),
     +     endfreq_spdisc(mspdisc), df_spdisc(mspdisc),
     +     nfreqs_spdisc(mspdisc), segtypef_spdisc(mspdisc),
     +     taper_spdisc(mspdisc), datatype_spdisc(mspdisc),
     +     time_spdisc(mspdisc), endtime_spdisc(mspdisc), 
     +     samprate_spdisc(mspdisc), nsamp_spdisc(mspdisc), 
     +     calib_spdisc(mspdisc), calper_spdisc(mspdisc), 
     +     segtypet_spdisc(mspdisc), dir_spdisc(mspdisc),
     +     dfile_spdisc(mspdisc), foff_spdisc(mspdisc),
     +     commid_spdisc(mspdisc), lddate_spdisc(mspdisc), 
     +     nrowspdisc

c		seismic region (sregion) declarations (3.0)
	character*17 lddate_sregion
	character*40 srname_sregion
	integer srn_sregion
	common/c_sregion/srn_sregion, srname_sregion, 
     +   lddate_sregion

c		tape declarations
	parameter (mtape = 100)
	character label_tape
	character*8 media_tape
	character*10 foreign_tape
	character*12 class_tape
	character*15 source_tape
	character*17 lddate_tape
	character*20 tapename_tape
	character*50 desc_tape
	integer size_tape, usage_tape, commid_tape, nrowtape
	real*8 creation_tape, modification_tape, access_tape
	common/c_tape/tapename_tape(mtape), source_tape(mtape),
     +    desc_tape(mtape), size_tape(mtape), media_tape(mtape),
     +    class_tape(mtape), foreign_tape(mtape), 
     +   label_tape(mtape),
     +    creation_tape(mtape), modification_tape(mtape),
     +    access_tape(mtape),
     +    usage_tape(mtape), commid_tape(mtape), 
     +   lddate_tape(mtape),
     +    nrowtape

c		tapedata declarations
	parameter (mtapedata = 2000)
	character*6 sta_tapedata
	character*8 chan_tapedata, net_tapedata
	character*17 lddate_tapedata
	character*20 tapename_tapedata
	character*80 database_tapedata
	integer fileno_tapedata, commid_tapedata
	real*8 time_tapedata, endtime_tapedata
	common/c_tapedata/net_tapedata(mtapedata),
     +    sta_tapedata(mtapedata),
     +    chan_tapedata(mtapedata), time_tapedata(mtapedata), 
     +    endtime_tapedata(mtapedata),
     +   tapename_tapedata(mtapedata), 
     +    fileno_tapedata(mtapedata), database_tapedata(mtapedata),
     +    commid_tapedata(mtapedata), lddate_tapedata(mtapedata), 
     +   nrowtapedata

c		tapefile declarations
	parameter (mtapefile = 2000)
	character*8 format_tapefile
	character*17 lddate_tapefile
	character*20 tapename_tapefile
	character*32 dfile_tapefile
	character*50 desc_tapefile
	character*64 dir_tapefile, loadpt_tapefile
	integer fileno_tapefile, size_tapefile, commid_tapefile
	real*8 creation_tapefile
	common/c_tapefile/tapename_tapefile(mtapefile), 
     +   fileno_tapefile(mtapefile),
     +    size_tapefile(mtapefile), creation_tapefile(mtapefile), 
     +    format_tapefile(mtapefile), desc_tapefile(mtapefile),
     +    dir_tapefile(mtapefile),
     +    dfile_tapefile(mtapefile), loadpt_tapefile(mtapefile), 
     +   commid_tapefile(mtapefile),
     +    lddate_tapefile(mtapefile), nrowtapefile

c		wfdisc declarations (3.0)
	parameter(mwfdisc = 10000)
	character segtype_wfdisc, clip_wfdisc
	character*2 datatype_wfdisc
	character*6 sta_wfdisc, instype_wfdisc
	character*8 chan_wfdisc
	character*17 lddate_wfdisc
	character*32 dfile_wfdisc
	character*64 dir_wfdisc
	integer wfid_wfdisc, chanid_wfdisc, jdate_wfdisc,
     +    nsamp_wfdisc, 
     +     foff_wfdisc, commid_wfdisc
	real samprate_wfdisc, calib_wfdisc, calper_wfdisc
	real*8 time_wfdisc, endtime_wfdisc
	common/c_wfdisc/sta_wfdisc(mwfdisc), chan_wfdisc(mwfdisc),
     +    time_wfdisc(mwfdisc), 
     +     wfid_wfdisc(mwfdisc), chanid_wfdisc(mwfdisc), 
     +   jdate_wfdisc(mwfdisc),
     +     endtime_wfdisc(mwfdisc), nsamp_wfdisc(mwfdisc),
     +    samprate_wfdisc(mwfdisc),
     +     calib_wfdisc(mwfdisc), calper_wfdisc(mwfdisc), 
     +   instype_wfdisc(mwfdisc), 
     +     segtype_wfdisc(mwfdisc), datatype_wfdisc(mwfdisc), 
     +   clip_wfdisc(mwfdisc), 
     +     dir_wfdisc(mwfdisc), dfile_wfdisc(mwfdisc),
     +    foff_wfdisc(mwfdisc), 
     +     commid_wfdisc(mwfdisc), lddate_wfdisc(mwfdisc),
     +   nrowwfdisc

c		wfedit declarations (mhr)
	parameter (mwfedit = 10000)
	character*6 sta_wfedit
	character*8 chan_wfedit,probtype_wfedit,edtype_wfedit
	character*15 auth_wfedit
	character*17 lddate_wfedit
	integer edid_wfedit, commid_wfedit
	real*8 time_wfedit, endtime_wfedit
	common/c_wfedit/sta_wfedit(mwfedit), chan_wfedit(mwfedit),
     +     edid_wfedit(mwfedit), time_wfedit(mwfedit), 
     +   endtime_wfedit(mwfedit),  
     +     probtype_wfedit(mwfedit), edtype_wfedit(mwfedit),
     +    commid_wfedit(mwfedit),
     +     auth_wfedit(mwfedit), lddate_wfedit(mwfedit), nrowwfedit


c		disp, dispdata and disperr declarations (mhr)
c			disp
	parameter (mdisp = 500, mdispdata = 100)
	character*2 stage_disp
	character*6 sta_disp
	character*8 chan_disp, wavetype_disp
	character*16 model_disp
	character*17 lddate_disp
	character*32 dfile_disp, dfileerr_disp
	character*64 dir_disp
	integer dispid_disp, jdate_disp, orid_disp, nfreq_disp,
     +     commid_disp
	real range_disp, backaz_disp, az_disp, t01_disp, tc1_disp, 
     +     tc2_disp, t02_disp
	real*8 time_disp
	common/c_disp/sta_disp(mdisp), chan_disp(mdisp), 
     +     dispid_disp(mdisp), wavetype_disp(mdisp),
     +    jdate_disp(mdisp),
     +     orid_disp(mdisp), time_disp(mdisp), range_disp(mdisp),
     +     backaz_disp(mdisp), az_disp(mdisp), nfreq_disp(mdisp),
     +     stage_disp(mdisp), t01_disp(mdisp), tc1_disp(mdisp),
     +     tc2_disp(mdisp), t02_disp(mdisp), model_disp(mdisp), 
     +	   dir_disp(mdisp), dfile_disp(mdisp), 
     +  dfileerr_disp(mdisp), 
     +     commid_disp(mdisp), lddate_disp(mdisp), nrowdisp

c			dispdata
	integer nfreq_dispdata
	real f_dispdata, t_dispdata, groupvel_dispdata, 
     +     dgroupvel_dispdata, phasevel_dispdata, 
     +  dphasevel_dispdata,
     +     amp_dispdata, damp_dispdata, pol_dispdata, 
     +  dpol_dispdata,
     +     filt1_dispdata, filt2_dispdata
	common/c_dispdata/nfreq_dispdata, f_dispdata(mdispdata), 
     +     filt1_dispdata(mdispdata), filt2_dispdata(mdispdata),
     +     t_dispdata(mdispdata), groupvel_dispdata(mdispdata), 
     +     dgroupvel_dispdata(mdispdata),
     +     phasevel_dispdata(mdispdata),
     +    dphasevel_dispdata(mdispdata),
     +     amp_dispdata(mdispdata), damp_dispdata(mdispdata),
     +     pol_dispdata(mdispdata), dpol_dispdata(mdispdata)
c			disperr
	integer nfreq_disperr
	real f_disperr, t_disperr, groupvel_disperr, 
     +     dgroupvel_disperr, phasevel_disperr, dphasevel_disperr,
     +     amp_disperr, damp_disperr, pol_disperr, dpol_disperr
	common/c_disperr/nfreq_disperr, f_disperr(mdispdata), 
     +     t_disperr(mdispdata), groupvel_disperr(mdispdata), 
     +     dgroupvel_disperr(mdispdata),
     +     phasevel_disperr(mdispdata), 
     +  dphasevel_disperr(mdispdata),
     +     amp_disperr(mdispdata), damp_disperr(mdispdata),
     +     pol_disperr(mdispdata), dpol_disperr(mdispdata)

c			ftdisc and ftimag
	parameter (mftdisc = 500, mftimag = 250)
	character*2 datatype_ftdisc, stage_ftdisc
	character*6 sta_ftdisc
	character*8 chan_ftdisc, wavetype_ftdisc, imagefield_ftdisc
        character*16 imagetype_ftdisc, xaxistype_ftdisc,
     +    yaxistype_ftdisc
	character*17 lddate_ftdisc
	character*32 dfile_ftdisc
	character*64 dir_ftdisc
	integer ftid_ftdisc, jdate_ftdisc, orid_ftdisc, 
     +   commid_ftdisc,
     +     numtot_ftdisc, numimage_ftdisc, ny_ftdisc, nx_ftdisc
	real range_ftdisc
	real*8 time_ftdisc
	common/c_ftdisc/sta_ftdisc(mftdisc), chan_ftdisc(mftdisc), 
     +     ftid_ftdisc(mftdisc), wavetype_ftdisc(mftdisc),
     +    jdate_ftdisc(mftdisc), 
     +     orid_ftdisc(mftdisc), time_ftdisc(mftdisc),
     +    range_ftdisc(mftdisc), stage_ftdisc(mftdisc), 
     +     imagetype_ftdisc(mftdisc), imagefield_ftdisc(mftdisc), 
     +   xaxistype_ftdisc(mftdisc), 
     +     yaxistype_ftdisc(mftdisc), numtot_ftdisc(mftdisc),
     +    numimage_ftdisc(mftdisc),
     +     ny_ftdisc(mftdisc), nx_ftdisc(mftdisc),
     +    datatype_ftdisc(mftdisc), 
     +     dir_ftdisc(mftdisc), dfile_ftdisc(mftdisc),  
     +	   commid_ftdisc(mftdisc), lddate_ftdisc(mftdisc),
     +   nrowftdisc
	real imag_ftimag_re, imag_ftimag_im, xaxis_ftimag,
     +    yaxis_ftimag
	common/c_ftimag/imag_ftimag_re(mftimag,mftimag),
     +    imag_ftimag_im(mftimag,mftimag), 
     +     xaxis_ftimag(mftimag), yaxis_ftimag(mftimag)

c			model relation
	parameter (mmodel = 10)
	character isotropic_model, physdisp_model 
	character*8 param1_model, param2_model, param3_model
	character*16 modelname_model
	character*17 lddate_model
	character*32 dfile_model
	character*64 dir_model
	integer modid_model, ndiscs_model, nknots_model, 
     +  nic_model, 
     +   noc_model, nmoho_model, nss_model, numdim_model, 
     +   commid_model, nrowmodel
	real refper_model, radius_model
	common/c_model/modelname_model(mmodel), 
     +  modid_model(mmodel),
     +		isotropic_model(mmodel), physdisp_model(mmodel),
     +          refper_model(mmodel), ndiscs_model(mmodel), 
     +   nknots_model(mmodel), 
     +          nic_model(mmodel), noc_model(mmodel),
     +    nmoho_model(mmodel), 
     +          nss_model(mmodel), radius_model(mmodel),
     +    numdim_model(mmodel), 
     +		param1_model(mmodel), param2_model(mmodel), 
     +          param3_model(mmodel), dir_model(mmodel), 
     +   dfile_model(mmodel),
     +		commid_model(mmodel), lddate_model(mmodel), 
     +   nrowmodel
	parameter (mknots = 250)
	integer level_model_data
	real r_model_data, rho_model_data, vpv_model_data,
     +   vph_model_data,
     +   vsv_model_data, vsh_model_data, eeta_model_data,
     +    g_model_data,  
     +   qshear_model_data, qkappa_model_data, ell_model_data, 
     +   eta_model_data
	common/c_model_data/level_model_data(mknots),
     +    r_model_data(mknots),
     +   rho_model_data(mknots), vpv_model_data(mknots),
     +    vph_model_data(mknots),
     +   vsv_model_data(mknots), vsh_model_data(mknots), 
     +   eeta_model_data(mknots),
     +   g_model_data(mknots), qshear_model_data(mknots),
     +    qkappa_model_data(mknots),
     +   ell_model_data(mknots), eta_model_data(mknots)

c			cst relation
	parameter (mcst = 1000, mismax = 36, mitmax = 2*mismax+1)
	character typemode_cst, ifelastic_cst, typemode2_cst,
     +    s0_cst, 
     +    s1_cst, s2_cst, s3_cst, s4_cst, s5_cst, s6_cst, s7_cst, 
     +    s8_cst, s9_cst, s10_cst, s11_cst, s12_cst
	character*6 ifest_cst
	character*16 cstname_cst,  modelnamesph_cst,
     +    modelnameasph_cst, 
     +    modelnamestart_cst
	integer cstid_cst, nmode_cst, lmode_cst, nmode2_cst, 
     +    lmode2_cst, numevt_cst, numhoriz_cst, numvert_cst, 
     +    numparam_cst, numiter_cst, commid_cst
	character*17 lddate_cst
	character*32 dfile_cst, dfilerr_cst
	character*48 runningfile_cst
	character*64 dir_cst
	real fmode_cst, dfmode_cst, qmode_cst, dqmode_cst,
     +    condnum_cst, 
     +   chisq0_cst, chisq_cst
	common/c_cst/cstid_cst(mcst), nmode_cst(mcst),
     +    typemode_cst(mcst), 
     +      lmode_cst(mcst), cstname_cst(mcst), ifest_cst(mcst), 
     +      ifelastic_cst(mcst), modelnamesph_cst(mcst),
     +    modelnameasph_cst(mcst), 
     +      modelnamestart_cst(mcst), fmode_cst(mcst),
     +    dfmode_cst(mcst), 
     +      qmode_cst(mcst), dqmode_cst(mcst), nmode2_cst(mcst),
     +    typemode2_cst(mcst),
     +	    lmode2_cst(mcst), s0_cst(mcst), s1_cst(mcst),
     +    s2_cst(mcst), s3_cst(mcst), 
     +      s4_cst(mcst), s5_cst(mcst), s6_cst(mcst), 
     +   s7_cst(mcst), s8_cst(mcst),
     +      s9_cst(mcst), s10_cst(mcst), s11_cst(mcst),
     +    s12_cst(mcst), numevt_cst(mcst), 
     +      numhoriz_cst(mcst), numvert_cst(mcst),
     +    numparam_cst(mcst), numiter_cst(mcst), 
     +      condnum_cst(mcst), chisq0_cst(mcst), chisq_cst(mcst),
     +	    runningfile_cst(mcst), dir_cst(mcst), dfile_cst(mcst),
     +    dfilerr_cst(mcst),
     +	    commid_cst(mcst), lddate_cst(mcst), nrowcst
	real cst_data, csterr_data
	common/c_cst_data/cst_data(0:mismax, mitmax), 
     +   csterr_data(0:mismax, mitmax),
     +   ismin_data, ismax_data, ismin_err, ismax_err


c		aspher relation declarations
	parameter (mismaxvol = 36, mismaxcrust = 72, 
     +    mitmaxvol = 2*mismaxvol + 1, mitmaxcrust = 
     +   2*mismaxcrust + 1,  
     +    mdiscs = 20, mvol = 120, mcrust = 30, maspher = 10)
	integer aspherid_aspher, nknots_sph_aspher, 
     +   nknots_vol_aspher, nknots_crust_aspher,
     +    ndiscs_aspher, nmin_vol_aspher, nmax_vol_aspher, 
     +   nmin_crust_aspher,
     +    nmax_crust_aspher, smin_vol_aspher, smax_vol_aspher, 
     +   smin_crust_aspher, 
     +    smax_crust_aspher, commid_aspher, nrowaspher
	character*2 iftopo_aspher, ifcrustvs_aspher,
     +    ifcrustvp_aspher, ifcrustrho_aspher, 
     +    ifvolvs_aspher, ifvolvp_aspher, ifvolrho_aspher
	character*15 author_aspher
	character*16 modelnamesph_aspher, modelnameasph_aspher
	character*17 lddate_aspher
	character*32 dfile1_aspher, dfile2_aspher, dfile3_aspher,
     +    dfile4_aspher, 
     +    dfile5_aspher, dfile6_aspher, dfile7_aspher
	character*64 dir_aspher
	common/c_aspher/aspherid_aspher(maspher),
     +    modelnameasph_aspher(maspher), 
     +    modelnamesph_aspher(maspher), nknots_sph_aspher(maspher),
     +    nknots_vol_aspher(maspher), 
     +    nknots_crust_aspher(maspher), ndiscs_aspher(maspher),
     +    nmin_vol_aspher(maspher), nmax_vol_aspher(maspher),
     +    nmin_crust_aspher(maspher),
     +    nmax_crust_aspher(maspher), smin_vol_aspher(maspher),
     +    smax_vol_aspher(maspher), 
     +    smin_crust_aspher(maspher), smax_crust_aspher(maspher),
     +	  iftopo_aspher(maspher), ifcrustvs_aspher(maspher),
     +    ifcrustvp_aspher(maspher), 
     +    ifcrustrho_aspher(maspher), ifvolvs_aspher(maspher),
     +    ifvolvp_aspher(maspher), 
     +    ifvolrho_aspher(maspher), author_aspher(maspher),
     +	  dir_aspher(maspher), dfile1_aspher(maspher),
     +    dfile2_aspher(maspher), dfile3_aspher(maspher), 
     +    dfile4_aspher(maspher), dfile5_aspher(maspher),
     +    dfile6_aspher(maspher), 
     +    dfile7_aspher(maspher), commid_aspher(maspher),
     +    lddate_aspher(maspher), nrowaspher
	common/c_aspher_data/hdisc(0:mismaxcrust, mdiscs,
     +    mitmaxcrust), 
     +    dvolvs(0:mismaxvol, mvol, mitmaxvol),
     +	  dvolvp(0:mismaxvol, mvol, mitmaxvol),
     +    dvolrho(0:mismaxvol, mvol, mitmaxvol),
     +    dcrustvs(0:mismaxcrust, mcrust, mitmaxcrust),
     +    dcrustvp(0:mismaxcrust, mcrust, mitmaxcrust), 
     +	  dcrustrho(0:mismaxcrust, mcrust, mitmaxcrust),
     +    rdisc_aspher(mdiscs), rvol_aspher(mvol),
     +    rcrust_aspher(mcrust)

c		map declarations (mhr)
	parameter (mmap = 100)
	integer mapid_map, commid_map, numgridpts_map, 
     +   latlonorder_map
	real refval_map, period_map, frequency_map,
     +    depth_map
	character*8 units_map, wavetype_map
	character*15 author_map
	character*16 mapname_map, maptype_map, reference_map,
     +    source_map
	character*17 lddate_map
	character*32 dfile_map
	character*64 dir_map
	common/c_map/mapid_map(mmap), mapname_map(mmap),
     +    maptype_map(mmap), 
     +   wavetype_map(mmap), reference_map(mmap),
     +   refval_map(mmap), source_map(mmap),
     +   period_map(mmap), frequency_map(mmap), 
     +   depth_map(mmap), units_map(mmap),
     +   numgridpts_map(mmap), latlonorder_map(mmap),
     +   dir_map(mmap), dfile_map(mmap), author_map(mmap),
     +    commid_map(mmap), 
     +   lddate_map(mmap), nrowmap
c		mapdata declarations (mhr)
	real xlat_mapdata, xlon_mapdata, val_mapdata
	parameter (mmapdata = 100000)
	common/c_mapdata/xlat_mapdata(mmapdata), 
     +   xlon_mapdata(mmapdata), val_mapdata(mmapdata)


