#include <stdio.h>
#include <string.h>
#include <errno.h>  
#include <sys/stat.h>
#include <dirent.h>
#include <ctype.h>
#include <unistd.h>

int 
IsDirectory(char *sourceDir)
{

 DIR              *dirp;
   struct dirent    *dp;
   struct stat       s_buf;
   
   char *ptr = 0;
   if (stat(sourceDir, &s_buf) == -1 || !(s_buf.st_mode & S_IREAD))
   return 1;   

     if (s_buf.st_mode & S_IFDIR )    {

          if (!(dirp = opendir(sourceDir))) return 1;

     closedir(dirp);
     }
return 0;
}

int
DirectoryIsUserDefinedModels(char *OutErr,char *sourceDir,char *fileMask)
{

 DIR              *dirp;
   struct dirent    *dp;
   struct stat       s_buf;
   int cnt = 0;
   int lenFileMask = strlen(fileMask);
   
   char *ptr = 0;
   if (stat(sourceDir, &s_buf) == -1 || !(s_buf.st_mode & S_IREAD))
{ sprintf(OutErr,"System error. '%s' Directory. \n    Try again or Quit\n",sourceDir) ;  return -1;   }  

if (s_buf.st_mode & S_IFDIR )    {

     if (!(dirp = opendir(sourceDir))) {
      sprintf (OutErr,"Error: Can't open %s Directory ",sourceDir); 
                         return -1;}

  
    while  ( (dp = readdir(dirp) ) )   
        if (strcmp(dp->d_name, ".") && strcmp(dp->d_name, "..")) { 
	if(strrchr(dp->d_name, '@') != 0) continue;
             ptr = dp->d_name + strlen(dp->d_name) - lenFileMask;
		if( strncmp(ptr,fileMask,lenFileMask) == 0 ) cnt++;
           
              
    
            
         }
closedir(dirp);
}
return cnt;
}

int 
DirectoryIsEmpty(char *OutErr,char *sourceDir,char *fileMask)
{

 DIR              *dirp;
   struct dirent    *dp;
   struct stat       s_buf;
   int cnt = 0;
   int lenFileMask = strlen(fileMask);
   
   char *ptr = 0;
   if (stat(sourceDir, &s_buf) == -1 || !(s_buf.st_mode & S_IREAD))
{ sprintf(OutErr,"System error. '%s' Directory. \n    Try again or Quit\n",sourceDir) ;  return -1;   }  

if (s_buf.st_mode & S_IFDIR )    {

     if (!(dirp = opendir(sourceDir))) {
      sprintf (OutErr,"Error: Can't open %s Directory ",sourceDir); 
                         return -1;}

  
    while  ( (dp = readdir(dirp) ) )   
        if (strcmp(dp->d_name, ".") && strcmp(dp->d_name, "..")) { 
          if (lenFileMask > 0) {
             ptr = dp->d_name + strlen(dp->d_name) - lenFileMask;
		if( strncmp(ptr,fileMask,lenFileMask) == 0 ) cnt++;
            } else cnt++;
              
    
            
         }
closedir(dirp);
}
return cnt;
}
int	CheckDirAndEnter(char* dirName,char* OutErr) {
    if ( chdir(dirName) == -1 )
     if(mkdir(dirName, 0777) == -1) {
          sprintf(OutErr, "System Error: Cannot create directory\n   %s",dirName);
          return 1;
     } else chdir(dirName);
return 0;
}



void StrRemoveBlank(char *str){
char* ptr;
 while ( ( ( ptr = strchr(str,' ') ) != 0 ) )  strcpy(ptr,ptr +1);
}
void StrRemoveLeadingBlank(char *str){
char* ptr = str;
while (*ptr == ' ') strcpy(ptr,ptr+1);
}
void StrRemoveTailBlank (char *str) {
char* ptr = str + strlen(str) - 1;
while (*ptr == ' ') { *ptr = '\0'; ptr--; }
}
