//===============================================================
// fmtdirsel.h - reply modal dialog
//
// Copyright (C) 1995,1996  Bruce E. Wampler
//
// This file is part of the V C++ GUI Framework, and is covered
// under the terms of the GNU Library General Public License,
// Version 2. This library has NO WARRANTY. See the source file
// vapp.cxx for more complete information about license terms.
//===============================================================


// These member functions  modified from vfilesel.cxx &
// vfilesel.h Bruce E. Wampler code by A. Mostinski in 10.1998.
// MITPAN Moscow mostinsk@mitp.ru 

#ifndef VFMTDIRSEL_H
#define VFMTDIRSEL_H
#include <v/vmodald.h>

#ifndef maxFiles
#define maxFiles 400
#endif

#ifndef maxDirs
#define maxDirs 200
#endif

#ifndef maxFileLen 
#define maxFileLen 200
#endif

    class vApp;
    class vDirSelect : protected vModalDialog
      {
      public:		//---------------------------------------- public
	vDirSelect(vBaseWindow* bw, char* title = "File Select") : 
	    vModalDialog(bw,title) { _cmdsAdded = 0; }
	vDirSelect(vApp* aw, char* title = "File Select") : 
	    vModalDialog(aw,title) { _cmdsAdded = 0; }
	~vDirSelect() {}

	int DirSelect(VCONST char* msg, char* filename, 
	    const int maxlen, char** filter, int& filterIndex);
	int FileSelectSave(VCONST char* msg, char* filename, 
	    const int maxlen, char** filter, int& filterIndex);

      protected:	//--------------------------------------- protected

      private:		//--------------------------------------- private
	int curSel;
	int dirSel;
	int _cmdsAdded;
	int _curFilter;
	int _showHidden;

	const char* fileFilter;
	char **filterPtr;		// ptr to filter list
	char curDir[maxFileLen];	// to hold current dir
	char origFile[maxFileLen];	// to hold original file
	char* fileList[maxFiles];	// the list of files
	char* dirList[maxFiles];	// the list of directories

        char DirectoryName[maxFileLen];
	virtual void DialogCommand(ItemVal id, ItemVal val, CmdType ctype);

	void GetDirList(const char *dir, const char* wild, 
	    char** filelist, const int max, char** dirlist, const int maxdir);

      };
#endif
