
 /****  Standard include files  ****/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <limits.h>


 /****  Local include files  ****/
//#include "tmpl.h"
//#include "elog.h"
//#include "csstime.h"
//#include "db.h"
//#include "stock.h" 

#ifndef MAX
#define MAX(a,b)        ((a)>(b) ? (a) : (b))
#endif

#ifndef MIN
#define MIN(a,b)        ((a)<(b) ? (a) : (b))
#endif
#define SECONDS_PER_DAY (24*60*60)
static int days_in_month[] = {31,28,31,30,31,30,31,31,30,31,30,31,31};
static char *month_name[] =
{"Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec"};


double h2e();
int mday2doy();
int etoh();
void doy2mday();
double dtoepoch();
static double year2days (  ) ;
int isleap();

double fmtepoph();
void fmtetoh();

struct date_time
{
    double          epoch;
    long            date;
    int             year;
    int             month;
    char            mname[4];
    int             day;
    int             doy;
    int             hour;
    int             minute;
    float           second;
};


void fmtdoy2mday ( doy, year, month, day ) 
int doy;
int year;
int *month;
int *day;
{
doy2mday(doy, year, month, day);

}


double fmtepoph( year,month,day,hour,minute, second) 
int year;
int month;
int day;
int hour;
int minute;
float second;
{
int doy;
		doy = mday2doy (year,month,day);

      return(   h2e(year, doy, hour,minute,second) );

}

void fmtetoh(epoch,year,month,day,doy,hour,minute,second) 
double epoch;
int *year;
int *month;
int *day;
int *doy;
int *hour;
int *minute;
float *second;
{
    struct date_time time;	

time.epoch = epoch;
    etoh(&time);
*year = time.year;
*month = time.month;
*day = time.day;
*doy = time.doy;
*hour = time.hour;
*minute = time.minute;
*second = time.second;

}

double
h2e(iyear, iday, ihour, imin, sec)

int            iyear;
int            iday;
int            ihour;
int            imin;
double         sec;

/* htoe will compute a double precision epoch time in seconds from 00:00:00.0
 * 1 Jan 1970 GMT. */

{
    int             jdate;
    double          epoch;

    jdate = 1000 * (iyear) + (iday);
    epoch = dtoepoch(jdate);
    epoch += 3600.0 * (ihour) + 60.0 * (imin) + sec;
    return epoch ; 
}
int 
mday2doy ( year, month, day ) 
int month, day, year ; 
{
    struct date_time dt ; 

    dt.year = year ; 
    dt.month = month ;
    dt.day = day ; 

    mdtodate ( &dt ) ; 

    return dt.doy ;
}
void 
doy2mday ( doy, year, month, day ) 
int year, doy ;
int *month, *day ; 
{
    struct date_time dt ; 

    dt.year = year ; 
    dt.doy = doy ; 
    month_day ( &dt ) ; 
    *day = dt.day ; 
    *month = dt.month ; 
}

int
etoh(dt)
struct date_time *dt;
{
	double doy, year, days ;
	double remainder, rdays ;

	rdays = floor(dt->epoch / 86400.);
	remainder = dt->epoch - rdays * 86400. ; 
	dt->hour = floor(remainder/3600.) ; 
	remainder -= dt->hour*3600. ; 
	dt->minute = floor(remainder/60.) ; 
	remainder -= dt->minute*60. ; 
	dt->second = remainder ;

	/* given a number of days, we want to find the year and day of year */
	year = floor(rdays/365.) + 1970 ; 
	days = year2days ( year ) ; 
	doy = rdays - days ; 
	if ( doy < -366 ) { /* epoch way out of range */
	    doy = 0 ;
	} if ( doy < 0 ) {
	    year-- ; 
	    if ( isleap ((int) year) ) 
		doy += 366 ; 
	    else
		doy += 365 ; 
	} else if ( doy >= 730 ) {
	    doy = 0 ; 
	} else if ( isleap((int) year) ) {
	    if ( doy > 365 ) {
		year++; 
		doy -= 366 ; 
	    }
	} else if ( doy > 364 ) {
	    year++ ; 
	    doy -= 365 ; 
	}

	/* All this nonsense is to keep returning somewhat reasonable
	   numbers even when the input epoch time is way out of range,
	   like -1e219.  
        */
	dt->doy = doy+1 ;
	dt->year = MAX(MIN(year,LONG_MAX/10000.),LONG_MIN/10000.) ;

	dt->date = dt->year * 1000 + dt->doy;
	month_day(dt);
	return 0;
}
double
dtoepoch(date)
long date;
{
        int year, day ;
	double days, leapdays ; 

        year = date / 1000;
        day  = date % 1000;
 
	days  = day-1 + (year - 1970) * 365 ;
	leapdays =   floor((year - 1969) /   4.0)  
		   - floor((year - 1901) / 100.0) 
		   + floor((year - 1601) / 400.0);
	days += leapdays ;

        return days*SECONDS_PER_DAY ;
}

int
mdtodate(dt)
struct date_time *dt;
{
	int i,dim;
	dt->doy = 0;
	for( i = 0 ; i < dt->month - 1 ; i++ ){
		dim = days_in_month[i];
		if( i == 1 && isleap(dt->year) ) dim++;
		dt->doy += dim;
	}
	dt->doy += dt->day;
	dt->date = 1000 * dt->year + dt->doy;
	return(0);
}
int
month_day(dt)
struct date_time *dt;
{
	int i,dim,leap;

	leap = isleap(dt->year);
	dt->day = dt->doy;
	for( i = 0 ; i < 12 ; i ++ ){
		dim = days_in_month[i];
		if( leap && i == 1 ) dim++;
		if( dt->day <= dim ) break;
		dt->day -= dim;
	}
	dt->month = i + 1;
	strcpy(dt->mname,month_name[i]);
	return 0 ;
}
static double 
year2days ( year ) 
double year ; 
{
    double leapdays ; 
    leapdays =   floor((year - 1969) /   4.0)  
	       - floor((year - 1901) / 100.0) 
	       + floor((year - 1601) / 400.0);
    return  (year - 1970) * 365 + leapdays ;
}

/* return true if leap year else false */
int
isleap(year)
int year;
{
	return(year % 4 == 0 && year % 100 != 0 || year % 400 == 0);
}
	/* time conversion stolen from original archive */
