      subroutine azdel_n(z_sdlat,z_sdlon,z_edlat,z_edlon,z_del,
     +z_delt,z_azi_b,
     +z_azi,norb)
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
C     slat,slon are station coordinates in degrees
C     elat,elon are epicenter coordinates in degrees
C     del is epic. distance in degrees
C     del is epic. distance in km     
C     azis is backazimuth in degrees
C     azie is azimuth in degrees
      IMPLICIT REAL*8 (A-H,O-Y)
      IMPLICIT REAL*4 (Z)
      data pi/3.14159265359D0/
      rad=pi/180.D0
      if(z_sdlat.eq.-90.0)z_sdlat=-89.9999
      sdlat=z_sdlat
      sdlon=z_sdlon
      edlat=z_edlat
      edlon=z_edlon
      slat=sdlat*rad
      slon=sdlon*rad
      elat=rad*edlat
      elon=rad*edlon
      call azidl(slat,slon,elat,elon,del,dels,azis,azie)
      del=del/rad
      azis=azis/rad
      azie=azie/rad
      delt=dels
      azi=azie
      azi_b=azis
      if(norb.gt.1) call orbit(norb,dels,azis,azie,delt,azi_b,a
     +zi)
      z_del=del
      z_delt=delt
      z_azi_b=azi_b
      z_azi=azi
      end
C###############################################################
      subroutine  orbit(i,dels,azis,azie,delt,azi_b,azi)
      IMPLICIT REAL*8 (A-H,O-Y)
      data rad/.017453293D0/,circ/40030.173592D0/
	    nq=i/2
	   fff=float(i)/2.-float(nq)
C-----------odd  orbit------------------
		 delt=dels+((i-1)/2)*circ
		 azi=azie
		 azi_b=azis
	    if(fff.eq.0.0) then
C-----------even orbit------------------
	    delt=circ*(i/2)-dels
	    azi_b=azis+180.
	    azi=azie+180.
			 end if
			 return
			 end 
c####################################################################
      SUBROUTINE AZIDL(SLAT,SLON,ELAT,ELON,DEL,DELS,AZIS,AZIE)
C     AZIS IS AZIMUTH FROM STATION, AZIE - FROM EPICENTER
C     DELS IS THE DISTANCE OVER THE SURFACE OF A SPHERICAL EARTH 
C     GEOCENTRIC LATITUDES ARE USED IN ALL COMPUTATIONS
C     ALL IS IN RADIANS 
      IMPLICIT REAL*8 (A-H,O-Y)
      DATA R/6371.D0/,PI/3.14159265359D0/,GEO/0.993277D0/
      COLAT(A)=1.57079632679D0-DATAN(GEO*DTAN(A))
C------------------------------------------------------------------
      SCOLAT=COLAT(SLAT)
      ECOLAT=COLAT(ELAT)
      C=ELON-SLON
      SC5=DCOS(C)
      SC6=DSIN(C)
      SC1=DSIN(SCOLAT) 
      SC2=DCOS(SCOLAT) 
      SC3=DSIN(SLON)
      SC4=DCOS(SLON)
      EC3=DSIN(ELON)
      EC4=DCOS(ELON)
      EC1=DSIN(ECOLAT) 
      EC2=DCOS(ECOLAT) 
      AE=EC1*EC4
      BE=EC1*EC3
C________AZIMUTHS CALCULATION__________________________________
      AZI1=(AE-SC3)**2+(BE+SC4)**2+EC2*EC2-2.
      AZI2=(AE-SC2*SC4)**2+(BE-SC2*SC3)**2+(EC2+SC1)**2-2.
      IF(AZI2.EQ.0.D0) GO TO 10
      AZIS=DATAN2(AZI1,AZI2)
      GO TO 20
10    AZIS=3.141592653D0-DSIGN(1.570796326D0,AZI1)
20    CONTINUE
      AS=SC1*SC4
      BS=SC1*SC3
      AZI1=(AS-EC3)**2+(BS+EC4)**2+SC2*SC2-2.
      AZI2=(AS-EC2*EC4)**2+(BS-EC2*EC3)**2+(SC2+EC1)**2-2.
      IF(AZI2.EQ.0.) GO TO 30
      AZIE=DATAN2(AZI1,AZI2)
      GO TO 40
30    AZIE=3.141592653D0-DSIGN(1.570796326D0,AZI1)
40    CONTINUE
C__________DELTA CALCULATION_____________________________________
      COSD=SC2*EC2+SC1*EC1*SC5
      DEL= DACOS(COSD)
      DELS=R*DEL
      RETURN
      END 
